;;;; regalloc $B$N%F%9%HMQ%b%8%e!<%k(B $B4pK\%V%m%C%/%5%]!<%HHG(B
;;;; LastChange: Sat Feb 10 11:12:49 2007

;;; ASL $B$H$$$&4JC1$J8@8l$K$h$j%l%8%9%?%"%m%1!<%7%g%s$N%F%9%H$r9T$&!#(B
;;; ASL $B$K$D$$$F$ODj?t(B sck=asl-program-sample $B$NDj5A$r;2>H!#(B
;;;
;;; $B%G%b(B ESC x sck-asl-demo RET $B$K$h$j!"$3$N%5%s%W%k$G%F%9%H$r9T$&!#(B
;;;
;;; $BDL>o$O0J2<$N4X?t$K$h$j%F%9%H$r$9$k!#(B
;;; (sck-asl-test <ASL-Program>)


(require 'sck-regalloc)
(require 'sck-live)

(defconst sck=asl-program-sample
  '(;; $B@k8@It(B
    ;; $B0J2<$NL>A0$O(B
    ;; real-register-sets
    ;; real-register-constraints
    ;; possible-assignments
    ;; sck-regalloc $B$X$N(B A-List $B%$%s%?%U%'!<%9$N0lIt(B
    (real-register-sets
     ((G ("r0" "r1" "r2"))
      (F ("f0" "f1"))))
    (real-register-constraints
     ())
    (possible-assignments 
     ((i G)
      (n G)
      ;; $BL5;XDj$N2>A[%l%8%9%?$O(B real-register-sets $B$N:G=i$N%/%i%9$H$J$k(B
      ))
    ;;
    ;; $BL?NaNs$O(B EmacsLisp $B$N(B (setq sym sexp) $B$N%j%9%H!#(B
    ;; $B>.J8;z$G;O$^$C$F$$$kJQ?t$O2>A[%l%8%9%?!"(B
    ;; $BBgJ8;z$G;O$^$k$b$N$O%0%m!<%P%kJQ?t$H$9$k!#(B
    ;;
    (instructions
     ;; 1+2+...+10
     Lbeg  ; $B4pK\%V%m%C%/$N;O$a$O%i%Y%k$,I,MW!#(BLbeg $B$OF~$j8}$N%i%Y%k!#(B
     (setq i 1)
     (setq m 10)
     (setq n m)
     (setq total 0)
     (jump L1) ; $B4pK\%V%m%C%/$N=*$o$j$O(B jump / jumpc

     L1  ; $BF~$j8}$G$b=P8}$G$b$J$$%i%Y%k$NL>A0$OG$0U!#(B
     (setq sum (+ total i))
     (setq total sum)
     (setq i (1+ i))
     (jumpc (<= i n) L1 Lend) ; $B>r7o$,??$J$i(B L1 $B$=$&$G$J$1$l$P(B Lend $B$X!#(B

     Lend ; $B=P8}$N4pK\%V%m%C%/$N%i%Y%k$O(B Lend$B!#(B
     (setq RET total) ; $B=P8}%V%m%C%/$ONc30E*$K(B jump $BL?Na$G$O=*$o$i$J$$!#(B
     ))
  "ASL $B%W%m%0%i%`$N%5%s%W%k(B")


(defun sck-asl-demo ()
  "ASL $B$N%5%s%W%k(B sck=asl-program-sample $B$G%F%9%H$r9T$&!#(B"
  (interactive)
  (sck-asl-test sck=asl-program-sample))

(defun sck-asl-test (asl-program)
  "ASL $B%W%m%0%i%`(B ASL-PROGRAM $B$+$i!"%l%8%9%?%"%m%1!<%7%g%s$N$?$a$N(B
A-List $B%$%s%?%U%'!<%9$r:n@.$7!"(Bregalloc $B$XEO$9!#(B
$B$=$7$F!"%l%8%9%?%"%m%1!<%7%g%sA0$NI>2ACM$H%"%m%1!<%7%g%s8e$NI>2ACM$rI=<($9$k!#(B
Example:
  (sck-asl-test sck=asl-program-sample)"
  (let* (;; ASL $B%W%m%0%i%`$+$i(B sck-regalloc $B$X$NF~NO(B A-List $B$r:n$j!"(B
	 (input-alist (sck-asl-make-input-alist-for-regalloc asl-program))
	 ;; sck-regalloc $B8F$S=P$7$F!"=PNO(B A-List $B$rF@$k!#(B
	 (output-alist (condition-case err
			   ;; sck-regalloc $B<B9TCf$K%(%i!<$,5/$3$C$?>l9g$O(B
			   ;; $B$=$N%(%i!<%a%C%;!<%8$rI=<($9$k$h$&$KG[N8!#(B
			   (sck-regalloc input-alist
					 :graphviz-outdir
					 (format "%s/tmp/regalloc-graphviz"
						 sck=root-directory))
			 (error (cons 'sck-regalloc-error err)))))
    (if (eq (car output-alist) 'sck-regalloc-error)
	;; sck-regalloc $B$G%(%i!<H/@8!#(B
	(with-display-buffer "*sck-asl*"
	  (insertf "sck-regalloc signaled the following error:\n\n\t%s\n\n"
		   (error-message-string (cdr output-alist)))
	  (insertf "with the following input:\n\n%s"
		   (pp-to-string input-alist)))
      ;; sck-regalloc $B$,@5>o$K=*N;!#(B
      ;; * Output A-list
      ;; ((register-assignments  ((<VirtualReg> <RealReg>)..))
      ;;  (spilled-registers     (<VirtualReg>..))
      (sck-letalist output-alist
	  (register-assignments spilled-registers)
	(let ((original-bblock (sck-asl-make-bblocks asl-program))
	      (replaced-bblock
	       (sck-asl-life-analysis ; $B3d$jEv$F8e$@$,I=<($N$?$a%U%m!<2r@O(B
		(sck-asl-replace-bblock-vregs
		 (sck-asl-make-bblocks asl-program)
		 register-assignments))))
	  (with-display-buffer "*sck-asl*"
	    (insertf "* Input:\n%s\n* Output:\n%s\n"
		     (pp-to-string input-alist)
		     (pp-to-string output-alist))
	    (cond
	     (spilled-registers
	      ;; $B%"%m%1!<%7%g%s<:GT(B
	      (insertf "* Partially register allocated instructions:\n%s\n"
		       (sck-asl-format-bblock replaced-bblock))
	      (insertf "* Actual spill:\nspilled-registers = %S"
		       spilled-registers))
	     (t
	      (let ((oval (sck-asl-eval-bblocks original-bblock))
		    (rval (sck-asl-eval-bblocks replaced-bblock)))
		;; $B%"%m%1!<%7%g%s@.8y!*(B
		;; $BL?Na$r<B9T$7$F7k2L$rHf3S$9$k!#(B
		(insertf "* Register allocated instructions:\n%s\n"
			 (sck-asl-format-bblock replaced-bblock))
		(insertf "* The value of the original program = %S\n" oval)
		(insertf "* And that of the allocated program = %S\n" rval)
		(insertf "* Register allocation is done %s"
			 (if (equal oval rval)
			     "successfully !!!\n"
			   "wrongly...\n")))))))))))

(defun sck-asl-program-insts (asl-program)
  ;; (sck-asl-program-insts sck=asl-program-sample)
  ;; => ...
  (cdr (assq 'instructions asl-program)))


(defstruct sck-asl-bblock
  label ; jump $B%i%Y%k%7%s%\%k!#(B'sck-asl-bblock $BB0@-$X(B bblock $B$,%;%C%H$5$l$k!#(B
  insts ; $B%i%Y%k0J2<$NL?Na$NNs!#(B
  succ  ; outgoing bblock $B$N%j%9%H!#(B
  pred  ; incomming bblock $B$N%j%9%H!#(B
  ;; $B0J2<$=$NB>$NMM!9$J>pJs(B
  ;; liveness
  livein
  liveout)

(defun sck-asl-format-bblock (bblock-s)
  ;; bblock $B$^$?$O$=$N%j%9%H$rJ8;zNs$KJQ49$9$k!#(B
  (with-temp-buffer
    (cond
     ((sck-asl-bblock-p bblock-s)
      (insertf "%S ; %S->%S ; livein=%s liveout=%s\n"
	       (sck-asl-bblock-label bblock-s)
	       (mapcar 'sck-asl-bblock-label
		       (sck-asl-bblock-pred bblock-s))
	       (mapcar 'sck-asl-bblock-label
		       (sck-asl-bblock-succ bblock-s))
	       (sck-asl-bblock-livein bblock-s)
	       (sck-asl-bblock-liveout bblock-s))
      (dolist (inst (sck-asl-bblock-insts bblock-s))
	(if (and (eq (car inst) 'setq)
		 (eq (cadr inst) (caddr inst)))
	    (insertf "  ;; %S\n" inst)
	    (insertf "  %S\n" inst))
	))
     (t
      (dolist (b bblock-s)
	(insertf "%s" (sck-asl-format-bblock b)))))
    (buffer-string)))


(when (featurep 'elim)
  (elim-add-printer
   #'(lambda (x)
       (or (sck-asl-bblock-p x)
	   (and (listp x)
		(sck-asl-bblock-p (car x)))))
   'sck-asl-format-bblock))

(defun sck-asl-bblock-last-inst (bblock)
  ;; bblock $B$N:G8e$NL?Na$rJV$9!#(B
  ;; $B$J$1$l$P(B nil$B!#(B
  (car (last (sck-asl-bblock-insts bblock))))

(defun sck-asl-jump-labels (inst)
  ;; inst $B$,(B jump/jumpc $B$J$i$=$N%i%Y%k$N%j%9%H$r!"(B
  ;; $B$=$l0J30$NL?Na$J$i(B nil $B$rJV$9!#(B
  (case (car inst)
    (jump (cdr inst))
    (jumpc (cddr inst))
    (t nil)))


(defun sck-asl-make-bblocks (asl-program)
  ;; asl-program $B$+$i(B bblock $B$N%j%9%H$r:n@.$9$k!#(B
  ;; (sck-asl-format-bblock (sck-asl-make-bblocks sck=asl-program-sample))
  ;; => ...
  (let* ((insts (sck-asl-program-insts asl-program))
	 (bblockalist nil)
	 (binsts nil))
    ;;
    ;; $B$^$:(B bblockalist = ((Lbeg inst...) (L0 inst...) ... (Lend ...)) $B$r:n$k!#(B
    ;;
    (dolist (inst (append insts '(Ldummy)))
      (cond
       ((symbolp inst)
	(when binsts
	  (push (nreverse binsts) bblockalist)
	  (setq binsts nil))
	(push inst binsts))
       (t
	(push inst binsts))))
    (setq bblockalist (nreverse bblockalist))
    ;;
    ;; $B$=$l$+$i(B bblock $B$r:n$j!"$=$N%j%9%H$rJV$9!#(B
    ;;
    (let ((bblocks (mapcar '(lambda (x)
			      ;; x = (Label inst...)
			      (make-sck-asl-bblock
			       :label (car x)
			       :insts (cdr x)))
			   bblockalist)))
      ;; succ/pred $B$r%;%C%H!#(B
      (dolist (b bblocks)
	(setf (sck-asl-bblock-succ b)
	      (mapcar #'(lambda (label)
			  (or (find label bblocks
				    :key 'sck-asl-bblock-label)
			      (error "Label %s not found" label)))
		      (sck-asl-jump-labels
		       (sck-asl-bblock-last-inst b))))
	(dolist (bs (sck-asl-bblock-succ b))
	  (push b (sck-asl-bblock-pred bs))))
      ;;
      ;; bblock $B$N%A%'%C%/$r9T$&!#(B
      ;;
      (let ((lbls (mapcar 'sck-asl-bblock-label bblocks)))
	(dolist (l lbls)
	  (when (< 1 (length (filter '(lambda (ll) (eq l ll)) lbls)))
	    (error "Duplicatd label %s" l)))
	(unless (eq (sck-asl-bblock-label (car bblocks)) 'Lbeg)
	  (error "Illegal insts: The first label is not Lbeg"))
	(unless (eq (sck-asl-bblock-label (car (last bblocks))) 'Lend)
	  (error "Illegal insts: The last label is not Lend"))
	(dolist (b bblocks)
	  (let ((linst (car (last (sck-asl-bblock-insts b)))))
	    (unless (or (memq (car linst) '(jump jumpc))
			(eq (sck-asl-bblock-label b) 'Lend))
	      (error "Illegal last inst in bblock %s"
		     (sck-asl-bblock-label b))))))
      ;;
      bblocks)))


(defun sck-asl-eval-bblocks (bblocks)
  "asl-program $B$r<B9T$7!"(BLend $B%V%m%C%/$N:G8e$NCM$rJV$9!#(B
Example:
  (sck-asl-eval-bblocks (sck-asl-make-bblocks sck=asl-program-sample))"
  (let ((pc 'Lbeg)
	(val nil))
    (loop
     (let ((bblock (find pc bblocks :key 'sck-asl-bblock-label)))
       (unless bblock
	 (error "Label %s not found" pc))
       (setq val (sck-asl-eval-bblock bblock))
       (when (eq pc 'Lend)
	 (return))
       (setq pc val)))
    val))

(defun sck-asl-eval-bblock (bblock)
  ;; $B0l$D$N(B bblock $B$rI>2A$7!"Ht$S@h$N%i%Y%k$rJV$9!#(B
  ;; Lend $B%V%m%C%/$N>l9g$O(B Lend $B%V%m%C%/$N:G8e$N%U%)!<%`$NCM$rJV$9!#(B
  (let ((val nil))
    (dolist (inst (sck-asl-bblock-insts bblock))
      (ecase (car inst)
	((setq)
	 (setq val (eval inst)))
	((jump)
	 (setq val (cadr inst)))
	((jumpc)
	 (setq val (if (eval (cadr inst))
		       (caddr inst)
		     (cadddr inst))))))
    val))

(defun sck-asl-replace-bblock-vregs (bblocks register-assignments)
  "bblocks $B$r(B substalist $B$K=>$C$FGK2uE*$K=q$-49$($k!#(B
Example:
  (sck-asl-format-bblock
    (sck-asl-replace-bblock-vregs (sck-asl-make-bblocks sck=asl-program-sample)
       '((\"i\" \"j\"))))"
  (dolist (b bblocks)
    (setf (sck-asl-bblock-insts b)
	  ;; $B!z(B sublis $B$G$O4X?tL>$HF1$8JQ?t$r;H$C$?>l9g$K%^%:%$$,!D(B
	  (sublis (mapcar #'(lambda (x) (cons (intern (car x))
					      (intern (cadr x))))
			  register-assignments)
		  (sck-asl-bblock-insts b))))
  bblocks)



(defun sck-asl-life-analysis (bblocks)
  "bblock $B$N%j%9%H(B BBLOCKS $B$r<u$1<h$j!"=q$/(B bblock $B$N(B live{in,out} $B$r7W;;!#(B
BBLOCKS $B$rJV$9!#%U%m!<2r@O%Q%C%1!<%8(B sck-live $B$r;H$&!#(B"
  (let ((output (sck-live
		 ;; <basic-blocks> ::= ((<Label> (<Inst>..) (<Succ>..))..)
		 (list
		  (list 'basic-blocks
			(mapcar #'(lambda (b)
				    (list (sck-asl-bblock-label b)
					  (mapcar 'sck-asl-inst-defrefs
						  (sck-asl-bblock-insts b))
					  (mapcar 'sck-asl-bblock-label
						  (sck-asl-bblock-succ b))))
				bblocks))))))
    (sck-letalist output
	;; <liveness-info> ::= ((<Label> (<LiveIn>..) (<LiveOut>..))..)
	(liveness-info)
      (dolist (i liveness-info)
	(let ((b (find (car i) bblocks :key 'sck-asl-bblock-label)))
	  (setf (sck-asl-bblock-livein b) (cadr i)
		(sck-asl-bblock-liveout b) (caddr i)))))
    ;;
    bblocks))
      
(defun sck-asl-make-input-alist-for-regalloc (asl-program)
  "regalloc $B$N(B input A-list $B$r:n$k!#(B
  <interference-graph> ::= ({<VirtualReg> [<VirtualReg>]})
  <coalesceable-edges> ::= ({<VirtualReg> <VirtualReg>})
  <real-register-sets> ::= ({(<RealRegSet> ({<RealReg>}))})
  <real-register-constraints> ::= ({<RealReg> <RealReg>})
  <possible-assignments> ::= ({(<VirtualReg> <RealRegSet>)})
Example:
  (sck-asl-make-input-alist-for-regalloc sck=asl-program-sample)"
  ;;
  (let ((bblocks (sck-asl-make-bblocks asl-program)))
    `((interference-graph
       ,(sck-asl-make-interference-graph bblocks))
      (coalesceable-edges
       ,(sck-asl-make-coalesceable-edges bblocks))
      (real-register-sets
       ,(cadr (assoc 'real-register-sets asl-program)))
      (real-register-constraints
       ,(cadr (assoc 'real-register-constraints asl-program)))
      (possible-assignments
       ;; $B%G%U%)%k%H$rJd=<$9$k=hM}$rDI2C!#(B
       ,(let ((posass (mapcar
		       '(lambda (vr)
			  (list (symbol-name (car vr)) (cadr vr)))
		       (cadr (assoc 'possible-assignments asl-program))))
	      (vregs (sck-asl-all-vregs bblocks))
	      (default (caar (cadr (assoc 'real-register-sets asl-program)))))
	  (dolist (v vregs)
	    (unless (assoc v posass)
	      (push (list v default) posass)))
	  posass)))))


(defun sck-asl-vreg-p (x)
  ;; $B!z(Bstring x $B$,2>A[%l%8%9%?$+$I$&$+H=Dj(B
  ;;   (sck-asl-vreg-p 'foo) => 0 (true)
  ;;   (sck-asl-vreg-p 'BAR) => nil
  (when (stringp x) (setq x (intern x))) ; $B!z$`$7$m(B stringp $B$N$_$K$9$Y$-!#(B
  (and (symbolp x)
       (let ((case-fold-search nil))
	 (string-match "^[a-z]" (symbol-name x)))))

(defun sck-asl-make-coalesceable-edges (bblocks)
  "coalesceable-edge $B$r:n$k!#(B
Example:
  (sck-asl-make-coalesceable-edges 
    (sck-asl-make-bblocks sck=asl-program-sample))"
  (let ((edges nil))
    (dolist (b bblocks)
      (let ((insts (sck-asl-bblock-insts b)))
	(setq edges
	      (union edges
		     (mapcar '(lambda (setqxy)
				(list (symbol-name (cadr setqxy))
				      (symbol-name (caddr setqxy))))
			     (filter '(lambda (inst)
					(and (eq (car inst) 'setq)
					     (sck-asl-vreg-p (cadr inst))
					     (sck-asl-vreg-p (caddr inst))))
				     insts))
		     :test 'equal))))
    edges))

(defun sck-asl-inst-defrefs (inst)
  "inst $B$N(B out $B$H(B in $B$N2>A[%l%8%9%?$N%j%9%H$rJV$9!#(B
  (sck-asl-inst-defrefs '(setq a (+ b c)))
  => ((\"a\") (\"b\" \"c\"))
  (sck-asl-inst-defrefs '(setq RET (+ b (* c d E))))
  => (nil (\"b\" \"c\" \"d\"))
  (sck-asl-inst-defrefs '(jump L1))
  => (nil nli)
  (sck-asl-inst-defrefs '(jumpc (< a b) L1 L2))
  => (nil (\"a\" \"b\"))"
  (case (car inst)
    (setq
     (list (mapcar 'symbol-name
		   (filter 'sck-asl-vreg-p (list (cadr inst))))
	   (filter 'sck-asl-vreg-p
		   (nreverse (remove-duplicates
			      (sck-asl-expr-vars (caddr inst)))))))
    (jump
     (list nil nil))
    (jumpc
     (let ((c (sck-asl-inst-defrefs `(setq DUMMY ,(cadr inst)))))
       (list nil (cadr c))))
    (t
     (error "sck-asl-inst-defrefs: illegal instruction: %S" inst))))


(defun sck-asl-expr-vars (expr)
  "EmacsLisp $B$N%U%)!<%`(B expr $B$G;2>H$5$l$F$$$kJQ?t$NL>A0$N%j%9%H$rJV$9!#(B
Example:
  (sck-asl-expr-vars '(list a (cons b '(c d)))) => (\"b\" \"a\")"
  (mapcar 'symbol-name
	  (with-temp-buffer
	    (let ((vars nil)
		  (byte-compile-warnings nil))
	      
	      (disassemble `(lambda () ,expr) (current-buffer))
	      (while (re-search-forward "^[0-9]+\tvarref[ \t]+\\(.*\\)$" nil t)
		(push (intern (match-string 1)) vars))
	      vars))))
  
(defun sck-asl-all-vregs (bblocks)
  "$B4pK\%V%m%C%/%j%9%H(B BBLOCKS $B$K$"$kA4$F$N2>A[%l%8%9%?$N%j%9%H$rJV$9!#(B
Example:
  (sck-asl-all-vregs (sck-asl-make-bblocks sck=asl-program-sample))"
  (let ((allvars nil))
    (dolist (b bblocks)
      (let ((insts (sck-asl-bblock-insts b)))
	(setq allvars
	      (union allvars
		     (remove-duplicates
		      (remove nil (flat (mapcar 'sck-asl-inst-defrefs insts)))
		      :test 'equal)
		     :test 'equal))))
    allvars))

(defun sck-asl-make-interference-graph (bblocks)
  "$B4pK\%V%m%C%/%j%9%H(B BBLOCKS $B$+$i43>D%0%i%U$r:n$k!#(B 
Example:
  (sck-asl-make-interference-graph 
    (sck-asl-make-bblocks sck=asl-program-sample))"
  (let* ((bblocks (sck-asl-life-analysis bblocks))
	 (conflicts nil))
    (dolist (b bblocks)
      (let ((liveout (sck-asl-bblock-liveout b)))
	(dolist (inst (reverse (sck-asl-bblock-insts b)))
	  (let* ((defrefs (sck-asl-inst-defrefs inst))
		 (defs (car defrefs))
		 (refs (cadr defrefs)))
	    (dolist (ref (union liveout defs :test 'equal))
	      (dolist (def defs)
		(unless (equal def ref)
		  (pushnew (list def ref) conflicts :test 'equal))))
	    ;; defs $B$rH4$-!"(Brefs $B$rDI2C!#(B
	    (setq liveout (set-difference liveout defs :test 'equal)
		  liveout (union liveout refs :test 'equal))))
	;; liveout $B$O(B bblock-livein $B$KEy$7$$%O%:!#(B
	(unless (set-equal liveout (sck-asl-bblock-livein b))
	  (error "sck-asl-make-interference-graph: Assertion failed: liveout"))
	))
    ;;
    conflicts))


;;;
(provide 'sck-asl)
