;;;; ̌^`FbN
;;;; LastChange: Wed Apr 11 00:54:42 2007


(defun sck-ast-complete-expr (expr)
  ;; ɍꂽ EXPR:<sck-ast-expr> ^AKvȏCsB
  ;; expr ̌^ݒ肷B ^G[Ȃ error ^B
  ;; ͊ complete ς݂łƂB
  (let* (($ (sck-ast-expr-pos expr))
	 (cexpr (sck-ast-check-expr expr)))
    (unless cexpr
      (sck-ast-error "incompatible types")
      (setq cexpr expr)
      (setf (sck-ast-expr-type cexpr) 'error))
    cexpr))
    
(defun sck-ast-check-expr (expr)
  ;; ͊ complete ς݂̎B
  ;;  decay Aop ɂĒ`Ă镡 checkfun ĂяoB
  ;; ^G[̏ꍇ nil ԂB
  ;; I[o[[hĂȂ op ɂāAG[ꍇ
  ;; S checkfun ŃG[oAerror ^̎ƂĕԂB
  ;; Return: <sck-ast-expr> | nil
  (block return
    (let (($ (sck-ast-expr-pos expr)))
      ;;
      ;;  args  error Ȃ`FbNȂB
      ;; ܂A void lƂĎgꂽG[B
      ;;
      (dolist (a (sck-ast-expr-args expr))
	(cond
	 ((eq (sck-ast-expr-type a) 'error)
	  (setf (sck-ast-expr-type expr) 'error)
	  (return-from return expr))
	 ((sck-ast-void-type-p (sck-ast-expr-type a))
	  ;;  comma ̌
	  (sck-ast-error "void value is used")
	  (setf (sck-ast-expr-type expr) 'error)
	  (return-from return expr))))
      ;;
      ;; &, sizeof, ȊȎSĂ̈ decay 
      ;;
      (let* ((op (sck-ast-expr-op expr))
	     (setopp (memq op '(set setadd setsub setmul setdiv setmod setband
				    setbor setbxor setlsh setrsh preinc predec
				    posinc posdec)))
	     (i 0))
	(unless (memq op '(sizeof addr))
	  (dorest (ap (sck-ast-expr-args expr))
	    (unless (and setopp (= i 0))
	      (setf (car ap) (sck-ast-make-decay-expr (car ap))))
	    (incf i))))
      ;;
      ;; op ɒ`Ă checkfun KpB
      ;;
      (let ((checkfuns (sck-ast-get-checkfuns (sck-ast-expr-op expr)))
	    (retexpr nil))
	(dolist (checkfun checkfuns)
	  (when (setq retexpr (funcall checkfun expr))
	    (return-from return retexpr)))
	;;
	retexpr))))


	 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; ȉA^`FbN֐

;;; ЂƂÂ checkfun  apply A͂߂Ă non-nil
;;; (expr-p ̂͂) ʂƂȂB ̂悤Ȃ̂Ȃ΃G[łB
;;; checkfun ׂ̂Ƃ͈Ȃ expr-type ̃ZbgB
;;; ꍇɂV expr \AԂB
;;; D܂Ȃꍇ nil ԂBG[̎wE͂ȂB
;;; ̑IȂꍇ́Atype  error ɃZbg expr Ă悢B

(defconst sck=ast-checkfuns
  '(((const ident sizeof) (sck-ast-check-nocheck))
    ;; (type)
    ((cast) (sck-ast-check-cast)) ; (type)
    ((conv) (sck-ast-check-conv)) ; p[TIɐ
    ;; + - * /
    ((uadd neg mul div) (sck-ast-check-n+-n))
    ;; ~ % & | ^
    ((bnot mod band bor bxor)  (sck-ast-check-i+-i))
    ;; << >>
    ((lsh rsh) (sck-ast-check-shift))
    ;; ! && ||
    ((lnot land lor) (sck-ast-check-b+-b))
    ;; == != < <= >= >
    ((tsteq tstne tstlt tstle tstge tstgt)
     (sck-ast-check-nn-b sck-ast-check-pp-b))
    ;; + -
    ((add) (sck-ast-check-n+-n sck-ast-check-po-p sck-ast-check-op-p))
    ((sub) (sck-ast-check-n+-n sck-ast-check-po-p sck-ast-check-pp-o))
    ;; =
    ((set)    (sck-ast-check-set))
    ;; ++ --
    ((preinc) (sck-ast-check-preinc))
    ((predec) (sck-ast-check-predec))
    ((posinc) (sck-ast-check-posinc))
    ((posdec) (sck-ast-check-posdec))
    ;; = += -= *= /= %= &= |= ^= <<= >>=
    ((setadd setsub setmul setdiv setmod setband setbor setbxor setlsh setrsh)
     (sck-ast-check-setop))
    ;; ,
    ((comma) (sck-ast-check-comma))
    ;; ?:
    ((cond) (sck-ast-check-cond))
    ;; [] . ->
    ((aref) (sck-ast-check-aref))
    ((member) (sck-ast-check-member))
    ((pmember) (sck-ast-check-pmember))
    ;; & *
    ((addr) (sck-ast-check-addr))
    ((mem) (sck-ast-check-mem))
    ;; call
    ((call) (sck-ast-check-call))))

    
(defun sck-ast-get-checkfuns (op)
  ;;  (with-cache "(sck-ast-get-checkfuns op)" op
  (block return
    (dolist (e sck=ast-checkfuns)
      (when (memq op (car e))
	(return-from return (cadr e))))
    (assert nil)))

(defun sck-ast-check-nocheck (expr)
  ;; const, ident, sizeof ͍쐬Ƀ`FbNς݁B
  (assert (memq (sck-ast-expr-op expr) '(const ident sizeof)))
  expr)


(defun sck-ast-check-cast (expr)
  ;; Iȕϊ
  (setf (sck-ast-expr-op expr) 'conv) ; op  conv 
  (sck-ast-check-conv-aux expr t))

(defun sck-ast-check-conv (expr)
  ;; ÖٓIip[T}jϊ
  (sck-ast-check-conv-aux expr nil))

(defun sck-ast-check-conv-aux (expr explicit)
  ;; łɍĂ܂ conv m[ȟ^ϊ\ǂׂB
  ;; ϊs\ȂG[wEB
  ;; nil ͕ԂȂB
  ;; explicit Non-nil Ȃ疾IȕϊB
  (assert (eq (sck-ast-expr-op expr) 'conv))
  (let* ((x (car (sck-ast-expr-args expr)))
	 (xtype (sck-ast-skip-typedef-and-qual (sck-ast-expr-type x)))
	 (ytype (sck-ast-skip-typedef-and-qual (sck-ast-expr-type expr)))
	 (xptype (sck-ast-pointer-type-p xtype))
	 (yptype (sck-ast-pointer-type-p ytype)))
    (assert (and xtype ytype))
    (cond
     ;; error ̓X[B
     ((or (eq xtype 'error) (eq ytype 'error)) expr)
     ;; void ւ̕ϊ͉\B
     ((eq ytype 'void)
      (unless explicit
	(sck-ast-warning "implicit conversion to void"))
      expr)
     ;; void  void ȊOւ̕ϊ͕s\B
     ((eq xtype 'void)
      ;; G[bZ[W͏oĂ͂B
      expr)
     ;; XJ[^ȊOł͕ϊs\B
     ((or (not (sck-ast-scalar-type-p xtype))
	  (not (sck-ast-scalar-type-p ytype)))
      (sck-ast-error "illegal type conversion")
      expr)
     ;;
     ;; ȉAƂXJ[^B
     ;;
     ;; |C^B
     ;;
     ((and xptype yptype)
      (cond
       ;; [jOsv
       (explicit expr)
       ;; ÖٓIȏꍇA^Ă΃[jOoB
       (t
	(when xptype
	  (unless (or (sck-ast-type-equal xtype ytype)
		      (sck-ast-pointer-to-void-type-p xtype))
	    (sck-ast-warning
	     "implicit conversion to incompatible pointer type"))
	  ;; ȉ̃`FbN͕ϊłȂŃ`FbNB
	  ;; (when (and (sck-ast-pointer-to-const-type-p xtype)
	  ;; (not (sck-ast-pointer-to-const-type-p ytype)))
	  ;; (sck-ast-warning
	  ;; "implicit conversion discarding const qualifier"))
	  ;; (when (and (sck-ast-pointer-to-volatile-type-p xtype)
	  ;; (not (sck-ast-pointer-to-volatile-type-p ytype)))
	  ;; (sck-ast-warning
	  ;; "implicit conversion discarding volatile qualifier"))
	  )
	expr)))
     ;;
     ;; ȂƂ|C^^B
     ;;
     ((or xptype yptype)
      (cond
       ;; integral-scalar ԂȂ烏[jOłƂɂϊ͉\B
       ((and (sck-ast-integral-scalar-type-p xtype)
	     (sck-ast-integral-scalar-type-p ytype))
	(cond
	 ;; [jOsv
	 (explicit expr)
	 ;; ȉÖٓIȕϊB
	 ;; 0 ͔Cӂ̃|C^փ[jOȂŕϊ\B
	 ((and (sck-ast-integral-zero-expr-p x) yptype) expr)
	 ;; ÖٓIȂ炱ȊOł̓[jOB
	 (t
	  (sck-ast-warning "implicit conversion from %s to %s"
			   (sck-ast-type-to-msgstr xtype)
			   (sck-ast-type-to-msgstr ytype))))
	expr)
       ;;
       ;;  integral łȂ (floating-types) XJ[̏ꍇB
       ;; IłĂ_B
       (t
	(sck-ast-error "illegal type conversion between pointer and floating")
	expr)))
     ;;
     ;; ȉAƂ|C^ȊÕXJ^B
     ;;
     ;; Zp^mȂ OK B
     ((and (sck-ast-adjust-arith-type xtype)
	   (sck-ast-adjust-arith-type ytype))
      expr)
     ;;
     ;; cP[X enum ܂̓XJ^B
     ;; ÖٓIłĂ OKB
     ;;
     (t
      expr))))
     


;;; sch-cps-check-X-Y
;;; i - integral type
;;; n - arith type
;;; e - enum type
;;; p - pointer type
;;; b - boolean type
;;; o - offset type (sck=ast-pointer-implement-type)


(defun sck-ast-check-i+-i (expr)
  (let* ((args (sck-ast-expr-args expr))
	 (type (sck-ast-integral-type-p
		(apply 'sck-ast-adjust-arith-type
		       (mapcar 'sck-ast-expr-type args)))))
    (cond
     ((null type) nil)
     (t
      (setf (sck-ast-expr-type expr) type
	    (sck-ast-expr-args expr) (mapcar
				      #'(lambda (a)
					  (sck-ast-make-conv-expr type a))
				      args))
      expr))))

(defun sck-ast-adjust-arith-args (args)
  ;; sck-ast-adjust-arith-type Ō^킹݂B
  ;; Ȃ nil
  (let ((type (apply 'sck-ast-adjust-arith-type
		     (mapcar 'sck-ast-expr-type args))))
    (cond
     (type
      (mapcar #'(lambda (a) (sck-ast-make-conv-expr type a)) args))
     (t
      nil))))

(defun sck-ast-check-n+-n (expr)
  (let* ((args (sck-ast-expr-args expr))
	 (adjargs (sck-ast-adjust-arith-args args)))
    (cond
     ((null adjargs) nil)
     (t
      (setf (sck-ast-expr-type expr) (sck-ast-expr-type (car adjargs))
	    (sck-ast-expr-args expr) adjargs)
      ;; uadd 
      (when (eq (sck-ast-expr-op expr) 'uadd)
	(setq expr (car args)))
      expr))))

(defun sck-ast-check-shift (expr)
  (let* ((args (sck-ast-expr-args expr))
	 (x (car args))
	 (y (cadr args))
	 (type (sck-ast-integral-type-p
		;; x<<y ̌^ x ̌^  y  sck=ast-shiftwidth-type
		(sck-ast-adjust-arith-type (sck-ast-expr-type x)))))
    (cond
     ((null type) nil)
     (t
      (setf (sck-ast-expr-type expr) type
	    (sck-ast-expr-args expr) (list
				      (sck-ast-make-conv-expr type (car args))
				      (sck-ast-make-conv-expr
				       sck=ast-shiftwidth-type
				       y)))
      expr))))

(defun sck-ast-check-nn-b (expr)
  (let* ((args (sck-ast-expr-args expr))
	 (type (apply 'sck-ast-adjust-arith-type
		      (mapcar 'sck-ast-expr-type args))))
    (cond
     ((null type) nil)
     (t
      (setf (sck-ast-expr-type expr) sck=ast-boolean-type
	    (sck-ast-expr-args expr) (mapcar
				      #'(lambda (a)
					  (sck-ast-make-conv-expr type a))
				      args))
      expr))))


(defun sck-ast-adjust-pointer-args (args)
  ;; tstXX  y cond  : ̗̈ X, Y ɂāA
  ;; X, Y ̏ȂƂ pointer ^̏ꍇ̌^킹݂B
  ;; s\Ȃ nil
  ;; Return: (X' Y') | nil
  (let* ((x (car args))
	 (y (cadr args))
	 (xtype (sck-ast-expr-type x))
	 (xptype (sck-ast-pointer-type-p xtype))
	 (ytype (sck-ast-expr-type y))
	 (yptype (sck-ast-pointer-type-p ytype)))
    (cond
     ;; Ƃ|C^łȂ
     ((not (or xptype yptype)) nil)
     ;; Ƃ|C^
     ((and xptype yptype)
      (cond
       ;; ^v
       ((sck-ast-type-equal xtype ytype)
	(list x y))
       ;;  void*
       ((or (sck-ast-pointer-to-void-type-p xtype)
	    (sck-ast-pointer-to-void-type-p ytype))
	(let ((nvtype (if (sck-ast-pointer-to-void-type-p xtype)
			  ytype
			xtype)))
	  ;; void* łȂ֌^킹
	  (mapcar #'(lambda (a) (sck-ast-make-conv-expr nvtype a)) args)))
       ;; ȊO̓_
       (t nil)))
     ;; ^
     ((or (sck-ast-integral-type-p xtype)
	  (sck-ast-integral-type-p ytype))
      (let ((ptype (or xptype yptype)))
	;; |C^֌^킹
	(mapcar #'(lambda (a) (sck-ast-make-conv-expr ptype a)) args)))
     ;; ȊO͂
     (t
      nil))))

(defun sck-ast-check-pp-b (expr)
  (let ((adjargs (sck-ast-adjust-pointer-args (sck-ast-expr-args expr))))
    (cond
     (adjargs
      (setf (sck-ast-expr-type expr) sck=ast-boolean-type
	    (sck-ast-expr-args expr) adjargs)
      expr)
     (t
      ;;  GCC ͈قȂ^ pointer m̔r warning...
      nil))))

(defun sck-ast-check-b+-b (expr)
  (setf (sck-ast-expr-type expr) sck=ast-boolean-type)
  (setf (sck-ast-expr-args expr)
	(mapcar 'sck-ast-make-conv-bool-expr (sck-ast-expr-args expr)))
  expr)

(defun sck-ast-check-po-p (expr)
  (let* ((args (sck-ast-expr-args expr))
	 (x (car args))
	 (xtype (sck-ast-skip-typedef-and-qual (sck-ast-expr-type x)))
	 (y (cadr args))
	 (type (sck-ast-pointer-type-p xtype)))
    (cond
     ((not (and type (sck-ast-integral-type-p (sck-ast-expr-type y))))
      nil)
     (t
      (setf (sck-ast-expr-type expr) (sck-ast-expr-type x)
	    (cadr args) (sck-ast-make-conv-expr sck=ast-pointer-implement-type
						y))
      expr))))

(defun sck-ast-check-op-p (expr)
  (let ((xexpr (copy-sck-ast-expr expr)))
    (setf (sck-ast-expr-args xexpr) (reverse (sck-ast-expr-args xexpr)))
    (setq xexpr (sck-ast-check-po-p xexpr))
    (cond
     (xexpr
      (setf (sck-ast-expr-args xexpr) (reverse (sck-ast-expr-args xexpr)))
      xexpr)
     (t
      nil))))

(defun sck-ast-check-pp-o (expr)
  (let* ((args (sck-ast-expr-args expr))
	 (x (car args))
	 (y (cadr args)))
    (cond
     ((and (sck-ast-pointer-type-p (sck-ast-expr-type x))
	   (sck-ast-type-equal (sck-ast-expr-type x) (sck-ast-expr-type y)))
      (setf (sck-ast-expr-type expr) sck=ast-pointer-implement-type)
      expr)
     (t
      nil))))

(defun sck-ast-check-addr (expr)
  (let ((x (car (sck-ast-expr-args expr))))
    (cond
     ((sck-ast-lvalue-expr-p x)
      (setf (sck-ast-expr-type expr) `(pointer ,(sck-ast-expr-type x)))
      (when (eq (sck-ast-expr-op x) 'vref)
	(let ((ident (sck-ast-expr-value x)))
	  (when (eq (sck-ast-ident-sc ident) 'register)
	    (sck-ast-warning "cannot take address of register varialbe `%s'"
			     (sck-ast-ident-name ident))
	    (setf (sck-ast-ident-sc ident) nil)))
	(setf (sck-ast-ident-addrp (sck-ast-expr-value x)) '&)))
     (t
      (sck-ast-error "not lvalue")
      (setf (sck-ast-expr-type expr) 'error)))
    expr))

(defun sck-ast-check-mem (expr)
  (let ((xtype (sck-ast-expr-type (car (sck-ast-expr-args expr)))))
    (setq xtype (sck-ast-pointer-type-p xtype))
    (cond
     ((not xtype) nil)
     (t
      (setf (sck-ast-expr-type expr) (cadr xtype))
      (unless (sck-ast-sizeof (sck-ast-expr-type expr))
	;; sS^̏ꍇ̂[bZ[W̉ǂKvB
	(sck-ast-error "unknown size of pointer object type")
	(setf (sck-ast-expr-type expr) 'error))
      expr))))

(defun sck-ast-check-aref (expr)
  ;; v[i]  *(v+i) ̃V^bNXVK[ƂĈB
  (sck-ast-make-mem-expr
   (sck-ast-complete-expr
    (sck-ast-make-expr 'add :args (sck-ast-expr-args expr)))))

(defun sck-ast-check-cond (expr)
  (let* ((args (sck-ast-expr-args expr))
	 (adjargs (or (sck-ast-adjust-arith-args (cdr args))
		      (sck-ast-adjust-pointer-args (cdr args)))))
    (cond
     (adjargs
      (setf (sck-ast-expr-type expr) (sck-ast-expr-type (car adjargs))
	    (sck-ast-expr-args expr) (cons
				      (sck-ast-make-conv-bool-expr (car args))
				      adjargs))
      expr)
     (t
      nil))))

(defun sck-ast-check-comma (expr)
  (setf (sck-ast-expr-type expr)
	(sck-ast-expr-type (cadr (sck-ast-expr-args expr))))
  expr)

(defun sck-ast-check-set (expr)
  (let* ((args (sck-ast-expr-args expr))
	 (x (car args))
	 (xtype (sck-ast-expr-type x))
	 (y (cadr args)))
    (cond
     ((not (sck-ast-lvalue-expr-p x))
      (sck-ast-error "not lvalue")
      (setf (sck-ast-expr-type expr) 'error)
      expr)
     (t
      (when (sck-ast-const-type-p xtype)
	(sck-ast-warning "assignment to const-qualified object"))
      (setf (sck-ast-expr-type expr) xtype
	    (sck-ast-expr-args expr) (list x (sck-ast-make-conv-expr xtype y)))
      expr))))


(defun sck-ast-check-preinc (expr)
  (sck-ast-check-idc-aux expr 'pref 'setadd))

(defun sck-ast-check-predec (expr)
  (sck-ast-check-idc-aux expr 'pref 'setsub))

(defun sck-ast-check-posinc (expr)
  (sck-ast-check-idc-aux expr 'posf 'setadd))

(defun sck-ast-check-posdec (expr)
  (sck-ast-check-idc-aux expr 'posf 'setsub))

(defun sck-ast-check-idc-aux (expr prepos op)
  (let* ((args (sck-ast-expr-args expr))
	 (type (sck-ast-scalar-type-p (sck-ast-expr-type (car args)))))
    (if (null type)
	nil
      (sck-ast-check-setop-aux
       (sck-ast-make-expr
	op
	:args (list (car args)
		    (sck-ast-make-nconst-expr (cond
					       ((sck-ast-pointer-type-p type)
						sck=ast-pointer-implement-type)
					       ((sck-ast-enum-type-p type)
						sck=ast-enum-implement-type)
					       (t
						type))
					      1)))
       prepos))))

(defun sck-ast-check-setop (expr)
  (sck-ast-check-setop-aux expr 'pref))

(defun sck-ast-check-setop-aux (expr prepos)
  (let* ((args (sck-ast-expr-args expr))
	 (x (car args))
	 (y (cadr args))
	 (op1 (let ((a (assq (sck-ast-expr-op expr)
			     '((setadd add) (setsub sub) (setmul mul)
			       (setdiv div) (setmod mod) (setband band)
			       (setbxor bxor) (setbor bor) (setlsh lsh)
			       (setrsh rsh)))))
		(assert a)
		(cadr a)))
	 (expr1 (sck-ast-check-expr (sck-ast-make-expr op1 :args args))))
    (cond
     ((null expr1) nil)
     ;; expr = (set(op1) x y)
     ;; expr1 = (op1 x y)
     (t
      ;; expr2 = (set x expr1)
      (let* ((expr2 (sck-ast-complete-expr
		     (sck-ast-make-expr 'set
					:args (list x expr1)))))
	;; (pref/posf (op1 x y)) or (pref/posf (convX (op1 (convX x) y)))
	(sck-ast-make-expr prepos
			   :type (sck-ast-expr-type x)
			   :args (cdr (sck-ast-expr-args expr2))))))))
     
(defun sck-ast-check-member (expr)
  (let* ((args (sck-ast-expr-args expr))
	 (su (car args))
	 (m (cadr args))
	 (sutype (sck-ast-struct-or-union-type-p (sck-ast-expr-type su))))
    (cond
     ((not sutype)
      (sck-ast-error "not a struct/union")
      (setf (sck-ast-expr-type expr) 'error)
      expr)
     ((null (cadr sutype))
      (sck-ast-error "illegal usage of incomplete %s" (car sutype))
      (setf (sck-ast-expr-type expr) 'error)
      expr)
     (t
      (assert (eq (sck-ast-expr-op m) 'vref))
      (let* ((mname (sck-ast-ident-name (sck-ast-expr-value m)))
	     (mident (sck-ast-search-ident (cadr sutype) mname t)))
	(cond
	 ((null mident)
	  (sck-ast-error "no such member `%s'" mname)
	  (setf (sck-ast-expr-type expr) 'error)
	  expr)
	 (t
	  (setf (sck-ast-expr-type expr)
		(sck-ast-merge-type-quals (sck-ast-ident-type mident)
					  (sck-ast-type-quals
					   (sck-ast-expr-type su))))
	  (setf (cadr (sck-ast-expr-args expr))
		(sck-ast-make-vref-expr mident))
	  ;;
	  expr)))))))


(defun sck-ast-check-pmember (expr)
  ;; p->m  (*p).m ̃V^bNXVK[ƂĈB
  (sck-ast-complete-expr
   (sck-ast-make-expr 'member
		      :args (list (sck-ast-make-mem-expr
				   (car (sck-ast-expr-args expr)))
				  (cadr (sck-ast-expr-args expr))))))

(defun sck-ast-check-call (expr)
  (let* ((args (sck-ast-expr-args expr))
	 (fun (car args))
	 (fargs (cdr args))
	 (fptype nil)
	 (fargtypes nil)
	 (fargtype nil)
	 (convarg nil)
	 (convargs nil)
	 (ftype nil))
    ;;
    (setq fptype (sck-ast-skip-typedef-and-qual (sck-ast-expr-type fun)))
    ;;
    (cond
     ((not (sck-ast-pointer-to-function-type-p fptype))
      (sck-ast-error "illegal function")
      (setf (sck-ast-expr-type expr) 'error)
      expr)
     (t
      (setq ftype (sck-ast-skip-typedef-and-qual (cadr fptype))
	    fargtypes (cadr ftype))
      (setf (sck-ast-expr-type expr) (caddr ftype))
      ;;
      (cond
       ((null fargtypes)
	(setq fargtype 'varargs))
       ((sck-ast-void-type-p (car fargtypes))
	(setq fargtypes nil)))
      ;;
      (dolist (a fargs)
	(unless (eq fargtype 'varargs)
	  (setq fargtype (pop fargtypes)))
	(when (null fargtype)
	  (sck-ast-error "too many arguments")
	  ;; break dolist
	  (return))
	(cond
	 ((eq fargtype 'varargs)
	  (setq convarg
		(sck-ast-make-conv-expr
		 (or (sck-ast-adjust-arith-type (sck-ast-expr-type a))
		     (sck-ast-expr-type a))
		 a)))
	 (t
	  ;; ǂbZ[W̌
	  ;; cperror("%Tincompatible type for %d-th parameter of function %T",
	  (setq convarg (sck-ast-make-conv-expr fargtype a))))
	;;
	(push convarg convargs))
      (setq convargs (nreverse convargs))
      ;;
      (when (and fargtypes
		 (not (eq (car fargtypes) 'varargs)))
	(sck-ast-error "too few arguments"))
      ;;
      (setf (sck-ast-expr-args expr) (cons fun convargs))
      ;;
      expr))))

	
;;;
(provide 'sck-ast-check)
