;;;; ԃR[ĥ߂̃vO̊ȗ
;;;; internal form  AST ̕ϊ
;;;; LastChange: Fri Apr 13 00:42:39 2007


;;; per module

(defvar sck*ast-reduce-global-env nil)
(defvar sck*ast-reduce-generated-labels nil)
(defvar sck*ast-reduce-sconst-alist nil)


(defun sck-ast-reduce (cps-output)
  "cps ̏o CPS-OUTPUT  reduce B
R}hƂċNꂽꍇ̓|Cgȉ S- CPS-OUTPUT ɂȂA
ʂobt@ɕ\B"
  (interactive (list (save-excursion (read (current-buffer)))))
  (sck-letalist cps-output
      (ast messages)
    (assert (eq (car-safe ast) 'module))
    (let ((rast nil)
	  (output nil))
      (cond
       ;; G[NĂA(module <Name>) ɂĂ܂B
       ((sck-ast-error-in-messages-p messages)
	(setq rast (copy-tree `(module ,(cadr ast)))))
       ;; m[}P[X
       (t
	(setq rast
	      (sck-ast-module-to-sexp
	       (sck-ast-reduce-module
		(sck-ast-sexp-to-module ast))))))
      ;;
      (setq output `((ast ,rast)
		     (messages ,messages)))
      ;;
      (when (interactive-p)
	(with-display-buffer "*sck-ast-reduce*"
	  (sck-ast-font-lock)
	  (insert (sck-ast-pp-output output))))
      ;;
      output)))

(defun sck-ast-reduce-module (module)
  (assert (eq (car-safe module) 'module))
  (let* ((sck*ast-reduce-global-env (caddr module))
	 (sck*ast-reduce-generated-labels nil)
	 (sck*ast-reduce-sconst-alist nil)
	 (gidentq (sck-ast-env-identq sck*ast-reduce-global-env))
	 (newidentq (make-que)))
    (dolist (ident (copy-list
		    ;;  copy-list  reduce ̒ǉ𖳎邽߁B
		    ;; ͕ʏ ident ́uOvɒǉB
		    (que-to-list gidentq))) 
      (when (and (eq (sck-ast-ident-kind ident) 'var)
		 (sck-ast-ident-value ident))
	(let ((savedlast (que-last gidentq))) ;  que-last ...
	  (setf (sck-ast-ident-value ident)
		(sck-ast-reduce-ident-value (sck-ast-ident-value ident)))
	  ;; reduce ɒǉĂ΁A
	  (unless (eq savedlast (que-last gidentq)) ;  que-last ...
	    ;; last ߂A
	    (setf (que-last gidentq) savedlast) ;  que-last ...
	    ;; ǉ ident ̑OɒǉB
	    (append-que-list newidentq (cdr savedlast)))))
      (append-que newidentq ident))
    ;;
    ;; reduce ł̒ǉ܂ newidentq ɍւB
    ;;
    (setf (sck-ast-env-identq sck*ast-reduce-global-env) newidentq)
    ;;
    ;; œK
    ;;
    (setq module (sck-ast-reduce-jopt-module module))
    ;;
    module))


(defun sck-ast-reduce-ident-value (value)
  (cond
   ((eq (car-safe value) 'lambda)
    (sck-ast-reduce-lambda value))
   ((sck-ast-expr-p value)
    (sck-ast-reduce-static-init-expr value))
   ((eq (car value) 'inits)
    (dorest (ep (cdr value))
      (when (sck-ast-expr-p (car ep))
	(setf (car ep) (sck-ast-reduce-static-init-expr (car ep)))))
    value)
   (t
    (assert nil))))
  

(defun sck-ast-reduce-static-init-expr (expr)
  (assert (sck-ast-expr-p expr))
  (multiple-value-bind (pres expr1 poss)
      (sck-ast-reduce-expr expr nil nil t)
    (assert (and (null pres) (null poss)))
    expr1))


(defun sck-ast-reduce-renamed-global-name (name)
  (make-new-name #'(lambda (n)
		       (sck-ast-search-ident sck*ast-reduce-global-env n))
		   name
		   "_"))

(defun sck-ast-reduce-new-sconst-ident-name ()
  (make-new-name #'(lambda (n)
		       (sck-ast-search-ident sck*ast-reduce-global-env n))
		   "S"))

(defun sck-ast-reduce-newlabel ()
  (let ((newname (make-new-name
		  #'(lambda (n)
		      (or (member n sck*ast-reduce-generated-labels)
			  (sck-ast-search-ident sck*ast-reduce-global-env n)))
		  "L")))
    (push newname sck*ast-reduce-generated-labels)
    newname))



;;; per function

(defvar sck*ast-reduce-param-env nil)
(defvar sck*ast-reduce-local-env nil)
(defvar sck*ast-reduce-label-alist nil)
(defvar sck*ast-reduce-stmt-alist nil)
(defvar sck*ast-reduce-prologue-label nil)
(defvar sck*ast-reduce-epilogue-label nil)
(defvar sck*ast-reduce-epilogue-tmp nil)

(defun sck-ast-reduce-lambda (lambda)
  ;; LAMBDA: (lambda <Type> (<Declaration>..) <BlockStmt>)
  (let* ((type (cadr lambda))
	 (block (cadddr lambda))
	 (sck*ast-reduce-param-env (caddr lambda))
	 (sck*ast-reduce-local-env (sck-ast-make-env sck*ast-reduce-param-env))
	 (sck*ast-reduce-label-alist nil)
	 (sck*ast-reduce-stmt-alist nil)
	 (sck*ast-reduce-prologue-label (sck-ast-reduce-newlabel))
	 (sck*ast-reduce-epilogue-label (sck-ast-reduce-newlabel))
	 (sck*ast-reduce-epilogue-tmp (if (sck-ast-void-type-p
					   (caddr type))
					  nil
					(sck-ast-reduce-newregister
					 (caddr type))))
	 (stmts nil))
    ;;
    ;; gbvx block  reduce A̗ɂB
    ;;
    (setq stmts `((label ,sck*ast-reduce-prologue-label)
		  ,@(sck-ast-reduce-block block)
		  (label ,sck*ast-reduce-epilogue-label)
		  (return ,sck*ast-reduce-epilogue-tmp)))
    ;;
    ;; sck*ast-reduce-{param,local}-env  sc ̐K
    ;;
    ;; R[h̐
    (dolist (ident (append (sck-ast-env-idents sck*ast-reduce-param-env)
			   (sck-ast-env-idents sck*ast-reduce-local-env)))
      (when (eq (sck-ast-ident-kind ident) 'var)
	(cond
	 ;; sc = extern, static ͂̂܂
	 ((memq (sck-ast-ident-sc ident) '(extern static)))
	 ;; XJ^ȊO auto
	 ((not (sck-ast-scalar-type-p (sck-ast-ident-type ident)))
	  (setf (sck-ast-ident-sc ident) 'auto))
	 ;; AhXĂ auto
	 ;; p[^̃AhXꂽꍇ̏KvB
	 ((sck-ast-ident-addrp ident)
	  (setf (sck-ast-ident-sc ident) 'auto))
	 ;; ̑ register
	 (t
	  (setf (sck-ast-ident-sc ident) 'register)))))
    ;;
    ;; stmts 󕶂폜
    ;;
    (setq stmts (remq nil stmts))
    ;;
    ;; stmt {ubN̋K𖞂悤ɂF
    ;;   אڂ{ubN͑O҂ŏIA҂xŎn܂邱ƁB
    ;;
    (let ((newstmts (make-que))
	  (prevstmt nil))
      (dolist (s stmts)
	(cond
	 ;; s = xA̒OłȂȂA
	 ((and (eq (car-safe s) 'label)
	       prevstmt
	       (not (memq (car-safe prevstmt) '(goto if))))
	  ;; }B
	  (append-que newstmts `(goto ,(cadr s))))
	 ;; s = xȊOA̒OȂA
	 ((and (not (eq (car-safe s) 'label))
	       prevstmt
	       (memq (car-safe prevstmt) '(goto if)))
	  ;; x}B
	  ;; ۂɂ͂̃ubN͓Bs\łB
	  (append-que newstmts `(label ,(sck-ast-reduce-newlabel)))))
	;; 
	(append-que newstmts s)
	(setq prevstmt s))
      ;;
      (setq stmts (que-to-list newstmts)))
    ;;
    `(lambda ,type ,sck*ast-reduce-param-env
       (block ,sck*ast-reduce-local-env ,@stmts))))



(defun sck-ast-reduce-renamed-local-name (name)
  (make-new-name
   #'(lambda (n)
       (or (sck-ast-search-ident sck*ast-reduce-param-env n t)
	   (sck-ast-search-ident sck*ast-reduce-local-env n t)))
   
   name
   "_"))

(defun sck-ast-reduce-new-local-name ()
  (make-new-name
   #'(lambda (n)
       (or (sck-ast-search-ident sck*ast-reduce-param-env n t)
	   (sck-ast-search-ident sck*ast-reduce-local-env n t)))
   "_"))


(defun sck-ast-reduce-get-labelname (gotolabel)
  ;; (sck-ast-reduce-get-labelname "exitt")
  (let ((a (assoc gotolabel sck*ast-reduce-label-alist)))
    (unless a
      (push (setq a (list gotolabel (sck-ast-reduce-newlabel)))
	    sck*ast-reduce-label-alist))
    (cadr a)))

(defun sck-ast-reduce-newregister (type)
  (assert (sck-ast-scalar-type-p type))
  (let* ((name (sck-ast-reduce-new-local-name))
	 (ident (sck-ast-make-ident `(ident ($ 0 0) ,name)
				    :kind 'var
				    :type type
				    :sc 'register)))
    (sck-ast-enter-ident sck*ast-reduce-local-env ident)
    ;;
    (sck-ast-make-vref-expr ident)))

(defun sck-ast-reduce-newauto (type)
  (let* ((name (sck-ast-reduce-new-local-name))
	 (ident (sck-ast-make-ident `(ident ($ 0 0) ,name)
				    :kind 'var
				    :type type
				    :sc 'auto)))
    (sck-ast-enter-ident sck*ast-reduce-local-env ident)
    ;;
    (sck-ast-make-vref-expr ident)))

(defun sck-ast-reduce-newtmp (type)
  (if (sck-ast-scalar-type-p type)
      (sck-ast-reduce-newregister type)
    (sck-ast-reduce-newauto type)))


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;  reduce

(defun sck-ast-reduce-stmt (stmt)
  ;; Return: (<Stmt>..)
  (cond
   ((sck-ast-expr-p stmt) (sck-ast-reduce-expr-stmt stmt))
   ((null stmt) nil)
   (t
    (ecase (car stmt)
      (block (sck-ast-reduce-block stmt))
      (if (sck-ast-reduce-if stmt))
      (switch (sck-ast-reduce-switch stmt))
      (case (sck-ast-reduce-case stmt))
      (default (sck-ast-reduce-default stmt))
      (while (sck-ast-reduce-while stmt))
      (do (sck-ast-reduce-do stmt))
      (for (sck-ast-reduce-for stmt))
      (break (sck-ast-reduce-break stmt))
      (continue (sck-ast-reduce-continue stmt))
      (label (sck-ast-reduce-label stmt))
      (goto (sck-ast-reduce-goto stmt))
      (return (sck-ast-reduce-return stmt))))))

(defun sck-ast-reduce-expr-stmt (expr)
  ;; ƂČ鎮 reduce
  ;; Return: (<Stmt>..)
  (multiple-value-bind (pres expr1 poss)
      (sck-ast-reduce-expr expr nil nil t)
    ;;  volatile...
    (append pres poss)))


(defun sck-ast-reduce-block (block)
  ;; Return: (<Stmt>..)
  (let ((blkenv (cadr block))
	(iast-stmts (cddr block))
	(stmtq (make-que)))
    ;;
    ;; initializer ̑𐶐B
    ;;
    (dolist (ident (sck-ast-env-idents blkenv))
      (when (and (eq (sck-ast-ident-kind ident) 'var)
		 (sck-ast-ident-value ident)
		 (not (eq (sck-ast-ident-sc ident) 'static)))
	(let ((value (sck-ast-ident-value ident)))
	  (setf (sck-ast-ident-value ident) nil)
	  ;;  [Jϐ (inits ...) ܂B
	  (assert (sck-ast-expr-p value)) 
	  (append-que-list stmtq
			     (sck-ast-reduce-stmt
			      (sck-ast-make-set-expr
			       (sck-ast-make-vref-expr ident)
			       value))))))
    ;;
    ;; blkenv  sck*ast-reduce-{local,global}-env ɈړB
    ;;
    (dolist (ident (sck-ast-env-idents blkenv))
      (let* ((sc (sck-ast-ident-sc ident))
	     (newname (funcall
		       (if (eq sc 'static)
			   'sck-ast-reduce-renamed-global-name
			 'sck-ast-reduce-renamed-local-name)
		       (sck-ast-ident-name ident))))
	(setf (sck-ast-ident-name ident) newname
	      (sck-ast-ident-env ident) nil)
	(sck-ast-enter-ident (if (eq sc 'static)
				 sck*ast-reduce-global-env
			       sck*ast-reduce-local-env)
			     ident)))
    ;;
    ;; body ̏B
    ;;
    (dolist (iast-stmt iast-stmts)
      (let ((stmts (sck-ast-reduce-stmt iast-stmt)))
	(append-que-list stmtq stmts)))
    ;;
    (que-to-list stmtq)))


(defun sck-ast-reduce-if (stmt)
  (let* ((expr (cadr stmt))
	 (then (caddr stmt))
	 (else (cadddr stmt))
	 (Lthen (sck-ast-reduce-newlabel))
	 (Lelse (sck-ast-reduce-newlabel))
	 (Lbreak (sck-ast-reduce-newlabel))
	 (estmts (sck-ast-reduce-expr-jump expr Lthen Lelse)))
    ;;
    `(,@estmts
      (label ,Lthen)
      ,@(sck-ast-reduce-stmt then)
      (goto ,Lbreak)
      (label ,Lelse)
      ,@(sck-ast-reduce-stmt else)
      ;; ̗̊{ubNK𖞂߂ɂ́A
      ;;  (goto ,Lbreak) }Kv邪A
      ;; XɑΏɂꍇ̂ŁA
      ;; ̂悤Ȏdグ̏͌ňꊇĂB
      (label ,Lbreak))))

(defun sck-ast-reduce-switch (stmt)
  (let* ((name (cadr stmt))
	 (expr (caddr stmt))
	 (type (sck-ast-expr-type expr))
	 (reg (sck-ast-reduce-newregister type))
	 (body (cadddr stmt))
	 (Lbreak (sck-ast-reduce-newlabel))
	 (switchtab `(,name ,Lbreak
			      ;; ȉ case, default ȉǉ
			      ;; (<default|<Integer> <String>)..
			    )))
    ;;
    (push switchtab sck*ast-reduce-stmt-alist)
    ;;
    (setq body (sck-ast-reduce-stmt body))
    ;;
    `(;; reg = expr
      ,@(sck-ast-reduce-expr-stmt
	 (sck-ast-make-set-expr reg expr))
	;; if ...
	,@(let* ((casealist (cddr switchtab))
		 (Ldefault (cadr (assoc 'default casealist)))
		 (jumps (make-que)))
	    ;; e case ɂ
	    (dolist (c casealist)
	      (unless (eq (car c) 'default)
		(let ((Lnext (sck-ast-reduce-newlabel)))
		  (append-que-list
		   jumps
		   `((if
			 ;; R[fBO
			 ,(sck-ast-complete-expr
			   (sck-ast-make-expr
			    'tsteq
			    :args (list reg
					(sck-ast-make-iconst-expr
					 type (car c)))))
			 ;;
			 (goto ,(cadr c)) (goto ,Lnext))
		     (label ,Lnext))))))
	    ;; default ̏
	    (append-que jumps
			  (if Ldefault
			      `(goto ,Ldefault)
			    `(goto ,Lbreak)))
	    ;;
	    (que-to-list jumps))
	;;
	,@body
	;;
	(label ,Lbreak))
    ;;
    ))
    

(defun sck-ast-reduce-case (stmt)
  (let ((cval (caddr stmt))
	(switchtab (assoc (cadr stmt) sck*ast-reduce-stmt-alist))
	(L (sck-ast-reduce-newlabel)))
    (assert switchtab)
    (nconc switchtab (list (list cval L)))
    ;;
    `((label ,L)
      ,@(sck-ast-reduce-stmt (cadddr stmt)))))

(defun sck-ast-reduce-default (stmt)
  (let ((switchtab (assoc (cadr stmt) sck*ast-reduce-stmt-alist))
	(L (sck-ast-reduce-newlabel)))
    (assert switchtab)
    (nconc switchtab (list (list 'default L)))
    ;;
    `((label ,L)
      ,@(sck-ast-reduce-stmt (caddr stmt)))))

(defun sck-ast-reduce-while (stmt)
  (let* ((name (cadr stmt))
	 (expr (caddr stmt))
	 (body (cadddr stmt))
	 (Lcontinue (sck-ast-reduce-newlabel))
	 (Lthen (sck-ast-reduce-newlabel))
	 (Lbreak (sck-ast-reduce-newlabel))
	 (estmts (sck-ast-reduce-expr-jump expr Lthen Lbreak)))
    (push `(,name ,Lbreak ,Lcontinue) sck*ast-reduce-stmt-alist)
    ;;
    `((label ,Lcontinue)
      ,@estmts
      ;;
      (label ,Lthen)
      ,@(sck-ast-reduce-stmt body)
      (goto ,Lcontinue)
      ;;
      (label ,Lbreak))))

(defun sck-ast-reduce-do (stmt)
  (let* ((name (cadr stmt))
	 (expr (caddr stmt))
	 (body (cadddr stmt))
	 (Lcontinue (sck-ast-reduce-newlabel))
	 (Lthen (sck-ast-reduce-newlabel))
	 (Lbreak (sck-ast-reduce-newlabel))
	 (estmts (sck-ast-reduce-expr-jump expr Lthen Lbreak)))
    (push `(,name ,Lbreak ,Lcontinue) sck*ast-reduce-stmt-alist)
    ;;
    `((label ,Lthen)
      ,@(sck-ast-reduce-stmt body)
      ;;
      (label ,Lcontinue)
      ,@estmts
      ;;
      (label ,Lbreak))))

(defun sck-ast-reduce-for (stmt)
  (let* ((name (cadr stmt))
	 (expr3 (caddr stmt))
	 (expr1 (elt expr3 0))
	 (expr2 (elt expr3 1))
	 (expr3 (elt expr3 2))
	 (body (cadddr stmt))
	 (Lthen (sck-ast-reduce-newlabel))
	 (Lbreak (sck-ast-reduce-newlabel))
	 (Lcontinue (sck-ast-reduce-newlabel))
	 (e1stmts (and expr1 (sck-ast-reduce-expr-stmt expr1)))
	 (e2stmts (and expr2
		       (sck-ast-reduce-expr-jump expr2 Lthen Lbreak)))
	 (e3stmts (and expr3 (sck-ast-reduce-expr-stmt expr3))))
    (push `(,name ,Lbreak ,Lcontinue) sck*ast-reduce-stmt-alist)
    ;;
    `(,@e1stmts
      ;;
      (label ,Lcontinue)
      ,@e2stmts
      ;;
      (label ,Lthen)
      ,@(sck-ast-reduce-stmt body)
      ,@e3stmts
      (goto ,Lcontinue)
      ;;
      (label ,Lbreak))))
  

(defun sck-ast-reduce-break (stmt)
  (let ((a (assoc (cadr stmt) sck*ast-reduce-stmt-alist)))
    (assert a)
    `((goto ,(cadr a)))))
  
(defun sck-ast-reduce-continue (stmt)
  (let ((a (assoc (cadr stmt) sck*ast-reduce-stmt-alist)))
    (assert a)
    `((goto ,(caddr a)))))

(defun sck-ast-reduce-label (stmt)
  `((label ,(sck-ast-reduce-get-labelname (cadr stmt)))
    ,@(sck-ast-reduce-stmt (caddr stmt))))

(defun sck-ast-reduce-goto (stmt)
  `((goto ,(sck-ast-reduce-get-labelname (cadr stmt)))))


(defun sck-ast-reduce-return (stmt)
  (let ((rexp (cadr stmt)))
    (cond
     (rexp
      `(,@(sck-ast-reduce-expr-stmt
	   (sck-ast-make-set-expr sck*ast-reduce-epilogue-tmp rexp))
	  (goto ,sck*ast-reduce-epilogue-label)))
     (t
      `((goto ,sck*ast-reduce-epilogue-label))))))


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;  reduce


(defun sck-ast-reduce-expr (expr tlabel flabel voidp)
  ;; Return: (<Pres> <<Expr>|nil> <Poss>)
  ;; <Pres>, <Poss> ::= (<Expr>..)
  (let ((op (sck-ast-expr-op expr)))
    (cond
     ;;
     ;; ѐw肠B
     ;;
     ((or tlabel flabel)
      (assert (null voidp))
      (list (sck-ast-reduce-expr-jump expr tlabel flabel)
	    nil
	    nil))
     ;;
     ;; t
     ;;
     ((memq op '(const vref))
      (cond
       ((sck-ast-sconst-expr-p expr)
	(list nil (sck-ast-reduce-sconst expr) nil))
       (t
	(list nil expr nil))))
     ;;
     ;; tłȂ
     (t
      (ecase op
	;;
	;; PȃP[X
	;;
	((neg add sub mul div mod lsh rsh bnot bor bxor band
	      conv decay
	      addr mem member)
	 (multiple-value-bind (pres poss)
	     (sck-ast-reduce-expr-args (sck-ast-expr-args expr) voidp nil)
	   ;;
	   (list pres expr poss)))
	;;
	;; 򂪊҂ĂȂꏊł tstXX, !, &&, ||
	;;
	((tsteq tstne tstlt tstgt tstle tstge
		lnot land lor)
	 ;; expr ? 1:0 ɕϊďB
	 (sck-ast-reduce-expr
	  (sck-ast-complete-expr
	   (sck-ast-make-expr
	    'cond
	    :args (list expr
			(sck-ast-make-iconst-expr sck=ast-boolean-type 1)
			(sck-ast-make-iconst-expr sck=ast-boolean-type 0))))
	  nil nil voidp))
	;;
	;; (set ...)
	;;
	(set
	 (sck-ast-reduce-expr-set expr voidp))
	;;
	;; (pref/posf (op x y))
	;; (pref/posf (conv (op (conv x) y)))
	;;
	((pref posf)
	 (sck-ast-reduce-expr-preposf expr voidp))
	;;
	;; x, y
	;;
	(comma
	 (sck-ast-reduce-expr-comma expr voidp))
	;;
	;; x ? y:z
	;;
	(cond
	 (sck-ast-reduce-expr-cond expr voidp))
	;;
	;; (call ...)
	;;
	(call
	 (sck-ast-reduce-expr-call expr voidp)))))))


(defun sck-ast-reduce-sconst (expr)
  ;; ŏꂽ static variable ɕϊB
  (let* ((stype (sck-ast-skip-typedef-and-qual
		 (sck-ast-expr-type expr)))
	 (nelm (cadr stype))
	 (etype (sck-ast-skip-typedef-and-qual (caddr stype)))
	 (chars (sck-ast-expr-value expr))
	 (key (cons etype chars))
	 (a (assoc key sck*ast-reduce-sconst-alist)))
    ;; ̈ӉȂꍇ́A
    ;; (setq a nil)
    (cond
     (a
      (cadr a))
     (t
      (let* ((sident
	      (sck-ast-make-ident
	       `(ident ($ 0 0) ,(sck-ast-reduce-new-sconst-ident-name))
	       :kind 'var
	       :type stype
	       :sc 'static
	       :value (cons 'inits
			    (mapcar #'(lambda (c)
					(sck-ast-make-iconst-expr etype c))
				    chars))))
	     (svref (sck-ast-make-vref-expr sident)))
	(push (list key svref) sck*ast-reduce-sconst-alist)
	(sck-ast-enter-ident sck*ast-reduce-global-env sident)
	;;
	svref)))))

(defun sck-ast-reduce-expr-set (expr voidp)
  (let ((args (sck-ast-expr-args expr))
	(type (sck-ast-expr-type expr)))
    (multiple-value-bind (pres poss)
	(sck-ast-reduce-expr-args args nil nil)
      ;;
      (cond
       ;; x = y;
       (voidp
	(list (append pres (list expr))
	      nil
	      poss))
       ;; z = (x = y);
       ((sck-ast-reduce-simple-expr-p (cadr args))
	(list (append pres (list expr))
	      (cadr args)
	      poss))
       ;; z = (x = y);
       ((sck-ast-reduce-simple-expr-p (car args))
	(list (append pres (list expr))
	      (car args)
	      poss))
       ;; ({tmp = y}, {x = tmp}), tmp, ()
       (t
	(let ((tmp (sck-ast-reduce-newtmp type)))
	  (list (append pres
			(list (sck-ast-make-set-expr tmp (cadr args)))
			(progn
			  (setf (cadr args) tmp)
			  (list expr)))
		tmp
		poss)))))))


(defun sck-ast-reduce-expr-preposf (expr voidp)
  ;; EXPR: (pref/posf <ValExpr>)
  ;; <ValExpr> ::= (<Bop> x y)) | (conv (<Bop> <x|(conv x)> y))
  ;;
  ;; ӁF int i; int *p;  i+=p; ł̃[jOP[X <ValExpr> 
  ;; (conv int (add (pointer char) (vref int "i") (vref (pointer char) "p")))
  ;; ƂȂB
  (let ((op (sck-ast-expr-op expr))
	(valexpr (car (sck-ast-expr-args expr))))
    (multiple-value-bind (pres poss)
	(sck-ast-reduce-expr-args (sck-ast-expr-args valexpr) nil nil)
      (let* ((bopexpr (if (eq (sck-ast-expr-op valexpr) 'conv)
			  (car (sck-ast-expr-args valexpr))
			valexpr))
	     (xplace (if (eq (sck-ast-expr-op
			      (car (sck-ast-expr-args bopexpr)))
			     'conv)
			 (sck-ast-expr-args
			  (car
			   (sck-ast-expr-args bopexpr)))
		       (sck-ast-expr-args bopexpr)))
	     (x (car xplace))
	     (setaddrexpr (sck-ast-reduce-factorize-address x))
	     (setxexpr (sck-ast-make-set-expr x valexpr)))
	;; ɂAlvalue GȏꍇAAhX̍ČvZ邽߂
	;; setaddrexpr 𐶐ĂB
	(when setaddrexpr
	  (setq pres (append pres (list setaddrexpr))))
	;;
	(ecase op
	  (pref
	   (multiple-value-bind (pres1 expr1 poss1)
	       (sck-ast-reduce-expr setxexpr nil nil voidp)
	     (list (append pres pres1)
		   expr1
		   (append poss poss1))))
	  (posf
	   (cond
	    (voidp
	     (list pres
		   nil
		   (append poss (list setxexpr))))
	    ((sck-ast-reduce-simple-expr-p x)
	     ;;
	     (list pres
		   x
		   (append poss (list setxexpr))))
	    (t
	     (let ((tmp (sck-ast-reduce-newregister
			 (sck-ast-expr-type x))))
	       (setf (car xplace) tmp)
	       ;;
	       (list (append pres
			     (list (sck-ast-make-set-expr tmp x)))
		     tmp
		     (append poss
			     (list setxexpr))))))))))))

(defun sck-ast-reduce-expr-comma (expr voidp)
  (let* ((args (sck-ast-expr-args expr))
	 (x (car args))
	 (y (cadr args)))
    ;; x
    (multiple-value-bind (pres1 expr1 poss1)
	(sck-ast-reduce-expr x nil nil t)
      ;; , ̑ÕV[PX|Cg̏B
      (multiple-value-setq (pres1 expr1 poss1)
	(sck-ast-reduce-move-poss-to-pres pres1 expr1 poss1))
      (assert (null poss1))
      ;; y
      (multiple-value-bind (pres2 expr2 poss2)
	  (sck-ast-reduce-expr y nil nil voidp)
	(list (append pres1 pres2)
	      expr2
	      poss2)))))

(defun sck-ast-reduce-expr-cond (expr voidp)
  ;; x ? y:z
  (let* ((args (sck-ast-expr-args expr))
	 (x (car args))
	 (y (cadr args))
	 (z (caddr args))
	 (ystmt nil)
	 (zstmt nil)
	 (tmp nil))
    (cond
     (voidp
      (setq ystmt y
	    zstmt z))
     (t
      (setq tmp (sck-ast-reduce-newregister (sck-ast-expr-type y))
	    ystmt (sck-ast-make-set-expr tmp y)
	    zstmt (sck-ast-make-set-expr tmp z))))
    ;;
    (list (sck-ast-reduce-if `(if ,x ,ystmt ,zstmt))
	  tmp
	  nil)))

(defun sck-ast-reduce-expr-call (expr voidp)
  (multiple-value-bind (pres expr1 poss)
      (sck-ast-reduce-expr-args (sck-ast-expr-args expr) nil t)
    (cond
     (voidp
      (list (append pres (list expr))
	    nil
	    nil))
     (t
      (let ((tmp (sck-ast-reduce-newregister (sck-ast-expr-type expr))))
	(list (append pres (list (sck-ast-make-set-expr tmp expr)))
	      tmp
	      nil))))))


(defun sck-ast-reduce-expr-args (args voidp onlypres)
  ;; ARGS: (<Expr>..) ̊e <Expr>  reduce A
  ;; <Pres>  <Poss> ꂼW߂XgԂB
  ;; ONLYPRES  Non-nil Ȃ poss  pres ɈړB
  ;; ARGS ͔jIɏCB
  ;; Return: (<Pres> <Poss>)
  (let ((pres nil)
	(poss nil))
    (dorest (ep args)
      (let ((expr (car ep)))
	(assert (sck-ast-expr-p expr))
	(multiple-value-bind (pres1 expr1 poss1)
	    (sck-ast-reduce-expr expr nil nil voidp)
	  (when onlypres
	    (multiple-value-setq (pres1 expr1 poss1)
	      (sck-ast-reduce-move-poss-to-pres pres1 expr1 poss1)))
	  (setf pres (append pres pres1)
		(car ep) expr1
		poss (append poss poss1)))))
    ;;
    (list pres poss)))

(defun sck-ast-reduce-move-poss-to-pres (pres expr poss)
  ;; EXPR: <Expr>|nil
  ;; V[PX|Cg̏̂߂ɁAKvȂ expr ̃Rs[
  ;; poss  pres ɈړB
  ;; Return: (<Pres> <<Expr>|nil> nil)
  (cond
   ((null poss)
    (list pres
	  expr
	  poss))
   ((null expr)
    (list (append pres poss)
	  nil
	  nil))
   ((eq (sck-ast-expr-op expr) 'const)
    (list (append pres poss)
	  expr
	  nil))
   (t
    (let ((tmp (sck-ast-reduce-newregister (sck-ast-expr-type expr))))
      (list (append pres
		    (list (sck-ast-make-set-expr tmp expr))
		    poss)
	    tmp
	    nil)))))

(defun sck-ast-reduce-simple-expr-p (x)
  (memq (sck-ast-expr-op x) '(const vref)))

(defun sck-ast-reduce-factorize-address (x)
  ;; lvalue x  (mem a)  (mem reg) ɔjIɒuA
  ;; (set reg a) ԂBȂ nilB
  (assert (sck-ast-lvalue-expr-p x))
  (ecase (sck-ast-expr-op x)
    ((vref const) nil) ; const  string ̏ꍇ
    (member
     (sck-ast-reduce-factorize-address (car (sck-ast-expr-args x))))
    (mem
     (let ((a (car (sck-ast-expr-args x))))
       (cond
	((sck-ast-reduce-simple-expr-p a)
	 nil)
	(t
	 (let ((reg (sck-ast-reduce-newregister (sck-ast-expr-type a))))
	   (setf (car (sck-ast-expr-args x)) reg)
	   ;;
	   (sck-ast-make-set-expr reg a))))))))
   

(defun sck-ast-reduce-expr-jump (expr tlabel flabel)
  ;; Return: (<Stmt>..)
  (let ((op (sck-ast-expr-op expr))
	(args (sck-ast-expr-args expr)))
    (ecase op
      ;;
      ;; r
      ;;
      ((tsteq tstne tstlt tstgt tstle tstge)
       (multiple-value-bind (pres poss)
	   (sck-ast-reduce-expr-args (sck-ast-expr-args expr) nil t)
	 `(,@pres
	   (if ,expr (goto ,tlabel) (goto ,flabel)))))
      ;;
      ;; X && Y
      ;;
      (land
       ;; X L1 flabel
       ;; L1
       ;; Y tlabel flabel
       (let ((L1 (sck-ast-reduce-newlabel)))
	 `(,@(sck-ast-reduce-expr-jump (car args) L1 flabel)
	     (label ,L1)
	     ,@(sck-ast-reduce-expr-jump (cadr args) tlabel flabel))))
      ;;
      ;; X || Y
      ;;
      (lor
       ;; 
       ;; X tlabel L1
       ;; L1
       ;; Y tlabel flabel
       (let ((L1 (sck-ast-reduce-newlabel)))
	 `(,@(sck-ast-reduce-expr-jump (car args) tlabel L1)
	     (label ,L1)
	     ,@(sck-ast-reduce-expr-jump (cadr args) tlabel flabel))))
      ;;
      ;; ! X
      ;;
      (lnot
       (sck-ast-reduce-expr-jump (car args) flabel tlabel)))))



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; AST module ̕œK
;;; ʂȕ{ubNAxtB

(defun sck-ast-reduce-jopt-module (module)
  (assert (eq (car-safe module) 'module))
  (let* ((genv (caddr module))
	 (fidents (let ((fq (make-que)))
		    (dolist (ident (sck-ast-env-idents genv))
		      (when (and (eq (sck-ast-ident-kind ident)
				     'var)
				 (eq (car-safe (sck-ast-ident-value ident))
				     'lambda))
			(append-que fq ident)))
		    ;;
		    (que-to-list fq)))
	 (labelq (make-que)))
    ;;
    ;; ֐Pʂ jopt
    ;;
    (dolist (fident fidents)
      (sck-ast-reduce-jopt-fident fident labelq))
    ;;
    ;; xl[
    ;;
    (sck-ast-reduce-jopt-rename
     (mapcar #'(lambda (fident)
		 (let* ((lam (sck-ast-ident-value fident))
			(block (cadddr lam))
			(stmts (cddr block)))
		   stmts))
	     fidents)
     (que-to-list labelq))
    ;;
    module))


(defun sck-ast-reduce-jopt-fident (fident labelq)
  (let* ((lambda (sck-ast-ident-value fident))
	 (block (cadddr lambda))
	 (stmts (cddr block)))
    (setq stmts (sck-ast-reduce-jopt-stmts stmts labelq))
    (setf (cddr block) stmts)
    (setf (sck-ast-ident-value fident) lambda)))

(defun sck-ast-reduce-jopt-fgraph-deflabel (stmt)
  ;; exprlist-to-fgraph p
  (cond
   ((sck-ast-expr-p stmt) nil)
   ((eq (car stmt) 'label)
    (cadr stmt))
   (t
    nil)))

(defun sck-ast-reduce-jopt-fgraph-reflabels (stmt)
  ;; exprlist-to-fgraph p
  (cond
   ((sck-ast-expr-p stmt) nil)
   ((eq (car stmt) 'goto)
    (cdr stmt))
   ((eq (car stmt) 'if)
    (mapcar 'cadr (cddr stmt)))
   (t
    nil)))


(defvar sck*ast-reduce-jopt-stmts-debug nil)
;; (setq sck*ast-reduce-jopt-stmts-debug t)


(defun sck-ast-reduce-jopt-stmts (stmts labelq)
  (let ((fgraph (exprlist-to-fgraph stmts
				    'sck-ast-reduce-jopt-fgraph-deflabel
				    'sck-ast-reduce-jopt-fgraph-reflabels
				    'sck-ast-stmt-to-sexp)))
    (when sck*ast-reduce-jopt-stmts-debug
      (sck-ast-printf "\n;;; Before jopt:\n%s\n" (fgraph-to-str fgraph)))
    ;;
    (progn
      ;; ̃xŎ܂ŌJԂKv邩H
      (sck-ast-reduce-jopt-stmts/shortcut fgraph)
      (sck-ast-reduce-jopt-stmts/merge fgraph))
    ;;
    (append-que-list labelq (deflabels-of-fgraph fgraph))
    ;;
    (when sck*ast-reduce-jopt-stmts-debug
      (sck-ast-printf "\n;;; After jopt:\n%s\n"  (fgraph-to-str fgraph)))
    ;;
    (fgraph-to-exprlist fgraph)))

(defun sck-ast-reduce-jopt-stmts/shortcut (fgraph)
  (dofnode (fnode fgraph)
    (let ((stmt (fstmt-expr (last-fstmt fnode))))
      (cond
       ((eq (car-safe stmt) 'goto)
	(sck-ast-reduce-jopt-stmts/shortcut-goto fgraph stmt))
       ((eq (car-safe stmt) 'if)
	(sck-ast-reduce-jopt-stmts/shortcut-goto fgraph (caddr stmt))
	(sck-ast-reduce-jopt-stmts/shortcut-goto fgraph (cadddr stmt))))))
  (set-succ-pred-fgraph fgraph)
  (delete-unreachable-fnodes fgraph))

(defun sck-ast-reduce-jopt-stmts/shortcut-goto (fgraph gotostmt)
  (let* ((label (cadr gotostmt))
	 (fnode (label-to-fnode fgraph label))
	 (vfnodes nil))
    (while (and (not (memq fnode vfnodes)) ; L: gotoL; ւ̑ΏB
		(sck-ast-reduce-jopt-empty-fnode-p fnode))
      (push fnode vfnodes)
      (setq fnode (car (fnode-succ fnode))))
    (setf (cadr gotostmt)
	  (fnode-to-deflabel fgraph fnode))))

(defun sck-ast-reduce-jopt-empty-fnode-p (fnode)
  (and (eq (fstmt-next (first-fstmt fnode))
	   (last-fstmt fnode))
       (eq (car-safe (fstmt-expr (last-fstmt fnode)))
	   'goto)))

(defun sck-ast-reduce-jopt-epilogue-fnode-p (fnode)
  (eq (car-safe (fstmt-expr (last-fstmt fnode)))
      'return))

(defun sck-ast-reduce-jopt-stmts/merge (fgraph)
  (let ((merged nil)
	(n 0))
    (loop
     ;; ͎܂ŌJԂ
     (setq merged nil)
     (dofnode (fnode fgraph)
       (let ((stmt (fstmt-expr (last-fstmt fnode))))
	 ;; goto ł̍s悪inext ŁjA pred ȂȂA
	 ;;
	 ;;inext ŁAƂ͖ĂǂAepilogue vbN
	 ;;  ɎグƂ悤Ȋ댯̂ŁAƂ肠͂Łj
	 (when (and (eq (car-safe stmt) 'goto)
		    (= 1 (length (fnode-pred (car (fnode-succ fnode)))))
		    ;; epilogue ͈ԉɂȂƃ}ŶŁA
		    ;; epilogue }[Wô͂̏̃ubN̂݁B
		    (or (not (sck-ast-reduce-jopt-epilogue-fnode-p
			      (car (fnode-succ fnode))))
			(eq (fnode-next fnode) (car (fnode-succ fnode)))))
	   ;; ̍s fnode փ}[WB
	   (let ((fnode1 (car (fnode-succ fnode))))
	     (delete-fnode fnode1)
	     (delete-fstmt (last-fstmt fnode))
	     (delete-fstmt (first-fstmt fnode1))
	     (merge-dque (fnode-fstmtdqh fnode) (fnode-fstmtdqh fnode1)))
	   (setq merged t))))
     (cond
      (merged
       (set-succ-pred-fgraph fgraph)
       (delete-unreachable-fnodes fgraph))
      (t
       (return))))))

(defun sck-ast-reduce-jopt-rename (stmtss labels)
  (let ((newlabels nil)
	(n 0)
	(rnalist nil))
    (dotimes (i (length labels))
      (let ((name nil))
	(while (sck-ast-search-ident sck*ast-reduce-global-env
				     (setq name (format "L%d" (incf n)))))
	(push name newlabels)))
    (setq rnalist (zip labels (nreverse newlabels)))
    (dolist (stmts stmtss)
      (dolist (stmt stmts)
	(cond
	 ((eq (car-safe stmt) 'label)
	  (sck-ast-reduce-jopt-rename/aux (cdr stmt) rnalist))
	 ((eq (car-safe stmt) 'goto)
	  (sck-ast-reduce-jopt-rename/aux (cdr stmt) rnalist))
	 ((eq (car-safe stmt) 'if)
	  (sck-ast-reduce-jopt-rename/aux (cdr (caddr stmt)) rnalist)
	  (sck-ast-reduce-jopt-rename/aux (cdr (cadddr stmt)) rnalist)))))))

(defun sck-ast-reduce-jopt-rename/aux (place rnalist)
  (setf (car place) (cadr (assoc (car place) rnalist))))


;;;
(provide 'sck-ast-reduce)
