;;;; ^֘A
;;;; LastChange: Sat Apr 14 14:34:51 2007

;; <Type> ::= <AtomicType> | <PointerType> | <EnumType>
;;          | <ArrayType> | <StructType> | <UnionType> | <FunctionType>
;;          | <NamedType>
;;          | void
;;          | nil /*  */
;;          | error /* sȌ^ */
;; 
;; <AtomicType> ::= <IntegralType> | <FloatingType>
;; 
;; <IntegralType> ::= char | short | uint | ulong ...
;; <FloatingType> ::= float | double ...
;; 
;; <PointerType> ::= (pointer <Type>)
;; <ArrayType> ::= (array <<Length>|nil> <Type>)
;; <FunctionType> ::= (function (<Type>.. [varargs]) <Type>)
;; <StructType> ::= (struct [<sck-ast-env> <Size> <Align>])
;; <UnionType> ::= (union [<sck-ast-env> <Size> <Align>])
;; <EnumType> ::= (enum [<EnumName>])
;; <EnumName> ::= <String>
;;
;; <NamedType> ::= (typename <sck-ast-ident>)
;; 
;; <Length>, <Size>, <Align> ::= <Integer>
;;
;; <Ltype> ::= <Symbol>
;; <Ltype>  kind=(integal floating aggregate) size, align ̑΂悢


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; ^ɊւJX^}CY\ȃe[u

(defconst sck=ast-atomic-type-syntax
  ;; ((<AtomicType> (<TypeKeyword>..)..))
  '((char       (char) (signed char))
    (short      (short) (signed short) (short int) (signed short int))
    (int        ())
    (int        (int) (signed) (signed int))
    (long       (long) (signed long) (long int) (signed long int))
    (longlong   (long long) (signed long long) (long long int)
	        (signed long long int))
    ;;
    (uchar      (unsigned char))
    (ushort     (unsigned short) (unsigned short int))
    (uint       (unsigned int) (unsigned))
    (ulong      (unsigned long) (unsigned long int))
    (ulonglong  (unsigned long long) (unsigned long long int))
    ;;
    (float      (float))
    (double     (double))
    (longdouble (long double))))

(defconst sck=ast-signed-types '(char short int long longlong))
(defconst sck=ast-unsigned-types '(uchar ushort uint ulong ulonglong))
(defconst sck=ast-floating-types '(float double longdouble))

(defconst sck=ast-integral-types
  (append sck=ast-signed-types sck=ast-unsigned-types))
(defconst sck=ast-atomic-types
  (append sck=ast-integral-types sck=ast-floating-types))

(defconst sck=ast-enum-implement-type 'int)
(defconst sck=ast-pointer-implement-type 'int)

(defconst sck=ast-byte-in-bits 8)


(defconst sck=ast-iconst-types
  ;; ((<decimal|octhex> (<nil|L|LL|U|UL|ULL> <IntegralType>..))..)
  '((decimal (nil  int long longlong)
	     (U    uint ulong ulonglong)
	     (L    long longlong)
	     (UL   ulong ulonglong)
	     (LL   longlong)
	     (ULL  ulonglong))
    (octhex  (nil  int uint long ulong longlong ulonglong)
	     (U    uint ulong ulonglong)
	     (L    long ulong longlong ulonglong)
	     (UL   ulong ulonglong)
	     (LL   longlong ulonglong)
	     (ULL  ulonglong))))

(defconst sck=ast-fconst-types
  '((nil double)
    (F   float)
    (L   longdouble)))

(defconst sck=ast-cconst-types
  '((nil int)
    (L   short)))

(defconst sck=ast-sconst-element-types
  '((nil char)
    ;; (nil uchar)
    (L   short)))

(defconst sck=ast-arith-types
  '((char int)
    (uchar int)
    (short int)
    (ushort int)
    (int int)
    (uint uint)
    (long long)
    (ulong ulong)
    (longlong longlong)
    (ulonglong ulonglong)
    (float double)
    (double double)
    (longdouble longdouble)))

(defconst sck=ast-sizeof-type 'uint)
(defconst sck=ast-shiftwidth-type 'int)
(defconst sck=ast-boolean-type 'int)
(defconst sck=ast-switch-type 'int)
(defconst sck=ast-default-function-type '(function () int))
(defconst sck=ast-alignof-function 4)



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; <Ltype> ֌W
;;;  <Ltype>  cps ؂藣A$SCK/lir  $SCK/lirgen ֈړB

(defconst sck=ast-lir-types
  '((char       i8)
    (short      i16)
    (int        i32)
    (long       i32)
    (longlong   i64)
    (uchar      i8)
    (ushort     i16)
    (uint       i32)
    (ulong      i32)
    (ulonglong  i64)
    (float      f32)
    (double     f64)
    (longdouble f128)))

(defun sck-ast-ltypeof-atomic-type (type)
  ;; (sck-ast-ltypeof-atomic-type 'int) => i32
  (let ((ltype (cadr (assq type sck=ast-lir-types))))
    (assert ltype)
    ltype))

(defun sck-ast-kindof-ltype (ltype)
  (ecase (aref (symbol-name ltype) 0)
    (?i 'integral)
    (?f 'floating)
    (?a 'aggregate)))

(defun sck-ast-sizeof-ltype (ltype)
  ;; (sck-ast-sizeof-ltype 'i32) => 4
  ;; (sck-ast-sizeof-ltype 'a1024) => 128
  (let* ((name (symbol-name ltype))
	 (nbits (string-to-int (substring name 1))))
    ;;  ltype o^֐AŃ`FbNׂB
    (assert (memq (aref name 0) '(?i ?f ?a)))
    (assert (zerop (% nbits sck=ast-byte-in-bits)))
    (/ nbits sck=ast-byte-in-bits)))

(defun sck-ast-alignof-ltype (ltype)
  ;; (sck-ast-alignof-ltype 'i32) => 4
  (assert (not (eq (aref (symbol-name ltype) 0) ?a)))
  (sck-ast-sizeof-ltype ltype))


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; 萔̌^

(defun sck-ast-typeof-iconst (val radix suffix)
  ;; (sck-ast-typeof-iconst 1234 'decimal 'L) = long
  ;; (sck-ast-typeof-iconst "1111111111111" 'decimal 'U) => ulonglong
  (assert (bn-integer-p val))
  (assert (memq radix '(decimal octhex)))
  (assert (memq suffix '(nil U L UL LL ULL)))
  (let ((types (cdr (assq suffix (cdr (assq radix sck=ast-iconst-types))))))
    (or (dolist (type types nil)
	  (when (sck-ast-intval-in val type)
	    (return type)))
	(car (last types)))))

(defun sck-ast-integral-type-max (type)
  (assert (sck-ast-integral-type-p type))
  ;;  with-cache
  (let ((nbits (* sck=ast-byte-in-bits (sck-ast-sizeof type))))
    (if (sck-ast-signed-type-p type)
	(bn-sub (bn-expt2 (1- nbits)) 1)
      (bn-sub (bn-expt2 nbits) 1))))

(defun sck-ast-integral-type-min (type)
  (assert (sck-ast-integral-type-p type))
  ;;  with-cache
  (let ((nbits (* sck=ast-byte-in-bits (sck-ast-sizeof type))))
    (if (sck-ast-signed-type-p type)
	(bn-neg (bn-expt2 (1- nbits)))
      0)))

(defun sck-ast-intval-in (val type)
  (assert (bn-integer-p val))
  (and (bn-<= (sck-ast-integral-type-min type) val)
       (bn-<= val (sck-ast-integral-type-max type))))


(defun sck-ast-typeof-fconst (suffix)
  (let ((type (cadr (assq suffix sck=ast-fconst-types))))
    (assert type)
    type))

(defun sck-ast-typeof-cconst (suffix)
  (let ((type (cadr (assoc suffix sck=ast-cconst-types))))
    (assert type)
    type))

(defun sck-ast-typeof-sconst (len suffix)
  (let ((elmtype (cadr (assq suffix sck=ast-sconst-element-types))))
    (assert elmtype)
    `(array ,len ,elmtype)))



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; ^֌W̏qꓙ


(defconst sck=ast-type-quals '(const volatile))

(defun sck-ast-find-atomic-type (syms)
  ;; SYMS: (<char|short|int|long|float|double|signed|unsigned>)..)
  ;; Return: <AtomicType>
  ;; Example:
  ;;  (sck-ast-find-atomic-type '(unsigned short int)) => ushort
  ;;  (sck-ast-find-atomic-type nil) => int
  (with-cache "(sck-ast-find-atomic-type syms)" syms
    (block break
      (dolist (a sck=ast-atomic-type-syntax)
	(when (member*
	       syms (cdr a)
	       :test #'(lambda (x y)
			 (equal (sort (mapcar 'symbol-name x) 'string<)
				(sort (mapcar 'symbol-name y) 'string<))))
	  (return-from break (car a)))))))


;;; ^Ɋւq͐^̏ꍇA
;;; Ƃ skip-typedef-and-qual ̂ԂB

(defun sck-ast-type-memq (type syms)
  ;; SYMS: <Symbol> | (<Symbol>..)
  ;; (sck-ast-type-memq 'int sck=ast-integral-types) => int
  ;; (sck-ast-type-memq '(array 10 int) 'array) => (array 10 int)
  (setq type (sck-ast-skip-typedef-and-qual type))
  (and (memq (if (symbolp type) type (car type))
	     (if (symbolp syms) (list syms) syms))
       type))

(defun sck-ast-void-type-p (type)
  (sck-ast-type-memq type 'void))

(defun sck-ast-integral-type-p (type)
  (sck-ast-type-memq type sck=ast-integral-types))

(defun sck-ast-signed-type-p (type)
  (sck-ast-type-memq type sck=ast-signed-types))

(defun sck-ast-unsigned-type-p (type)
  (sck-ast-type-memq type sck=ast-unsigned-types))

(defun sck-ast-floating-type-p (type)
  (sck-ast-type-memq type sck=ast-floating-types))

(defun sck-ast-arith-type-p (type)
  (sck-ast-type-memq type (append sck=ast-integral-types
				  sck=ast-floating-types)))

(defun sck-ast-scalar-type-p (type)
  (sck-ast-type-memq type (append sck=ast-integral-types
				  sck=ast-floating-types
				  '(pointer enum))))

(defun sck-ast-integral-scalar-type-p (type)
  (sck-ast-type-memq type (append sck=ast-integral-types
				  '(pointer enum))))

(defun sck-ast-signed-scalar-type-p (type)
  (setq type (sck-ast-skip-typedef-and-qual type))
  (cond
   ((sck-ast-signed-type-p type))
   ((sck-ast-pointer-type-p type)
    (sck-ast-signed-scalar-type-p sck=ast-pointer-implement-type))
   ((sck-ast-enum-type-p type)
    (sck-ast-signed-scalar-type-p sck=ast-enum-implement-type))
   (t
    nil)))

(defun sck-ast-unsigned-scalar-type-p (type)
  (setq type (sck-ast-skip-typedef-and-qual type))
  (cond
   ((sck-ast-unsigned-type-p type))
   ((sck-ast-pointer-type-p type)
    (sck-ast-unsigned-scalar-type-p sck=ast-pointer-implement-type))
   ((sck-ast-enum-type-p type)
    (sck-ast-unsigned-scalar-type-p sck=ast-enum-implement-type))
   (t
    nil)))

				  
;;(defun sck-ast-switch-scalar-type-p (type)
;;  (sck-ast-type-memq type (append sck=ast-integral-types
;;				  '(enum))))
  
(defun sck-ast-pointer-type-p (type)
  (sck-ast-type-memq type 'pointer))

(defun sck-ast-array-type-p (type)
  (sck-ast-type-memq type 'array))

(defun sck-ast-enum-type-p (type)
  (sck-ast-type-memq type 'enum))

(defun sck-ast-function-type-p (type)
  (sck-ast-type-memq type 'function))

(defun sck-ast-struct-type-p (type)
  (sck-ast-type-memq type 'struct))

(defun sck-ast-union-type-p (type)
  (sck-ast-type-memq type 'union))

(defun sck-ast-struct-or-union-type-p (type)
  (sck-ast-type-memq type '(struct union)))

(defun sck-ast-struct-or-union-or-enum-type-p (type)
  (sck-ast-type-memq type '(struct union enum)))

(defun sck-ast-adjust-arith-type (xtype &optional ytype)
  ;; xtype (ytype) Zp^ȂAʏ̒Pi񍀁jZsȂ߂̌^ԂB
  ;; łȂ nil ԂB
  ;; (sck-ast-adjust-arith-type 'char) => int
  ;; (sck-ast-adjust-arith-type 'char 'uint) => uint
  ;; (sck-ast-adjust-arith-type 'char 'ushort) => int
  (cond
   ;; unary
   ((null ytype)
    (cadr (assq (sck-ast-skip-typedef-and-qual xtype) sck=ast-arith-types)))
   ;; binary
   ((and (sck-ast-adjust-arith-type xtype)
	 (sck-ast-adjust-arith-type ytype))
    (setq xtype (sck-ast-skip-typedef-and-qual xtype)
	  ytype (sck-ast-skip-typedef-and-qual ytype))
    (cadr (elt sck=ast-arith-types
	       (max (position xtype sck=ast-arith-types :key 'car)
		    (position ytype sck=ast-arith-types :key 'car)))))
   (t
    nil)))

(defun sck-ast-pointer-to-void-type-p (type)
  (and (setq type (sck-ast-pointer-type-p type))
       (sck-ast-void-type-p (cadr type))
       type))

(defun sck-ast-pointer-to-function-type-p (type)
  (and (setq type (sck-ast-pointer-type-p type))
       (sck-ast-function-type-p (cadr type))
       type))

(defun sck-ast-pointer-to-const-type-p (type)
  ;; (sck-ast-pointer-to-const-type-p '(pointer (const int)))
  (and (setq type (sck-ast-pointer-type-p type))
       (memq 'const (sck-ast-type-quals (cadr type)))
       type))

(defun sck-ast-pointer-to-nonconst-type-p (type)
  ;; (sck-ast-pointer-to-nonconst-type-p '(pointer (const int)))
  (and (setq type (sck-ast-pointer-type-p type))
       (not (memq 'const (sck-ast-type-quals (cadr type))))
       type))

(defun sck-ast-pointer-to-volatile-type-p (type)
  ;; (sck-ast-pointer-to-volatile-type-p '(pointer (volatile int)))
  (and (setq type (sck-ast-pointer-type-p type))
       (memq 'volatile (sck-ast-type-quals (cadr type)))
       type))

(defun sck-ast-pointer-to-nonvolatile-type-p (type)
  ;; (sck-ast-pointer-to-nonvolatile-type-p '(pointer (volatile int)))
  (and (setq type (sck-ast-pointer-type-p type))
       (not (memq 'volatile (sck-ast-type-quals (cadr type))))
       type))

(defun sck-ast-type-quals (type)
  ;; (sck-ast-type-quals '(const (volatile (pointer (const int)))))
  ;; => (const volatile)
  (let ((quals nil))
    (while (memq (car-safe (setq type (sck-ast-skip-typedef type)))
		 sck=ast-type-quals)
      (pushnew (car type) quals)
      (setq type (cadr type)))
    (nreverse quals)))

(defun sck-ast-const-type-p (type)
  (and (memq 'const (sck-ast-type-quals type))
       (sck-ast-skip-typedef-and-qual type)))

(defun sck-ast-volatile-type-p (type)
  (and (memq 'volatile (sck-ast-type-quals type))
       (sck-ast-skip-typedef-and-qual type)))

(defun sck-ast-merge-type-quals (type quals)
  ;; (sck-ast-merge-type-quals '(const int) '(volatile const))
  ;; => (volatile (const int))
  (dolist (q quals)
    (unless (memq q (sck-ast-type-quals type))
      (setq type (list q type))))
  type)


(defun sck-ast-check-type-combination (type ident)
  ;; sȌ^̑gwEî݁jB
  ;; sck-cps-decl-declarator Ō^_ŌĂ΂B
  ;; (array * void)
  ;; (array * (function))
  ;; (function * (array))
  ;; (function * (function))
  ;; (function * (const))
  ;; (function * (volatile))
  (sck-ast-check-type-combination/rec type)
  (when (and ident (sck-ast-void-type-p type))
    (sck-ast-error "`%s' is declared as void" ident)))

(defun sck-ast-check-type-combination/rec (type)
  (setq type (sck-ast-skip-typedef-and-qual type))
  (unless (symbolp type)
    (case (car type)
      (pointer
       (sck-ast-check-type-combination/rec (cadr type)))
      (array
       (let ((elmtype (caddr type)))
	 (sck-ast-check-type-combination/rec elmtype)
	 (cond
	  ((sck-ast-void-type-p elmtype)
	   (sck-ast-error "array of void is illegal"))
	  ((sck-ast-function-type-p elmtype)
	   (sck-ast-error "array of function is illegal")))))
      (function
       ;; ͂łɃ`FbNς
       (let ((rtype (caddr type)))
	 (sck-ast-check-type-combination/rec rtype)
	 (dolist (q (sck-ast-type-quals rtype))
	   (sck-ast-error "function returning %s is illegal" q))
	 (cond
	  ((sck-ast-array-type-p rtype)
	   (sck-ast-error "function returning array is illegal"))
	  ((sck-ast-function-type-p rtype)
	   (sck-ast-error "function returning function is illegal"))))))))

  
(defun sck-ast-skip-typedef (type)
  (while (eq (car-safe type) 'typename)
    (setq type (sck-ast-ident-type (cadr type))))
  type)

(defun sck-ast-skip-typedef-and-qual (type)
  (loop 
   (cond
    ((symbolp type)
     (return type))
    ((eq (car type) 'typename)
     (setq type (sck-ast-ident-type (cadr type))))
    ((memq (car type) sck=ast-type-quals)
     (setq type (cadr type)))
    (t
     (return type)))))


(defun sck-ast-type-equal (t1 t2)
  ;; ^̓B
  ;; ȂƂ t1 t2 ^ł邱Ƃ͉肵ĂB
  ;; const volatile ͖B
  (setq t1 (sck-ast-skip-typedef-and-qual t1)
	t2 (sck-ast-skip-typedef-and-qual t2))
  (cond
   ((eq t1 t2) t)
   ((or (eq t1 'error) (eq t2 'error)) t)
   ((symbolp t1) (eq t1 t2))
   ((symbolp t2) nil)
   ((not (eq (car t1) (car t2))) nil)
   (t
    (ecase (car t1)
      (pointer (sck-ast-type-equal (cadr t1) (cadr t2)))
      (array (if (or (null (cadr t1)) (null (cadr t2))
		      (bn-= (cadr t1) (cadr t2)))
		  (sck-ast-type-equal (caddr t1) (caddr t2))
		nil))
      (function
       (and (sck-ast-type-equal (caddr t1) (caddr t2))
	    (let ((args1 (cadr t1))
		  (args2 (cadr t2)))
	      (block break
		(while (and args1 args2)
		  (unless (sck-ast-type-equal (car args1) (car args2))
		    (return-from break nil))
		  (setq args1 (cdr args1)
			args2 (cdr args2)))
		(and (null args1) (null args2))))))
      ((struct union enum)
       (eq (cadr t1) (cadr t2)))))))

(defun sck-ast-type-equal-strict (t1 t2)
  ;; sck-ast-type-equal ƓlA
  ;; const volatile ʂB
  ;;  const, volatile ̏̌B
  (setq t1 (sck-ast-skip-typedef t1)
	t2 (sck-ast-skip-typedef t2))
  (cond
   ((eq t1 t2) t)
   ((or (eq t1 'error) (eq t2 'error)) t)
   ((symbolp t1) (eq t1 t2))
   ((symbolp t2) nil)
   ((not (eq (car t1) (car t2))) nil)
   ((sck-ast-type-quals t1) (sck-ast-type-equal-strict (cadr t1) (cadr t2)))
   (t
    (ecase (car t1)
      (pointer (sck-ast-type-equal-strict (cadr t1) (cadr t2)))
      (array (if (or (null (cadr t1)) (null (cadr t2))
		      (bn-= (cadr t1) (cadr t2)))
		  (sck-ast-type-equal-strict (caddr t1) (caddr t2))
		nil))
      (function
       (and (sck-ast-type-equal-strict (caddr t1) (caddr t2))
	    (let ((args1 (cadr t1))
		  (args2 (cadr t2)))
	      (block break
		(while (and args1 args2)
		  (unless (sck-ast-type-equal-strict (car args1) (car args2))
		    (return-from break nil))
		  (setq args1 (cdr args1)
			args2 (cdr args2)))
		(and (null args1) (null args2))))))
      ((struct union enum)
       (eq (cadr t1) (cadr t2)))))))

(defun sck-ast-sizeof (type)
  ;; Return: <Integer> | nil
  (setq type (sck-ast-skip-typedef-and-qual type))
  (let ((size
	 (cond
	  ((symbolp type)
	   (cond
	    ((eq type 'error) 1)
	    ((eq type 'void)
	     ;; (sck-ast-error "cannot take sizeof void")
	     ;; sizeof(void) = 1 ƂB
	     1)
	    (t
	     (sck-ast-sizeof-ltype (sck-ast-ltypeof-atomic-type type)))))
	  (t
	   (ecase (car type)
	     (pointer (sck-ast-sizeof sck=ast-pointer-implement-type))
	     (array
	      (let ((elmsize (sck-ast-sizeof (caddr type))))
		(if (and elmsize (cadr type))
		    (bn-mul (cadr type) elmsize)
		  nil)))
	     ;; <FunctionType> ::= (function (<Type>.. [varargs]) <Type>)
	     ;; (sck-ast-error "cannot take sizeof function")
	     ;; sizeof(function) = 1 ƂB
	     (function 1)
	     ;; <StructType> ::= (struct <sck-ast-env> <Size> <Align>)
	     ;; <UnionType> ::= (union <sck-ast-env> <Size> <Align>)
	     ((struct union)
	      (caddr type))
	     ;; <EnumType> ::= (enum [<EnumName>])
	     (enum
	      (if (cadr type)
		  (sck-ast-sizeof sck=ast-enum-implement-type)
		nil)))))))
    (if size
	(bn-try-to-elnum size)
      nil)))


(defun sck-ast-alignof (type)
  ;; Return: <Integer> | nil
  (setq type (sck-ast-skip-typedef-and-qual type))
  (cond
   ((eq type 'error) 1)
   ((symbolp type)
    (if (eq type 'void)
	1
      (sck-ast-alignof-ltype (sck-ast-ltypeof-atomic-type type))))
   (t
    (ecase (car type)
      (pointer (sck-ast-alignof sck=ast-pointer-implement-type))
      (array (sck-ast-alignof (caddr type)))
      (function sck=ast-alignof-function)
      ((struct union) (cadddr type))
      (enum
       (if (cadr type)
	   (sck-ast-alignof sck=ast-enum-implement-type)
	 nil))))))

(defun sck-ast-ltypeof (type)
  (setq type (sck-ast-skip-typedef-and-qual type))
  (cond
   ((memq type '(nil void))
    ;; (assert nil)
    nil)
   ((eq type 'error) (sck-ast-ltypeof 'int))
   ((symbolp type)
    (sck-ast-ltypeof-atomic-type type))
   ((sck-ast-pointer-type-p type)
    (sck-ast-ltypeof sck=ast-pointer-implement-type))
   ((sck-ast-enum-type-p type)
    (sck-ast-ltypeof sck=ast-enum-implement-type))
   ((sck-ast-function-type-p type)
    nil)
   (t
    (let ((size (sck-ast-sizeof type)))
      (if size
	  (intern (format "a%s" (bn-to-str (bn-mul sck=ast-byte-in-bits
						   size))))
	nil)))))


(defun sck-ast-layout-struct (type)
  (assert (and (eq (car type) 'struct)
	       (sck-ast-env-p (cadr type))))
  (let ((memenv (cadr type))
	(offset 0)
	(totalalign 1))
    (dolist (ident (sck-ast-env-idents memenv))
      (assert (eq (sck-ast-ident-kind ident) 'var))
      (let* ((type (sck-ast-ident-type ident))
	     (size (sck-ast-sizeof type))
	     (align (sck-ast-alignof type)))
	(assert (and size align))
	(setq offset (roundup offset align))
	(setf (sck-ast-ident-value ident) (bn-try-to-elnum offset))
	(setq offset (bn-add offset size))
	(setq totalalign (bn-lcm totalalign align))))
    (setq offset (roundup offset totalalign))
    (setf (caddr type) (bn-try-to-elnum offset)
	  (cadddr type) (bn-try-to-elnum totalalign))
    type))

(defun sck-ast-layout-union (type)
  (assert (and (eq (car type) 'union)
	       (sck-ast-env-p (cadr type))))
  (let ((memenv (cadr type))
	(offset 0)
	(totalalign 1))
    (dolist (ident (sck-ast-env-idents memenv))
      (assert (eq (sck-ast-ident-kind ident) 'var))
      (let* ((type (sck-ast-ident-type ident))
	     (size (sck-ast-sizeof type))
	     (align (sck-ast-alignof type)))
	(assert (and size align))
	(setq offset (roundup offset align))
	(setf (sck-ast-ident-value ident) 0)
	(when (bn-< offset size)
	  (setq offset size))
	(setq totalalign (bn-lcm totalalign align))))
    (setq offset (roundup offset totalalign))
    (setf (caddr type) (bn-try-to-elnum offset)
	  (cadddr type) (bn-try-to-elnum totalalign))
    type))

(defun sck-ast-merge-array-type (t1 t2)
  ;; t1,t2  array  nil ̂̂𗼎҂jIɕ[B
  ;; (sck-ast-merge-array-type '(array nil int) '(array 10 int))
  ;; => (array 10 int)
  (assert (sck-ast-type-equal-strict t1 t2))
  (sck-ast-merge-array-type/rec t1 t2)
  t1)

(defun sck-ast-merge-array-type/rec (t1 t2)
  (setq t1 (sck-ast-skip-typedef-and-qual t1)
	t2 (sck-ast-skip-typedef-and-qual t2))
  (when (consp t1)
    (case (car t1)
      (array
       (setf (cadr t1) (or (cadr t1) (cadr t2))
	     (cadr t2) (or (cadr t2) (cadr t1)))
       (sck-ast-merge-array-type/rec (caddr t1) (caddr t2)))
      (pointer
       (sck-ast-merge-array-type/rec (cadr t1) (cadr t2)))
      (function
       (let ((args1 (cadr t1))
	     (args2 (cadr t2)))
	 (while args1
	   (sck-ast-merge-array-type/rec (pop args1) (pop args2)))
	 (sck-ast-merge-array-type/rec (caddr t1) (caddr t2)))))))


;;; G[bZ[Wp

(defun sck-ast-type-to-msgstr (type)
  ;;  ulong Ƃł͂Ȃ unsigned long Ƃ\ɁB
  (format "%s" (if (atom type) type (car type))))
      

;;;
(provide 'sck-ast-types)
