;;;; C ̃e (iconst, fconst, cconst, fconst) [_
;;;; LastChange: Sat Apr 14 14:38:08 2007

;;; obt@̃|Cgȉ̃e͂AƂʂ̊֐B
;;; ͌ʂƃbZ[W̃XgԂPȎdlB
;;; G[ƃ[jŐʂ͂ȂB
;;; iKvȂ烁bZ[W̕񂩂ŋʏoj

;;; Public:
;;; sck-clex-readlit : <CurrentBuffer> -> (<Literal> <Messages>)
;;; sck-clex-readlit-unparse : <Literal> -> <String>
;;;
;;; <Literal> ::= <Iconst> | <Fconst> | <Cconst> | <Sconst>
;;; <Iconst> ::= (iconst <Integer> <ISuffixes>)
;;; <Fconst> ::= (fconst (<Ipart> <Fpart> <Epart>) <FSuffixes>)
;;; <Cconst> ::= (cconst <CharCode> <CSuffixes>)
;;; <Sconst> ::= (sconst (<CharCode>..) <SSuffixes>)
;;; <{I,F,E}part> ::= <Integer>
;;; <CharCode> ::= <Fixnum>
;;; <ISuffixes> ::= [L | LL | U | UL | ULL]
;;; <FSuffixes> ::= [F | L | LL]
;;; <CSuffixes> ::= [L]
;;; <SSuffixes> ::= [L]
;;; <Messages> ::= (<String>..)


(defun sck-clex-readlit ()
  "|Cgȉ̃e͂B
 (looking-at \"\\\\.?[0-9]\\\\|L?['\\\"]\") ł邱ƁB

Return: (<Literal> <Mseeages>)
<Literal> ::= <Iconst> | <Fconst> | <Cconst> | <Sconst>
<Iconst> ::= (iconst <Integer> <ISuffixes>)
<Fconst> ::= (fconst (<Ipart> <Fpart> <Epart>) <FSuffixes>)
<Cconst> ::= (cconst <CharCode> <CSuffixes>)
<Sconst> ::= (sconst (<CharCode>..) <SSuffixes>)
<{I,F,E}part> ::= <Integer>
<CharCode> ::= <Fixnum>
<ISuffixes> ::= [L | LL | U | UL | ULL]
<FSuffixes> ::= [F | L]
<CSuffixes> ::= [L]
<SSuffixes> ::= [L]
<Messages> ::= (<String>..)"
  (assert (let ((case-fold-search nil))
	    (looking-at "\\.?[0-9]\\|L?['\"]")))
  (if (looking-at "[.0-9]")
      (sck-clex-readlit-number)
    (sck-clex-readlit-cs)))


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; <Iconst>, <Fconst>

(defun sck-clex-readlit-number ()
  "|Cgȉ <Iconst>, <Fconst> ͂B
|Cǵ̕@'0'..'9' ܂ '.' ł邱ƁB
Return: (<<Iconst> | <Fconst>> <Messages>)"
  ;; (assert (looking-at "[.0-9]"))
  (let ((ipart nil)
	(fpart nil)
	(epart nil)
	(esign "")
	(value nil)
	(token nil)
	(radix 10)
	(suffs nil)
	(msgs nil))
    ;;
    ;; ipart ̉
    ;;
    (cond
     ;; .123
     ;; ^
     ((= (following-char) ?.)
      (setq token 'fconst
	    ipart "0"))
     ;; 0...
     ;; ^
     ((= (following-char) ?0)
      (forward-char)
      (setq token 'iconst)
      (cond
       ;; 0x...
       ;;  ^
       ((memq (following-char) '(?x ?X))
	(forward-char)
	(setq radix 16)
	(cond
	 ((sck-clex-readlit-prop-p (following-char) 'hex)
	  (setq ipart (sck-clex-readlit-nat 16)))
	 (t
	  (push "hexadecimal constant without digits" msgs)
	  (setq ipart "0"))))
       ;; 01...
       ;;  ^
       ;; ̎_ octal Ƃ͒fłȂB
       ;; 009 ̓G[A 009.0 ͐I
       ;; ĉ radix = 8 ƂAۂ͂邭 radix = 10
       ;; œǂłAƊm肵ƂɃ`FbNB
       ((sck-clex-readlit-prop-p (following-char) 'dec)
	(setq radix 8)
	(setq ipart (sck-clex-readlit-nat 10)))
       ;; 0?...
       ;;  ^
       (t
	(setq ipart "0"))))
     ;; 123...
     ;; ^
     (t
      (setq token 'iconst)
      (setq radix 10)
      (setq ipart (sck-clex-readlit-nat 10))))
    ;;
    ;; fpart ȉ̉
    ;;
    (cond
     ;; Ɗm
     ;; fpart ̉
     ;; 16 i float (P) ͖T|[gB
     ((memq (following-char) '(?. ?e ?E))
      (setq token 'fconst
	    fpart "0")
      (when (= radix 8)
	;; 01.2
	(setq radix 10))
      (when (= radix 16)
	;; P ͖T|[g
	(push "illegal radix for floating constant" msgs)
	(setq ipart "0")
	(setq radix 10))
      (assert (= 10 radix))
      (when (= (following-char) ?.)
	(forward-char)
	(cond
	 ;; 123.45...
	 ;;     ^
	 ((sck-clex-readlit-prop-p (following-char) 'dec)
	  (setq fpart (sck-clex-readlit-nat 10)))
	 ;; 123.e...
	 ;;     ^
	 (t
	  (setq fpart "0"))))
      ;; w esign, epart ̉
      (cond
       ;; 3.14e...
       ;;     ^ 
       ((memq (following-char) '(?e ?E))
	(forward-char)
	(when (memq (following-char) '(?+ ?-))
	  (when (= (following-char) ?-)
	    (setq esign "-"))
	  (forward-char))
	(cond
	 ((sck-clex-readlit-prop-p (following-char) 'dec)
	  (setq epart (sck-clex-readlit-nat 10)))
	 (t
	  ;; 123e?
	  ;;     ^
	  (push "floating constant exponent without digits" msgs)
	  (setq epart "0"))))
       (t
	;; 123.444?
	;;        ^
	(setq epart "0"))))
     ;;
     ;; ƊmB
     ;; radix=10 œǂł radix=8  ipart `FbNB
     (t
      (when (= radix 8)
	(unless (string-match "\\`[0-7]+\\'" ipart)
	  (push "illegal octal digit" msgs)
	  (setq ipart "0"))
	(setq ipart (concat "#o" ipart)))))
    ;;
    ;; iconst, fconst ɏ] value B
    ;;
    (setq value (ecase token
		  (iconst ipart)
		  (fconst (list ipart fpart (concat esign epart)))))
    ;;
    ;; Suffix ̉
    ;;
    (let ((case-fold-search t))
      (while (looking-at "\\(U\\)\\|\\(LL\\)\\|\\(L\\)\\|\\(F\\)")
	(cond
	 ((match-beginning 1) (push 'U suffs))
	 ((match-beginning 2) (push 'LL suffs))
	 ((match-beginning 3) (push 'L suffs))
	 ((match-beginning 4) (push 'F suffs)))
	(goto-char (match-end 0)))
      (setq suffs (nreverse suffs))
      ;; Suffix ̃`FbN
      (when suffs
	(let ((suffscounts (count-elements suffs)))
	  (dolist (a (filter #'(lambda (x) (< 1 (cadr x))) suffscounts))
	    (push (format "duplicated suffix %s" (car a)) msgs))
	  (setq suffs (mapcar 'car suffscounts))
	  (let ((a (assoc* suffs
			   (ecase token
			     (iconst '(((L) L)
				       ((LL) LL)
				       ((U) U)
				       ((U L) UL)
				       ((U LL) ULL)))
			     (fconst '(((F) F)
				       ((L) L))))
			   :test 'set-equal)))
	    (unless a
	      (push (format "illegal suffix combination for %s constant"
			    (ecase token
			      (iconst "integral")
			      (fconst "floating")))
		    msgs))
	    (setq suffs (cdr a))))))
    ;;
    (list (list* token value suffs)
	  (nreverse msgs))))

    
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; <Cconst>, <Sconst>

(defun sck-clex-readlit-cs ()
  "|Cgȉ <Cconst>, <Sconst> ͂B
|Cgȉ (looking-at \"L?['\\\"]\") ł邱ƁB"
  ;; (assert (let ((case-fold-search nil)) (looking-at "L?['\"]")))
  (let ((cs nil)
	(suffs nil)
	(chars nil)
	(msgs nil))
    (when (= ?L (following-char))
      (push 'L suffs)
      (forward-char))
    (setq cs (following-char))
    (forward-char)
    (save-restriction
      (narrow-to-region (point) (save-excursion (end-of-line) (point)))
      (while (and (/= (following-char) cs)
		  (not (eobp)))
	(cond
	 ((= (following-char) ?\\)
	  (forward-char)
	  (let ((esc (sck-clex-readlit-prop-p (following-char) 'esc)))
	    (cond
	     (esc (push esc chars)
		  (forward-char))
	     ;; X 3  octal
	     ;; W`FbNH
	     ((sck-clex-readlit-prop-p (following-char) 'oct)
	      (push (read (sck-clex-readlit-nat 8 3)) chars))
	     ;; \x ͌̐͂Ȃ炵
	     ;; W`FbNH
	     ((= (following-char) ?x)
	      (forward-char)
	      (if (sck-clex-readlit-prop-p (following-char) 'hex)
		  ;; ͕ <Fixnum> ƂB
		  (let ((n (bn-try-to-elnum (sck-clex-readlit-nat 16))))
		    (cond
		     ((integerp n)
		      (push n chars))
		     (t
		      (push "character in hexadecimal too big" msgs)
		      (push bn=fixnum-max chars))))
		(push "empty '\\x' escape sequence" msgs)))
	     (t
	      (push (format "unknown escape sequence '\\%c'" (following-char))
		    msgs)
	      (push (following-char) chars)
	      (forward-char)))))
	 (t
	  (push (following-char) chars)
	  (forward-char))))
      (setq chars (nreverse chars))
      (if (= (following-char) cs)
	  (forward-char)
	(push (format "unterminated %s" (if (= ?\' cs) "character" "string"))
	      msgs)))
    ;;
    ;; R[h̏
    ;;  chars=(... k ...) -> (... k1 k2 ...)
    ;; ȉ̗LɂAchar  uchar ɂΊ܂ޕ͈ꉞ͒ʂ邪A
    ;; Ki͂Ԃ񐳂B
    ;;
    (quote
     (let ((chars1 nil))
      (dolist (c chars)
	(cond
	 ((< #xff c)
	  (let* ((k (encode-sjis-char c))
		 (k1 (logand (lsh k -8) #xff))
		 (k2 (logand k #xff)))
	    (push k1 chars1)
	    (push k2 chars1)))
	 (t
	  (push c chars1))))
      (setq chars (nreverse chars1))))
    ;;
    ;; 񂩂ɏ]Ďdグ
    ;;
    (ecase cs
      (?\' (cond
	    ((zerop (length chars))
	     (push (format "empty character") msgs)
	     (setq chars 0))
	    ((< 1 (length chars))
	     (push (format "too big character") msgs)
	     (setq chars (car chars)))
	    (t
	     (setq chars (car chars)))))
      (?\" (setq chars (append chars '(0)))))
    ;;
    (list (list* (if (= ?\' cs) 'cconst 'sconst)
		 chars
		 (nreverse suffs))
	  (nreverse msgs))))


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; ⏕֐


(defconst sck=clex-readlit-char-table
  (let ((ctab (make-char-table 'syntax-table)))
    (dolist (kv '((?\'  ?\')
		  (?\"  ?\")
		  (??   ??)
		  (?\\  ?\\)
		  (?a   ?\a)
		  (?b   ?\b)
		  (?f   ?\f)
		  (?n   ?\n)
		  (?r   ?\r)
		  (?t   ?\t)
		  (?v   ?\v)))
      (push (list 'esc (cadr kv))
	    (aref ctab (car kv))))
    (loop for i from 0 to 7
	  do (push (list 'oct i)
		   (aref ctab (+ i ?0))))
    (loop for i from 0 to 9
	  do
	  (push (list 'dec i)
		(aref ctab (+ i ?0)))
	  (push (list 'hex i)
		(aref ctab (+ i ?0))))
    (loop for i from 10 to 15
	  do
	  (push (list 'hex i)
		(aref ctab (+ (- i 10) ?a)))
	  (push (list 'hex i)
		(aref ctab (+ (- i 10) ?A))))
    ;;
    ctab))

(defun sck-clex-readlit-prop-p (c prop)
  ;; (sck-clex-readlit-prop-p ?n 'esc) => 10
  ;; (sck-clex-readlit-prop-p ?a 'oct) => nil
  ;; (sck-clex-readlit-prop-p ?2 'oct) => 2
  ;; (sck-clex-readlit-prop-p ?a 'hex) => 10
  (cadr (assq prop (aref sck=clex-readlit-char-table c))))


(defun sck-clex-readlit-nat (radix &optional maxlen)
  ;; |Cgȉ RADIX i̎RƂēǂ݁Abn CũX^C
  ;; ƂĕԂBmaxlen  Non-nil Ȃ獂X maxlen ǂށB
  ;; 1234
  ;; abcdef
  (let ((str (progn
	       (looking-at (concat (ecase radix
				     (8  "[0-7]")
				     (10 "[0-9]")
				     (16 "[0-9a-fA-F]"))
				   (if maxlen
				       (format "\\{,%d\\}" maxlen)
				     "*")))
	       (match-string 0))))
    (assert (< 0 (length str)))
    (goto-char (match-end 0))
    (concat (ecase radix (8 "#o") (10 "") (16 "#x"))
	    str)))


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; t

(defun sck-clex-readlit-unparse (literal)
  ;; <Literal> -> <String>
  ;;  radix ̕ۑ
  ;; Example:
  ;;   (sck-clex-readlit-unparse '(iconst "0xabe" L)) => "2750L"
  (ecase (car literal)
    (iconst
     (format "%s%s"
	     (bn-to-str (str-to-bn (cadr literal)))
	     (sck-clex-readlit-unparse/suffs (cddr literal))))
    (fconst
     (format "%s%s"
	     (bn-to-str (str-to-bn
			 (apply 'format "%s.%se%s" (cadr literal))))
	     (sck-clex-readlit-unparse/suffs (cddr literal))))
    (cconst
     (format "%s'%s'"
	     (sck-clex-readlit-unparse/suffs (cddr literal))
	     (sck-clex-readlit-unparse/char (cadr literal) t)))
    (sconst
     (format "%s\"%s\""
	     (sck-clex-readlit-unparse/suffs (cddr literal))
	     (apply 'concat
		    (mapcar 'sck-clex-readlit-unparse/char
			    (butlast (cadr literal))))))))

(defun sck-clex-readlit-unparse/suffs (suffs)
  ;; (sck-clex-readlit-unparse/suffs '(ULL)) => "ULL"
  (mapconcat 'identity (mapcar 'symbol-name suffs) ""))

(defun sck-clex-readlit-unparse/char (c &optional inchar)
  ;; (sck-clex-readlit-unparse/char ?a nil)
  ;; (sck-clex-readlit-unparse/char ?\n nil)
  ;; (sck-clex-readlit-unparse/char ?\' t)
  ;; (sck-clex-readlit-unparse/char ?\" t)
  (let ((a (assq c '((?\\ "\\\\")
		     (?\a "\\a")
		     (?\b "\\b")
		     (?\f "\\f")
		     (?\n "\\n")
		     (?\r "\\r")
		     (?\t "\\t")
		     (?\v "\\v")))))
    (cond
     (a
      (cadr a))
     ((= c ?\')
      (if inchar "\\'" "'"))
     ((= c ?\")
      (if inchar "\"" "\\\""))
     ((and (<= ?  c) (<= c ?~))
      (format "%c" c))
     ((and (<= 0 c) (<= c #xff))
      (format "\\%03o" c))
     (t
      (format "\\x%x" c)))))
      


;;;
(provide 'sck-clex-readlit)
