;;;
;;; $Id: yayacc-doty-to-alist.el,v 1.2 2007/04/09 09:50:23 heavy Exp $
;;;
;;;  .y(yacc,bison file) yayacc alist ɕϊ
;;;
(require 'sck-yayacc-yacc)
(require 'sck-cparse-yayacc)		; sck-clex g

(defconst yayacc=doty-to-alist-grammer
  '((object-language "elisp")
    (associativity nil)
    (attribute-grammar 
     (
      ((START file " EOF")	nil)

      ((file	ps-list)	nil)

      ((ps-list	ps)		nil)
      ((ps-list	ps-list ps)	nil)

      ;;((action	"{" " ERROR" "}")	nil)
      
      ((ps "%" bnf)
       (setq sck*yayacc-doty-to-alist-grammar $1))
      ((ps "%" attr)
       (setq sck*yayacc-doty-to-alist-precs
	     ;; ̎_ł͋t
	     (push $1 sck*yayacc-doty-to-alist-precs)))
      ((ps "%" " ERROR")
       (message "ps: Error %s!" $1))
      
      ((bnf "%" production-list "%" "%") $1)
      ((attr "id" term-list)
       (list (yayacc-doty-to-alist-id $0) $1))

      ((production-list	production)
       $0)
      ((production-list production-list production)
       (append $0 $1))
      ((production-list production-list " ERROR")
       (progn
	 (message "production-list: Error %s!" $1)
	 $0))
      
      ((production "id" ":" right-list ";")
       (let (r)
	 (if $2
	     (progn
	       (dolist (x $2) 
		 (push (list (cons (yayacc-doty-to-alist-id $0) x)) r))
	       (nreverse r))
	   (list (list (list (yayacc-doty-to-alist-id $0)))))
	 ))
;;      ((production "id" ":" ";")
;;       (list (list (list (yayacc-doty-to-alist-id $0)))))
      ((production " ERROR" ";")
       (progn
	 (message "production: Error! %S" $0)
	 nil))
             
      ((right-list term-list)
       (list $0))
      ((right-list right-list "|" term-list)
       (append $0 (list $2)))
      
      ((term-list ) nil)
      ((term-list term-list term)
       (append $0 $1))
      
      ((term	"id")
       (list (yayacc-doty-to-alist-id $0)))
      ((term	"string")
       (list 
	(apply 'concat
	       (mapcar 'sck-clex-readlit-unparse/char
		       (butlast (caddr $0))))))
      ))
    (output-filename "yayacc-doty-to-alist-output.el")))

;;
(defun yayacc-doty-to-alist-id (id)
  (intern (caddr id)))

;;
;;
;;
(defun yayacc-doty-to-alist-make-executor ()
  "yayacc=doty-to-alist-grammer gĎsvO쐬"
  (interactive)
  (sck-yayacc-yacc yayacc=doty-to-alist-grammer))

(defun yayacc-doty-to-alist (file)
  ".y t@C yayacc alist ɕϊ"
  (interactive "fFile (.y file) :")
  (load "yayacc-doty-to-alist-output")
  (let ((source (with-temp-buffer
		  (insert-file-contents file)
		  (buffer-string))))
    (with-display-buffer "*sck-yayacc-doty-to-alist*"
      (sck-letalist (sck-cparse-yayacc-init-clex file source)
	  ((tokens sck*cparse-lex-tokens)
	   (file-names sck*cparse-lex-file-names)
	   messages)
	(if messages
	    (dolist (m messages)
	      (sck-cparse-message m))
	  (let (sck*yayacc-doty-to-alist-precs
		sck*yayacc-doty-to-alist-grammar
		sck*cparse-type-tables
		(sck*cparse-tokens sck*cparse-lex-tokens)
		sck*cparse-token-pos)
	    (sck-yayacc-executor)
	    (let (output
		  assoc-list
		  token-list)
	      (setq output
		    (list
		     (list 'object-language "elisp")
		     (list 'associativity
			   (progn
			     (dolist (x sck*yayacc-doty-to-alist-precs)
			       ;; ŏ߂
			       (cond
				((or (eq 'left (car x))
				     (eq 'right (car x)))
				 (push x assoc-list))
				((eq 'token (car x))
				 (setq token-list
				       (append (cadr x) token-list)))
				(t
				 ;; Ή
				 )))
			     assoc-list))
		     (list 'attribute-grammar
			   (cons (list
				  (list 'start 
					(caaar sck*yayacc-doty-to-alist-grammar)
					" EOF"))
				 (sck-yayacc-doty-to-alist-change-token
				  sck*yayacc-doty-to-alist-grammar
				  token-list)))
		     (list 'output-filename
			   "output.el")))
	      (insert (pp-to-string output)))))))))

(defun sck-yayacc-doty-to-alist-change-token (grammar tokens)
  (message "grammar %S" grammar)

  (dolist (gg grammar)
    (let (new)
      (dolist (g (car gg))
	(if (memq g tokens)
	    (push (symbol-name g) new)
	  (push g new)))
      (setf (car gg) (nreverse new))))
  grammar)
