;;;
;;;
;;;
(require 'sck-yayacc-yacc)
(require 'sck-cparse-yayacc)

(defconst yayacc-yacc-demo-bnf
  '((object-language "elisp")
    (associativity nil)
    (attribute-grammar 
     (
      ((START SL " EOF") (cons 'progn $0))
       
      ((SL S)		(list $0))
      ((SL SL S)	(append $0 (list $1)))

      ((S "id" "=" E ";")
       (list 'setq (intern (caddr $0)) $2))
      ((S E ";")	$0)

      ((E E "+" T)	(list '+ $0 $2))
      ;;((E E "-" T)	(list '- $0 $2))
      ((E T)		$0)

      ((T T "*" F)	(list '* $0 $2))
      ;;((T T "/" F)	(list '/ $0 $2))
      ((T F)		$0)

      ((F "(" E ")")	$1)
      ((F "id")		(intern (caddr $0)))
      ((F "int_const")	(read (caddr $0)))
      )
     )
    (output-filename "yayacc-yacc-demo-output.el")))

;;;
;;;
;;;
(defun yayacc-yacc-demo-file (file)
  (interactive "fFile :")
  (yayacc-yacc-demo-str 
   (with-temp-buffer
     (insert-file-contents file)
     (buffer-string))))


(defun yayacc-yacc-demo-str (source)
  (load "yayacc-yacc-demo-output.el")
  (sck-letalist (sck-cparse-yayacc-init-clex source)
      ((tokens sck*cparse-lex-tokens)
       (file-names sck*cparse-lex-file-names)
       messages)
    (let ((sck*cparse-type-tables (list nil))
	  (sck*cparse-tokens sck*cparse-lex-tokens)
	  sck*cparse-token-pos)
      (sck-cparse-yayacc-init-clex source)
      (sck-yayacc-executor))))

;;;
;;;
;;;
(defun yayacc-yacc-demo-make-exe ()
  (interactive)
  (sck-yayacc-yacc yayacc-yacc-demo-bnf))

(defun yayacc-yacc-demo-display ()
  (interactive)
  (sck-letalist yayacc-yacc-demo-bnf
      ((object-language language)
       (associativity associativity)
       (attribute-grammar grammar)
       (output-filename outfile))
    (sck-yayacc-lr (list (list 'productions (mapcar 'car grammar))))
    (sck-yayacc-dump)
    (sck-yayacc-graphviz-display)
    ))
