;;;; LVJAiCUiclex Ƃ̃C^tF[Xj
;;;; LastChange: Wed Apr 04 01:49:05 2007


(defvar sck*cpps-token nil)
(defvar sck*cpps-token-value nil)
(defvar sck*cpps-token-pos nil)
(defvar sck*cpps-token-rest nil)

(defvar sck*cpps-clex-name nil)
(defvar sck*cpps-clex-tokens nil)
(defvar sck*cpps-clex-file-names nil)
(defvar sck*cpps-clex-messages nil)

(defun sck-cpps-getlex-open (clex-output)
  (sck-letalist clex-output
      (name tokens file-names messages)
    (setq sck*cpps-clex-name name
	  sck*cpps-clex-tokens tokens
	  sck*cpps-clex-file-names file-names
	  sck*cpps-clex-messages messages)
    (setq sck*cpps-token nil
	  sck*cpps-token-value nil
	  sck*cpps-token-pos nil
	  sck*cpps-token-rest sck*cpps-clex-tokens)))

(defun sck-cpps-getlex-close ()
  (setq sck*cpps-clex-name nil
	sck*cpps-clex-tokens nil
	sck*cpps-clex-file-names nil
	sck*cpps-clex-messages nil)
  (setq sck*cpps-token nil
	sck*cpps-token-value nil
	sck*cpps-token-pos nil
	sck*cpps-token-rest nil))

(defun sck-cpps-getlex-store (clex-token tns)
  (assert clex-token)
  (cond
   ((symbolp clex-token)
    (setq sck*cpps-token clex-token
	  sck*cpps-token-value nil))
   (t
    (ecase (setq sck*cpps-token (car clex-token))
      (ident
       (let ((name (cadr clex-token)))
	 (when (member name tns)
	   (setq sck*cpps-token 'typename))
	 (setq sck*cpps-token-value clex-token)))
      ((iconst fconst cconst sconst)
       (setq sck*cpps-token-value clex-token))
      ($
       (setq sck*cpps-token-value nil
	     sck*cpps-token-pos clex-token))))))

(defun sck-cpps-getlex (tns)
  (unless (eq sck*cpps-token 'eof)
    (loop (sck-cpps-getlex-store (pop sck*cpps-token-rest) tns)
	  (unless (eq sck*cpps-token '$) (return))))
  sck*cpps-token)

(defun sck-cpps-getlex-lookahead (tns)
  (let ((token (if (symbolp (car sck*cpps-token-rest))
		   (car sck*cpps-token-rest)
		 (caar sck*cpps-token-rest))))
    (if (eq token 'ident)
	(if (member (cadr (car sck*cpps-token-rest)) tns)
	    'typename
	  'ident)
      token)))
     

;;;
(provide 'sck-cpps-getlex)
