;;;; cpps pʊ֐
;;;; LastChange: Thu Apr 12 23:38:56 2007


;;; G[bZ[W

(defvar sck*cpps-messageq nil)

(defun sck-cpps-message-init ()
  (setq sck*cpps-messageq (make-que)))

(defun sck-cpps-message (fmt &rest args)
  (let ((msg (format "%s:%d: %s"
		     (elt sck*cpps-clex-file-names
			  (cadr sck*cpps-token-pos))
		     (caddr sck*cpps-token-pos)
		     (apply 'format fmt args))))
    (append-que sck*cpps-messageq msg)))

(defun sck-cpps-error (fmt &rest args)
  (apply 'sck-cpps-message fmt args))

(defun sck-cpps-warning (fmt &rest args)
  ;; ͑SG[ɂĂ̂ŁA͎gĂȂB
  (apply 'sck-cpps-message (concat "warning: " fmt) args))

(defun sck-cpps-message-strings ()
  (que-to-list sck*cpps-messageq))

(defun sck-cpps-token-to-string (tk)
  (case tk
    ((ident typename) "identifier")
    (iconst "integer constant")
    (fconst "floating constant")
    (cconst "character constant")
    (sconst "string constant")
    (t
     (format "`%s'" (sck-clex-token-to-string tk)))))


;;; p[T[⏕

(defun sck-cpps-getlex-expect (tns tk)
  (if (eq sck*cpps-token tk)
      (sck-cpps-getlex tns)
    (sck-cpps-error "missing %s" (sck-cpps-token-to-string tk))))

(defun sck-cpps-getlex-skip (tns sys)
  ;; sys ܂ŃXLbv
  (loop (when (memq sck*cpps-token sys)
	  (return))
	(case sck*cpps-token
	  ((iconst fconst)
	   (sck-cpps-error "unexpected number %s"
			     (sck-clex-token-to-string sck*cpps-token-value)))
	  ((cconst)
	   (sck-cpps-error "unexpected character %s"
			     (sck-clex-token-to-string sck*cpps-token-value)))
	  ((sconst)
	   (sck-cpps-error "unexpected string %s"
			     (sck-clex-token-to-string sck*cpps-token-value)))
	  ((ident typename)
	   (sck-cpps-error "unexpected identifier %s"
			     (sck-clex-token-to-string sck*cpps-token-value)))
	  ((eof)
	   (sck-cpps-error "unexpected end of input")
	   (return))
	  (t
	   (sck-cpps-error "unexpected `%s'"
			     (sck-clex-token-to-string sck*cpps-token))))
	(sck-cpps-getlex tns)))

(defun sck-cpps-getlex-skip2 (tns sys fsys)
  ;; Jgg[N sys ɂȂ sys + fsys ܂ŃXLbvB
  (unless (memq sck*cpps-token sys)
    (sck-cpps-getlex-skip tns (union sys fsys))))

(defun sck-cpps-delimited-list (tns fsys itembegsys parser
				    deltk deltype endtk readend)
  ;; ȉ̂悤ȃXgp[XA<Item> p[X̂̃XgԂB
  ;;
  ;; <ListTerm> ::= {<Item> <Del>} <End>
  ;; <ListSep>  ::= [<Item> {<Del> <Item>}] <End>
  ;; <ListBoth> ::= [<Item> {<Del> <Item>}] [<Del>] <End>
  ;;
  ;; PARSER  <Item> ̃p[TB
  ;; DELTK ͋؂LB
  ;; DELTYPE ̓Xg̋؂L̎g (term | sep | both)B
  ;; ENDTK ̓Xǧ̃g[NB
  ;; READEND  Non-nil Ȃ ENDTK ̎̃g[N܂œǂݐi߂B
  (let ((ast (make-que))
	(fsys1 (union (list deltk endtk) fsys)))
    (ecase deltype
      (term
       (while (memq sck*cpps-token itembegsys)
	 (append-que ast (funcall parser tns fsys1))
	 (sck-cpps-getlex-expect tns deltk)))
      (sep
       (when (memq sck*cpps-token itembegsys)
	 (append-que ast (funcall parser tns fsys1))
	 (while (eq sck*cpps-token deltk)
	   (sck-cpps-getlex tns)
	   (append-que ast (funcall parser tns fsys1)))))
      (both
       (when (memq sck*cpps-token itembegsys)
	 (append-que ast (funcall parser tns fsys1))
	 (loop (unless (eq sck*cpps-token deltk)
		 (return))
	       (sck-cpps-getlex tns)
	       (if (memq sck*cpps-token itembegsys)
		   (append-que ast (funcall parser tns fsys1))
		 (return))))))
    ;; sck*cpps-token = endtk ̂͂B
    (cond
     ((eq sck*cpps-token endtk)
      (when readend
	(sck-cpps-getlex tns)))
     (t
      (sck-cpps-error "missing %s" (sck-cpps-token-to-string endtk))))
    ;;
    (que-to-list ast)))


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; typename ̏

(defun sck-cpps-find-decl-ident (decl)
  ;; (sck-cpps-find-decl-ident '(mem () (ident () "foo"))) => (ident nil "foo")
  ;; (sck-cpps-find-decl-ident '(mem () (empty ()))) => nil
  (ecase (car decl)
    (empty nil)
    (ident decl)
    ((mem aref call const volatile)
     (sck-cpps-find-decl-ident (caddr decl)))))

(defun sck-cpps-find-typedef (specs)
  ;; specs : Specifiers
  ;; (sck-cpps-find-typedef '((keyword nil int)))
  ;; (sck-cpps-find-typedef '((keyword nil typedef) (keyword nil int)))
  (block found
    (dolist (spec specs)
      (when (and (eq (car spec) 'keyword)
		 (eq (caddr spec) 'typedef))
	(return-from found spec)))
    nil))

(defun sck-cpps-enter-typename (declaration tns)
  ;; (sck-cpps-enter-typename '((keyword nil typedef)) '(ident nil "foo") nil)
  (assert (eq (car-safe declaration) 'declaration))
  (let ((specs (caddr declaration))
	(decls (mapcar 'car (cdddr declaration))))
    (when (sck-cpps-find-typedef specs)
      (dolist (decl decls)
	(let ((ident (sck-cpps-find-decl-ident decl)))
	  (when ident
	    (pushnew (caddr ident) tns :test 'equal)))))
    ;;  typedef int a; a b; ̌
    ;; AŐǂ݃g[N̏CsB
    ;; łȉ̏ꍇ͖肪B
    ;;  f(){typedef int a; a b;} a b;
    ;;  sck-cpps-stmt ̃ubN̏őΏĂB
    (when (and (eq sck*cpps-token 'ident)
	       (member (cadr sck*cpps-token-value) tns))
      (setq sck*cpps-token 'typename))
    ;;
    tns))


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; veB[v^

(defun sck-cpps-pp-ast (ast &optional col)
  (with-temp-buffer
    (sck-cpps-pp-ast/rec ast (or col 0))
    (buffer-string)))

(defun sck-cpps-pp-ast/rec (ast col)
  (sck-cpps-pp-ast/indent-to col)
  (cond
   ((atom ast)
    (insertf "%S" ast))
   ((consp (car ast))
    (sck-cpps-pp-ast/indent-to col)
    (insert "(")
    (dolist (e ast)
      (sck-cpps-pp-ast/rec e (+ col 1)))
    (insert ")"))
   ((memq (car ast) '(ident iconst fconst cconst sconst keyword))
    (insertf "%S" ast))
   (t
    (insertf "(%S %S" (car ast) (cadr ast))
    (dolist (a (cddr ast))
      (sck-cpps-pp-ast/rec a (1+ col)))
    (insert ")"))))

(defun sck-cpps-pp-ast/indent-to (col)
  (when (< col (current-column))
    (newline))
  (indent-to col))
	   


(defconst sck=cpps-ast-font-lock-keywords
  lisp-font-lock-keywords)
  
(defun sck-cpps-ast-font-lock ()
  (setq font-lock-defaults
	'((sck=cpps-ast-font-lock-keywords)
	  nil nil (("+-*/.<>=!?$%_&~^:" . "w")) beginning-of-defun
	  (font-lock-mark-block-function . mark-defun)))
  (font-lock-mode t))


;;;
(provide 'sck-cpps-lib)
