;;;; 錾
;;;; LastChange: Thu Apr 12 23:43:36 2007


;;; 錾  plain AST
;;;
;;;<PlainAST> ::= (module <Pos> <Name> <<Function> | <Declaration>>..)
;;;<Name> ::= <String>
;;;
;;;<Function> ::= (function <Pos> <Declaration> <OldParamDecls> <Block>)
;;;<OldParamDecls> ::= (<Declaration>..)  /* f(a,b) int a,b;  int a,b; */
;;;
;;;<Declaration> ::= (declaration <Pos>
;;;                    <Specifiers> (<Declarator> <<Initializer>|nil>)..)
;;;
;;;<Specifiers> ::= (<Specifier>..)
;;;<Specifier> ::= <SimpleSpecifier> | <TypeName> | <StructUnion> | <Enum>
;;;<TypeName> ::= <Ident>
;;;
;;;<SimpleSpecifier> ::= (keyword <Pos>
;;;                          <typedef | extern | static | auto | register
;;;                           | void | char | short | int | long | float
;;;                           | double | signed | unsigned | const | volatile>)
;;;
;;;<StructUnion> ::= (<struct|union> <Pos> <<Ident>|nil> <Declaration>..)
;;;
;;;<Enum> ::= (enum <Pos> <<Ident>|nil> (<Ident> <<Expr>|nil>)..)
;;;
;;;<Declarator> ::= (empty <Pos>)
;;;               | <Ident>
;;;               | (mem <Pos> <Declarator>)          /* pointer */
;;;               | (aref <Pos> <Declarator> <<Expr>|nil>) /* array */
;;;               | (call <Pos> <Declarator>           /*  function */
;;;                                <<Declaration>|varargs>..)
;;;                           /* Plain parser ł͂̂悤ɂ邭͂B*/
;;;               | (const <Pos> <Declarator>)
;;;               | (volatile <Pos> <Declarator>)


(defvar sck*cps-global-env nil) ; 


(defun sck-cps-module (past)
  "PAST:<PlainAST>  AST (internal form) "
  (assert (eq (car past) 'module))
  (let ((env (sck-ast-make-env nil)))
    (setq sck*cps-global-env env) ;  let ...
    (dolist (extdecl (cdddr past))
      (ecase (car extdecl)
	(declaration (sck-cps-decl-declaration-global env extdecl))
	(function (sck-cps-decl-function env extdecl))))
    (sck-cps-decl-check-endof-module env)
    ;;
    `(module ,(caddr past) ,env)))


(defun sck-cps-decl-declaration-global (env past)
  ;; <Declaration> ::= (declaration <Pos>
  ;;                    <Specifiers> (<Declarator> <<Initializer>|nil>)..)
  (assert (eq (car past) 'declaration))
  (let* (($ (cadr past))
	 (specifiers (caddr past))
	 (declinits (cdddr past))
	 (sctp (sck-cps-decl-specifiers env specifiers)))
    (when (memq (car sctp) '(auto register))
      (sck-ast-error "illegal storage class `%s'" (car sctp))
      ;; sc = nil ɏCB
      (setf (car sctp) nil))
    (dolist (declinit declinits)
      (let ((decl (car declinit))
	    (init (cadr declinit)))
	(multiple-value-bind (type ident paramidents)
	    (sck-cps-decl-declarator env sctp decl)
	  (sck-cps-decl-declaration-global-1 env
					     (car sctp)
					     type
					     ident
					     paramidents
					     init))))))

(defun sck-cps-decl-declaration-global-1 (env sc type ident paramidents init)
  (cond
   (ident
    ;; int a = ... a ... \Ȃ̂ŁA enter B
    (let (($ (sck-ast-ident-pos ident))
	  (valident (sck-cps-decl-enter-ident-global env ident)))
      (when init
	(cond
	 ((eq sc 'typedef)
	  (sck-ast-error "initializer for typename `%s'" ident))
	 ((sck-ast-function-type-p type)
	  (sck-ast-error "initializer for function `%s'" ident))
	 (t
	  (when (eq sc 'extern)
	    (sck-ast-warning "initializer for external variable `%s'" ident))
	  (cond
	   (valident
	    (sck-ast-error "redefinition of `%s'" ident))
	   (t
	    (setf (sck-ast-ident-value ident)
		  (sck-cps-initializer-expr env type init t)))))))))
   (init
    (sck-ast-error "missing identifier in declaration"))
   (t
    (unless (sck-ast-struct-or-union-or-enum-type-p type)
      (sck-ast-error "missing identifier in declaration")))))


(defun sck-cps-decl-enter-ident-global (env ident)
  ;; ident: <sck-ast-ident>
  ;; Return: <sck-ast-ident>|nil
  ;; value  Non-nil Ȃ̂ɓo^Ă΁AԂB
  (let* (($ (sck-ast-ident-pos ident))
	 (pident (sck-ast-search-ident env ident t)))
    (cond
     ;; ŏ̒`
     ((null pident)
      ;; O[ȍꍇ͕sS^͍ŌɈꊇă`FbNB
      (sck-ast-enter-ident env ident)
      (assert (null (sck-ast-ident-value ident))))
     ;; ȉd`...
     ;;
     ;; ^svȂ_B
     ((not (sck-ast-type-equal-strict (sck-ast-ident-type pident)
				      (sck-ast-ident-type ident)))
      (sck-ast-error "redeclaration of `%s'" ident)
      nil)
     ;; ȉA^͈vĂB
     ;; ISO/IEC9899
     ;;
     ;; int i1 = 1;	    // definition, external linkage
     ;; static int i2 = 2;  // definition, internal linkage
     ;; extern int i3 = 3;  // definition, external linkage
     ;; int i4;             // tentative definition, external linkage
     ;; static int i5;      // tentative definition, internal linkage
     ;;
     ;; int i1;             // valid tentative definition, refers to previous
     ;; int i2;             // 6.2.2 renders undefined, linkage disagreement
     ;; int i3;             // valid tentative definition, refers to previous
     ;; int i4;             // valid tentative definition, refers to previous
     ;; int i5;             // 6.2.2 renders undefined, linkage disagreement
     ;;
     ;; extern int i1;      // refers to previous, whose linkage is external
     ;; extern int i2;      // refers to previous, whose linkage is internal
     ;; extern int i3;      // refers to previous, whose linkage is external
     ;; extern int i4;      // refers to previous, whose linkage is external
     ;; extern int i5;      // refers to previous, whose linkage is internal
     ;;
     (t
      ;; xNg^̃}[WĂB
      (sck-ast-merge-array-type (sck-ast-ident-type pident)
				 (sck-ast-ident-type ident))
      ;; value  Non-nil Ȃ̂ valident ƂB
      (let ((valident nil))
	(dolist (i (sck-ast-env-idents env))
	  (when (and (equal (sck-ast-ident-name i)
			    (sck-ast-ident-name ident))
		     (sck-ast-ident-value i))
	    (setq valident i)
	    (return)))
	(cond
	 ;; sc vȂ狖B
	 ((eq (sck-ast-ident-sc pident) (sck-ast-ident-sc ident))
	  (sck-ast-enter-ident env ident t)
	  valident)
	 ;; ȉAsc ͕sv
	 (t
	  ;; static ̕sv̂݋ȂB
	  (cond
	   ((or (eq 'static (sck-ast-ident-sc pident))
		(eq 'static (sck-ast-ident-sc ident)))
	    (sck-ast-error "illegal storage class redeclaration of `%s'" ident)
	    nil)
	   (t
	    ;; sc }[W
	    (setf (sck-ast-ident-sc pident)
		  (or (sck-ast-ident-sc pident) (sck-ast-ident-sc ident)))
	    (setf (sck-ast-ident-sc ident)
		  (or (sck-ast-ident-sc ident) (sck-ast-ident-sc pident)))
	    ;; ēo^
	    (sck-ast-enter-ident env ident t)
	    valident)))))))))


(defun sck-cps-decl-declaration-local (env past)
  ;; <Declaration> ::= (declaration <Pos>
  ;;                    <Specifiers> (<Declarator> <<Initializer>|nil>)..)
  (assert (eq (car past) 'declaration))
  (let* (($ (cadr past))
	 (specifiers (caddr past))
	 (declinits (cdddr past))
	 (sctp (sck-cps-decl-specifiers env specifiers)))
    (dolist (declinit declinits)
      (let ((decl (car declinit))
	    (init (cadr declinit)))
	(multiple-value-bind (type ident paramidents)
	    (sck-cps-decl-declarator env sctp decl)
	  (sck-cps-decl-declaration-local-1 env
					    (car sctp)
					    type
					    ident
					    paramidents
					    init))))))

(defun sck-cps-decl-declaration-local-1 (env sc type ident paramidents init)
  (cond
   ;; extern Ɗ֐錾̓ubNłO[oƈB
   ((or (eq sc 'extern)
	(sck-ast-function-type-p type))
    (sck-cps-decl-declaration-global-1 sck*cps-global-env
				       sc type ident paramidents init))
   (ident
    ;; int a = ... a ... \Ȃ̂ŁA enter B
    ;; global ̏ꍇƈقȂd`͕svB
    (sck-cps-decl-enter-ident-local env ident) 
    (let ($ (sck-ast-ident-pos ident))
      (when init
	(cond
	 ((eq sc 'typedef)
	  (sck-ast-error "initializer for typename `%s'" ident))
	 ((eq sc 'extern)
	  (sck-ast-error "initializer for extern `%s'" ident))
	 ((sck-ast-function-type-p type)
	  (sck-ast-error "initializer for function `%s'" ident))
	 (t
	  (setf (sck-ast-ident-value ident)
		(sck-cps-initializer-expr env type init (eq sc 'static))))))))
   (init
    (sck-ast-error "missing identifier in declaration"))
   (t
    (unless (sck-ast-struct-or-union-or-enum-type-p type)
      (sck-ast-error "missing identifier in declaration")))))

(defun sck-cps-decl-enter-ident-local (env ident)
  ;; ident : <sck-ast-ident>
  ;; Return: nil
  (let (($ (sck-ast-ident-pos ident))
	(pident (sck-ast-search-ident env ident t)))
    (cond
     (pident
      (sck-ast-error "redeclaration of `%s'" ident))
     (t
      (unless (sck-ast-sizeof (sck-ast-ident-type ident))
	;;  void f(){int v[]={1,2,3};} ̌B
	(sck-ast-error "unknown size of `%s'" ident)
	(setf (sck-ast-ident-type ident) 'error))
      (sck-ast-enter-ident env ident)))
    ;;
    nil))


(defun sck-cps-decl-specifiers (env specs &optional emptyspecnowarn)
  ;; <Specifiers> ::= (<Specifier>..)
  ;; <Specifier> ::= <SimpleSpecifier> | <TypeName> | <StructUnion> | <Enum>
  ;; <SimpleSpecifier> ::= (keyword <Pos>
  ;; 			    <typedef | extern | static | auto | register
  ;; 		             | void | char | short | int | long | float
  ;; 		             | double | signed | unsigned | const | volatile>)
  ;; <TypeName> ::= <Ident>
  ;;
  ;; Return: (<typedef|extern|static|auto|register|nil> <Type>)
  (let ((typedef nil)
	(sc nil)
	(void nil)
	(atomictypes nil)
	(quals nil)
	(typenames nil)
	(structs nil)
	(unions nil)
	(enums nil)
	;;
	(types nil)
	(type nil))
    ;;
    ;; 
    ;;
    (dolist (spec specs)
      (ecase (car spec)
	(keyword (ecase (caddr spec)
		   (typedef
		    (when typedef
		      (sck-ast-error "duplicated `typedef'"))
		    (setq typedef 'typedef))
		   ((extern static auto register)
		    (if sc
			(sck-ast-error "duplicated storage classes")
		      (setq sc (caddr spec))))
		   (void
		    (when void
		      (sck-ast-error "duplicated `void'"))
		    (setq void 'void))
		   ((const volatile)
		    (if (memq (caddr spec) quals)
			(sck-ast-warning "duplicated `%s'" (caddr spec))
		      (push (caddr spec) quals)))
		   ((char short int long float double signed unsigned)
		    (push spec atomictypes))))
	(ident (push spec typenames))
	(struct (push spec structs))
	(union (push spec unions))
	(enum (push spec enums))))
    (setq atomictypes (nreverse atomictypes)
	  quals (nreverse quals)
	  typenames (nreverse typenames)
	  structs (nreverse structs)
	  unions (nreverse unions)
	  enums (nreverse enums))
    ;;
    ;; typedef D
    ;;
    (when (and typedef sc)
      (setq sc nil)
      (sck-ast-error "typedef with storage class"))
    ;;
    ;; S
    ;;
    (when void
      (push 'void types))
    (dolist (s (append typenames structs unions enums))
      (let (($ (cadr s)))
	(push (ecase (car s)
		(ident (sck-cps-decl-typename env s))
		(struct (sck-cps-decl-struct env s))
		(union (sck-cps-decl-union env s))
		(enum (sck-cps-decl-enum env s)))
	      types)))
    (when (or (null types) atomictypes)
      (when (and (null typedef) (null sc) (null quals) (null atomictypes))
	(unless emptyspecnowarn
	  (sck-ast-warning "missing both storage class and type")))
      (push (sck-cps-decl-atomic-types atomictypes) types))
    (setq types (nreverse types))
    ;;
    ;; d`FbN quals ̏
    ;;
    (unless (= 1 (length types))
      (sck-ast-error "too many type specifiers"))
    (setq type (car types))
    (dolist (q quals)
      (setq type (list q type)))
    ;;
    ;; Return: (<typedef|extern|static|auto|register|nil> <Type>)
    ;;
    (list (or typedef sc) type)))


(defun sck-cps-decl-atomic-types (atypes)
  ;; ATYPES: ((keyword <Pos>
  ;;             <char|short|int|long|float|double|signed|unsigned>)..)
  ;; Return: <AtomicType>
  (let* (($ (cadr (car atypes)))
	 (syms (mapcar 'caddr atypes))
	 (type (sck-ast-find-atomic-type syms)))
    (cond
     (type type)
     (t
      (sck-ast-error "illegal type combination")
      'error))))


(defun sck-cps-decl-declarator (env sctp decl)
  ;; SCTP : (<<Sc>|nil> <Type) ; sck-cps-decl-specifiers Ԃ
  ;; DECL : <Declarator>
  ;; Return: (<Type> <<DeclaredIdent>|nil> (<<ParamIdent>|nil>..))
  ;;   <DeclaredIdent> : <sck-ast-ident>  ; kind : var|type
  ;;   <ParamIdent> : <sck-ast-ident> ; ֐^̏ꍇ̈p[^
  ;;  merge-type-qual ̌
  ;;  Return  ident Ɍ^ZbgȂقH
  (let (($ $)
	(sc (car sctp))
	(type (cadr sctp))
	(ident nil)
	(paramidents nil))
    (while (not (memq (car decl) '(empty ident)))
      (setq $ (cadr decl))
      (setq paramidents nil)
      (ecase (car decl)
	(mem
	 (setq type `(pointer ,type)
	       decl (caddr decl)))
	(aref
	 ;; (aref <Pos> <Declarator> <<Expr>|nil>)
	 (let ((plen (cadddr decl))
	       (len nil))
	   (when plen
	     (let ((elen (sck-ast-fold-const (sck-ast-expr env plen))))
	       (cond
		((and (eq (sck-ast-expr-op elen) 'const)
		      (or (sck-ast-integral-type-p (sck-ast-expr-type elen))
			  (sck-ast-enum-type-p (sck-ast-expr-type elen)))
		      (bn-integer-p (sck-ast-expr-value elen))
		      (bn-<= 0 (sck-ast-expr-value elen)))
		 (setq len (bn-try-to-elnum (sck-ast-expr-value elen))))
		(t
		 (sck-ast-error "illegal array size")
		 (setq len 1)))))
	   (setq type `(array ,len ,type)
		 decl (caddr decl))))
	(call
	 (let ((argtypes nil))
	   (multiple-value-setq (argtypes paramidents)
	     (sck-cps-decl-declarator/params env (cdddr decl)))
	   (setq type `(function ,argtypes ,type)
		 decl (caddr decl))))
	((const volatile)
	 (cond
	  ((memq (car decl) (sck-ast-type-quals type))
	   (sck-ast-warning "duplicated `%s'" (car decl)))
	  (t
	   (setq type `(,(car decl) ,type))))
	 (setq decl (caddr decl)))))
    ;;
    (when (eq (car decl) 'ident)
      (setq ident (sck-ast-make-ident
		   decl
		   :kind (if (eq sc 'typedef) 'type 'var)
		   :sc (if (eq sc 'typedef) nil sc)
		   :type type)))
    ;;
    (sck-ast-check-type-combination type ident)
    ;;
    (list type ident paramidents)))

(defun sck-cps-decl-declarator/params (env args)
  ;; ARGS : (<<Declaration>|varargs>..)
  ;; Return: ((<<Type>|nil>..) (<<Ident>|nil>..))
  (multiple-value-bind (types idents)
      (unzip (mapcar #'(lambda (arg)
			 (sck-cps-decl-declarator/params-1 env arg))
		     args))
    (cond
     ;;
     ;; New-style
     ;;
     ((and types (not (memq nil types)))
      ;; ӁF̏ꍇ idents ɂ nil ĂĂG[ł͂ȂB
      ;; int foo(int a, char)
      (cond
       ;; foo(...,void,...)
       ((some 'sck-ast-void-type-p types)
	(cond
	 ;; foo(void)
	 ((= 1 (length types))
	  (setq idents nil))
	 ;; foo(...,void,...)
	 (t
	  (sck-ast-error "illegal usage of void")
	  (setq types (list 'void)
		idents nil))))
       ;; foo(int a,...)
       ((memq 'varargs types)
	(assert (null (car (last idents))))
	(setq idents (butlast idents))
	(when (not (and (<= 2 (length types))
			(= 1 (count 'varargs types))
			(eq (car (last types)) 'varargs)))
	  (sck-ast-error "illegal usage of `...'")
	  ;; varargs ͂ȂƂɂB
	  (setq types (remq 'varargs types))))))
     ;;
     ;; Old-style
     ;;
     ((null (remq nil types))
      (setq types nil)
      (when (memq nil idents)
	(sck-ast-error "missing parameter")))
     ;;
     ;; ݂ old-style ɏCB
     ;;
     (t
      (sck-ast-error "missing type specifier")
      (setq types nil)
      (setq idents (delq nil idents))))
    ;;
    (dolist (dn (filter #'(lambda (a) (< 1 (cadr a)))
			(count-elements
			 (remq nil
			       (mapcar #'(lambda (i)
					   (and i (sck-ast-ident-name i)))
				       idents))
			 :test 'equal)))
      (sck-ast-error "redeclaration of `%s'" (car dn)))
    ;;
    (list types idents)))

(defun sck-cps-decl-declarator/params-1 (env declaration)
  ;; DECLARATION : <<Declaration>|varargs>
  ;; ֐̂ЂƂ̈ϊB
  ;; Return: (<<Type>|nil> <<Ident>|nil>) | (varargs nil)
  (if (eq declaration 'varargs)
      (list 'varargs nil)
    (let* (($ (cadr declaration))
	   (spec (caddr declaration))
	   (declinits (cdddr declaration))
	   (declinit (car declinits))
	   (sctp (if spec
		     (sck-cps-decl-specifiers env spec)
		   (list nil 'dummytype))))
      (assert (= 1 (length declinits))) ;  cpps Ń`FbNς
      (assert (null (cadr declinit)))	;  cpps Ń`FbNς
      (unless (memq (car sctp) '(auto register nil))
	(sck-ast-error "illegal storage class for parameter"))
      ;; (setq sctp (cons nil (cdr sctp))) ; SĂA
      ;; register ͎cB
      (multiple-value-bind (type ident paramidents)
	  (sck-cps-decl-declarator env sctp (car declinit))
	;; Old-style ̏ꍇ
	(unless spec
	  ;; declarator  ident ݂̂łȂ int f(*p) ̂悤ȃP[X̏B
	  (unless (eq type 'dummytype)
	    (sck-ast-error "missing type specifier"))
	  ;; Old-style Ȃ type = nil
	  (setq type nil)
	  (when ident
	    (setf (sck-ast-ident-type ident) nil)))
	;;
	;; ֐̌^ύXîPANew-stylejĂA
	(setq type (sck-cps-decl-decay-paramtype type))
	;; ^ sc ZbgB
	(when ident
	  (setf (sck-ast-ident-type ident) type
		(sck-ast-ident-sc ident) (car sctp)))
	;;
	(list type ident)))))

(defun sck-cps-decl-typename (env past-ident)
  (let ((ident (sck-ast-search-ident env past-ident)))
    (cond
     ;; ̃P[X͂肦Ȃ͂AꉞΏĂB
     ((null ident)
      (sck-ast-error "undefined type name `%s'" (caddr past-ident))
      (setq ident (sck-ast-make-ident past-ident :kind 'type :type 'error))
      (sck-ast-enter-ident env ident)
      `(typename ,ident))
     ;; ̃P[X肦Ȃ͂AꉞΏĂB
     ((not (eq (sck-ast-ident-kind ident) 'type))
      (sck-ast-error "illegal type name `%s'" (caddr past-ident))
      'error)
     (t
      `(typename ,ident)))))


(defun sck-cps-decl-struct (env past)
  ;; <StructUnion> ::= (<struct|union> <Pos> <<Ident>|nil> <Declaration>..)
  (sck-cps-decl-tagtype env 'struct (caddr past) (cdddr past)))

(defun sck-cps-decl-union (env past)
  ;; <StructUnion> ::= (<struct|union> <Pos> <<Ident>|nil> <Declaration>..)
  (sck-cps-decl-tagtype env 'union (caddr past) (cdddr past)))

(defun sck-cps-decl-enum (env past)
  ;; <Enum> ::= (enum <Pos> <<Ident>|nil> (<Ident> <<Expr>|nil>)..)
  (sck-cps-decl-tagtype env 'enum (caddr past) (cdddr past)))

(defun sck-cps-decl-tagtype (env kind past-tagident declarations)
  ;; <StructUnion> ::= (<struct|union> <Pos> <<Ident>|nil> <Declaration>..)
  (assert (memq kind '(struct union enum)))
  (let ((tagname (if past-tagident
		     (format "%s %s" kind (caddr past-tagident))
		   (sck-ast-genname
		    (format "%s t" kind))))
	(typeident nil))
    ;;
    (when past-tagident
      (setq typeident (sck-ast-search-ident env tagname
					   (not (null declarations)))))
    (unless typeident
      (setq typeident (sck-ast-make-ident
		      `(ident ,(if past-tagident (cadr past-tagident) $)
			      ,tagname)
		      :kind 'type
		      :type (list kind)))
      (sck-ast-enter-ident env typeident))
    ;;
    ;; struct/union/enum  {...}
    (when declarations
      (let ((type
	     (ecase kind
	       ((struct union)
		(sck-cps-decl-tagtype/structuniondef env kind declarations))
	       (enum
		(sck-cps-decl-tagtype/enumdef env typeident declarations)))))
	(cond
	 ((cadr (sck-ast-ident-type typeident))
	  (sck-ast-error "redeclaration of %s" (sck-ast-ident-name typeident)))
	 (t
	  ;;  struct/union/enum ̃l[Xy[XʂĂB
	  ;; ̕^ struct foo ̂悤ɂȂsǂB
	  ;; ۂ̓l[Xy[X͋ʂȂ̂ŁAŃ`FbN
	  ;;  kind ̂̂ƏdȂĂ烏[jOG[ɂׂB
	  (setf (sck-ast-ident-type typeident) type)))))
    ;;
    `(typename ,typeident)))

(defun sck-cps-decl-tagtype/structuniondef (env kind declarations)
  ;; struct/union  {...} ͂A^ (struct/union ...) ԂB
  (let ((memenv (sck-ast-make-env env)))
    (dolist (declaration declarations)
      ;; ݂ cpps  struct foo {int f(){};}; ĂB
      (ecase (car declaration)
	(function
	 (sck-ast-error "cannot define member function"))
	(declaration
	 (let* (($ (cadr declaration))
		(specifiers (caddr declaration))
		(declinits (cdddr declaration))
		(sctp (sck-cps-decl-specifiers env specifiers)))
	   (when (car sctp)
	     (sck-ast-error "illegal storage class for member `%s'"
			    (car sctp))
	     (setf (car sctp) nil))
	   (dolist (declinit declinits)
	     (let ((decl (car declinit))
		   (init (cadr declinit)))
	       (multiple-value-bind (type ident paramidents)
		   (sck-cps-decl-declarator env sctp decl)
		 (cond
		  (ident
		   (when init
		     (sck-ast-error "illegal initializer for member `%s'"
				    ident))
		   (let (($ (sck-ast-ident-pos ident))
			 (pident (sck-ast-search-ident memenv ident t)))
		     (cond
		      (pident
		       (sck-ast-error "redeclaration of menber `%s'"
				      ident))
		      ((sck-ast-function-type-p type)
		       (sck-ast-error "illegal function declaration `%s'"
				      ident)
		       (setf (sck-ast-ident-type ident) 'error))
		      ((null (sck-ast-sizeof type))
		       (sck-ast-error "unknown size of member `%s'"
				      ident)
		       (setf (sck-ast-ident-type ident) 'error)))
		     (unless pident
		       (sck-ast-enter-ident memenv ident))))
		  (t
		   (sck-ast-error "missing member"))))))))))
    ;;
    (let ((type (copy-list `(,kind ,memenv nil nil))))
      (ecase kind
	(struct (sck-ast-layout-struct type))
	(union (sck-ast-layout-union type))))))

(defun sck-cps-decl-tagtype/enumdef (env typeident enumvalalist)
  ;; enum  {...} ͂A^ (enum ...) ԂB
  (let ((memenv (sck-ast-make-env env))
	(enumval 0))
    (dolist (a enumvalalist)
      (let* ((ident (sck-ast-make-ident (car a)
					:kind 'const
					:type `(typename ,typeident)))
	     ($ (sck-ast-ident-pos ident))
	     (pident (sck-ast-search-ident memenv ident))
	     (past-valexp (cadr a)))
	(cond
	 (pident
	  (sck-ast-error "redeclaration of enumeration constant `%s'" ident))
	 (t
	  (when (cadr a)
	    (let ((val (sck-ast-fold-const (sck-ast-expr env (cadr a)))))
	      (cond
	       ((sck-ast-iconst-expr-p val)
		(setq enumval (sck-ast-expr-value val)))
	       (t
		(sck-ast-error "illegal enumeration value")))))
	  ;;
	  (setq enumval (sck-ast-expr-value
			 (sck-ast-make-nconst-expr
			  sck=ast-enum-implement-type
			  enumval)))
	  (setf (sck-ast-ident-value ident) (bn-try-to-elnum enumval))
	  (sck-ast-enter-ident env ident)
	  (setq enumval (bn-add enumval 1))))))
    ;; 
    `(enum ,(substring (sck-ast-ident-name typeident) 5))))


(defun sck-cps-decl-function (env fun)
  ;; <Function> ::= (function <Pos> <Declaration> <OldParamDecls> <Block>)
  ;; p[^ array ̂Ƃ pointer ɕϊ鏈܂B
  (assert (eq (car fun) 'function))
  (let* (($ (cadr fun))
	 (past-block (elt fun 4))
	 (oldparamdecls (elt fun 3))
	 (paramenv (sck-ast-make-env env)))
    ;;
    (multiple-value-bind (ftype fident paramidents)
	(sck-cps-decl-declaration-simple env (caddr fun) t)
      (cond
       ((null fident)
	(sck-ast-error "syntax error"))
       ((eq (sck-ast-ident-kind fident) 'type)
	(assert (eq (sck-ast-ident-kind fident) 'var))
	(sck-ast-error "function definition with `typedef'"))
       ((not (sck-ast-function-type-p ftype))
	;; (sck-ast-error "`%s' is not a function but has a block" fident)
	(sck-ast-error "syntax error")
	(setq fident nil))
       (t
	;; ܂łŃG[Ȃ͂p
	(setq ftype (sck-ast-skip-typedef-and-qual ftype))
	(cond
	 ;; New-style
	 ((cadr ftype)
	  ;; int f(int a, int){}
	  (when (memq nil paramidents)
	    (sck-ast-error "missing parameter")
	    (setq paramidents (remq nil paramidents)))
	  ;; int f(int a) char b;{}
	  (when oldparamdecls
	    ;; ݂Ă疳B
	    (sck-ast-error "mixed-style parameter declarations"))
	  (dolist (paramident paramidents)
	    (let ((pident (sck-ast-search-ident paramenv paramident t)))
	      (cond
	       (pident
		;; d`G[͊ɏoĂB
		)
	       (t
		(sck-ast-enter-ident paramenv paramident))))))
	 ;; Ord-style
	 ((null (cadr ftype))
	  (sck-cps-decl-function/oldparam
	   paramenv paramidents oldparamdecls)))))
      ;;
      (when fident
	;; f(){... f() ...} ̂Őɓo^B
	(let* ((valident (sck-cps-decl-enter-ident-global env fident))
	       ;;  reduce Ɠl̉R[hc
	       ;;  que-last ...
	       (gidentq (sck-ast-env-identq env))
	       (savedlast (que-last gidentq))
	       ;;
	       (blk (sck-cps-function-body paramenv fident past-block)))
	  (cond
	   (valident
	    (sck-ast-error "redefinition of function `%s'" fident))
	   (t
	    ;; f(){foo();} ɂ foo ̈Öق̐錾 f OɒuB
	    (assert (eq (car savedlast) fident))
	    (unless (eq savedlast (que-last gidentq))
	      ;; last ߂A
	      ;; (setf (que-last gidentq) savedlast)
	      ;; ǉOɈړB
	      ;; (append-que-list gidentq (cdr savedlast))
	      (let ((addedlist (cdr savedlast)))
		(setf (cdr savedlast) nil
		      (que-last gidentq) savedlast)
		(insert-que-list-before-last gidentq addedlist)))
	    ;;
	    (setf (sck-ast-ident-value fident) blk)))))
      ;;
      )))


(defun sck-cps-decl-function/oldparam (paramenv paramidents declarations)
  ;; p[^o^B
  (dolist (paramident paramidents)
    (let ((pident (sck-ast-search-ident paramenv paramident t)))
      (cond
       (pident
	;; d`G[͊ɏoĂB
	)
       (t
	(sck-ast-enter-ident paramenv paramident)))))
  ;; ^ZbgB
  (dolist (declaration declarations)
    (let* ((specifiers (caddr declaration))
	   (declinits (cdddr declaration))
	   (sctp (sck-cps-decl-specifiers paramenv specifiers)))
      (unless (memq (car sctp) '(auto register nil))
	(sck-ast-error "illegal storage class for parameter"))
      ;; (setq sctp (cons nil (cdr sctp))) ; SĂA
      ;; register ͎cB
      (setq sctp (cons (if (eq (car sctp) 'register) 'register nil)
		       (cdr sctp)))
      (dolist (declinit declinits)
	(let ((decl (car declinit))
	      (init (cadr declinit)))
	  (multiple-value-bind (type ident paramidents)
	      (sck-cps-decl-declarator paramenv sctp decl)
	    (when init
	      (sck-ast-error "syntax error"))
	    (cond
	     (ident
	      (let ((pident (sck-ast-search-ident paramenv ident t)))
		(cond
		 (pident
		  (cond
		   ((sck-ast-ident-type pident)
		    (sck-ast-error "redeclaration of `%s'" ident))
		   (t
		    ;; ֐̌^ύXîQAOld-stylejĂA
		    (setq type (sck-cps-decl-decay-paramtype type))
		    ;; ^ sc ZbgB
		    (setf (sck-ast-ident-type pident) type
			  (sck-ast-ident-sc pident) (car sctp)))))
		 (t
		  (sck-ast-error "declaration of unknown parameter `%s'"
				 ident)))))
	     (t
	      (sck-ast-error "missing parameter"))))))))
  ;; `Ȃ̂ int ɂB
  (dolist (paramident paramidents)
    (unless (sck-ast-ident-type paramident)
      (setf (sck-ast-ident-type paramident) (sck-ast-find-atomic-type nil))
      (sck-ast-warning "implicitly declared parameter (assume int) `%s'"
		       paramident)))
  ;;
  )


(defun sck-cps-decl-decay-paramtype (type)
  ;; ֐̌^ύX
  ;; (array ... T) -> (pointer T)
  ;; (function ...) -> (pointer (function ...))
  (let ((tp nil))
    (cond
     ((setq tp (sck-ast-array-type-p type))
      `(pointer ,(caddr tp)))
     ((setq tp (sck-ast-function-type-p type))
      `(pointer ,tp))
     (t
      type))))


	
(defun sck-cps-decl-declaration-simple (env declaration
					    &optional emptyspecnowarn)
  ;; Ȃ̂ЂƂ <Declarator> Ȃ <Declaration> ̉͂B
  ;; env ɓo^͂ȂB
  ;; ֐`AsizeofAcast ŎgpB
  ;; <Declaration> : (declaration <Pos> <Specifiers> (<Declarator> nil))
  ;;
  ;; Return: (<Type> <<sck-ast-ident>|nil> (<sck-ast-ident>..))
  ;;          sck-cps-decl-declarator Ɠl̂̂ԂB
  (let ((specifiers (caddr declaration))
	(declinits (cdddr declaration)))
    (unless (and (= 1 (length declinits))
		 (null (cadr (car declinits))))
      (sck-ast-error "syntax error"))
    (sck-cps-decl-declarator env
			     (sck-cps-decl-specifiers env specifiers
						      emptyspecnowarn)
			     (caar declinits))))


(defun sck-cps-decl-check-endof-module (env)
  ;; module ̍Ōōs`FbNB
  ;; O[oōŌ܂ unknown size ϐwEB
  ;;  extern int v[]; ͋ÃPA܂B
  (let ((unknowns nil))
    (dolist (ident (sck-ast-env-idents env))
      (when (eq (sck-ast-ident-kind ident) 'var)
	(unless (sck-ast-sizeof (sck-ast-ident-type ident))
	  (pushnew (sck-ast-ident-name ident) unknowns :test 'equal))))
    (dolist (name unknowns)
      (let* ((ident (sck-ast-search-ident env name))
	     ($ (sck-ast-ident-pos ident)))
	(sck-ast-error "unknown size of `%s'" ident)))))


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


;;;
(provide 'sck-cps-decl)
