;;; ex2-ans.el

(load "ex1-ans.el" t)

(defun my-remove (e x)
  (cond
   ((null x) nil)
   ((equal e (car x))
    (my-remove e (cdr x)))
   (t (cons (car x) (my-remove e (cdr x))))))

(defun my-butlast (x)
  (cond
   ((null x) nil)
   ((null (cdr x)) nil)
   (t (cons (car x) (my-butlast (cdr x))))))

(defun my-unzip (x)
  (if (null x)
      (list nil nil)
    (let ((r (my-unzip (cdr x))))
      (list (cons (caar x) (car r))
	    (cons (cadar x) (cadr r))))))

(defun my-union (x y)
  (if (null x)
      y
    (let ((r (my-union (cdr x) y)))
      (if (member (car x) r)
	  r
	(cons (car x) r)))))

(defun my-flat (x)
  (cond
   ((null x) nil)
   ((atom (car x))
    (cons (car x) (my-flat (cdr x))))
   (t (append (my-flat (car x)) (my-flat (cdr x))))))

(defun my-flat* (x)
  (cond
   ((null x) nil)
   ((null (car x)) (my-flat* (cdr x))) ; my-flat $B$H$N0c$$(B
   ((atom (car x))
    (cons (car x) (my-flat* (cdr x))))
   (t (append (my-flat* (car x)) (my-flat* (cdr x))))))

(defun my-subst (new old x)
  (cond
   ((equal old x) new)
   ((atom x) x)
   (t (cons (my-subst new old (car x))
	    (my-subst new old (cdr x))))))

(defun my-sublis (alist x)
  (let ((a (assoc x alist)))
    (cond
     (a (cadr a))
     ((atom x) x)
     (t (cons (my-sublis alist (car x))
	      (my-sublis alist (cdr x)))))))

(defun my-3n+1 (n)
  (if (= n 1)
      '(1)
    (cons n (my-3n+1 (if (zerop (% n 2)) (/ n 2) (+ (* n 3) 1))))))

(defun my-hanoi (n)
  (my-hanoi-1 n 'A 'B 'C))

(defun my-hanoi-1 (n from to work)
  (if (zerop n)
      nil
    (append (my-hanoi-1 (- n 1) from work to)
	    (list (list from '-> to))
	    (my-hanoi-1 (- n 1) work to from))))


(defun my-set-member (x y)
  (cond
   ((atom y) nil) ; x $B$O(B y (NNA) $B$NMWAG$G$O$J$$(B
   ((my-set-equal x (car y)) t)
   (t (my-set-member x (cdr y)))))

(defun my-set-subset (x y)
  (cond
   ((null x) t)
   ((atom x) (equal x y)) ; x (NNA) $B">(B y  $B"N(B  (equal x y)
   ((my-set-member (car x) y)
    (my-set-subset (cdr x) y))
   (t nil)))

(defun my-set-equal (x y)
  (and (my-set-subset x y)
       (my-set-subset y x)))
