;;; ex3-ans.el

(load "ex2-ans.el" t)

(defun my-repeat-funcall (f x n)
  (if (<= n 0)
      x
    (funcall f (my-repeat-funcall f x (1- n)))))

(defun my-iprod (x y)
  (my-total (mapcar '(lambda (a) (apply '* a)) (my-zip x y))))

(defun my-unzip-by-mapcar (x)
  (list (mapcar 'car x) (mapcar 'cadr x)))

(defun my-powerset (s)
  (if (null s)
      '(()) ; $B6u=89g(B {} $B$NQQ=89g$O(B {{}}
    (let ((r (my-powerset (cdr s))))
      ;; s = {a,b...} $B$N$H$-!"(B r = {u,v,...} $B$O(B s $B$+$i(B a $B$r=|$$$?=89g$NQQ=89g!#(B
      ;; $B$3$N3FMWAG$K(B a $B$rDI2C$7$?$b$N$H(B r $B$NOB=89g$,5a$a$k$b$N$G$"$k!#(B
      ;; Return: {{a}$B"@(Bu, {a}$B"@(Bv, ...} $B"@(B {u,v,...}
      (append (mapcar '(lambda (x) (cons (car s) x))
		      r)
	      r))))

(defun my-gray (n)
  (if (zerop n)
      '(())
    (let ((g (my-gray (1- n))))
      (append (mapcar '(lambda (x) (cons 0 x)) g)
	      (mapcar '(lambda (x) (cons 1 x)) (reverse g))))))

(defun my-combi (x n)
  (cond
   ((zerop n) '(()))
   ((= n (length x)) (list x))
   (t (append (mapcar '(lambda (y) (cons (car x) y))
		      (my-combi (cdr x) (1- n)))
	      (my-combi (cdr x) n)))))


(defun my-perm1 (x)
  ;; (my-perm1 '(a b c))
  ;; => ((a b c) (b a c) (b c a) (a c b) (c a b) (c b a))
  (if (null x)
      '(())
    (my-perm1-insert (car x) (my-perm1 (cdr x)))))

(defun my-perm1-insert (x y)
  ;; (my-perm1-insert 'A '((b c) (c b)))
  ;; => ((A b c) (b A c) (b c A) (A c b) (c A b) (c b A))
  ;; $BJdB-!'(B (my-append* x) = (apply 'append x)
  (my-append* (mapcar '(lambda (e) (my-perm1-insert-1 x e)) y)))

(defun my-perm1-insert-1 (x y)
  ;; (my-perm1-insert-1 '* '(a b c))
  ;; => ((* a b c) (a * b c) (a b * c) (a b c *))
  (if (null y)
      `((,x))
    (cons (cons x y)
	  (mapcar '(lambda (r) (cons (car y) r))
		  (my-perm1-insert-1 x (cdr y))))))


(defun my-perm2 (x n)
  ;; $B2r#1(B xPn = x * x-1Pn-1, xP0 = 1 $B$K4p$E$/%H%C%W%@%&%s$JJ}K!(B
  ;; $BNc$($P(B (a b c d) $B$+$i;0$D<h$k=gNs$J$i!"0J2<$N$h$&$KJ,3d$9$k!'(B
  ;; $B:G=i$K(B a $B$r<h$k=gNs!'(B (my-perm2 '(b c d) 2) $B$N3FNs$K(B a $B$r(B cons
  ;;    ........
  ;; $B:G=i$K(B d $B$r<h$k=gNs!'(B (my-perm2 '(a b c) 2) $B$N3FNs$K(B d $B$r(B cons
  (if (zerop n)
      '(()) ; xP0 = 1
    (my-append*
     (mapcar '(lambda (a)
		(mapcar '(lambda (b) (cons (car a) b))
			(my-perm2 (cdr a) (1- n))))
	     (mapcar '(lambda (c) (cons c (remove c x))) x)))))


(defun my-perm2 (x n)
  ;; $B2r#2(B $B2<0L4X?t(B my-perm2-expand{,-1} $B$r;H$$?M<j$G9T$&$h$&$K@8@.$7$F$/J}K!(B
  ;; $B$3$l$O%\%H%`%"%C%W$G$"$j!":F5"$O;H$C$F$$$J$$$N$GJ,$+$j$d$9$$$+$b$7$l$J$$(B
  ;; (my-perm2 '(a b c) 2)
  ;; => ((a b) (a c) (b a) (b c) (c a) (c b))
  (mapcar 'car (my-repeat-funcall 'my-perm2-expand `((() ,x))  n)))

(defun my-perm2-expand (x)
  ;; (my-perm2-expand '(((a) (b c))  ((b) (a c))  ((c) (a b))))
  ;; => (((a b) (c))
  ;;     ((a c) (b))
  ;;     ((b a) (c))
  ;;     ((b c) (a))
  ;;     ((c a) (b))
  ;;     ((c b) (a)))
  (my-append* (mapcar 'my-perm2-expand-1 x)))

(defun my-perm2-expand-1 (x)
  ;; (my-perm2-expand-1 '((a) (b c)))
  ;; => (((a b) (c)) ((a c) (b)))
  ;; (my-perm2-expand-1 '((a b) (x y z)))
  ;; => (((a b x) (y z))
  ;;     ((a b y) (x z))
  ;;     ((a b z) (x y)))
  (let ((to (car x))
	(from (cadr x)))
    (mapcar '(lambda (e) (list (append to (list e))
			       (remove e from)))
	    from)))


(defun my-filter (p x)
  ;; (my-filter 'symbolp '(0 one 2)) => (one)
  (cond
   ((null x) nil)
   ((funcall p (car x))
    (cons (car x) (my-filter p (cdr x))))
   (t (my-filter p (cdr x)))))

(defun my-zipwith (f x y)
  ;; (my-zipwith '* '(1 2 3) '(4 5 6)) => (4 10 18)
  (cond
   ((null x) nil)
   ((null y) nil)
   (t (cons (funcall f (car x) (car y))
	    (my-zipwith f (cdr x) (cdr y))))))

(defun my-iprod-by-zipwith (x y)
  (my-total (my-zipwith '* x y)))

(defun my-takewhile (p x)
  (cond
   ((null x) nil)
   ((funcall p (car x))
    (cons (car x) (my-takewhile p (cdr x))))
   (t nil)))

(defun my-dropwhile (p x)
  (cond
   ((null x) nil)
   ((funcall p (car x))
    (my-dropwhile p (cdr x)))
   (t x)))

(defun my-member-by-dropwhile (e x)
  (my-dropwhile '(lambda (y) (not (equal e y))) x))

(defun my-assoc-by-dropwhile (e x)
  (let ((r (my-dropwhile '(lambda (y) (not (equal e (car y)))) x)))
    (and r (car r))))


(defun my-foldr (f e x)
  (if (null x)
      e
    (funcall f (car x) (my-foldr f e (cdr x)))))

(defun my-foldl (f e x)
  (if (null x)
      e
    (my-foldl f (funcall f e (car x)) (cdr x))))

(defun my-length-by-fold (x)
  (my-foldl '(lambda (x y) (+ x 1))
	    0 x))

(defun my-reverse-by-fold (x)
  (my-foldl '(lambda (x y) (cons y x))
	    nil x))

(defun my-total-by-fold (x)
  (my-foldl '+ 0 x))

(defun my-append*-by-fold (x)
  (my-foldr 'append nil x))

(defun my-uniq-by-fold (x)
  (my-foldr '(lambda (x y) (if (member x y) y (cons x y)))
	    nil x))

(defun my-unzip-by-fold (x)
  (my-foldr '(lambda (x y) (list (cons (car x) (car y))
				 (cons (cadr x) (cadr y))))
	    nil x))

(defun my-filter-by-fold (p x)
  (my-foldr '(lambda (x y) (if (funcall p x) (cons x y) y))
	    nil x))
