;;; ex6-ans.el

(load "ex5-ans.el")


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; $B9=J82r@O$NLdBj(B

(defvar *my-parse-lex-buffer* nil)    ; $B%=!<%9%P%C%U%!(B
(defvar *my-parse-lex-token* nil)     ; $B%H!<%/%s<oJL(B
(defvar *my-parse-lex-token-val* nil) ; $B%H!<%/%sCM!J%7%s%\%k$H?t$N>l9g!K(B

(defun my-parse (str)
  ;; $BJ8;zNs(B str $B$r(B S-$B<0(B <sexp> $B$H$7$F(B
  ;; $B0J2<$N[#Kf$G$J$$(B LL(1) $BJ8K!$K=>$$!":F5"E*2<8~$-K!$G9=J82r@O$9$k!#(B
  ;;   <exp>    = <term>   {[+|-] <term>}
  ;;   <term>   = <factor> {[*|/] <factor>}
  ;;   <factor> = <symbol> | <number> | (<exp>)
  ;;   <symbol> = $B%"%k%U%!%Y%C%H$G;O$^$k1Q?t;z(B
  ;;   <number> = 0..9 $B$N#12s0J>e$N7+$jJV$7(B
  ;; $B%(%i!<$N>l9g$OJ8;zNs$H$7$FJV$9!#(B
  ;; $B<B9TNc!'(B
  ;; (my-parse "a+(1-b)*2/(c+3)") => (+ a (/ (* (- 1 b) 2) (+ c 3)))
  ;; (my-parse "a+(1-b)*2/+c+3 ") => "Syntax error"
  (let ((*my-parse-lex-buffer* *my-parse-lex-buffer*)
	(*my-parse-lex-token* *my-parse-lex-token*)
	(*my-parse-lex-token-val* *my-parse-lex-token-val*))
    (my-parse-init str)
    (prog1
	(catch 'my-parse-catch-tag
	  (my-parse-lex)
	  (prog1
	      (my-parse-exp)
	    (unless (eq *my-parse-lex-token* 'end-of-input)
	      (my-parse-error "Syntax error"))))
      (kill-buffer *my-parse-lex-buffer*))))

(defun my-parse-error (msg)
  ;; $B%(%i!<%a%C%;!<%8J8;zNs(B msg $B$r(B my-parse-catch-tag $B$X%9%m!<$9$k!#(B
  (throw 'my-parse-catch-tag msg))

(defun my-parse-init (str)
  ;; $B%l%-%7%+%k%"%J%i%$%6$N=i4|2=$r9T$&!#(B
  ;; $B%F%s%]%i%j%P%C%U%!$r:n@.$7!"(B*my-parse-lex-buffer* $B$K%;%C%H!#(B
  ;; $B$=$N%P%C%U%!$K%=!<%9J8;zNs(B str $B$rA^F~$7!"%]%$%s%H$r@hF,$X0\F0!#(B
  (setq *my-parse-lex-buffer* (generate-new-buffer "*sample*"))
  (save-excursion
    (set-buffer *my-parse-lex-buffer*)
    (insert str)
    (goto-char (point-min))))

(defun my-parse-lex ()
  ;; $B%l%-%7%+%k%"%J%i%$%6!#(B*my-parse-lex-buffer* $B%P%C%U%!$+$i(B
  ;; $B#1%H!<%/%s$r@Z$j=P$7!"%H!<%/%s$H$=$NCM$r(B *my-parse-lex-token{,-val}*
  ;; $B$K%;%C%H$9$k!#(B
  (save-excursion
    (set-buffer *my-parse-lex-buffer*)
    (skip-chars-forward " \t\n")
    (cond
     ((looking-at "(")
      (setq *my-parse-lex-token* 'left-paren))
     ((looking-at ")")
      (setq *my-parse-lex-token* 'right-paren))
     ((looking-at "[a-zA-Z][a-zA-Z0-9]*")
      (setq *my-parse-lex-token* 'symbol
	    *my-parse-lex-token-val* (intern (match-string 0))))
     ((looking-at "[0-9]+")
      (setq *my-parse-lex-token* 'number
	    *my-parse-lex-token-val* (string-to-int (match-string 0))))
     ((looking-at "[-+*/]")
      (setq *my-parse-lex-token* (intern (match-string 0))))
     ((looking-at "\\'") ; (eobp)
      (setq *my-parse-lex-token* 'end-of-input))
     (t
      (my-parse-error "Unexpected input")))
    (goto-char (match-end 0)) ; looking-at $B$G%^%C%A$7$?%Q%?!<%s$N8e$m$X0\F0(B
    *my-parse-lex-token*))

(defun my-parse-exp ()
  ;; <exp> $B$r%Q!<%9(B
  (let ((ret (my-parse-term)))
    (while (memq *my-parse-lex-token* '(+ -))
      (setq ret (list *my-parse-lex-token*
		      ret
		      (progn
			(my-parse-lex)
			(my-parse-term)))))
    ret))

(defun my-parse-term ()
  ;; <term> $B$r%Q!<%9(B
  (let ((ret (my-parse-factor)))
    (while (memq *my-parse-lex-token* '(* /))
      (setq ret (list *my-parse-lex-token*
		      ret
		      (progn
			(my-parse-lex)
			(my-parse-factor)))))
    ret))

(defun my-parse-factor ()
  ;; <factor> $B$r%Q!<%9(B
  (case *my-parse-lex-token*
    ((symbol number)
     (prog1
	 *my-parse-lex-token-val*
       (my-parse-lex)))
    (left-paren
     (my-parse-lex)
     (prog1
	 (my-parse-exp)
       (unless (eq *my-parse-lex-token* 'right-paren)
	 (my-parse-error "Syntax error"))
       (my-parse-lex)))
    (t
     (my-parse-error "Syntax error"))))


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; ex5 $B$N%$%s%?%W%j%?$N=$@5(B

(defun my-eval2-apply-lambda (lam args)
  ;; ex4 $B$K$*$1$k(B my-eval-apply-lambda $B$HF1MM$N$3$H$r9T$&$,!"(B
  ;; $B%7%c%m!<%P%$%s%G%#%s%0K!$K$h$j<BAu!#(B
  ;; lam $B$,(B lambda $B$G;O$^$k%j%9%H$G$J$1$l$P0J2<$N%(%i!<$r=P$9!#(B
  ;; (error "Illegal function: %s" lam)$B!!(B
  (unless (eq (car-safe lam) 'lambda)
    (error "Illegal function: %s" lam))
  (let ((savedsp *my-eval2-bind-stack-sp*))
    (dolist (sym (cadr lam))
      (my-eval2-save-bind sym)
      (my-eval2-setq sym (car args))
      (setq args (cdr args)))
    (unwind-protect
	(my-eval2-progn (cddr lam))
      (my-eval2-restore-binds savedsp))))

(defun my-eval2-let (vars exps forms)
  ;; let $B$N=hM}(B
  (let ((savedsp *my-eval2-bind-stack-sp*))
    (unwind-protect
	(let ((vals (mapcar 'my-eval2 exps))) ; $B?7$?$JB+G{$r:n$kA0$KA4ItI>2A(B
	  (dolist (sym vars)
	    (my-eval2-save-bind sym)
	    (my-eval2-setq sym (car vals))
	    (setq vals (cdr vals)))
	  (my-eval2-progn forms))
      (my-eval2-restore-binds savedsp))))

(defun my-eval2-let* (vars exps forms)
  ;; let* $B$N=hM}!J(Blet $B$H$NHyL/$J0c$$$KCm0U!K(B
  (let ((savedsp *my-eval2-bind-stack-sp*))
    (unwind-protect
	(progn
	  (dolist (sym vars)
	    (my-eval2-save-bind sym)
	    (my-eval2-setq sym (my-eval2 (car exps))) ; $BI>2A$7$D$DB+G{$r:n$k(B
	    (setq exps (cdr exps)))
	  (my-eval2-progn forms))
      (my-eval2-restore-binds savedsp))))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; my-eval3


(defvar *my-eval3-toplevel-env*
  ;; $B%7%s%\%k$N%H%C%W%l%Y%k$K$*$1$kCM$rJ];}$9$k%H%C%W%l%Y%k4D6-!J(Ba-list$B!K!#(B
  '(;; $BDj?t!JDj5A:Q$_JQ?t!K(B
    (nil nil)
    (t t)
    ;; $B%W%j%_%F%#%V4X?t(B
    (car my-car)
    (cdr my-cdr)
    (cons my-cons)
    (atom my-atom)
    (equal my-equal)))

(defun my-eval3-symbol-value (sym env)
  ;; $B%7%s%\%k(B sym $B$NCM$r%m!<%+%k4D6-(B env $B$+$iC5$7$FJV$9!#(B
  ;; env $B$KEPO?$5$l$F$$$J$1$l$P!"%H%C%W%l%Y%k4D6-(B *my-eval3-toplevel-env*
  ;; $B$+$iC5$9!#(B
  ;; (my-eval3-symbol-value 'foo '((foo 1) (bar 2))) => 1
  ;; (my-eval3-symbol-value 'car nil) => my-car
  ;; $B%H%C%W%l%Y%k4D6-$K$bL5$1$l$P0J2<$N%(%i!<$r=P$9!#(B
  ;; (error "Unbound variable: %s" sym)
  (let ((a (or (assq sym env)
	       (assq sym *my-eval3-toplevel-env*))))
    (unless a
      (error "Unbound variable: %s" sym))
    (cadr a)))

(defun my-eval3-setq (sym val)
  ;; $B%7%s%\%k(B sym $B$N%H%C%W%l%Y%k$K$*$1$kCM$r(B val $B$K%;%C%H$7!"(Bval $B$rJV$9!#(B
  ;; (my-eval3-setq 'poi '(p o i)) => poi
  ;; (my-eval3-symbol-value 'poi nil) => (p o i)
  ;; sym $B$,%7%s%\%k$G$J$$>l9g!"0J2<$N%(%i!<$r=P$9!#(B
  ;; (error "Illegal symbol: %s" sym)
  (unless (symbolp sym)
    (error "Illegal symbol: %s" sym))
  (setq *my-eval3-toplevel-env*
	(cons (list sym val) *my-eval3-toplevel-env*))
  val)

(defun my-eval3-toplevel (sexp)
  ;; $B%U%)!<%`(B sexp $B$r6u$N%m!<%+%k4D6-$N2<$GI>2A$9$k!#(B
  ;; (my-eval3-toplevel '(car '(a b))) => a
  (my-eval3 sexp nil))

(defun my-eval3 (sexp env)
  ;; $B%U%)!<%`(B sexp $B$r%m!<%+%k4D6-(B env $B$N2<$GI>2A$9$k!#(B
  ;; $B%9%Z%7%c%k%U%)!<%`$O(B if, setq, defun $B$r%5%]!<%H!#(B
  ;; $B%W%j%_%F%#%V4X?t$O(B car, cdr, cons, atom, equal $B$r%5%]!<%H!#(B
  ;; (my-eval3 '(cons x y) '((x a) (y (b c)))) => (a b c)
  ;; $BK\4X?t$G$O!"(Bsexp $B$,%7%s%\%k5Z$S$=$NB>$N%"%H%`$N>l9g$N=hM}$r9T$$!"(B
  ;; sexp $B$,(B nil $B$G$J$$%j%9%H$N>l9g$O(B my-eval3-call $B$KG$$;$k!'(B
  ;; ... (my-eval3-call (car sexp) (cdr sexp) env)
  (cond
   ((symbolp sexp) (my-eval3-symbol-value sexp env))
   ((atom sexp) sexp)
   (t (my-eval3-call (car sexp) (cdr sexp) env))))

(defun my-eval3-call (fun args env)
  ;; $B%9%Z%7%c%k%U%)!<%`$^$?$O4X?t(B fun $B$N=hM}$r9T$&!#(B
  ;; (my-eval3-call 'if '(t a b) '((a 1))) => 1
  ;; (my-eval3-call 'if '(nil a b) '((a 1))) => Error: Unbound variable: b
  ;; $BK\4X?tFb$G$O!"%9%Z%7%c%k%U%)!<%`$N>l9g$N=hM}$r9T$$!"(B
  ;; $B4X?t8F$S=P$7!J%9%Z%7%c%k%U%)!<%`0J30!K$N>l9g$O(B my-eval3-apply $B$KG$$;$k!#(B
  ;; my-eval3-apply $B$K$O!"(Bfun $B$rI>2A$7$F<h$j=P$7$?4X?tK\BN!"(B
  ;; $B5Z$S(B args $B$N3FMWAG$rI>2A$7$?%j%9%H$rEO$9!#(B
  (case fun
   ;; Special forms
   ((quote) (car args))
   ((if)
    (if (my-eval3 (car args) env)
	(my-eval3 (cadr args) env)
      (my-eval3 (caddr args) env)))
   ((setq)
    (my-eval3-setq (car args) (my-eval3 (cadr args) env)))
   ((defun)
    (my-eval3-setq (car args)
		   (my-eval3
		    (list* 'lambda (cadr args) (cddr args))
		    env))
    (car args))
   ((lambda)
    (my-eval3-make-closure (cons 'lambda args) env))
   ((progn)
    (my-eval3-progn args env))
   ((let let*)
    (my-eval3-letX fun (car args) (cdr args) env))
   ;; Functoin call
   (t
    (my-eval3-apply (my-eval3 fun env)
		    (mapcar '(lambda (s) (my-eval3 s env)) args)))))

(defun my-eval3-make-closure (lam env)
  (list 'closure lam env))
  
(defun my-eval3-apply (funobj args)
  ;; $B4X?tK\BN(B funobj $B$r!JI>2A:Q$_!K0z?t(B args $B$KE,MQ$9$k!#(B
  ;; $BK\4X?t$G$O(B funobj $B$,%7%s%\%k$N>l9g$O(B my-eval3-apply-primitive $B$r(B
  ;; $B$=$&$G$J$1$l$P%/%m!<%8%c$G$"$k$H2>Dj$7$F(B my-eval3-apply-closure $B$r(B
  ;; $B8F$S=P$9!#(B
  (if (symbolp funobj)
      (my-eval3-apply-primitive funobj args)
    (my-eval3-apply-closure funobj args)))

(defun my-eval3-apply-primitive (prim args)
  ;; $B%W%j%_%F%#%V(B prim $B$r!JI>2A:Q$_!K0z?t(B args $B$KE,MQ$9$k!#(B
  ;; $B%W%j%_%F%#%V$O(B my-FOO $B$H$$$&%7%s%\%k$G$"$j!"(BEmacsLisp $B$N(B FOO $B$HF1$80UL#!#(B
  ;; (my-eval3-apply-primitive 'my-cons '(a (b c))) => (a b c)
  ;; prim $B$,(B my-{car,cdr,cons,atom,equal} $B0J30$N>l9g$O0J2<$N%(%i!<$r=P$9!#(B
  ;; (error "Unknwon primitive function: %s" prim)
  (case prim
   (my-car (car (car args)))
   (my-cdr (cdr (car args)))
   (my-cons (cons (car args) (cadr args)))
   (my-atom (atom (car args)))
   (my-equal (equal (car args) (cadr args)))
   (t
    (error "Unknwon primitive function: %s" prim))))

(defun my-eval3-apply-closure (clo args)
  ;; $B%/%m!<%8%c(B lam $B$r!JI>2A:Q$_!K0z?t$KE,MQ$9$k!#(B
  ;; (setq clo (my-eval3-make-closure '(lambda (x) (cons N x))  '((N 0))))
  ;; (my-eval3-apply-closure clo '(1 2)) => (0 1 2)
  ;; clo $B$,(B closure $B$G;O$^$k%j%9%H$G$J$1$l$P0J2<$N%(%i!<$r=P$9!#(B
  ;; (error "Illegal closure: %s" clo)
  ;; $B@5Ev$J%/%m!<%8%c$+$I$&$+$K$D$$$F$N!"$h$j>\:Y$J%A%'%C%/$OITMW!#(B
  (unless (eq (car-safe clo) 'closure)
    (error "Illegal closure: %s" clo))
  (let ((lam (cadr clo))
	(env (caddr clo)))
    (my-eval3-progn (cddr lam)
		    (append (my-zip (cadr lam) args) env))))

(defun my-eval3-progn (forms env)
  (let ((val nil))
    (dolist (form forms)
      (setq val (my-eval3 form env)))
    val))

(defun my-eval3-letX (letX binds forms env)
  ;; let $B$H(B let* $B$N=hM}(B
  ;; <letX>  = let | let*
  ;; <binds> = ({(<symbol> <exp>)})
  ;; <forms> = ({<form>})
  (let ((vars (mapcar 'car binds))
	(exps (mapcar 'cadr binds)))
    (ecase letX
      (let  (my-eval3-let  vars exps forms env))
      (let* (my-eval3-let* vars exps forms env)))))

(defun my-eval3-let (vars exps forms env)
  ;; let $B$N=hM}(B
  (my-eval3-progn forms (append (my-zip vars
					(mapcar '(lambda (e) (my-eval3 e env))
						exps))
				env)))
  
(defun my-eval3-let* (vars exps forms env)
  ;; let* $B$N=hM}!J(Blet $B$H$NHyL/$J0c$$$KCm0U!K(B
  (dolist (var vars)
    (setq env (cons (list var (my-eval3 (car exps) env)) env))
    (setq forms (cdr exps)))
  (my-eval3-progn forms env))


(defun my-eval3-test ()
  ;; elim $B%i%$%V%i%j$K$h$j%F%9%H$r9T$&!#(B
  ;; ESC x my-eval3-test $B$G5/F0!#(B
  (interactive)
  (elim "*my-eval3*") 
  (setq elim*eval 'my-eval3-toplevel))
