;;; ex7-ans.el

(load "ex6-ans.el")


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; $B5U9=J82r@O$NLdBj(B

(defun my-unparse (sexp)
  ;; (my-unparse (my-parse "(a*(1+b))-a/(2+(c-3))/((d/4)*(e-((5+f)-6+g)))"))
  ;; => "a*(1+b)-a/(2+c-3)/(d/4*(e-(5+f-6+g)))"
  ;; $BJdB-!'(Bwith-temp-buffer $B$O$"$N$h$&$JE57?E*$J%3!<%I$r=q$/$N$KJXMx$J%^%/%m!#(B
  ;; $B<B9T8e!"0l;~E*%P%C%U%!$O(B unwind-protect $B$5$l$?(B kill-buffer $B$G:o=|$5$l$k!#(B
  (with-temp-buffer
    (my-unparse-rec sexp '(toplevel nil))
    (buffer-string)))

(defun my-unparse-put (x)
  ;; Lisp $B%*%V%8%'%/%H$r%+%l%s%H%P%C%U%!$XA^F~$9$k!#(B
  ;; $BJdB-!'(B (insert (format "%s" x)) $B$G$b$h$$!#(B
  (insert (etypecase x
	    (string x)
	    (symbol (symbol-name x))
	    (number (number-to-string x)))))

(defun my-unparse-rec (sexp ctx)
  ;; S-$B<0(B sexp $B$r5U%Q!<%9$9$k!#%H!<%/%s$N=PNO$K$O(B my-unparse-put $B$r;H$&!#(B
  ;; $B3g8L$,I,MW$+$I$&$+$rCN$k$?$a$K!"J8L.>pJs(B ctx $B$r;2>H$9$k!#(B
  ;;  <ctx> = (<op> <pos>)
  ;;  <op>  = + | - | * | / | toplevel
  ;;  <pos> = left | right | nil
  (if (atom sexp)
      (my-unparse-put sexp)
    (let* ((op (car sexp))
	   (lexp (cadr sexp))
	   (rexp (caddr sexp))
	   (parenp (ecase (car ctx)
		     (toplevel nil)
		     (+ nil)
		     (* (memq op '(+ -)))
		     (- (if (eq (cadr ctx) 'left)
			    nil
			  (memq op '(+ -))))
		     (/ (if (eq (cadr ctx) 'left)
			    (memq op '(+ -))
			  (memq op '(+ - * /)))))))
      (when parenp
	(my-unparse-put "("))
      (my-unparse-rec lexp (list op 'left))
      (my-unparse-put op)
      (my-unparse-rec rexp (list op 'right))
      (when parenp
	(my-unparse-put ")")))))
  

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; my-spy

(defun my-spy (fmt &rest args)
  (let ((buf (get-buffer-create "*my-spy*")))
    (save-excursion
      (set-buffer buf)
      (goto-char (point-max))
      (insert (apply 'format fmt args) "\n")
      (set-window-point (display-buffer buf) (point))
      nil)))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; my-numbering-region

(defun my-numbering-region (beg end)
  (interactive "*r")
  (let* ((nl (count-lines beg end))
	 (fmt (format "%%%dd  " (truncate (1+ (log10 nl))))))
    (untabify beg end)
    (goto-char beg)
    (dotimes (n nl)
      (insert (format fmt (1+ n)))
      (forward-line 1))))


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; my-wordfreq-buffer

(defun my-wordfreq-buffer (&optional srcname)
  (interactive)
  (my-wordfreq-buffer-display (my-wordfreq-buffer-count-words) srcname))

(defun my-wordfreq-buffer-display (alist srcname)
  ;; $B=P8=IQEY>pJs(B alist $B$r(B *my-wordfreq* $B%P%C%U%!$XI=<($9$k!#(B
  (let ((srcbuf (current-buffer))
	(dspbuf (get-buffer-create "*my-wordfreq*")))
    (save-excursion
      (set-buffer dspbuf)
      (erase-buffer)
      (insert (format "The frequency list of the words in %S\n\n"
		      (or srcname (buffer-name srcbuf))))
      (dolist (a alist)
	(insert (format "%-16s : %d\n" (car a) (cadr a))))
      (goto-char (point-min))
      (display-buffer dspbuf))))

(defun my-wordfreq-buffer-count-words ()
  ;; $B%+%l%s%H%P%C%U%!$N1QC18l$N=P8=IQEY$r0J2<$N$h$&$J(B alist $B$H$7$FJV$9!#(B
  ;; $B=g=x$O=P8=IQEY(B <freq> $B$N9b$$=g$K%=!<%H$5$l$F$$$k!#(B
  ;;  <alist> = ({(<words> <freq>)})
  ;;  <words> = <string>
  ;;  <freq>  = <number>
  (save-excursion
    (goto-char (point-min))
    (let ((alist nil))
      (while (re-search-forward "[a-zA-Z][-a-zA-Z]*" nil t)
	(let ((word (match-string 0)))
	  (let ((a (assoc word alist)))
	    (if a
		(incf (cadr a))
	      (push (list word 1) alist)))))
      (sort alist '(lambda (x y) (> (cadr x) (cadr y)))))))
