(require 'cl)

(defun my-wordfreq-batch ()
  ;; EMACS -batch -l my-wordfreq.el -f my-wordfreq-batch  srcfile [objfile]
  (unless command-line-args-left
    (message "Usage: my-wordfreq srcfile [objfile]")
    (kill-emacs 1))
  (let ((srcfile (car command-line-args-left))
	(objfile (cadr command-line-args-left)))
    (with-temp-buffer
      (insert-file-contents srcfile)
      (my-wordfreq-buffer srcfile)
      (set-buffer "*my-wordfreq*")
      (if objfile
	  (write-region (point-min) (point-max) objfile)
	(princ (buffer-string)))))
  (kill-emacs 0))


(defun my-wordfreq-buffer (&optional srcname)
  (interactive)
  (my-wordfreq-buffer-display (my-wordfreq-buffer-count-words) srcname))

(defun my-wordfreq-buffer-display (alist srcname)
  ;; opx alist  *my-wordfreq* obt@֕\B
  (let ((srcbuf (current-buffer))
	(dspbuf (get-buffer-create "*my-wordfreq*")))
    (save-excursion
      (set-buffer dspbuf)
      (erase-buffer)
      (insert (format "The frequency list of the words in %S\n\n"
		      (or srcname (buffer-name srcbuf))))
      (dolist (a alist)
	(insert (format "%-16s : %d\n" (car a) (cadr a))))
      (goto-char (point-min))
      (display-buffer dspbuf))))

(defun my-wordfreq-buffer-count-words ()
  ;; Jgobt@̉pP̏opxȉ̂悤 alist ƂĕԂB
  ;; ͏opx <freq> ̍Ƀ\[gĂB
  ;;  <alist> = ({(<words> <freq>)})
  ;;  <words> = <string>
  ;;  <freq>  = <number>
  (save-excursion
    (goto-char (point-min))
    (let ((alist nil)
	  (htab (make-hash-table :test 'equal)))
      (while (re-search-forward "[a-zA-Z][-a-zA-Z]*" nil t)
	(let ((word (match-string 0)))
	  (if (gethash word htab)
	      (incf (gethash word htab))
	    (setf (gethash word htab) 1))))
      (maphash '(lambda (key val)
		  (push (list key val) alist))
	       htab)
      (sort alist '(lambda (x y) (> (cadr x) (cadr y)))))))

