;;;; rbgxN^
;;;; LastChange: Sat Feb 10 10:13:14 2007


(defstruct (bitvec (:constructor make-bitvec-raw)
		   (:copier copy-bitvec-raw))
  ;; <Fixnum> = bitvec=fixnum-bits bit signed integer
  length
  ;; $ Ŏn܂郁o[̓vCx[g
  $vec ;vector (/ (+ len bitvec=fixnum-bits -1) bitvec=fixnum-bits) of <Fixnum>
  )


(defconst bitvec=fixnum-bits
  (1+ (ceiling (log (lsh -1 -1) 2))))


(defun make-bitvec (len)
  " LEN ̃rbgxNgB"
  (let ((bv (make-bitvec-raw)))
    (setf (bitvec-length bv) len
	  (bitvec-$vec bv) (make-vector (/ (+ len bitvec=fixnum-bits -1)
					   bitvec=fixnum-bits) 0))
    bv))

(defun bitvec-ref (bv i)
  "rbgxN^ BV ̑ I rbgԂB"
  (if (zerop (logand (aref (bitvec-$vec bv) (/ i bitvec=fixnum-bits))
		     (lsh 1 (% i bitvec=fixnum-bits))))
      0
    1))

(defun bitvec-set (bv i bit)
  "rbgxN^ BV ̑ I rbg BIT ɐݒ肷B"
  (let ((j (/ i bitvec=fixnum-bits)))
    (aset (bitvec-$vec bv)
	  j
	  (if (zerop bit)
	      (logand (aref (bitvec-$vec bv) j)
		      (lognot (lsh 1 (% i bitvec=fixnum-bits))))
	    (logior (aref (bitvec-$vec bv) j)
		    (lsh 1 (% i bitvec=fixnum-bits)))))
    bit))

(defsetf bitvec-ref bitvec-set)

(defun copy-bitvec (bv)
  (let ((bv1 (copy-bitvec-raw bv)))
    (setf (bitvec-$vec bv1) (copy-sequence (bitvec-$vec bv)))
    bv1))


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; {Z

(defun bitvec-and (bv1 bv2)
  "rbgxN^ BV1  BV2 ̘_ςԂB"
  (bitvec-apply-internal (make-bitvec (min (bitvec-length bv1)
					   (bitvec-length bv2)))
			 #'logand bv1 bv2))
    
(defun bitvec-ior (bv1 bv2)
  "rbgxN^ BV1  BV2 ̘_aԂB"
  (bitvec-apply-internal (make-bitvec (min (bitvec-length bv1)
					   (bitvec-length bv2)))
			 #'logior bv1 bv2))

(defun bitvec-xor (bv1 bv2)
  "rbgxN^ BV1  BV2 ̔rI_aԂB"
  (bitvec-apply-internal (make-bitvec (min (bitvec-length bv1)
					   (bitvec-length bv2)))
			 #'logxor bv1 bv2))

(defun bitvec-not (bv)
  "rbgxN^ BV ̘_ےԂB"
  (bitvec-apply-internal (make-bitvec (bitvec-length bv))
			 #'lognot bv))

(defun bitvec-nand (bv1 bv2)
  "rbgxN^ BV1  BV2 ̘_ς BV1 ɔjIɃZbgABV1 ԂB"
  (bitvec-apply-internal bv1 #'logand bv1 bv2))
    
(defun bitvec-nior (bv1 bv2)
  "rbgxN^ BV1  BV2 ̘_a BV1 ɔjIɃZbgABV1 ԂB"
  (bitvec-apply-internal bv1 #'logior bv1 bv2))

(defun bitvec-nxor (bv1 bv2)
  "rbgxN^ BV1  BV2 ̔rI_a BV1 ɔjIɃZbgA
BV1 ԂB"
  (bitvec-apply-internal bv1 #'logxor bv1 bv2))

(defun bitvec-nnot (bv)
  "rbgxN^ BV ̘_ے BV ɔjIɃZbgABV ԂB"
  (bitvec-apply-internal bv #'lognot bv))


(defun bitvec-apply-internal (ret op &rest args)
  ;; ret := op(args)
  ;; op: logand | logior | logxor | lognot
  (dotimes (i (length (bitvec-$vec ret)))
    (aset (bitvec-$vec ret) i (apply op (mapcar #'(lambda (bv)
						    (aref (bitvec-$vec bv) i))
						args))))
  ret)
				     

(defun bitvec-neg (bv)
  "rbgxN^ BV  2 iƂ݂Ƃ̕]B"
  (let ((bv (bitvec-not bv))
	(carry t))
    (dotimes (i (length (bitvec-$vec bv)))
      (unless carry (return))
      (if (= -1 (aref (bitvec-$vec bv) i))
	  (aset (bitvec-$vec bv) i 0)
	(aset (bitvec-$vec bv) i
	      (1+ (aref (bitvec-$vec bv) i)))
	(setq carry nil)))
    bv))

(defun bitvec-lsh (bv n)
  "rbgxN^ BV ̘_VtgB"
  ;; ̈R[h
  (let ((bvl (bitvec-to-list bv))
	(len (bitvec-length bv)))
    (list-to-bitvec
     (if (<= 0 n)
	 (append (nthcdr (min len n) bvl)
		 (make-list (min len n) 0))
       (append (make-list (min len (- n)) 0)
	       (nbutlast bvl (min len (- n))))))))

(defun bitvec-ash (bv n)
  "rbgxN^ BV ̎ZpVtgB"
  ;; ̈R[h
  (let ((bvl (bitvec-to-list bv))
	(len (bitvec-length bv)))
    (if (<= 0 n)
	(bitvec-lsh bv n)
      (list-to-bitvec
       (append (make-list (min len (- n)) (car bvl))
	       (nbutlast bvl (min len (- n))))))))
     

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; ϊ

(defun bitvec-to-list (bv)
  "rbgxN^ BV rbg̃XgɕϊB"
  (let ((ret nil))
    (dotimes (i (bitvec-length bv))
      (push (bitvec-ref bv i) ret))
    ret))

(defun list-to-bitvec (list)
  "rbg̃XgrbgxN^ɕϊB"
  (let ((bv (make-bitvec (length list)))
	(i 0))
    (dolist (bit (reverse list))
      (bitvec-set bv i (if (zerop bit) 0 1))
      (setq i (1+ i)))
    bv))

(defun bitvec-to-str (bv)
  "rbgxN^ BV  Common Lisp ̕\Lɏ]ĕɕϊB
Example:
 (bitvec-to-str (list-to-bitvec '(1 0 1 1))) => \"#*1011\""
  (concat "#*"
	  (list-to-string
	   (mapcar '(lambda (b) (+ b ?0))
		   (bitvec-to-list bv)))))

(defun str-to-bitvec (str)
  "Common Lisp ̕\Lɏ]ĕ STR rbgxN^ɕϊB
Example:
 (bitvec-to-list (str-to-bitvec \"#*1011\")) => (1 0 1 1)"
  (save-match-data
    (unless (string-match "\\`#\\*[01]+\\'" str)
      (error "str-to-bitvec: Illegal bitvector syntax: %s" str))
    (list-to-bitvec
     (mapcar '(lambda (c) (if (= c ?0) 0 1))
	     (string-to-list (substring str 2))))))



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; ELIM v^̐ݒ

(when (featurep 'elim)
  (elim-add-printer
   #'bitvec-p
   #'(lambda (x) (format "%S" (bitvec-to-str x)))))


;;;
(provide 'bitvec)
