;;;; LbV@\
;;;; LastChange: Wed Apr 11 01:16:51 2007

;;; ڍׂ with-cache ̃hLgQƂ̂ƁB

(require 'advice)


(defvar with-cache-hash-table
  (make-hash-table :test 'equal)
  "with-cache }N cachename -> hash-table")

(defun reset-cache ()
  "SẴLbVZbgB"
  (interactive)
  (setq with-cache-hash-table
	(make-hash-table :test 'equal)))

(defun list-cache ()
  "SẴLbV̓e\B"
  (interactive)
  (with-display-buffer "*cache-list*"
    (let ((hashtables nil)
	  (print-circle t))
      (maphash #'(lambda (name hashtab)
		   (push (list name hashtab)
			 hashtables))
	       with-cache-hash-table)
      (setq hashtables
	    (sort hashtables
		  #'(lambda (x y) (string< (car x) (car y)))))
      (dolist (h hashtables)
	(insertf "%s:\n" (car h))
	(let ((kvs nil))
	  (maphash #'(lambda (keyfreq val)
		       (push (list keyfreq val) kvs))
		   (cadr h))
	  (setq kvs (sort kvs
			  ;; freq Ń\[g
			  #'(lambda (kv1 kv2)
			      (> (cadr (cadr kv1)) (cadr (cadr kv2))))))
	  (dolist (kv kvs)
	    (insertf "  key=%S  freq=%d  val=%S\n"
		     (car kv)
		     (cadr (cadr kv))
		     (car (cadr kv)))))
	(newline)))))


(defvar disable-with-cache
  nil
  "Non-nil Ȃ with-cache }N̓LbVsȂB
 with-cache ̌ʂ𒲂ׂ邽߂ɁAꎞIɎgptOłB")

(defmacro with-cache (cachename key &rest body)
  " CACHENAME ̃LbVi:test 'equal ̃nbVjL[ KEY
̒lA΂ԂBȂ BODY sAʂ̒lLbV
ɓo^B̒l KEY ݂̂Ɉˑ̂łȂ΂ȂȂB
reset-cache R}h͑SẴLbVZbgB
list-cache R}h͑SẴLbV̓e\B

Example:
;; elim ňȉ̎sԂrB

 (defun fibo (n)
   ;; (fibo 26) => 121393
   (if (<= n 1)
       n
     (+ (fibo (- n 1))
        (fibo (- n 2)))))

 (defun fibo-cache (n)
   ;; (fibo-cache 26) => 121393
   (with-cache \"(fibo-cache n)\" n
     (if (<= n 1)
	 n
       (+ (fibo-cache (- n 1))
	  (fibo-cache (- n 2))))))"
  `(if (not disable-with-cache)
       (let* ((-cachename- ,cachename)
	      (-key- ,key)
	      (-hashtab- (or (gethash -cachename-
				      with-cache-hash-table)
			     (puthash -cachename-
				      (make-hash-table :test 'equal)
				      with-cache-hash-table)))
	      (-valfreq- (gethash -key- -hashtab-)))
	 (cond
	  ((consp -valfreq-)
	   ;; -valnuse- = (val freq)
	   (incf (cadr -valfreq-))
	   (car -valfreq-))
	  (t
	   (car (puthash -key- (list (progn ,@body) 1) -hashtab-)))))
     ;;  body ӏɁc
     ,@body))

(put 'with-cache 'lisp-indent-function 2)



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; R[hC with-cache Ԃ@\B

(defun attach-cache (func)
  "֐iV{jFUNC  around advice 𗘗p cache tB
֐LbVƂȂASĂ̈̃XgL[ƂȂ悤
with-cache ÖٓIɑ}B
́A܂ł with-cache ̌ʂ𒲂ׂ邽߂ɈꎞIɎgpA
KvȂ炻̊֐ɓK؂ with-cache }B
 around advice ɂ detach-cache R}h FUNC w肷B"
  (interactive "aAttach cache: ")
  (eval `(defadvice ,func (around cache-advice activate)
	   (setq ad-return-value
		 (with-cache ,(symbol-name func) (ad-get-args 0)
		   ad-do-it)))))

(defun cache-attached-function-p (func)
  ;;  advice pbP[WˑB
  (and (symbolp func)
       (fboundp func)
       (let ((def (symbol-function func)))
	 (and (byte-code-function-p def)
	      (memq 'with-cache-hash-table (vector-to-list (aref def 2)))))))

(defun detach-cache (func)
  "attach-cache  with-cach ꂽ֐ FUNC LbVOB"
  (interactive
   (list
    (let ((ad-advised-functions
	   (filter #'(lambda (x)
		       (cache-attached-function-p (intern (car x))))
		   ad-advised-functions)))
      (ad-read-advised-function "Detach cache: " 'ad-is-active))))
  (ad-deactivate func))

;;;
(provide 'cache)
