;;;; next, prev NL[
;;;; defstruct  include ĎgpB
;;;; LastChange: Thu Apr 12 09:01:57 2007


(defstruct dque
  "NXg"
  next
  prev
  ;; 
  data)


(defun make-dque-header (&optional d)
  "<dequeu> wb_[BIvVi D:<dque>|nil  Non-nil ȂA
D wb_[ƂăZbgAbvAD ԂB"
  (unless d
    (setq d (make-dque)))
  (link2-dque d d)
  (setf (dque-data d) 'dque-header)
  d)

(defun dque-header-p (x)
  "X  dque wb_ǂ肷B"
  (and (dque-p x)
       (eq (dque-data x) 'dque-header)))

(defun dque-empty-p (dqh)
  "DQH:<dque> wb_Ƃ dque 󂩂ǂ肷B"
  (assert (dque-header-p dqh))
  (eq (dque-next dqh) dqh))

(defun first-dque (dqh)
  "DQH:<dque> wb_Ƃ dque ̍ŏ̗vfAȂ DQH ԂB"
  (assert (dque-header-p dqh))
  (dque-next dqh))

(defun last-dque (dqh)
  "DQH:<dque> wb_Ƃ dque ̍Ō̗vfAȂ DQH ԂB"
  (assert (dque-header-p dqh))
  (dque-prev dqh))

(defun link2-dque (d1 d2)
  "D1,D2:<dque> ̏ɌqB"
  (setf (dque-next d1) d2
	(dque-prev d2) d1)
  nil)

(defun link3-dque (d1 d2 d3)
  "D1,D2,D3:<dque> ̏ɌqB"
  (setf (dque-next d1) d2
	(dque-next d2) d3
	(dque-prev d3) d2
	(dque-prev d2) d1)
  nil)

(defun insert-dque (d1 d2)
  "D1 ̑O D2 NAD2 ԂB
D1 wb_ȂL[̍Ōɒǉ邱ƂɂȂB"
  (link3-dque (dque-prev d1) d2 d1)
  d2)

(defun append-dque (d1 d2)
  "D1 ̌ D2 NAD2 ԂB"
  (link3-dque d1 d2 (dque-next d1))
  d2)

(defun merge-dque (dqh1 dqh2)
  "DQH1:<dque> ̌ DQH2:<dque> qADQH1 ԂB
Example:
 -> (setq dqh1 (list-to-dque '(a b c)))
 #<dque header (a b c)>
 -> (setq dqh2 (list-to-dque '(d e f)))
 #<dque header (d e f)>
 -> (merge-dque dqh1 dqh2)
 #<dque header (a b c d e f)>
 -> dqh2
 #<dque header nil>"
  (assert (dque-header-p dqh1))
  (assert (dque-header-p dqh2))
  (link2-dque (last-dque dqh1) (first-dque dqh2))
  (link2-dque (last-dque dqh2) dqh1)
  (make-dque-header dqh2)
  dqh1)

(defun delete-dque (d)
  "D L[폜B"
  (link2-dque (dque-prev d) (dque-next d))
  d)


(defmacro* dodque ((var dqh) &rest body)
  "DQH:<dque> wb_Ƃ dque ̊evf (<dque>) 
VAR ɑABODY s (block nil ...) ň͂܂ꂽ[vB"
  `(let ((,var ,dqh))
     (assert (dque-header-p ,dqh))
     (block nil
       (while (neq (setq ,var (dque-next ,var))
		   ,dqh)
	 ,@body))))

(put 'dodque 'lisp-indent-function 1)

(defmacro* dodque-reverse ((var dqh) &rest body)
  "DQH:<dque> wb_Ƃ dque ̊evf (<dque>) t
AR ɑA BODY s (block nil ...) ň͂܂ꂽ[vB"
  `(let ((,var ,dqh))
     (assert (dque-header-p ,dqh))
     (block nil
       (while (neq (setq ,var (dque-prev ,var))
		   ,dqh)
	 ,@body))))

(put 'dodque-reverse 'lisp-indent-function 1)


(font-lock-add-keywords 'emacs-lisp-mode
  `((,(concat "(" (regexp-opt
		   '("dodque" "dodque-reverse") t)
	      "\\>")
     1
     font-lock-keyword-face)))

(defun list-to-dque (list)
  "LIST L[ɕϊāAwb_ԂB"
  (let ((dqh (make-dque-header)))
    (dolist (x list)
      (insert-dque dqh (make-dque :data x)))
    dqh))

(defun dque-to-list (dqh)
  "L[XgɕϊB"
  (assert (dque-header-p dqh))
  (let ((ret nil))
    (dodque (d dqh)
      (push (dque-data d) ret))
    ;;
    (nreverse ret)))
  

;;;

(when (featurep 'elim)
  (elim-add-printer
   #'dque-p
   #'(lambda (x) (format "#<dque :data %S>" (dque-data x))))
  (elim-add-printer
   #'dque-header-p
   #'(lambda (x) (format "#<dque header %S>" (dque-to-list x)))))


;;;
(provide 'dque)
