;;;; Flow Graph \
;;;; LastChange: Thu Apr 12 23:36:59 2007


;;; {Cu͖ߗƃt[OtƂ̑ݕϊ񋟂B
;;; uߗv͈ȉ̏𖞂Cӂ̖߂̃Xgł悢B
;;; 
;;; 1. אڂ{ubN͑O҂ŏIA҂xŎn܂邱ƁB
;;; 2. ߂ƂāAꂪx`ł邩ǂԂ֐`oB
;;; 3. ߂ƂāÃxXgԂ֐`oB
;;;
;;; {Cuł͎O̃f[^\񋟂F
;;; 1. fstmt - t[Ot̃m[h fnode yяL 2.,3. ̊֐ێB
;;; 2. fnode - t[Ot̕ fstmt ̓Xg <dque> ێB
;;; 3. fstmt - u߁vێXgB
;;;
;;; ڂ̓fR}h ESC x fgraph-demo RET QƂ̂ƁB


(require 'que)
(require 'dque)


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; fgraph.el 񋟂O̃f[^\ fgraph, fnode, fstmt


;;; t[Ot fgraph

(defstruct fgraph
  ;;  擪Jnm[hōŌオIm[hB
  (fnodedqh (make-fnode-header)) ; [gm[h͕K݂B
  ;;  <Expr> x`ł邩ǂ𔻒肷֐
  deflabel  ; <Expr> -> <Label>|nil
  ;;  <Expr> 򖽗߂ȂÃ̕xXgԂ֐
  reflabels ; <Expr> -> (<Label>..)
  ;; ȉ fgraph-to-str  <Expr> 𕶎ɕϊۂɎQƂB
  printexpr ; <Expr> -> <String>  |  nil
  )

(defun root-fnode (fgraph)
  "FGRAPH:<fgraph> ̃[gm[h ifnodedqh ̐擪vfjԂB
⑫FFGRAPH ɂ͕K[gm[hB"
  (dque-next (fgraph-fnodedqh fgraph)))

(defun last-fnode (fgraph)
  "FGRAPH:<fgraph>  next - prev N̍Ō̃m[hԂB"
  (dque-prev (fgraph-fnodedqh fgraph)))

(defun label-to-fnode (fgraph label)
  "FGRAPH:<fgraph>  LABEL:<Label>  fnode ԂB"
  (let ((deflabel (fgraph-deflabel fgraph)))
    (block return
      (dofnode (fnode (fgraph-fnodedqh fgraph))
	(when (equal
	       (funcall deflabel
			(fstmt-expr (first-fstmt fnode)))
	       label)
	  (return-from return fnode)))
      (error "No such label: %S" label))))

(defun fnode-to-deflabel (fgraph fnode)
  "FGRAPH:<fgraph>  FNODE:<fnode> Œ`Ă郉xԂB"
  (funcall (fgraph-deflabel fgraph)
	   (fstmt-expr (first-fstmt fnode))))

(defun fnode-to-reflabels (fgraph fnode)
  "FGRAPH:<fgraph>  FNODE:<fnode> ̕惉x̃XgԂB"
  (funcall (fgraph-reflabels fgraph)
	   (fstmt-expr (last-fstmt fnode))))

(defun deflabels-of-fgraph (fgraph)
  "FGRAPH:<fgraph> Œ`Ă郉x̃XgiojԂB"
  (let ((labelq (make-que)))
    (dofnode (fnode fgraph)
      (append-que labelq (fnode-to-deflabel fgraph fnode)))
    (que-to-list labelq)))

(defun fgraph-to-exprlist (fgraph)
  "FGRAPH:<fgraph>|<fnode:header> XgɕϊB"
  (let ((exprq (make-que)))
    (dofnode (fnode fgraph)
      (dofstmt (fstmt fnode)
	(append-que exprq (fstmt-expr fstmt))))
    (que-to-list exprq)))

(defun fgraph-to-str (fgraph)
  "FGRAPH:<fgraph> ₷ɕϊB"
  (with-temp-buffer
    (dofnode (fnode fgraph)
      (unless (bobp)
	(newline))
      (insertf ";; %S->*->%S\n"
	       (mapcar '(lambda (n) (fnode-to-deflabel fgraph n))
		       (fnode-pred fnode))
	       (mapcar '(lambda (n) (fnode-to-deflabel fgraph n))
		       (fnode-succ fnode)))
      (dofstmt (fstmt fnode)
	(insertf "%s\n" (funcall (or (fgraph-printexpr fgraph)
				     'prin1-to-string)
				 (fstmt-expr fstmt)))))
    (buffer-string)))



;;; t[Ot̃m[h fnode (:include dque)

(defstruct (fnode (:include dque))
  ;; fstmt L[̃wb_
  (fstmtdqh (make-fstmt-header))
  ;; succ, pred : (<fnode>..)
  succ pred
  ;; [g瓞B̂ǂ
  reachable)

(defun first-fstmt (fnode)
  "FNODE:<fnode> ̍ŏ fstmt"
  (dque-next (fnode-fstmtdqh fnode)))

(defun last-fstmt (fnode)
  "FNODE:<fnode> ̍Ō fstmt"
  (dque-prev (fnode-fstmtdqh fnode)))

(defun make-fnode-header ()
  (make-dque-header (make-fnode)))

(defun fnode-header-p (fnode)
  (and (fnode-p fnode)
       (dque-header-p fnode)))

(defalias 'insert-fnode 'insert-dque)
(defalias 'append-fnode 'append-dque)
(defalias 'delete-fnode 'delete-dque)

(defmacro* dofnode ((var fgraph) &rest body)
  "FGRAPH:<fgraph>|<fnode:header>  fnode (fnode-next) VAR ɑA
BODY s (block nil ...) ň͂܂ꂽ[vB"
  `(dodque (,var (dofnode/coerce-to-fnodedqh ,fgraph)) ,@body))
(put 'dofnode 'lisp-indent-function 1)

(defmacro* dofnode-reverse ((var fgraph) &rest body)
  "FGRAPH:<fgraph>|<fnode:header>  fnode t(fnode-prev) VAR ɑA
BODY s (block nil ...) ň͂܂ꂽ[vB"
  `(dodque-reverse (,var (dofnode/coerce-to-fnodedqh ,fgraph)) ,@body))
(put 'dofnode-reverse 'lisp-indent-function 1)

(defun dofnode/coerce-to-fnodedqh (x)
  ;; X:<fgraph>|<fnode:header>
  (etypecase x
    (fgraph (fgraph-fnodedqh x))
    (fnode x)))


(defun exprlist-to-fnode (exprlist)
  "̃Xg fnode ɕϊB"
  (let ((fnode (make-fnode)))
    (dolist (e exprlist)
      (insert-fstmt (fnode-fstmtdqh fnode)
		    (make-fstmt :expr e)))
    fnode))

(defun fnode-to-exprlist (fnode)
  "FNODE:<fnode>|<fstmt:header> XgɕϊB"
  (let ((exprq (make-que)))
    (dofstmt (fstmt fnode)
      (append-que exprq (fstmt-expr fstmt)))
    (que-to-list exprq)))


;;; {ubN fstmt (:include dque)

(defstruct (fstmt (:include dque))
  expr)

(defun make-fstmt-header ()
  (make-dque-header (make-fstmt)))

(defun fstmt-header-p (fstmt)
  (and (fstmt-p fstmt)
       (dque-header-p fstmt)))

(defalias 'insert-fstmt 'insert-dque)
(defalias 'append-fstmt 'append-dque)
(defalias 'delete-fstmt 'delete-dque)

(defmacro* dofstmt ((var fnode) &rest body)
  "FNODE:<fnode>|<fstmt:header>  fstmt  VAR ɑA
BODY s (block nil ...) ň͂܂ꂽ[vB"
  `(dodque (,var (fnode-fstmtdqh ,fnode)) ,@body))
(put 'dofstmt 'lisp-indent-function 1)

(defmacro* dofstmt-reverse ((var fnode) &rest body)
  "FNODE:<fnode>|<fstmt:header>  fstmt t VAR ɑA
BODY s (block nil ...) ň͂܂ꂽ[vB"
  `(dodque-reverse (,var (fnode-fstmtdqh ,fnode)) ,@body))
(put 'dofstmt-reverse 'lisp-indent-function 1)

(defun dofstmt/coerce-to-fstmtdqh (x)
  ;; X:<fnode>|<fstmt:header>
  (etypecase x
    (fnode (fnode-fstmtdqh x))
    (fstmt x)))


(font-lock-add-keywords 'emacs-lisp-mode
  `((,(concat "(" (regexp-opt
		   '("dofnode" "dofnode-reverse"
		     "dofstmt" "dofstmt-reverse") t)
	      "\\>")
     1
     font-lock-keyword-face)))


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; exprlist -> fgraph

(defun exprlist-to-fgraph (exprlist deflabel reflabels &optional printexpr)
  "EXPRLIST: (<Expr>..)
EXPRLIST ͊{ubNK𖞂̗

x`ł邩Ał邩͈ȉ̊֐Œ߂B
DEFLABEL : <Expr> -> <Label>|nil
REFLABELS  : <Expr> -> (<Label>..)

Return: <fgraph>"
  (let* ((fgraph (make-fgraph :deflabel deflabel
			      :reflabels reflabels
			      :printexpr (or printexpr 'prin1-to-string)))
	 (prevexpr nil)
	 (alllabels nil))
    (dolist (expr exprlist)
      (let ((dlabel (funcall deflabel expr))
	    (rlabels (funcall reflabels expr)))
	(cond
	 ;;
	 ;; VȊ{ubN̊Jn
	 ;;
	 (dlabel
	  (append-fnode (last-fnode fgraph) (make-fnode))
	  ;; x̒O͕łȂ΂ȂȂB
	  (unless (or (null prevexpr)
		      (funcall reflabels prevexpr))
	    (error "illegal exprlist (nojump before %S)" expr))
	  ;; x̒`Ɠd``FbN
	  (cond
	   ((member dlabel alllabels)
	    (error "illegal exprlist (duplicated label %S)" dlabel))
	   (t
	    (push dlabel alllabels))))
	 ;;
	 ;; {ubN̏I
	 ;;
	 (rlabels )
	 ;;
	 ;; {ubŇp
	 ;;
	 (t
	  ;; ʏ̎̒O͕łĂ͂ȂȂB
	  (when (and prevexpr
		     (funcall reflabels prevexpr))
	    (error "illegal exprlist (nolabel before %S)" expr)))))
      ;;
      ;; Ō̊{ubN̍Ō̕ƂĒǉ
      ;;
      (insert-fstmt (fnode-fstmtdqh (last-fnode fgraph))
		    (make-fstmt :expr expr))
      (setq prevexpr expr))
    ;;
    ;; `x̃`FbN
    ;;
    (dofnode (fnode fgraph)
      (dofstmt (fstmt fnode)
	(dolist (rlabel (funcall reflabels (fstmt-expr fstmt)))
	  (unless (member rlabel alllabels)
	    (error "illegal exprlist (undefned label %S)" rlabel)))))
    ;;
    (set-succ-pred-fgraph fgraph)))

(defun set-succ-pred-fgraph (fgraph)
  "FGRAPH:<fgraph>  succ, pred ݒ肵AFGRAPH ԂB"
  (dofnode (fnode fgraph)
    (setf (fnode-succ fnode) nil
	  (fnode-pred fnode) nil))
  ;;
  (dofnode (fnode fgraph)
    (dolist (lab (fnode-to-reflabels fgraph fnode))
      (let ((fnode1 (label-to-fnode fgraph lab)))
	(push fnode1 (fnode-succ fnode))
	(push fnode (fnode-pred fnode1)))))
  ;;
  (dofnode (fnode fgraph)
    (setf (fnode-succ fnode) (nreverse (fnode-succ fnode))
	  (fnode-pred fnode) (nreverse (fnode-pred fnode))))
  ;;
  fgraph)


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; 

(defun delete-unreachable-fnodes (fgraph)
  "BoȂ fnode 폜B
ۂɂubN폜ꂽꍇ t ԂA
Ō set-succ-pred-fgraph  succ, pred 𐳂ݒ肷B
łȂ nil ԂB"
  (let ((deleted nil))
    (dofnode (fnode fgraph)
      (setf (fnode-reachable fnode) nil))
    ;;
    (mark-reachable-fnodes fgraph)
    ;;
    (dofnode (fnode fgraph)
      (unless (fnode-reachable fnode)
	(delete-fnode fnode)
	(setq deleted t)))
    ;;
    (cond
     (deleted
      (set-succ-pred-fgraph fgraph)
      t)
     (t
      nil))))

(defun mark-reachable-fnodes (fgraph)
  "[g瓞B\ fnode  fnode-reachable  t ɁABs\Ȃ nil 
ZbgAFGRAPH ԂB"
  (dofnode (fnode fgraph)
      (setf (fnode-reachable fnode) nil))
  (mark-reachable-fnodes/aux (root-fnode fgraph))
  ;;
  fgraph)

(defun mark-reachable-fnodes/aux (fnode)
  (unless (fnode-reachable fnode)
    (setf (fnode-reachable fnode) t)
    (dolist (fnode (fnode-succ fnode))
      (mark-reachable-fnodes/aux fnode))))


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; test

(defconst fgraph-sample-exprlist
  '((deflabel "L0")
    (jumpc a "L1" "L2")
    ;;
    (deflabel "L1")
    (setq x 1)
    (jump "L3")
    ;;
    (deflabel "L2")
    (setq y 2)
    (jumpc z "L1" "L3")
    ;;
    (deflabel "L3")
    (epilogue)))

(defun fgraph-sample-deflabel (expr)
  ;; (fgraph-sample-deflabel '(deflabel "L1")) => "L1"
  ;; (fgraph-sample-deflabel '(setq x 1)) => nil
  (if (eq (car expr) 'deflabel)
      (cadr expr)
    nil))

(defun fgraph-sample-reflabels (expr)
  ;; (fgraph-sample-reflabels '(jump "L1")) => ("L1")
  ;; (fgraph-sample-reflabels '(jumpc x "L1" "L2")) => ("L1" "L2")
  ;; (fgraph-sample-reflabels '(setq x 1)) => nil
  (cond
   ((eq (car expr) 'jump)
    (cdr expr))
   ((eq (car expr) 'jumpc)
    (cddr expr))))


(defun fgraph-demo (&optional exprlist)
  "SCK ʃCu fgraph.el ̃f"
  (interactive)
  (setq exprlist (or exprlist fgraph-sample-exprlist))
  (with-display-buffer "*fgraph-demo*"
    (insertf ";;; exprlist:\n")
    (insertf "%s\n" (pp-to-string exprlist))
    (insertf ";;; fgraph:\n")
    (let* ((fgraph (exprlist-to-fgraph exprlist
				       'fgraph-sample-deflabel
				       'fgraph-sample-reflabels)))
      (insertf "%s\n" (fgraph-to-str fgraph))
      (assert (equal exprlist (fgraph-to-exprlist fgraph)))
      ;;
      fgraph)))

;;;

(when (featurep 'elim)
  (elim-add-printer
   #'fgraph-p 
   #'fgraph-to-str))

;;;
(provide 'fgraph)
