;;;; 낢
;;;; LastChange: Tue Apr 10 18:25:38 2007


(defun filter (p x*)
  "q P 𖞂AXg X ̗vfȂ郊XgԂB
Example:
 (filter 'symbolp '(0 one 2)) => (one)"
  (let ((ret* nil))
    (dolist (e* x*)
      (when (funcall p e*)
	(push e* ret*)))
    (nreverse ret*)))

(defun foldr (f e* x*)
  "Example:
 (foldr '(lambda (x y) (list x ' y)) nil '(a b c)) 
 => (a  (b  (c  nil)))
 (foldr 'cons nil '(a b c))
 => (a b c)"
  (if (null x*)
      e*
    (funcall f (car x*) (foldr f e* (cdr x*)))))

(defun foldl (f e* x*)
  "Example:
 (foldl '(lambda (x y) (list x ' y)) nil '(a b c))
 => (((nil  a)  b)  c)"
  (if (null x*)
      e*
    (foldl f (funcall f e* (car x*)) (cdr x*))))


(defun zip (x y)
  "Example:
 (zip '(a b c) '(d e f)) => ((a d) (b e) (c f))"
  (let ((ret nil))
    (while (and x y)
      (setq ret (cons (list (car x) (car y)) ret)
	    x (cdr x)
	    y (cdr y)))
    (nreverse ret)))
    
(defun zip-with (f x* y*)
  "Example:
 (zip-with '* '(1 2 3) '(4 5 6)) => (4 10 18)"
  (let ((ret* nil))
    (while (and x* y*)
      (setq ret* (cons (funcall f (car x*) (car y*)) ret*)
	    x* (cdr x*)
	    y* (cdr y*)))
    (nreverse ret*)))

(defun unzip (x)
  "Example:
 (unzip '((a 1) (b 2) (c 3))) => ((a b c) (1 2 3))"
  (let ((r1 nil)
	(r2 nil))
    (while x
      (setq r1 (cons (caar x) r1)
	    r2 (cons (cadar x) r2)
	    x (cdr x)))
    (list (nreverse r1) (nreverse r2))))
	  

; subseq 
; (defun take (x n)
;   "Example:
;  (take '(a b c d) 2) => (a b)
;  (take '(a b c d) 10) => (a b c d)"
;   (let ((ret nil))
;     (dotimes (i n)
;       (unless x
;         (return))
;       (push (pop x) ret))
;     (nreverse ret)))

(defun take-while (p x*)
  "Example:
 (take-while 'symbolp '(a b 1 c d)) => (a b)"
  (cond
   ((null x*) nil)
   ((funcall p (car x*))
    (cons (car x*) (take-while p (cdr x*))))
   (t nil)))

(defun drop-while (p x*)
  "Example:
 (drop-while 'symbolp '(a b 1 c d)) => (1 c d)"
  (cond
   ((null x*) nil)
   ((funcall p (car x*))
    (drop-while p (cdr x*)))
   (t x*)))


(defun flat (x)
  "Xg̃AgȂ郊Xg
 (a (b c) d) ̂悤ȍ\̃XgƂA̍\𕽒R(flat)
ɂďoɃAgȂׂ (a b c d) ̂悤ȃXgԂ̂łB
nil ͋̃Xgł͂Ȃ nil ƂV{ƂĈB
Example:
 (flat '((a (b (c) ((d) e)) (f)) (g))) => (a b c d e f g)
 (flat '(nil (nil (nil) (nil)) nil))   => (nil nil nil nil nil)
 (flat '((a((((b)))c)((((((())d)))e)))((((f)))))) => (a b c nil d e f)
 (flat '()) => ()"
  (cond
   ((null x) nil)
   ((atom (car x))
    (cons (car x) (flat (cdr x))))
   (t (append (flat (car x)) (flat (cdr x))))))

(defun flat* (x)
  "flat Ɠl@nil V{ł͂Ȃ̃XgƂĈB
Example:
 (flat* '(nil (nil (nil) (nil)) nil))   => ()
 (flat* '((a((((b)))c)((((((nil)d)))e)))((((f)))))) => (a b c d e f)
 (flat* '()) => ()"
  (cond
   ((null x) nil)
   ((null (car x)) (flat* (cdr x))) ; flat Ƃ̈Ⴂ
   ((atom (car x))
    (cons (car x) (flat* (cdr x))))
   (t (append (flat* (car x)) (flat* (cdr x))))))

(defun set-equal (cl-list1 cl-list2 &rest cl-keys)
  "̏Wǂ肷B"
  (and (apply 'subsetp cl-list1 cl-list2 cl-keys)
       (apply 'subsetp cl-list2 cl-list1 cl-keys)))

(defun union* (sets &rest cl-keys)
  "W̃Xg SETS ̗vf union ԂB
Example:
 (union* '((a b) (b c))) => (c a b)"
  (let ((r nil))
    (dolist (s sets)
      (setq r (apply 'union r s cl-keys)))
    r))

(defmacro dorest (spec &rest body)
  "(dorest (VAR LIST [RESULT]) BODY...): loop over a list.
Evaluate BODY with VAR bound to each `nthcdr' from LIST, in turn.
Then evaluate RESULT to get return value, default nil."
  (let ((temp (gensym "--dolist-temp--")))
    (list 'block nil
	  (list* 'let (list (list temp (nth 1 spec)) (car spec))
		 (list* 'while temp (list 'setq (car spec) temp)
			(append body (list (list 'setq temp
						 (list 'cdr temp)))))
		 (if (cdr (cdr spec))
		     (cons (list 'setq (car spec) nil) (cdr (cdr spec)))
		   '(nil))))))

(put 'dorest 'lisp-indent-function 1)


(defun nmapcar (f x)
  "Example:
 (setq args '(1 2 3))
 (nmapcar '1+ args) => (2 3 4)
 args => (2 3 4)"
  (dorest (r x)
    (setcar r (funcall f (car r))))
  x)

(defun neq (x y)
  "Return t if the two args are not the same Lisp object."
  (not (eq x y)))

(defun* count-elements (list &key (test 'eql))
  "Xg LIST ̗vfJEgA ((vf px)..) ƂXgԂB
Ԃ郊Xg͕pxŃ\[gĂB
Example:
 (count-elements '(a b a c d d d)) => ((d 3)@(a 2) (b 1) (c 1))
 (count-elements '(\"a\" \"b\" \"a\") :test 'equal) => ((\"a\" 2) (\"b\" 1))"
  (let ((alist nil)
	a)
    (dolist (e list)
      (unless (setq a (assoc* e alist :test test))
	(setq a (list e 0))
	(push a alist))
      (incf (cadr a)))
    (sort (nreverse alist) #'(lambda (x y) (> (cadr x) (cadr y))))))

  
(defun insertf (fmt &rest args)
  "(insert (apply 'format FMT ARGS)) ɓB"
  (insert (apply 'format fmt args)))

(defun list-to-string (list)
  "Return the string of characters of LIST."
  (apply 'concat (mapcar 'char-to-string list)))

(defun list-to-vector (list)
  "LIST xN^ɕϊB"
  ;; (vconcat list)
  (apply 'vector list))

(defun vector-to-list (vector)
  "VECTOR XgɕϊB"
  (unless (arrayp vector)
    (signal 'wrong-type-argument (list 'arrayp vector)))
  (append vector nil))


(defmacro with-display-buffer (bufname &rest body)
  "obt@ BUFNAME 쐬AJgobt@ɑ BODY sB
ŌɃobt@̓eEBhEɕ\B
Example:
 (with-display-buffer \"*test*\" (insert \"test\"))"
  ;;  (with-display-buffer "*test*" (insert "test"))
  `(let ((-buf- (get-buffer-create ,bufname)))
     (save-excursion
       (set-buffer -buf-)
       (erase-buffer)
       (prog1
	   (progn ,@body)
	 (let ((owp (one-window-p))
	       (nlines (count-lines (point-min) (point-max))))
	   (display-buffer -buf-)
	   (set-window-point (get-buffer-window -buf-) 1)
	   (set-buffer-modified-p nil)
	   ;; ȉ͂ȂׂEChEo悤ȃR[h
	   ;; Ă邳H
	   (quote
	    (when owp
	      (when (< nlines (/ (frame-height) 2))
		(set-window-text-height (get-buffer-window -buf-)
					(1+ nlines)))))
	   )))))

(put 'with-display-buffer 'lisp-indent-function 1)


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(defun file-contents (file)
  "Return the contents of FILE as a string."
  (with-temp-buffer
    (insert-file-contents file)
    (buffer-string)))

(defun caller-function-list ()
  "ݎs̊֐̃V{̃XgԂB
Example:
 (defun foo () (subseq (bar t) 0 2))
 (defun bar (x) (if x (caller-function-list)))
 (foo) => (bar foo ...)"
  (with-temp-buffer
    (let ((standard-output (current-buffer))
	  (print-circle t)
	  (print-escape-newlines t))
      (backtrace)
      (goto-char (point-min))
      (while (re-search-forward "^[ *] " nil t)
	(delete-region (match-beginning 0) (match-end 0)))
      (goto-char (point-min))
      (while (re-search-forward "^(.*" nil t)
	(delete-region (match-beginning 0) (match-end 0)))
      (goto-char (point-min))
      (while (re-search-forward "(.*" nil t)
	(delete-region (match-beginning 0) (match-end 0)))
      (goto-char (point-min))
      (cddr (read (concat "(" (buffer-string) ")"))))))


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; fontlock ǉ

(put 'font-lock-add-keywords 'lisp-indent-function 1)

(font-lock-add-keywords 'emacs-lisp-mode
  `((,(concat "(" (regexp-opt
		   '("multiple-value-bind"
		     "multiple-value-setq"
		     ;;
		     "dorest"
		     ) t)
	      "\\>")
     1
     font-lock-keyword-face)))


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; JX^}CY\ format

(defun fmt (fmtstr formatters args)
  "JX^}CY\ȃtH[}bg֐B
FORMATTERS: ((<String> <Formatter>)..)
Example:
 (defstruct point x y)
 (defun fmt-point (fmt x) (format \"(%s,%s)\" (point-x x) (point-y x)))
 (defconst my-fmt-formatters '((\"%p\" fmt-point)))
 (defun my-fmt (fmt &rest args)
   (fmt fmt my-fmt-formatters args))

 (my-fmt \"%s = %p\" \"p\" (make-point :x 1 :y 2))
 => \"p = (1,2)\"

 (defun fmt-point-s (fmt x)
   (if (point-p x)
       (format fmt (fmt-point fmt x))
     (format fmt x)))
 (push '(\"%[-0-9.]*s\" fmt-point-s) my-fmt-formatters)

 (my-fmt \"%s = %8s\" \"p\" (make-point :x 1 :y 2))
 => \"p =    (1,2)\""
  (let* ((formatters (append formatters
			     '(("%[-0-9.]*[sdXefgcS%]" format))))
	 (regexp (mapconcat 'identity (mapcar 'car formatters) "\\|"))
	 (case-fold-search nil)
	 (strs nil)
	 (beg 1))
    (with-temp-buffer
      (insert fmtstr)
      (goto-char (point-min))
      (while (re-search-forward regexp nil t)
	(push (buffer-substring beg (match-beginning 0)) strs)
	(setq beg (match-end 0))
	(let ((fmt (match-string 0)))
	  (dolist (f formatters)
	    (when (string-match (concat "\\`" (car f) "\\'") fmt)
	      (unless args
		(error "Too few arguments for format string"))
	      (push (funcall (cadr f) fmt (pop args)) strs)
	      (return)))))
      (push (buffer-substring beg (point-max)) strs))
    ;;
    (when args
      (error "Too many arguments for format string"))
    ;;
    (apply 'concat (nreverse strs))))



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; c[̕\

(defun format-tree (tree child label &optional numbering)
  "TREE: <Sexp> ₷ɕϊB
CHILD: <Sexp> -> (<Sexp>..)  TREE ̎q̃XgԂ֐A
LABEL: <Sexp> -> <String:sŋ؂ꂽ> ̓m[h̕\֐łB
NUMBERING  Non-nil ȂsԍtB
f ESX x format-tree-demo RET"
  (with-temp-buffer
    (format-tree/aux tree child label "" t)
    (when numbering
      (goto-char (point-min))
      (let ((n 0))
	(while (progn (insert (format "%3d " (incf n)))
		      (forward-line)
		      (not (eobp))))))
    (buffer-string)))

(defun format-tree/aux (tree child label vls top)
  (let ((args (funcall child tree))
	(info (split-string (funcall label tree) "\n")))
    (when (= 1 (length info))
      (setq info (append info (list ""))))
    (cond
     (top
      (insertf "%s" vls))
     (t
      (insertf "%s+--" (substring vls 0 (- (length vls) 3)))))
    (insertf "%s\n" (car info))
    (dolist (i (cdr info))
      (insertf "%s%s%s\n" vls (if args "| " "  ") i))
    (dorest (as args)
      (format-tree/aux (car as)
		       child
		       label
		       (concat vls (if (cdr as) "|  " "   "))
		       nil))))

(defun format-tree-demo ()
  "SCK Cu֐ format-tree ̃fsB"
  (interactive)
  (with-display-buffer "*format-tree*"
    (insert 
     (format-tree
      ;; c[f[^
      ;; <Tree> ::= ((<Symbol:m[h> <String:m[hf[^>..)  <Tree:q>..)
      '((a "a1" "a2")
	((b)
	 ((c "c1" "c2")))
	((d "d1" "d2")
	 ((e "e1"))))
      ;; q̃XgԂ֐
      'cdr
      ;; m[h
      #'(lambda (node)
	  (format "Node %s\n%s"
		  (caar node)
		  ;; (mapconcat 'identity '("foo" "bar") "\n") => "foo\nbar"
		  (mapconcat 'identity (cdar node) "\n")))
      ;; sԍw
      t))))


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; ӓIȖO̐

(defun make-new-name (oldnamep prefix &optional delim)
  "q OLDNAMEP: <String> -> <Boolean> 𖞂ȂKȕԂB
DELIM  nil Ȃ PREFIX1, PREFIX2, ... ōŏ̂̂A
DELIM Ȃ PREFIX, PREFIXDELIM1, PREFIXDELIM2 ōŏ̂̂ԂB
DELIM ́A[Jϐ̃l[ŏo΂̂܂܂̖O (PREFIX)
gĂقꍇɎgB"
  (cond
   ;; delim ẃA[Jϐ̃l[ŏo΂̂܂܂̖O (prefix)
   ;; gĂقƂӐ}B
   ((and delim
	 (not (funcall oldnamep prefix)))
    prefix)
   ;; ǏdȂĂȂ delim = "" ƂďB
   (t
    (setq delim (or delim ""))
    (let ((number 0)
	  (newname nil))
      (while (funcall oldnamep
		      (setq newname (format "%s%s%d"
					    prefix
					    delim
					    (incf number)))))
      newname))))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(defun roundup (n m)
  "n  m ̔{܂ŏグB
Example:
 (roundup 0 10) => 0
 (roundup 1 10) => 10
 (roundup 10 10) => 10
 (roundup 11 10) => 20"
  (bn-try-to-elnum
   (bn-mul (bn-div (bn-add n m -1)
		   m)
	   m)))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(defun setq-sexp (var sexp)
  "|Cgȉ S- Lisp ̕ϐɃZbgB"
  (interactive
   (let ((ov (make-overlay (point)
			   (save-excursion
			     (forward-sexp)
			     (point)))))
     (overlay-put ov 'face 'region)
     (unwind-protect
	 (list (intern (read-from-minibuffer "Store the sexp in variable: "))
	       (save-excursion (read (current-buffer))))
       (delete-overlay ov))))
  (set var sexp))
