;;;; RAM
;;;; LIR C^v^Ŏgp郁[IuWFNgij
;;;; LastChange: Sun Feb 04 05:05:38 2007

;;; (setq ram (make-ram))
;;; (ram-ref ram 100) => nil
;;; (setf (ram-ref ram 100) 1)
;;; (ram-ref ram 100) => 1
;;; (setf (ram-ref ram 12345678) 2)
;;; (ram-ref (sexp-to-ram (ram-to-sexp ram)) 12345678) => 2


;;  addr:natnum
;; (require 'bn)

(defstruct ram
  (blksize 1024)
  (htab (make-hash-table)))

(defun ram-to-sexp (ram)
  ;; <Sram> ::= (<BlkSize> (<BlkAddr> <Byte>..)..)
  ;; Return <Sram>
  (assert (ram-p ram))
  (let ((blks nil))
    (maphash #'(lambda (blkaddr vec)
		 (push (cons blkaddr (vector-to-list vec))
		       blks))
	     (ram-htab ram))
    (cons (ram-blksize ram)
	  blks)))

(defun sexp-to-ram (sram)
  ;; SRAM:<Sram>
  ;; Return ram
  (let* ((blksize (car sram))
	 (conts (cdr sram))
	 (ram (make-ram :blksize blksize)))
    (dolist (cont conts)
      (setf (gethash (car cont) (ram-htab ram)) (list-to-vector (cdr cont))))
    ram))

(defun ram-block (ram addr)
  (assert (ram-p ram))
  (assert (natnump addr))
  (let* ((blksize (ram-blksize ram))
	 (baddr (/ addr (ram-blksize ram)))
	 (htab (ram-htab ram))
	 (vec (gethash baddr htab)))
    (unless vec
      (setq vec (make-vector blksize nil))
      (setf (gethash baddr htab) vec))
    vec))

(defun ram-ref (ram addr)
  (aref (ram-block ram addr) (% addr (ram-blksize ram))))

(defun ram-set (ram addr byte)
  (aset (ram-block ram addr) (% addr (ram-blksize ram)) (logand #xff byte)))

(defsetf ram-ref ram-set)


;;;
(provide 'ram)
