;;;; SCK ̊{Cu[hB
;;;; LastChange: Mon Apr 16 14:05:26 2007

(require 'cl)


(defconst sck=library-directory
  (substring (file-name-directory load-file-name) 0 -1)
  "CufBNg $SCK/lib")


;(unless (boundp 'sck=symbols-before-loading-sck-library)
;  (defconst sck=symbols-before-loading-sck-library
;    (let ((syms nil))
;      (mapatoms #'(lambda (s)
;                    (when (or (boundp s) (fboundp s))
;                      (push s syms)))
;                syms)
;      syms)
;    "SCK Cũ[hȑOɒ`Ă֐AϐV{̃XgB"))


(defconst sck=library-contents-alist
  '(("README.txt" "Description of this directory")
    ("Makefile" "Makefile for this library")
    ("sck-lib.el"
     "Load the following libraries marked at the right with `Yes'")
    ("elim.el" "Emacs Lisp Interaction Mode" t)
    ("que.el" "Queue" t)
    ("dque.el" "Double-ended queue" t)
    ("fgraph.el" "General control flow graph" t)
    ("bitvec.el" "Bit vector" t)
    ("idtab.el" "A table structure for object numbering"t)
    ("misc.el" "Miscellaneous" t)
    ("cache.el" "Cache feature for pure functions" t)
    ("bn.el" "Arbitrary precision arithmetic" t)
    ("gnudoits.el" "Emacs Lisp code for $SCK/bin/gnudoits" t)
    ("sck-letalist.el" "Decoding A-List" t)
    ("sck-meddling.el" "Somewhat meddling features")
    ("hitohude.el" "Hitohudegaki puzzle solver")
    ("ram.el" "RAM"))
  "$SCK/lib ̃t@C ((<File> <Description> [t])..)
ɍŌ t ̂̂ $SCK/lib/sck-lib.el ̃[hɂ胍[hB
ȊO͕Kvɉ load/require ĎgpB")


(defun sck-describe-library-contents ()
  "$SCK/lib/* ̈ꗗobt@ *sck-describe-library-contents* \B
ob`[hĂ΂ꂽꍇ͕Wo͂֕\B"
  (interactive)
  (let ((str (with-temp-buffer
	       (insertf "%54s\n\n" "Brief description of $SCK/lib/*")
	       (insertf "%s %34s %39s\n\n"
			"File" "Description" "Loaded by sck-lib.el")
	       (dolist (c sck=library-contents-alist)
		 (multiple-value-bind (file description load) c
		   (insertf "%-16s %-58s %s\n"
			    file description (if load "Yes" ""))))
	       (buffer-string))))
    (if noninteractive
	(princ str)
      (with-display-buffer "*sck-describe-library-contents*"
	(insert str)))))


;;; Loading libraries
(dolist (a sck=library-contents-alist)
  (multiple-value-bind (file description load) a
    (when load
      (load (concat sck=library-directory "/" (file-name-sans-extension file))
	    nil
	    noninteractive))))


;(defconst sck=symbols-defined-by-sck-library
;  (let ((syms nil))
;    (mapatoms
;     #'(lambda (s)
;         (when (and (or (and (boundp s)
;                             (not (keywordp s)))
;                        (fboundp s))
;                    (not (memq s sck=symbols-before-loading-sck-library)))
;           (push s syms))))
;    (sort syms '(lambda (x y) (string< (symbol-name x) (symbol-name y)))))
;  "SCK Cu`֐AϐV{̃XgB")


;;;
(provide 'sck-lib)
