;;;; Constant folding
;;;; LastChange: Wed Apr 04 04:07:12 2007


(defun sck-lir-foldconst (exp)
  "EXP: <TypedExp> ̒萔ݍݍœKsB
R}hƂċNꂽꍇ̓|Cgȉ S- EXP ƂȂB
͔j󂵂ȂB
Retrun: <TypedExp>
Example: 
 ;; int f(int a, int b){return (-(a*2) + 4 - 3*b)*5 + 6;}
 (sck-lir-foldconst
   '(add i32
      (mul i32
	(sub i32
	  (add i32
	    (neg i32
	      (mul i32 (reg i32 \"a\") (iconst i32 2)))
	    (iconst i32 4))
	  (mul i32 (iconst i32 3) (reg i32 \"b\")))
	(iconst i32 5))
      (iconst i32 6)))
 
 => (add i32
      (add i32
        (mul i32 (reg i32 \"a\") (iconst i32 -10))
        (mul i32 (reg i32 \"b\") (iconst i32 -15)))
      (iconst i32 26))"
  (interactive (list (save-excursion (read (current-buffer)))))
  (assert (sck-lir-typed-exp-p exp))
  (let* ((exp0 exp)
	 (exp (copy-tree exp))
	 (op (car exp))
	 (type (cadr exp))
	 (exp1
	  (block return
	    ;;
	    ;; atomic Ȃ炻̂܂܁B
	    ;;
	    (when (sck-lir-atomic-exp-p exp)
	      (return-from return exp))
	    ;;
	    ;; ܂ȗB
	    ;;
	    (sck-lir-doargs* (ap exp)
	      (setf (car ap) (sck-lir-foldconst (car ap))))
	    ;;
	    ;; set, mem Ȃ炱ŏIB
	    ;;
	    (when (memq op '(set mem))
	      (return-from return exp))
	    ;;
	    ;; ȊOŁASĒ萔Ȃ萔vZB
	    ;; 
	    (when (every 'sck-lir-const-exp-p (sck-lir-args exp))
	      (return-from return (sck-lir-eval-pure-exp exp)))
	    ;;
	    ;; PZB
	    ;;
	    (when (sck-lir-unary-exp-p exp)
	      (return-from return (sck-lir-foldconst/unary exp)))
	    ;;
	    ;; ȉA񍀉Z x op y ̏ꍇB
	    ;;
	    (multiple-value-bind (x y) (sck-lir-args exp)
	      (cond
	       ;;  x {add,bor,bxor} 0 = x
	       ((and (memq op '(add bor bxor))
		     (sck-lir-const-zero-p y))
		x)
	       ;;  x {mul,band} 0 = 0
	       ((and (memq op '(mul band))
		     (sck-lir-const-zero-p y))
		y)
	       ;; x {mul,divs,divu} 1 = x
	       ((and (memq op '(mul divs divu))
		     (sck-lir-const-one-p y))
		x)
	       ;; x & -1 = x
	       ((and (eq op 'band)
		     (sck-lir-const-minusone-p y))
		x)
	       ;; 0 - y = -y
	       ((and (eq op 'sub)
		     (sck-lir-const-zero-p x))
		(sck-lir-foldconst `(neg ,type ,y)))
	       ;; x {mul,divs} -1 = -x
	       ((and (memq op '(mul divs))
		     (sck-lir-const-minusone-p y))
		(sck-lir-foldconst `(neg ,type ,x)))
	       ;;
	       ;; E萔ɂȂ悤ɐK
	       ;; 1 + y -> y + 1
	       ;; 1 < y -> y > 1
	       ;;
	       ((and (sck-lir-const-exp-p x)
		     (not (sck-lir-const-exp-p y))
		     (or (sck-lir-commutative-exp-p exp)
			 (sck-lir-tst-exp-p exp)))
		(sck-lir-foldconst
		 (if (sck-lir-commutative-exp-p exp)
		     `(,op ,type ,y ,x)
		   `(,(cadr (assq op sck=lir-tst-xargs-alist))
		     ,type ,y ,x))))
	       ;;
	       ;; (e0 + e1) * c2
	       ;;
	       ((and (eq op 'mul)
		     (eq (car x) 'add)
		     (sck-lir-const-exp-p y)
		     ;; Ŝ integral type ɌB
		     (sck-lir-integral-type-p type))
		;;
		(cond
		 ;; (e0 + c1) * c2 -> e0*c2 + c1*c2
		 ((sck-lir-const-exp-p (cadr (sck-lir-args x)))
		  (sck-lir-foldconst
		   `(add ,type
			 (mul ,type
			      ,(car (sck-lir-args x))
			      ,y)
			 (mul ,type
			      ,(cadr (sck-lir-args x))
			      ,y))))
		 ;; (e0*c0 + e1*c1) * c2 -> e0*c0*c2 + e1*c1*c2
		 ((multiple-value-bind (x0 x1) (sck-lir-args x)
		    (cond
		     ((and (eq (car x0) 'mul)
			   (eq (car x1) 'mul)
			   (sck-lir-const-exp-p (cadr (sck-lir-args x0)))
			   (sck-lir-const-exp-p (cadr (sck-lir-args x1))))
		      (sck-lir-foldconst
		       `(add ,type
			     (mul ,type ,x0 ,y)
			     (mul ,type ,x1 ,y))))
		     (t
		      exp))))
		 (t
		  (assert nil))))
	       ;;
	       ;; @
	       ;; op in sck=lir-associative-ops=(add mul band bxor bor)
	       ;; (e1 op c1) op y
	       ;;
	       ((and (sck-lir-associative-exp-p exp)
		     (eq (car x) op)
		     (sck-lir-const-exp-p (cadr (sck-lir-args x))))
		(cond
		 ;; (e1 op c1) op c2 -> e1 op (c1 op c2)
		 ((sck-lir-const-exp-p y)
		  (sck-lir-foldconst
		   `(,op ,type
			 ,(car (sck-lir-args x))
			 (,op ,type
			      ,(cadr (sck-lir-args x))
			      ,y))))
		 ;; (e1 op c1) op (e2 op c2) -> (e1 op e2) op (c1 op c2)
		 ((and (eq (car y) op)
		       (sck-lir-const-exp-p (cadr (sck-lir-args y))))
		  (sck-lir-foldconst
		   `(,op ,type
			 (,op ,type
			      ,(car (sck-lir-args x))
			      ,(car (sck-lir-args y)))
			 (,op ,type
			      ,(cadr (sck-lir-args x))
			      ,(cadr (sck-lir-args y))))))
		 ;; (e1 op c1) op y -> (e1 op y) op c1
		 (t
		  (sck-lir-foldconst
		   `(,op ,type
			 (,op ,type
			      ,(car (sck-lir-args x))
			      ,y)
			 ,(cadr (sck-lir-args x)))))))
	       ;;
	       ;; @
	       ;; op in sck=lir-associative-ops=(add mul band bxor bor)
	       ;; x op (e1 op c1) -> (x op e1) op c1
	       ;;
	       ((and (sck-lir-associative-exp-p exp)
		     (eq (car y) op)
		     (sck-lir-const-exp-p (cadr (sck-lir-args y))))
		(sck-lir-foldconst
		 (sck-lir-xchange-args exp)))
	       ;;
	       ;; \Ȃ sub  add 
	       ;; x - (e * c) -> x + (e * -c)
	       ;;
	       ((and (eq op 'sub)
		     (eq (car y) 'mul)
		     (sck-lir-const-exp-p (cadr (sck-lir-args y)))
		     (sck-lir-integral-type-p type))
		(sck-lir-foldconst
		 `(add ,type
		       ,x
		       (mul ,type
			    ,(car (sck-lir-args y))
			    (neg ,type
				 ,(cadr (sck-lir-args y)))))))
	       ;;  a + b + 2a -> 3a + b 
	       (t
		exp))))))
    ;;
    (when (interactive-p)
      (with-display-buffer "*sck-lir-foldconst*"
	(sck-lir-mode)
	(insertf ";;; Input:\n\n%s\n\n" (sck-lir-pp exp0))
	(insertf "\n;;; Output:\n\n%s" (sck-lir-pp exp1))))
    ;;
    exp1))


(defun sck-lir-foldconst/unary (exp)
  (let ((x (car (sck-lir-args exp)))
	(type (sck-lir-type exp)))
    (cond
     ;;
     ;; xL op(op e) -> e
     ;;
     ((and (memq (car exp) '(neg bnot))
	   (eq (car exp) (car x))
	   (sck-lir-integral-type-p type))
      (car (sck-lir-args x)))
     ;;
     ;; -(e*c) -> e*(-c)
     ;;
     ((and (eq (car exp) 'neg)
	   (eq (car x) 'mul)
	   (sck-lir-const-exp-p (cadr (sck-lir-args x)))
	   (sck-lir-integral-type-p type))
      (sck-lir-foldconst
       `(mul ,type
	     ,(car (sck-lir-args x))
	     (neg ,type
		  ,(cadr (sck-lir-args x))))))
     ;;
     (t
      exp))))



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; module/function Pʂł folding

(defun sck-lir-foldconst-module (module)
  "module:<Module> ̒萔ݍ݂sBj󂷂B"
  (assert (eq (car-safe module) 'module))
  (dorest (fp module)
    (when (eq (car-safe (car fp)) 'function)
      (setf (car fp) (sck-lir-foldconst-function (car fp)))))
  ;;
  module)

(defun sck-lir-foldconst-function (lfunc)
  "lfunc:<Lfunc> ̒萔ݍ݂sBj󂷂B"
  (assert (eq (car-safe lfunc) 'function))
  (let ((flowchanged nil))
    (dorest (ep (cdddr lfunc))
      (let ((exp (car ep)))
	(cond
	 ((sck-lir-typed-exp-p exp)
	  (setf (car ep) (sck-lir-foldconst exp)))
	 ((eq (car exp) 'jumpc)
	  (setf (cadr exp) (sck-lir-foldconst (cadr exp)))
	  (when (sck-lir-const-exp-p (cadr exp))
	    (setf (car ep) (if (sck-lir-const-zero-p (cadr exp))
			       `(jump ,(cadddr exp))
			     `(jump ,(caddr exp)))
		  flowchanged t)))
	 ((eq (car exp) 'call)
	  ;; ܂
	  ))))
    ;;
    (when flowchanged
      (setq lfunc (sck-lir-jopt-function lfunc))))
  ;;
  lfunc)
      

;;;
(provide 'sck-lir-foldconst)
