;;;; LIR $B$NJ,4t:GE,2=(B
;;;; LastChange: Thu Apr 12 08:50:42 2007

;;; $B!zFHN)ItJ,$r(B fgraph $B$K0\F0$7$?$$(B


(defvar sck*lir-module-labeltab nil
  "$B?7$?$J%i%Y%k$r@8@.$9$k$?$a$K(B sck-lir-make-labeltab $B$G:n@.$5$l!"(B
sck-lir-new-labelname $B$G;HMQ$5$l$k%F!<%V%k!#(B")


(defun sck-lir-jopt-function (lfunc &optional final)
  "LFUNC:<Lfunc> $B$NJ,4t:GE,2=$r9T$$!"(BLFUNC $B$rJV$9!#(B
$B0z?t$OGK2uE*$K=$@5$5$l$k!#(B
$B%3%^%s%I$H$7$F5/F0$5$l$?>l9g$O%]%$%s%H0J2<$N(B S-$B<0$,(B EXP $B$H$J$k!#(B
$B!z(B FINAL $B$,(B Non-nil $B$J$i!"(Basmout $BD>A0$N(B lfunc $B$rBP>]$H$9$k!#(B"
  (interactive (list (save-excursion (read (current-buffer)))))
  (assert (eq (car-safe lfunc) 'function))
  (let ((exps (sck-lir-function-exps lfunc)))
    (setf (sck-lir-function-exps lfunc) (sck-lir-jopt-exps exps final))
    ;;
    (when (interactive-p)
      (with-display-buffer "*sck-lir-jopt-function*"
	(sck-lir-mode)
	(insertf "\n;;; Output:\n\n%s" (sck-lir-pp lfunc))))
    ;;
    lfunc))

(defun sck-lir-fgraph-deflabel (exp)
  "exprlist-to-fgraph $B$X$N0z?t!#(B
exp $B$,%i%Y%kDj5A<0$J$i$=$N%i%Y%k!"$5$b$J$/$P(B nil$B!#(B
LIR $B0MB8(B
Example:
 (sck-lir-fgraph-deflabel '(deflabel \"L1\"))
 => \"L1\""
  (if (eq (car exp) 'deflabel)
      (cadr exp)
    nil))

(defun sck-lir-fgraph-reflabels (exp)
  "exprlist-to-fgraph $B$X$N0z?t!#(B
exp $B$,J,4t$J$iHt$S@h%i%Y%k$N%j%9%H!"$5$b$J$/$P(B nil$B!#(B
LIR $B0MB8(B
Example:
 (sck-lir-fgraph-reflabels '(jump (label i32 \"L1\")))
 => (\"L1\")
 (sck-lir-fgraph-reflabels '(jumpc x(label i32 \"L1\")(label i32 \"L2\")))
 => (\"L1\" \"L2\")"
  (case (car exp)
    (jump (cddr (cadr exp)))
    (jumpc (list (caddr (caddr exp))
		 (caddr (cadddr exp))))
    (jumpn
     (assert nil))
    (t
     nil)))

(defun sck-lir-exps-to-fgraph (exps)
  "EXPS:(<Lexp>..) $B$r%U%m!<%0%i%U(B <fgraph> $B$KJQ49$9$k!#(B
$B%3%^%s%I$H$7$F5/F0$5$l$?>l9g$O%j!<%8%g%sFb$N(B <Lexp> $B$,(B EXPS $B$K$J$k!#(B"
  (interactive (list
		(read (format "(%s)"
			      (buffer-substring (region-beginning)
						(region-end))))))
  (let ((fgraph (exprlist-to-fgraph exps
				    'sck-lir-fgraph-deflabel
				    'sck-lir-fgraph-reflabels
				    'sck-lir-pp)))
    (when (interactive-p)
      (with-display-buffer "*sck-lir-exps-to-fgraph*"
	(insert (fgraph-to-str fgraph))))
    ;;
    fgraph))

(defun sck-lir-jopt-exps (exps &optional final)
  "EXPS:(<Lexp>..) $B$NJ,4t:GE,2=$r9T$&!#(B
$B!z(B FINAL $B$,(B Non-nil $B$J$i!"(Basmout $BD>A0$N(B lfunc $B$N(B exps $B$rBP>]$H$9$k!#(B"
  ;; LIR $BFHN)(B
  (let ((fgraph (sck-lir-exps-to-fgraph exps)))
    (progn
      ;; $B!z$3$N%l%Y%k$G<}B+$9$k$^$G7+$jJV$9I,MW$,$"$k$+!)(B
      (sck-lir-jopt-exps/shortcut fgraph)
      (sck-lir-jopt-exps/merge fgraph))
    ;;
    (when final
      ;; $B!z(Bsucc/pred $B7W;;$7D>$7(B
      (set-succ-pred-fgraph fgraph)
      ;;
      ;;   jumpc e L1 L2
      ;; L2:
      ;; $B$K@55,2=(B
      ;;
      (dofnode (fnode fgraph)
	(let* ((lastfstmt (last-fstmt fnode))
	       (exp (fstmt-expr lastfstmt)))
	  (when (eq (car-safe exp) 'jumpc)
	    ;; jumpc e L1 L2 ; L2:... $B$H$J$C$F$$$J$$>l9g!"(B
	    (unless (eq (cadr (fnode-succ fnode))
			(fnode-next fnode))
	      (cond
	       ;; jumpc e L1 L2 ; L1:... $B$H$J$C$F$$$k$J$i(B
	       ((eq (car (fnode-succ fnode))
		    (fnode-next fnode))
		;; jumpc e' L2 L1 ; L2:... $B$KJQ49$9$k!#(B
		(let* ((e  (cadr exp))
		       (tl (caddr exp))
		       (fl (cadddr exp)))
		  (setf (car e) (let ((a (assq (car e) sck=lir-tst-not-alist)))
				  (assert a)
				  (cadr a))
			(caddr exp) fl
			(cadddr exp) tl)))
	       ;;
	       ;; $B$=$&$G$b$J$$$J$i!"(B
	       ;; jumpc e L1 Lnew; Lnew: jump L2; $B$HJQ49$9$k!#(B
	       (t
		(let* ((e (cadr exp))
		       (tl (caddr exp))
		       (fl (cadddr exp))
		       (Lnew (sck-lir-new-labelname sck*lir-module-labeltab))
		       (fnode1 (exprlist-to-fnode
				(list (sck-lir-make-deflabel-exp Lnew)
				      `(jump ,fl)))))
		  (setf (cadddr exp) (sck-lir-make-label-exp Lnew))
		  (append-fnode fnode fnode1))))))))
      ;;
      (set-succ-pred-fgraph fgraph) ; $BK\Ev$O>e$GJQ2=$7$?>l9g$N$_$G$$$$(B
      ;;
      ;; $B0J2<$NJQ49$O4pK\%V%m%C%/5,Ls$rGK$kJQ49(B
      ;;
      ;; prologue $B$N%i%Y%k$r:o=|(B
      (assert (fnode-to-deflabel fgraph (root-fnode fgraph)))
      (delete-fstmt (first-fstmt (root-fnode fgraph)))
      ;;
      (dofnode (fnode fgraph)
	(let* ((lastfstmt (last-fstmt fnode))
	       (exp (fstmt-expr lastfstmt)))
	  (cond
	   ;; $B2<$X$N(B jump $B$O:o=|(B
	   ((and (eq (car-safe exp) 'jump)
		 (eq (car (fnode-succ fnode))
		     (fnode-next fnode)))
	    (delete-fstmt lastfstmt)
	    ;; $B2<$N%i%Y%k$,L5BL$J$i:o=|(B
	    (when (= 1 (length (fnode-pred (fnode-next fnode))))
	      (delete-fstmt (first-fstmt (fnode-next fnode)))))
	   ;;     jumpc e L1 L2
	   ;; L2:
	   ;; $B$G!"(BL2 $B$X$NB>$N;2>H$,L5$$$J$i(B L2 $B$r:o=|$9$k!#(B
	   ((and (eq (car-safe exp) 'jumpc)
		 (eq (cadr (fnode-succ fnode))
		     (fnode-next fnode))
		 (= 1 (length (fnode-pred (fnode-next fnode)))))
	    (delete-fstmt (first-fstmt (fnode-next fnode))))))))
    ;;
    (fgraph-to-exprlist fgraph)))

(defun sck-lir-jopt-exps/shortcut (fgraph)
  ;; LIR $B0MB8(B
  (dofnode (fnode fgraph)
    (let ((exp (fstmt-expr (last-fstmt fnode))))
      (cond
       ((eq (car-safe exp) 'jump)
	(sck-lir-jopt-exps/shortcut-jump fgraph (cadr exp)))
       ((eq (car-safe exp) 'jumpc)
	(sck-lir-jopt-exps/shortcut-jump fgraph (caddr exp))
	(sck-lir-jopt-exps/shortcut-jump fgraph (cadddr exp))))))
  (set-succ-pred-fgraph fgraph)
  (delete-unreachable-fnodes fgraph))

(defun sck-lir-jopt-exps/shortcut-jump (fgraph labelexp)
  ;; LIR $BFHN)(B
  (let* ((label (caddr labelexp))
	 (fnode (label-to-fnode fgraph label))
	 (vfnodes nil))
    (while (and (not (memq fnode vfnodes)) ; L: gotoL; $B$X$NBP=h!#(B
		(sck-lir-jopt-empty-fnode-p fnode))
      (push fnode vfnodes)
      (setq fnode (car (fnode-succ fnode))))
    (setf (caddr labelexp)
	  (fnode-to-deflabel fgraph fnode))))



(defun sck-lir-jopt-empty-fnode-p (fnode)
  ;; LIR $B0MB8(B
  (and (eq (fstmt-next (first-fstmt fnode))
	   (last-fstmt fnode))
       (eq (car-safe (fstmt-expr (last-fstmt fnode)))
	   'jump)))

(defun sck-lir-jopt-epilogue-fnode-p (fnode)
  ;; LIR $B$[$\FHN)(B
  ;; $B:G8e$,J,4t$G$J$$(B fnode
  (null (sck-lir-fgraph-reflabels (fstmt-expr (last-fstmt fnode)))))

(defun sck-lir-jopt-exps/merge (fgraph)
  ;; $B!z$3$3$O(B LIR $BFHN)(B
  (let ((merged nil)
	(n 0))
    (loop
     ;; $B!z$3$3$O<}B+$9$k$^$G7+$jJV$7(B
     (setq merged nil)
     (dofnode (fnode fgraph)
       (let ((exp (fstmt-expr (last-fstmt fnode))))
	 ;; goto $B$G$N9T$-@h$,!J(Bnext $B$G!K!"B>$N(B pred $B$r;}$?$J$$$J$i!"(B
	 ;;
	 ;;$B!z!J(Bnext $B$G!"$H$$$&>r7o$OL5$/$F$bNI$$$,!"(Bepilogue $B%W%m%C%/$r(B
	 ;;  $B>e$K;}$A>e$2$k$H$$$&$h$&$J4m81@-$,$"$k$N$G!"$H$j$"$($::#$O$3$l$G!K(B
	 (when (and (= 1 (length (sck-lir-fgraph-reflabels exp)))
		    (= 1 (length (fnode-pred (car (fnode-succ fnode)))))
		    ;; epilogue $B$O0lHV2<$K$J$$$H%^%:$$$N$G!"(B
		    ;; epilogue $B$r%^!<%8=PMh$k$N$O$=$N>e$N%V%m%C%/$N$_!#(B
		    (or (not (sck-lir-jopt-epilogue-fnode-p
			      (car (fnode-succ fnode))))
			(eq (fnode-next fnode) (car (fnode-succ fnode)))))
	   ;; $B$=$N9T$-@h$r(B fnode $B$X%^!<%8$9$k!#(B
	   (let ((fnode1 (car (fnode-succ fnode))))
	     (delete-fnode fnode1)
	     (delete-fstmt (last-fstmt fnode))
	     (delete-fstmt (first-fstmt fnode1))
	     (merge-dque (fnode-fstmtdqh fnode) (fnode-fstmtdqh fnode1)))
	   (setq merged t))))
     (cond
      (merged
       (set-succ-pred-fgraph fgraph)
       (delete-unreachable-fnodes fgraph))
      (t
       (return))))))


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; $B%"%;%s%V%i%3!<%I$XJQ49$9$kD>A0$K9T$&:G8e$NJ,4t:GE,2=(B
;; $B!zCm0U!'$3$NJQ498e(B LIR $B$O4pK\%V%m%C%/>r7o$rK~$?$5$J$/$J$k!#(B


(defun sck-lir-final-jopt-module (module)
  "MODULE:<Module> $B%"%;%s%V%i%3!<%I$XJQ49$9$kD>A0$NJ,4t:GE,2=$r9T$&!#(B
$BDL>o$NJ,4t:GE,2=$N8e$K!"0J2<$r9T$&!#(B

1. $BL$;2>H%i%Y%k$N:o=|(B
2. $B2<$XMn$A$k(B jump $B$N:o=|(B
3. jumpc e L1 L2 $B$N2<(B(next)$B$O(B L2: $B$G;O$^$k%V%m%C%/$H$J$k$h$&$K$9$k!#(B
4. 3. $B$N(B L2 $B$,ITMW$J$i:o=|!#(B

$B!zCm0U!'$3$NJQ498e(B LIR $B$O4pK\%V%m%C%/>r7o$rK~$?$5$l$J$/$J$k!#(B
$B!zDL>o$N:GE,2=$G$O6X;_$7$F$$$k(B epilogue $B%V%m%C%/$N;}$A>e$2$b9T$($k$,!"(B
  $B!z!z!z:#$O$7$F$$$J$$!#(B

 $B%3%^%s%I$H$7$F5/F0$5$l$?>l9g$O%]%$%s%H0J2<$N(B S-$B<0$,(B MODULE$B$H$J$k!#(B
$B0z?t$rGK2u$9$k!#(B"
  (interactive (list (save-excursion (read (current-buffer)))))
  (let ((sck*lir-module-labeltab (sck-lir-make-labeltab module)))
    ;;
    (dorest (ep module)
      (when (eq (car-safe (car ep)) 'function)
	(setf (car ep) (sck-lir-jopt-function (car ep) t))))
    ;;
    (when (interactive-p)
      (with-display-buffer "*sck-lir-final-jopt-module*"
	(insert (sck-lir-pp module)))))
  ;;
  module)

;;;
(provide 'sck-lir-jopt)
