;;;; LIR Interpreter
;;;; LastChange: Wed Apr 11 01:29:41 2007

(require 'sck-lirgen)


(defun sck-liri-demo ()
  (interactive)
  (with-display-buffer "*sck-liri-demo*"
    (insertf
     (concat "$SCK/liri/demo.c  find-file A\n"
	     "擪̃Rgɏ]đ삷B"))))

(defun sck-liri-eval-lir (lir)
  "LIR: <Lmod> ]ALIR ̊֐ FOO ɑ΂ Emacs Lisp ֐
sck-liri-function-FOO B̊֐ Emacs ĂԂƂ LIR ̊֐
ssBϐ͈ȉ̂悤ɑΉB

 (reg t \"FOO\") -> sck*liri-reg-FOO
 (mem t (frame t \"FOO\")) -> sck*liri-frame-FOO
 (mem t (static t \"FOO\")) -> sck*liri-static-FOO

F|C^ZyсAaggregate ^̓T|[gĂȂB
R}hƂċNꂽꍇ́A|Cgȉ S- LIR Ƃĕ]B"
  (interactive (list (save-excursion (read (current-buffer)))))
  (assert (eq (car lir) 'module))
  (let ((gsymtab (caddr lir))
	(fsyms nil)
	(dsyms nil))
    (dolist (cont (cdddr lir))
      (ecase (car cont)
	(function
	 (push (sck-liri-eval-function cont)
	       fsyms))
	(data
	 (push (sck-liri-eval-data cont)
	       dsyms))))
    (setq fsyms (nreverse fsyms)
	  dsyms (nreverse dsyms))
    ;;
    (when (interactive-p)
      (with-display-buffer "*sck-liri-eval-lir*"
	(insert "The following symbols are defined.\n\n")
	(dolist (f fsyms)
	  (insertf "(defun %S %S ...)\n" f (cadr (symbol-function f))))
	(dolist (d dsyms)
	  (insertf "(defvar %S %S)\n" d (symbol-value d)))))))

(defun sck-liri-eval-function (lfunc)
  ;; LFUNC: <Lfunc>
  ;; <Lfunc> ::= (function <Name> <LocalSymtab> <Lseq>)
  ;; ֐ sck-liri-function-<Name> `ÃV{ԂB
  (let* ((name (cadr lfunc))
	 (prologue (assq 'prologue lfunc))
	 (fsym (sck-liri-make-function-elisp-symbol name))
	 (args (mapcar #'(lambda (p)
			   (intern (ecase (car p)
				     (reg (sck-lir-reg-name p))
				     ;; (mem t (frame t "name")) ̃nY
				     (mem (caddr (car (sck-lir-args p)))))))
		       (cdr prologue))))
    (eval `(defun ,fsym (,@args)
	     ,(sck-lir-pp lfunc)
	     (sck-liri-apply ',(copy-tree lfunc) (list ,@args))))))

(defun sck-liri-eval-data (data)
  ;; DATA: <Ldata>
  ;; <Ldata> ::= (DATA <Name> {<Lexp> | <DataSeq> | <ZeroSeq> | <SpaceSeq>})
  ;; ϐ sck*liri-static-<Name> `ÃV{ԂB
  (let* ((name (cadr data))
	 (exprs (cddr data))
	 (vsym (sck-liri-make-static-elisp-symbol name)))
    (cond
     ((and (= 1 (length exprs))
	   (memq (car (car exprs)) '(iconst fconst)))
      (set vsym (caddr (car exprs))))
     (t
      (error "Cannot handle: %S" data)))
    vsym))
       

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; function ̕]

(defun sck-liri-apply (lfunc args)
  ;; <Lfunc> ::= (function <Name> <LocalSymtab> <Lseq>)
  (assert (eq (car lfunc) 'function))
  (let* ((name (cadr lfunc))
	 (lsymtab (caddr lfunc))
	 (exps (cdddr lfunc))
	 (prologue (assq 'prologue exps))
	 ;;
	 (expv (list-to-vector exps))
	 (labeltab (let ((hashtab (make-hash-table :test 'equal)))
		     (dotimes (i (length expv))
		       (when (eq (car (aref expv i)) 'deflabel)
			 (setf (gethash (cadr (aref expv i)) hashtab) i)))
		     hashtab))
	 (pc 0))
    ;;
    ;; [Jϐ progv œIɃoChB
    ;;
    (assert (eq (car lsymtab) 'symtab))
    (progv
	(let ((vars nil))
	  (dolist (sent (cdr lsymtab))
	    ;; <LocalSymtab> ::= (Symtab {<LocalEnt>} )
	    ;; <LocalEnt>    ::= (<Name> < <RegEnt> | <FrameEnt>  >)
	    ;; <RegEnt>      ::= REG    <Ltype> <Align> <Offset>
	    ;; <FrameEnt>    ::= FRAME  <Ltype> <Align> <Offset>
	    (ecase (cadr sent)
	      (reg (push (sck-liri-make-reg-elisp-symbol (car sent))
			 vars))
	      (frame (push (sck-liri-make-frame-elisp-symbol (car sent))
			   vars))))
	  vars)
	nil ; vals
      ;;
      ;; ̌
      ;;
      (dolist (param (cdr prologue))
	(let ((type (cadr param)))
	  (sck-liri-eval-typed-exp-set-val
	   param
	   (ecase (sck-lir-type-kind type)
	     (integral
	      (bn-signed (bn-truncate (car args)) (sck-lir-type-bits type)))
	     (floating
	      (bn-add 0.0 (car args))))))
	(pop args))
      ;;
      ;; ֐{ (<Lexp>..) ̎s
      ;;
      (loop
       (let ((exp (aref expv pc)))
	 (incf pc)
	 ;; <Lexp> ::= <DefLabelExp> | <PrologueExp> | <EpilogueExp>
	 ;;          | <JumpExp> | <CallExp> | <TypedExp>
	 (case (car exp)
	   ((deflabel prologue))
	   (epilogue
	    (return (if (cadr exp)
			(sck-liri-eval-typed-exp-as-number (cadr exp))
		      nil)))
	   ;; (JUMP <LabelExp>)
	   (jump
	    ;; <LabelExp> ::= (LABEL <Ltype> <String>)
	    (setq pc (gethash (caddr (cadr exp)) labeltab)))
	   ;; (JUMPC <TypedExp> <LabelExp> <LabelExp>)
	   (jumpc
	    (setq pc (gethash (caddr
			       (if (bn-/= 0 (sck-liri-eval-typed-exp-as-number
					     (cadr exp)))
				   (caddr exp)
				 (cadddr exp)))
			      labeltab)))
	   ;; (JUMPN ...)
	   (jumpn
	    (error "jumpn is not supported"))
	   ;; <CallExp> ::= (CALL <TypedExp> (<TypedExp>..) (<InterfaceVar>..))
	   (call
	    (let ((fun (cadr exp))
		  (argvals (mapcar 'sck-liri-eval-typed-exp-as-number
				   (caddr exp)))
		  (retvar (car (cadddr exp)))
		  (retval nil))
	      (unless (eq (car fun) 'static)
		(error "Cannot call: %S" fun))
	      (setq retval
		    (apply (sck-liri-make-function-elisp-symbol (caddr fun))
			   argvals))
	      (when retvar
		(sck-liri-eval-typed-exp-set-val retvar retval))))
	   ;; <TypedExp>
	   (t
	    (sck-liri-eval-typed-exp exp))))))))

(defun sck-liri-make-function-elisp-symbol (name)
  (intern (format "sck-liri-function-%s" name)))

(defun sck-liri-make-static-elisp-symbol (name)
  (intern (format "sck*liri-static-%s" name)))

(defun sck-liri-make-frame-elisp-symbol (name)
  (intern (format "sck*liri-frame-%s" name)))

(defun sck-liri-make-reg-elisp-symbol (name)
  (intern (format "sck*liri-reg-%s" name)))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; <TypedExp> ̕]

(defun sck-liri-eval-typed-exp (exp)
  ;; EXP: <TypedExp> ]B
  ;; pƂāAsck*liri-{reg,frame,static}-foo ZbgB
  ;; <TypedExp> ::= <ConstExp> | <AddrExp> | <RegExp>
  ;;              | <MemExp> | <SetExp> | <PureExp>
  ;; Return: <ConstExp>
  (case (car exp)
   ;; <ConstExp> ::= <IntConstExp> | <FloatConstExp>
   ((iconst fconst)
    exp)
   ;; <AddrExp> ::= <StaticExp> | <FrameExp> | <LabelExp>
   ((static frame label)
    (error "Not supported: %S" (car exp)))
   ;; <RegExp> ::= <SimpleRegExp> | <SubRegExp>
   (reg
    (sck-liri-eval-typed-exp-reg exp))
   (subreg
    (error "Not supported: %S" (car exp)))
   ;; <MemExp> ::= (MEM <Ltype> <TypedExp>)
   (mem
    (sck-liri-eval-typed-exp-mem exp))
   ;; <SetExp> ::= (SET <Ltype> < <MemExp> | <RegExp> > <TypedExp>)
   (set
    (sck-liri-eval-typed-exp-set exp))
   ;; <PureExp> ::= (<PureOps> <Ltype> <TypedExp> {<TypedExp>})
   (t
    ;; lir pbP[W sck-lir-eval-pure-exp ɂA萔vZB
    (sck-lir-eval-pure-exp `(,(car exp)
			     ,(sck-lir-type exp)
			     ,@(mapcar 'sck-liri-eval-typed-exp
				       (sck-lir-args exp)))))))

(defun sck-liri-eval-typed-exp-as-number (exp)
  (let ((cexp (sck-liri-eval-typed-exp exp)))
    (assert (sck-lir-const-exp-p cexp))
    (caddr cexp)))

(defun sck-liri-eval-typed-exp-make-const (type value)
  (ecase (sck-lir-type-kind type)
    (integral
     (assert (bn-integer-p value))
     `(iconst ,type ,value))
    (floating
     (assert (bn-floating-p value))
     `(fconst ,type ,value))))

(defun sck-liri-eval-typed-exp-reg (exp)
  ;; (reg t ...)
  (let* ((name (caddr exp))
	 (varsym (sck-liri-make-reg-elisp-symbol name)))
    (sck-liri-eval-typed-exp-make-const
     (sck-lir-type exp)
     (symbol-value varsym))))

(defun sck-liri-eval-typed-exp-mem (exp)
  ;; (mem t (static t ...))  (mem t (frame ...)) ̂݃T|[g
  (let* ((a (caddr exp))
	 (name (caddr a)))
    (sck-liri-eval-typed-exp-make-const
     (sck-lir-type exp)
     (case (car a)
       (static
	(symbol-value (sck-liri-make-static-elisp-symbol name)))
       (frame
	(symbol-value (sck-liri-make-frame-elisp-symbol name)))
       (t
	(error "Cannot evaluate: %S" exp))))))
  
(defun sck-liri-eval-typed-exp-set (exp)
  ;; (set t (reg t ...))
  ;; (set t (mem t (static t ...)))
  ;; (set t (mem t (frame t ...)))
  ;; ̂݃T|[g
  (let ((lexp (caddr exp))
	(val (sck-liri-eval-typed-exp-as-number (cadddr exp))))
    (sck-liri-eval-typed-exp-set-val lexp val)
    (sck-liri-eval-typed-exp-make-const (sck-lir-type exp) val)))

(defun sck-liri-eval-typed-exp-set-val (lexp val)
  (assert (bn-number-p val))
  (cond
   ((eq (car lexp) 'reg)
    (set (sck-liri-make-reg-elisp-symbol (caddr lexp)) val))
   ((eq (car lexp) 'mem)
    (let* ((a (caddr lexp))
	   (name (caddr a)))
      (case (car a)
	(static
	 (set (sck-liri-make-static-elisp-symbol name) val))
	(frame
	 (set (sck-liri-make-frame-elisp-symbol name) val))
	(t
	 (error "Cannot set to: %S" lexp)))))
   (t
    (error "Cannot set to: %S" lexp))))

;;;
(provide 'sck-liri)
