;;;
;;; $Id: test.el,v 1.3 2007/01/04 08:20:51 heavy Exp $
;;; regalloc test
;;;
;;; sck-regalloc-test
;;; 
(require 'sck-asl)

(defun sck-regalloc-test-appel ()
  (interactive)
  (sck-asl-test sck=asl-test-appel))


(defun sck-regalloc-debug-1 ()
  (interactive)
  (sck-regalloc-debug sck-regalloc-test-input "~/tmp/graphviz"))

(defun sck-regalloc-debug-2 ()
  (interactive)
  (sck-regalloc-debug sck-regalloc-test-input2 "~/tmp/graphviz"))

;;;
;;; APPEL P.239
;;;
(defconst sck=asl-test-appel
  '(;;WX^Zbg̒`
    (real-register-sets
     ((G ("r1" "r2" "r3"))		;(WX^Zbg AWX^̃Xg)
      (F ("f0" "f1"))
      ;; n[hWX^gpꍇɂ͒PƂ̃WX^ݒ
      (R1 ("r1"))
      (R2 ("r2"))
      (R3 ("r3"))
     ))
    ;;󂯂郌WX^̒` ) AX->EAX 
    (real-register-constraints
     ())				;(AWX^ AWX^)
    ;;zWX^gWX^Zbg̒`
    (possible-assignments 
     ((r1 R1)				;(zWX^ WX^Zbg)
      (r2 R2)
      (r3 R3)
      (a G)
      (b G)
      (c1 G)
      (c2 G)
      (d G)
      (e G)
      ;; w̉zWX^ real-register-sets ̍ŏ̃NXƂȂ
      ))
    (spill-priority
     ((r1 1)
      (r2 1)
      (r3 1)
      (a 2)
      (b 11)
      (c1 1)
      (c2 1)
      (d 22)
      (e 31)
      ))
    ;;
    ;; ߗ EmacsLisp  (setq sym sexp) ̃XgB
    ;; Ŏn܂Ăϐ͉zWX^A
    ;; 啶Ŏn܂̂̓O[oϐƂB
    ;;
    (instructions
     ;;
     Lbeg  ; {ubN̎n߂̓xKvBLbeg ͓̃xB
     (setq r1 10)			;lݒ
     (setq r2 10)
     (setq r3 10)

     (setq c1 r3)
     (setq MEM c1)			;O[oɑޔ

     (setq a r1)
     (setq b r2)
     (setq d 0)
     (setq e a)
     (jump L1) ; {ubN̏I jump / jumpc

     L1  ; łołȂx̖O͔CӁB
     (setq d (+ d b))
     (setq e (- e 1))
     (jumpc (> e 0) L1 Lend) ; ^Ȃ L1 łȂ Lend ցB

     Lend ; o̊{ubÑx LendB

     (setq r1 d)

     (setq c2 MEM)			;O[o畜A
     (setq r3 c2)

     (setq RET r1) ; oubN͗OI jump ߂ł͏IȂB
     ))
  )

;;;
;;; Actual Spill
;;;
(defconst sck=asl-test-appel-actual-spill
  '(;; 錾
    ;; ȉ̖O
    ;; real-register-sets
    ;; real-register-constraints
    ;; possible-assignments
    ;; sck-regalloc ւ A-List C^tF[Ẍꕔ
    (real-register-sets
     ((G ("r1" "r2" "r3"))
      (F ("f0" "f1"))
      (R1 ("r1"))
      (R2 ("r2"))
      (R3 ("r3"))
     ))
    (real-register-constraints
     ())
    (possible-assignments 
     ((r1 R1)
      (r2 R2)
      (r3 R3)
      (a G)
      (b G)
      (c G)
      (d G)
      (e G)
      ;; w̉zWX^ real-register-sets ̍ŏ̃NXƂȂ
      ))
    (spill-priority
     ((r1 1)
      (r2 1)
      (r3 1)
      (a 2)
      (b 11)
      (c 2)
      (d 22)
      (e 31)
      ))
    ;;
    ;; ߗ EmacsLisp  (setq sym sexp) ̃XgB
    ;; Ŏn܂Ăϐ͉zWX^A
    ;; 啶Ŏn܂̂̓O[oϐƂB
    ;;
    (instructions
     ;;
     Lbeg  ; {ubN̎n߂̓xKvBLbeg ͓̃xB
     (setq r1 10)
     (setq r2 10)
     (setq r3 10)

     (setq c r3)
     (setq a r1)
     (setq b r2)
     (setq d 0)
     (setq e a)
     (jump L1) ; {ubN̏I jump / jumpc

     L1  ; łołȂx̖O͔CӁB
     (setq d (+ d b))
     (setq e (- e 1))
     (jumpc (> e 0) L1 Lend) ; ^Ȃ L1 łȂ Lend ցB

     Lend ; o̊{ubÑx LendB

     (setq r1 d)
     (setq r3 c)

     (setq RET r1) ; oubN͗OI jump ߂ł͏IȂB
     ))
  )

;;;
;;; Big Hardregs
;;;
(defconst sck=asl-test-big-hardregs
  '(;; 錾
    ;; ȉ̖O
    ;; real-register-sets
    ;; real-register-constraints
    ;; possible-assignments
    ;; sck-regalloc ւ A-List C^tF[Ẍꕔ
    (real-register-sets
     ((G ("r1" "r2" "r3" "r4" "r5" "r6" "r7" "r8"))
      (F ("f0" "f1"))
      (R1 ("r1"))
      (R2 ("r2"))
      (R3 ("r3"))
      (R4 ("r4"))
      (R5 ("r5"))
      (R6 ("r6"))
      (R7 ("r7"))
      (R8 ("r8"))
     ))
    (real-register-constraints
     ())
    (possible-assignments 
     ((r1 R1)
      (r2 R2)
      (r3 R3)
      (r4 R4)
      (r5 R5)
      (r6 R6)
      (r7 R7)
      (r8 R8)
      (a G)
      (b G)
      (c1 G)
      (c2 G)
      (d G)
      (e G)
      ;; w̉zWX^ real-register-sets ̍ŏ̃NXƂȂ
      ))
    (spill-priority
     ((r1 1)
      (r2 1)
      (r3 1)
      (r4 1)
      (r5 1)
      (r6 1)
      (r7 1)
      (r8 1)
      (a 2)
      (b 11)
      (c1 2)
      (c2 2)
      (d 22)
      (e 33)
      ;; w̉zWX^ real-register-sets ̍ŏ̃NXƂȂ
      ))
    ;;
    ;; ߗ EmacsLisp  (setq sym sexp) ̃XgB
    ;; Ŏn܂Ăϐ͉zWX^A
    ;; 啶Ŏn܂̂̓O[oϐƂB
    ;;
    (instructions
     ;;
     Lbeg  ; {ubN̎n߂̓xKvBLbeg ͓̃xB
     (setq r1 10)
     (setq r2 10)
     (setq r3 10)

     (setq c1 r3)
     (setq MEM c1)

     (setq a r1)
     (setq b r2)
     (setq d 0)
     (setq e a)
     (jump L1) ; {ubN̏I jump / jumpc

     L1  ; łołȂx̖O͔CӁB
     (setq d (+ d b))
     (setq e (- e 1))
     (jumpc (> e 0) L1 Lend) ; ^Ȃ L1 łȂ Lend ցB

     Lend ; o̊{ubÑx LendB

     (setq r1 d)

     (setq c2 MEM)
     (setq r3 c2)

     (setq RET r1) ; oubN͗OI jump ߂ł͏IȂB
     ))
  )
