;;;
;;; $Id: sck-regassign-demo.el,v 1.1 2007/04/09 07:19:41 heavy Exp $
;;; 
(defconst sck=regassign-demo-input
  '((module-defs 
     (defs
       (*reg-i32* ((reg i32 "%eax")
		   (reg i32 "%ecx")
		   (reg i32 "%edx")
		   (reg i32 "%ebx")
		   (reg i32 "%esi")
		   (reg i32 "%edi")))
       (*reg-i16* ((subreg i16 (reg i32 "%eax") 0)
		   (subreg i16 (reg i32 "%ecx") 0)
		   (subreg i16 (reg i32 "%edx") 0)
		   (subreg i16 (reg i32 "%ebx") 0)
		   (subreg i16 (reg i32 "%esi") 0)
		   (subreg i16 (reg i32 "%edi") 0)))
       (*reg-i8* ((subreg i8 (reg i32 "%eax") 0)
		  (subreg i8 (reg i32 "%ecx") 0)
		  (subreg i8 (reg i32 "%edx") 0)
		  (subreg i8 (reg i32 "%ebx") 0)))
       (*reg-eax-i32* ((reg i32 "%eax")))
       (*reg-ecx-i32* ((reg i32 "%ecx")))
       (*reg-edx-i32* ((reg i32 "%edx")))
       (*reg-mod$2-i32* ((reg i32 "%eax")
			 (reg i32 "%ecx")
			 (reg i32 "%ebx")
			 (reg i32 "%esi")
			 (reg i32 "%edi")))
       (*reg-call-clobbers* ((reg i32 "%eax")
			     (reg i32 "%ecx")
			     (reg i32 "%edx")))))
    (lfunc 
     ;; L-function after instruction selection:
     (function "sum"
	       (symtab ("from" reg i32 4 nil &regset *reg-i32*)
		       ("to" reg i32 4 nil &regset *reg-i32*)
		       ("_1" reg i32 4 nil &regset *reg-i32*)
		       ("total" reg i32 4 nil &regset *reg-i32*)
		       ("i" reg i32 4 nil &regset *reg-i32*))

	       (deflabel "L1")
	       (prologue)
	       (set	i32
			(reg i32 "from")
			(mem i32
			     (add i32 (reg i32 "%ebp") (iconst i32 20))))
	       (set	i32
			(reg i32 "to")
			(mem i32
			     (add i32 (reg i32 "%ebp") (iconst i32 24))))
	       (set i32 (reg i32 "total") (iconst i32 0))
	       (set i32 (reg i32 "i") (reg i32 "from"))
	       (jump (label i32 "L2"))

	       (deflabel "L2")
	       (jumpc (tstles i32 (reg i32 "i") (reg i32 "to"))
		      (label i32 "L3") (label i32 "L4"))

	       (deflabel "L3")
	       (set	i32
			(reg i32 "total")
			(add i32 (reg i32 "total") (reg i32 "i")))
	       (set	i32
			(reg i32 "i")
			(add i32 (reg i32 "i") (iconst i32 1)))
	       (jump (label i32 "L2"))

	       (deflabel "L4")
	       (set i32 (reg i32 "_1") (reg i32 "total"))
	       (set i32 (reg i32 "%eax") (reg i32 "_1"))
	       (epilogue (reg i32 "%eax"))))))

(defun sck-regassign-demo ()
  "sck-regassign $B$r%G%b$9$k(B"
  (interactive)
  (sck-regassign-demo-output sck=regassign-demo-input))

(defun sck-regassign-demo-output (input)
  (with-display-buffer "*sck-regassign-demo*"
    (insert ";;; Input\n")
    (insert (sck-lir-pp input))
    (insert "\n;;; Output\n")
    (insert (sck-lir-pp
	     (sck-regassign input)))))

(provide 'sck-regassign-demo)
