;;; Assembler output common functions
;;;; LastChange: Wed Mar 21 17:59:50 2007

;;; The following functions in comments beginning with `tmd-asmout-'
;;; are to be defined in tmd file.

;;; (defun sck-tmd-asmout-emit-comment (fmt &rest args)
;;;   ;; Emit comment.
;;;   )
;;; 
;;; (defun sck-tmd-asmout-emit-beginning-of-module ()
;;;   ;; Emit codes placed at the beginning of module.
;;;   )
;;; 
;;; (defun sck-tmd-asmout-emit-end-of-module ()
;;;   ;; Emit codes placed at the end of module.
;;;   )
;;; 
;;; (defun sck-tmd-asmout-emit-beginning-of-segment (segment)
;;;   ;; Emit beginning of segment.
;;;   )
;;; 
;;; (defun sck-tmd-asmout-emit-end-of-segment (segment)
;;;   ;; Emit end of segment.
;;;   )
;;; 
;;; (defun sck-tmd-asmout-emit-align (n)
;;;   ;; Emit alignment assembler directive.
;;;   )
;;; 
;;; (defun sck-tmd-asmout-emit-common (name size align)
;;;   ;; Emit assembler directive making a common space.
;;;   )
;;; 
;;; (defun sck-tmd-asmout-emit-zeros (n)
;;;   ;; Emit assembler directive to make n null bytes.
;;;   )
;;; 
;;; (defun sck-tmd-asmout-emit-linkage (name linkage)
;;;   ;; Emit linkage assembler directive.
;;;   )
;;; 
;;; (defun sck-tmd-asmout-emit-data (type data)
;;;   ;; Emit data.
;;;   )
;;; 
;;; (defun sck-tmd-asmout-emit-function-label (label)
;;;   ;; Emit a function label.
;;;   )
;;;
;;; (defun sck-tmd-asmout-emit-jump-label (label)
;;;   ;; Emit a jump label.
;;;   )
;;; 
;;; (defun sck-tmd-asmout-emit-data-label (label)
;;;   ;; Emit a data label.
;;;   )
;;; 
;;; (defun sck-tmd-asmout-framesize (lfunc)
;;;   ;; Return the frame size of L-function lfunc.
;;;   )
;;; 
;;; (defun sck-tmd-asmout-emit-prologue (framesize)
;;;   ;; Emit prologue.
;;;   )
;;;     
;;; (defun sck-tmd-asmout-emit-epilogue (framesize)
;;;   ;; Emit epilogue.
;;;   )
;;; 
;;; (defun sck-tmd-asmout-conv-arg (arg)
;;;   ;; Convert the S-exp arg into target assembler syntax as a string.
;;;   ;; The S-exp is constructed (asm ...) of defrule in the target TMD.
;;;   )
;;;
;;; (defun sck-tmd-asmout-conv-asmconst-exp (exp)
;;;   ;; AZuiJj萔𕶎ɕϊB
;;;    )



(defconst  sck*tmd-asmout-current-segment "")


(defun sck-tmd-asmout (module)
  "MODULE:<Module> ̃AZuR[h𐶐AƂĕԂB
R}hƂċNꂽꍇ̓|Cgȉ S- MODULEƂȂB
j󂷂B"
  (interactive (list (save-excursion (read (current-buffer)))))
  ;;
  ;; AZuR[h֕ϊ钼OɍsŌ̕œK
  ;; ӁF̕ϊ LIR ͊{ubN𖞂ȂȂB
  ;;
  (setq module (sck-lir-final-jopt-module module))
  ;;
  ;; {̂̃AZuR[h
  ;; 
  (cond
   ((interactive-p)
    (with-display-buffer "*sck-tmd-asmout*"
      (let ((str (sck-tmd-asmout/aux module)))
	(insert str)
	str)))
   (t
    (sck-tmd-asmout/aux module))))

(defun sck-tmd-asmout/aux (module)
  "MODULE:<Module> ̃AZuR[h𐶐AƂĕԂB"
  (let ((name (sck-lir-module-name module))
	(gsymtab (sck-lir-module-symtab module))
	(body (sck-lir-module-body module)))
    ;;
    (setq sck*tmd-asmout-current-segment nil)
    ;;
    (with-temp-buffer
      ;; (sck-tmd-asmout-emit-comment "MODULE %s" name)
      (sck-tmd-asmout-emit-beginning-of-module)
      ;;
      (dolist (b body)
	(case (car b)
	  ((function) (sck-tmd-asmout-lfunc b gsymtab))
	  ((data) (sck-tmd-asmout-data b gsymtab))
	  (t
	   (error "Illegal module body: %S" b))))
      ;;
      (when sck*tmd-asmout-current-segment
	(sck-tmd-asmout-emit-end-of-segment sck*tmd-asmout-current-segment))
      (sck-tmd-asmout-emit-end-of-module)
      ;;
      (buffer-string))))


(defun sck-tmd-asmout-emit-segment (segment)
  (unless (equal sck*tmd-asmout-current-segment segment)
    (sck-tmd-asmout-emit-end-of-segment sck*tmd-asmout-current-segment)
    (sck-tmd-asmout-emit-beginning-of-segment segment)
    (setq sck*tmd-asmout-current-segment segment)))


(defvar sck*tmd-asmout-lfunc-framesize nil)

(defun sck-tmd-asmout-lfunc (lfunc &optional gsymtab)
  "LFUNC:<Lfunc> ̃AZuo͂sB
R}hƂċNꂽꍇ̓|Cgȉ S- LFUNC ƂȂB
A{ asmout  module ɑ΂čŝׂłA
R}hƂ LFUNC Pʂŏ˗ꂽꍇ́AœKsȂB
AZuo͂ɂ镪œK͓łA module Pʂł̂ݍsB"
  (interactive (list (save-excursion (read (current-buffer)))))
  (cond
   ((interactive-p)
    (with-display-buffer "*sck-tmd-asmout-lfunc*"
      (let ((str (with-temp-buffer
		   (sck-tmd-asmout-lfunc/aux lfunc)
		   (buffer-string))))
	(insert str)
	str)))
   (t
    (sck-tmd-asmout-lfunc/aux lfunc gsymtab))))

(defun sck-tmd-asmout-lfunc/aux (lfunc &optional gsymtab)
  (let* ((name (cadr lfunc))
	 (gsent (or (assoc name gsymtab)
		    ;; R}hƂċNꂽꍇ
		    ;; ֐ gsent Kɍ쐬B
		    `(,name static nil 4 "data" xdef)))
	 (lsymtab (caddr lfunc))
	 (exps (cdddr lfunc)))
    ;;
    (setq sck*tmd-asmout-lfunc-framesize
	  (sck-lir-lsymtab-frame-size lsymtab))
    ;;
    (sck-tmd-asmout-emit-comment "Function %s" name)
    ;;
    (sck-tmd-asmout-emit-segment (sck-lir-gsent-segment gsent))
    (sck-tmd-asmout-emit-align (sck-lir-gsent-align gsent))
    (sck-tmd-asmout-emit-linkage name (sck-lir-gsent-linkage gsent))
    ;;
    (sck-tmd-asmout-emit-function-label name)
    (dolist (exp exps)
      (sck-tmd-asmout-exp exp))
    (insert "\n")))


(defun sck-tmd-asmout-data (data gsymtab)
  ;; <Ldata>     ::= (data <Name> <LdataItem>..)
  ;; <LdataItem> ::= <TypedExp> | <DataSeq> | <ZeroSeq> | <SpaceSeq>
  ;; <DataSeq>   ::= (<Ltype> {<Fixnum> | <Flonum>})
  ;; <ZeroSeq>   ::= (zeros <Fixnum>)
  ;; <SpaceSeq>  ::= (space <Fixnum>)
  (let* ((name (cadr data))
	 (items (cddr data))
	 (gsent (assoc name gsymtab)))
    (assert (eq (sck-lir-gsent-kind gsent) 'static))
    (sck-tmd-asmout-emit-segment (sck-lir-gsent-segment gsent))
    (cond
     ((and (eq (caar items) 'space)
	   (= 1 (length items)))
      ;;  space ͍ŏɈ݂̂邳Ȁꍇ common f[^ƌȂB
      ;;    Unix ñAZuŎg .common ߂
      ;;        .common name,size,align
      ;;    ŁAftHgP[W xdef łAldef ̏ꍇ
      ;;        .local name oA邢 .lcommon 
      ;;    ƓȂ̂ŁA sck-tmd-asmout-emit-common ňꊇĈB
      ;;    
      (sck-tmd-asmout-emit-common name
				  (cadr (car items)) 
				  (sck-lir-gsent-align gsent)
				  (sck-lir-gsent-linkage gsent)))
     (t
      (sck-tmd-asmout-emit-align (sck-lir-gsent-align gsent))
      (sck-tmd-asmout-emit-linkage name (sck-lir-gsent-linkage gsent))
      (sck-tmd-asmout-emit-data-label name)
      (dolist (item items)
	(cond
	 ((eq (car item) 'zeros)
	  (sck-tmd-asmout-emit-zeros (cadr item)))
	 ((eq (car item) 'space)
	  ;; rɂ SPACE ͋ȂB
	  (assert nil))
	 ((memq (car item) sck=lir-types)
	  (dolist (ifc (cdr item))
	    (sck-tmd-asmout-emit-data (car item) ifc)))
	 ((sck-lir-typed-exp-p item)
	  (sck-tmd-asmout-emit-data (cadr item)
				    (sck-tmd-asmout-conv-asmconst-exp item)))
	 (t
	  (error "sck-tmd-asmout-data: illegal data: %S" data))
	 ))))))


(defun sck-tmd-asmout-exp (exp)
  (when (eq (car exp) 'parallel)
    ;;  PARALLEL  USE  CLOBBER JbĝAȂ炸}b`
    ;; ƉB
    (setq exp (car (sck-tmd-separate-parallel-exp exp))))
  ;;
  (case (car exp)
    ((prologue)
     (sck-tmd-asmout-emit-prologue sck*tmd-asmout-lfunc-framesize))
    ((epilogue)
     (sck-tmd-asmout-emit-epilogue sck*tmd-asmout-lfunc-framesize))
    ((deflabel)
     (sck-tmd-asmout-emit-jump-label (cadr exp)))
    ((jumpn)
     (assert nil))
    (t
     (sck-tmd-tiling-exp exp) ; ^COȂ...
     ;; debug
     (dolist (inst (sck-tmd-asmout-exp/aux exp 'stmt))
       (sck-tmd-asmout-emit-inst inst))
     (sck-tmd-untiling-exp exp) ; ͂Ă
     )))

(defun sck-tmd-asmout-exp/aux (exp nt)
  ;; ߂̃XgԂB
  (sck-tmd-eval-with-$
   ;; ŏIIɏô͕
   `(list ,@(let ((asm (sck-tmd-rule-asm (sck-tmd-exp-rule exp nt))))
	      (case (car asm)
		(asmarg (list (cadr asm)))
		(asminst (cdr asm))
		(t
		 (error "rule %S has no asm"
			(sck-tmd-rule-name (sck-tmd-exp-rule exp nt)))))))
   ;;
   (let ((vals
	  (mapcar #'(lambda (nx)
		      (car (sck-tmd-asmout-exp/aux (cadr nx) (car nx))))
		  (sck-tmd-exp-nxalist exp nt))))
     (if (eq nt 'stmt)
	 vals
       (cons exp vals)))
   ))

(defun sck-tmd-asmout-emit-inst (inst)
  ;; S-\ꂽ߂AZutH[}bgŏóB
  (insertf "\t%S\t" (car inst))
  (let ((comma nil))
    (dolist (a (cdr inst))
      (when comma (insert ","))
      (insertf "%s" (sck-tmd-asmout-conv-arg a))
      (setq comma t)))
  (insert "\n"))

		       
;;;
(provide 'sck-tmd-asmout)
