;;;; TMD Compiler
;;;; LastChange: Thu Apr 12 23:33:53 2007


;;; tmd ̃[hɂȉ̕ϐZbgB
(defconst sck=tmd-def-form-list nil)
(defconst sck=tmd-rule-list nil)
(defconst sck=tmd-chain-rule-alist nil)


(defun sck-tmd-compile-file (tmdf)
  ;; foo.tmd  foo.cs B
  ;;
  ;; 1. (foreach ...) }N̓WJB
  ;; 1.5. canonicalize ( reg -> ($ n reg) , $n -> ($ n) )
  ;; 2. (defcode ....)  defrule ֕ϊB
  ;; 3. (defrule ...) ̃ftHgԁB
  ;; 4. }b`[R[h̐B
  ;;
  (interactive "ftmd file: ")
  (assert (string= (file-name-extension tmdf) "tmd"))
  (let* ((elf (concat (file-name-sans-extension tmdf) ".el"))
	 (forms-org (read (concat "(" (file-contents tmdf) ")")))
	 (forms (sck-tmd-compile-forms forms-org))
	 ;;
	 (defs (filter #'(lambda (form) (eq (car-safe form) 'def))
		       forms))
	 (defregsets (filter #'(lambda (form) (eq (car-safe form) 'defregset))
			     forms))
	 (rules (filter 'sck-tmd-rule-p forms))
	 (elforms (filter  #'(lambda (form)
			       (memq (car-safe form)
				     '(setq defun defconst defvar)))
			   forms)))
    (with-temp-buffer
      (insertf ";;;; This file is automatically created from %s.\n\n" tmdf)
      (insert "(eval-when-compile (setq max-specpdl-size 2000))\n\n")
      ;;
      ;; (defconst sck=tmd-def-list '((def ... ...)..))
      ;; Xg
      ;; (dolist (def sck=tmd-def-list)
      ;;    (put (cadr def) 'def (caddr def)))
      (insertf "\n%s" 
	       (pp-to-string 
		`(defconst sck=tmd-def-form-list ',defs)))
      (insertf "%s"
	       (pp-to-string
		'(dolist (def sck=tmd-def-form-list)
		   (put (cadr def) 'def (caddr def)))))
      ;;
      ;; (defregset reg ((I32 *reg-I32*) (I16 *reg-I16*) (I8 *reg-I8*)))
      ;; ɑ΂
      ;; Xg
      ;; (put 'reg 'defregset '((I32 *reg-I32*) (I16 *reg-I16*) (I8 *reg-I8*)))
      ;;
      (dolist (f defregsets)
	(insertf "\n%s" (pp-to-string
			 `(put ',(cadr f) 'defregset ',(caddr f)))))
      (insert "\n")
      ;;
      ;; (defconst sck=tmd-rule-list '((defrule ...)..))
      ;; Xg
      ;; (dolist (r sck=tmd-rule-list) (put (rule-sym r) 'rule r))
      (insertf "\n%s" 
	       (pp-to-string 
		`(defconst sck=tmd-rule-list '(,@rules))))
      (insertf "%s\n"
	       (pp-to-string
		'(dolist (r sck=tmd-rule-list)
		   (put (sck-tmd-rule-name r) 'rule r))))
      ;;
      ;; (defconst sck=tmd-chain-rule-alist ...)
      ;;
      (insertf "\n%s"
	       (pp-to-string `(defconst sck=tmd-chain-rule-alist
				',(sck-tmd-make-chain-rule-alist rules))))
      ;;
      ;; Emacs Lisp ̃tH[
      ;;
      (dolist (form elforms)
	(insertf "\n%s" (pp-to-string form)))
      ;;
      ;; }b`֐
      ;;
      (insertf "\n%s\n" (sck-tmd-compile-make-matcher "sck-tmd-matcher" rules))
      ;;
      (write-region (point-min) (point-max) elf nil :nomsg)
      (load elf nil t)
      (message "%s is generated and loaded." elf))))


(defun sck-tmd-make-chain-rule-alist (rules)
  ;; non terminal Ni ɂāA
  ;; [ R1, R2, ...  pat  Ni ̂ƂA
  ;; ((Ni  R1.sym R2.sym) ...)
  ;; Ƃ A-Xg B
  ;; Ri.sym  (rule-sym Ri)
  (let ((alist nil))
    (dolist (rule rules)
      (when (sck-tmd-chain-rule-p rule)
	;; chain rule
	(let* ((nt (sck-tmd-chain-rule-nt rule))
	       (a (assq nt alist)))
	  (unless a
	    (setq a (list nt))
	    (push a alist))
	  (nconc a (list (sck-tmd-rule-name rule))))))
    (nreverse alist)))


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(defun sck-tmd-compile-forms (forms)
  (let ((retformq (make-que)))
    (dolist (form (sck-tmd-macro forms))
      (case (car-safe form)
	(defrule
	  (append-que retformq (sck-tmd-defrule form)))
	(defcode
	  ;; defcode  1 ܂ 2  rule ɕϊB
	  (append-que-list retformq (sck-tmd-defcode form)))
	(t
	 (append-que retformq form))))
    ;;
    (que-to-list retformq)))


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; defcode ̏

(defun sck-tmd-defcode (defcode)
  "DEFCODE: (defcode <Name> <Pat> . <Body>)  1 ܂ 2  rule ɕϊB
Example:
 (mapcar 'sck-tmd-rule-to-sexp
	   (sck-tmd-defcode
	    '(defcode divs-reg (set i32 reg (divs i32 _reg _reg))
	       (regeq $0 $1)
	       (regset ($0 *reg-eax-i32*))
	       (asminst `(cdq)
			`(idivl ,$2))
	       (clobber (reg i32 \"%edx\"))
	       (cost 14))))
 => 
 ((defrule divs-reg/stmt stmt
   (set i32 ($ 0 reg) (divs i32 ($ 1 reg) ($ 2 reg)))
   (cost 14)
   (asminst `(cdq) `(idivl ,($ 2)))
   (regset (0 *reg-eax-i32*))
   (regeq 0 1)
   (clobber (reg i32 \"%edx\")))
  (defrule divs-reg/reg reg
   (divs i32 ($ 1 reg) ($ 2 reg))
   (cost 14)))"
  (assert (eq (car-safe defcode) 'defcode))
  (let ((retq (make-que))
	(name (cadr defcode))
	(pat (sck-tmd-desugar-pat (caddr defcode)))
	(body (sck-tmd-desugar-$n (cdddr defcode))))
    ;; name/stmt
    (append-que retq
		  (sck-tmd-defrule
		   `(defrule ,(intern (format "%s/stmt" name)) stmt
		      ,pat
		      ,@body)))
    ;; name/reg
    (when (and (eq (car pat) 'set)
	       (sck-tmd-defcode-lvalue-match-reg-p (caddr pat)))
      (append-que retq
		    (let ((rule
			   (sck-tmd-defrule
			    `(defrule ,(intern (format "%s/reg" name)) reg
			       ,(cadddr pat) ; (SET t x y)  y
			       ,@(remove-if
				  ;; (asmarg ...) (asminst ...) 
				  ;; QƂȂ̂ŃJbg
				  ;;  ܂ regeq ݂ op +=
				  ;; Ɍ̂߁Ant=reg ł̓JbgB
				  ;; ̂ւAʓIɂ͓̂B
				  ;;
				  ;;  regset, clobber /reg ł͕svB
				  ;; ƂA/stmt ł̂ݎQƂ悤ɂB
				  #'(lambda (item)
				      (memq (car item)
					    '(asmarg asminst regeq
						     regset clobber)))
				  body)))))
		      ;;
		      ;;  chain rule ɂȂꍇ͌^tB
		      ;;
		      (when (sck-tmd-patvar-p (cadddr pat))
			(setf (sck-tmd-rule-type rule) (cadr pat)))
		      ;;
		      rule)))
    ;;
    (que-to-list retq)))
		      

(defun sck-tmd-defcode-lvalue-match-reg-p (lvalue)
  ;; lvalue  patvar ŁA nt  reg 邢͂ɏ\Ȃ̂
  ;; 肷B
  ;; ۂɂ͂̔͑GłiCOINS ŁjAB
  ;; ł͂Ƃ肠u蓮vŎw肷邱ƂɂB
  (and (sck-tmd-patvar-p lvalue)
       ;;  x86 ˑ
       (eq (sck-tmd-patvar-nt lvalue) 'reg)))



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; make matcher

(defun sck-tmd-compile-make-matcher (matchername rules)
  (let ((sck=tmd-rule-list rules)
	(pats (filter #'(lambda (pat) (not (sck-tmd-patvar-p pat)))
		      (mapcar 'sck-tmd-rule-pat rules))))
    (sck-tmd-pm-make-matcher pats
			     matchername
			     'sck-tmd-compile-make-matcher/check-form
			     'sck-tmd-compile-make-matcher/action-form)))

(defun sck-tmd-compile-make-matcher/check-form (pat pvalist)
  (let ((ntchecks nil))
    (dolist (a pvalist)
      (let ((patvar (car a))
	    (exp (cadr a)))
	(push `(sck-tmd-exp-tile ,exp ',(caddr patvar))
	      ntchecks)))
    (setq ntchecks (nreverse ntchecks))
    (cond
     ((null ntchecks) t)
     ((= 1 (length ntchecks)) (car ntchecks))
     (t
      `(and ,@ntchecks)))))

(defun sck-tmd-compile-make-matcher/action-form (pat pvalist)
  (let* ((mrules (filter #'(lambda (r) (equal (sck-tmd-rule-pat r) pat))
			 sck=tmd-rule-list))
	 (expvec (if (null pvalist)
		     []
		   (let* ((expplis1 (mapcar 'caddr pvalist))
			  ;; .reg ł ($ 1) Ȃ̂ ($ 0) ̕ǉB
			  (expplis (if (= 1 (cadar (car pvalist)))
				       (cons nil expplis1)
				     expplis1)))
		     `(vector ,@expplis)))))
    ;;
    `(progn
       ,@(mapcar
	  #'(lambda (r) `(sck-tmd-tiling-exp-action x
						    ',(sck-tmd-rule-name r)
						    ,expvec))
	  mrules))))


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; tmd t@C̒

(defun sck-tmd-find-compiled-tmd (tmdname)
  "RpCꂽ TMD t@C TMDNAME:<String> ̃tpXԂB
Example:
 (sck-tmd-find-compiled-tmd \"sck-tmd-x86\")
  => \"c:/cygwin/home/abe/sck/tmd/sck-tmd-x86.el\""
  (block return
    (dolist (d (remq nil load-path))
      (let ((fpath (format "%s/%s.el" d tmdname)))
	(when (file-exists-p fpath)
	  (return-from return fpath))))
    (error "%s.el not found" tmdname)))


;;;
(provide 'sck-tmd-compile)
