;;;; Instruction selector
;;;; LastChange: Thu Apr 12 23:33:51 2007


(defvar sck*tmd-debug nil
  "Non-nil Ȃ疽ߑĨfobO_v 
*sck-tmd-instsel* obt@֕\B
sck-tmd-instsel R}hƂċNꂽꍇ t ɃZbgB")


(defun sck-tmd-instsel (lfunc)
  "LFUNC: <Lfunc> ̖ߑIsB
͔jIɏĈŁAKvȂ copy-tree gp邱ƁB
fobO_vsɂ sck*tmd-debug  Non-nil ɃZbgB
R}hƂċNꂽꍇ̓|Cgȉ S- EXP ƂȂA
fobO_vsB"
  ;; { defs 񂪕KvA 'def 𗘗pĂB"
  (interactive (list (save-excursion (read (current-buffer)))))
  (let* ((sck*tmd-debug (or sck*tmd-debug (interactive-p)))
	 ;; (debug-on-error sck*tmd-debug)
	 )
    (cond
     (sck*tmd-debug
      (with-display-buffer "*sck-tmd-instsel*"
	(setq lfunc (sck-tmd-instsel/aux lfunc))))
     (t
      (setq lfunc (sck-tmd-instsel/aux lfunc))))
    ;;
    lfunc))


(defun sck-tmd-instsel/aux (lfunc)
  (let ((name (sck-lir-function-name lfunc))
	(lsymtab (sck-lir-function-symtab lfunc))
	(exps (sck-lir-function-exps lfunc))
	(lsymtab-org (copy-tree (sck-lir-function-symtab lfunc)))
	;; spill Ă΂ꂽǂ frame ݂̑ŔfB
	(afterspill (sck-lir-function-include
		     lfunc
		     #'(lambda (e)
			 (eq (car-safe e) 'frame)))))
    ;;
    (when sck*tmd-debug
      (insertf ";;; Subject L-function:\n")
      (insertf "%s\n\n" (sck-lir-pp lfunc)))
    ;;
    ;; t[ItZbg restruct Ō肷邪A
    ;; spill Ă΂ꂽꍇAȃItZbg肵ȂB
    ;;
    (sck-tmd-restruct-alloc-locals lsymtab)
    ;;
    ;; &regset ȂzWX^łL̂ɐݒB
    (sck-tmd-restruct-fillup-regset lsymtab)
    ;;
    (let ((expq (make-que)))
      (dolist (exp exps)
	(append-que-list expq (sck-tmd-instsel-exp exp lsymtab)))
      (setq exps (que-to-list expq)))
    (setf (cdddr lfunc) exps)
    ;;
    ;; &regset  pending ̂̂AłL̂ɁB
    (sck-tmd-restruct-fillup-pending-regset lsymtab)
    ;;
    ;; spill Ă΂ꂽꍇAinstsel őzWX^xƃXs
    ;; Ȃ悤ɂ邽߁A&spillcost  10000 ɐݒ肷B
    ;;
    (when afterspill
      (dolist (sym (cdr (sck-lir-function-symtab lfunc)))
	(unless (assoc (car sym) lsymtab-org)
	  (sck-lir-putprop sym '&spillcost 10000))))
    ;;
    ;; &regset VOg̉zWX^͂̎WX^ɒuB
    ;;
    (when sck*tmd-debug
      (insertf "\n\n;;; L-function before sck-tmd-reduce-singleton-regsets:\n")
      (insertf "%s\n" (sck-lir-pp lfunc)))
    (setq lfunc (sck-tmd-reduce-singleton-regsets lfunc))
    (when sck*tmd-debug
      (insertf "\n\n;;; L-function after sck-tmd-reduce-singleton-regsets:\n")
      (insertf "%s\n" (sck-lir-pp lfunc)))
    ;;
    (when sck*tmd-debug
      (insertf "\n\n;;; L-function after instruction selection:\n")
      (insertf "%s\n" (sck-lir-pp lfunc)))
    ;;
    lfunc))


(defun sck-tmd-instsel-exp (exp lsymtab)
  (cond
   ((eq (car exp) 'data)
    ;; DATA ͖
    (list exp))
   ;;
   ((sck-lir-getprop exp '&inst)
    ;; &inst ΁AɖߑIĂ̂ŖB
    (list exp))
   ;;
   (t
    ;; spill Ă΂ꂽꍇAFRAME ܂܂\̂
    ;; FRAME XgĂB
    (sck-tmd-restruct-frame-exp exp lsymtab)
    ;;
    (let ((exps (case (car exp)
		  ((prologue epilogue deflabel)
		   (list exp))
		  ((parallel)
		   (sck-tmd-instsel-exp-parallel exp lsymtab))
		  ((jumpn)
		   (assert nil))
		  (t
		   (sck-tmd-instsel-exp-regular exp lsymtab)))))
      ;;
      ;; ̑S폜
      ;;
      (setq exps (mapcar 'sck-lir-without-plist exps))
      ;;
      ;; &inst t }[N
      ;; (dolist (exp exps) (sck-lir-putprop exp '&inst t))
      ;;
      exps))))

(defun sck-tmd-instsel-exp-parallel (exp lsymtab)
  (let* ((euc (sck-tmd-separate-parallel-exp exp))
	 (es (car euc))
	 (us (cadr euc))
	 (cs (caddr euc)))
    ;; USE  CLOBBER 𕪗 es Ń}b`OsB
    (let* ((exps (sck-tmd-instsel-exp-regular es lsymtab))
	   (expsbut (butlast exps)) ; ŌȊO(ł肤)
	   (explast (car (last exps)))) ; Ō
      ;;  us  cs ݂΁A explast  PARALLEL ŒǉB
      (unless (and (null us) (null cs))
	(setq explast (copy-list
		       `(parallel ,explast ,@us ,@cs))))
      ;;
      (append expsbut (list explast)))))

(defun sck-tmd-separate-parallel-exp (exp)
  ;; PARALLEL  exp  USE, CLOBBER 𕪗A
  ;; (exp1 uses clobbers) ƂXgŕԂB
  ;; exp1  USE  CLOBBER ꂽ exp ŁAꂪ (PARALLEL e) ̌`Ȃ
  ;; P e ƂȂBuses, clobbbers ͂ꂼ exp  USE ACLOBBBER 
  ;; XgB
  (assert (eq (car-safe exp) 'parallel))
  (let ((es (make-que))
	(us (make-que))
	(cs (make-que)))
    (dolist (e (cdr exp))
      (case (car e)
	((use) (append-que us e))
	((clobber) (append-que cs e))
	(t (append-que es e))))
    (setq es (que-to-list es))
    (setq us (que-to-list us))
    (setq cs (que-to-list cs))
    ;;
    (copy-list
     `(,(if (= 1 (length es))
	    (car es)
	  `(parallel ,@es))
       ,us
       ,cs))))


(defun sck-tmd-instsel-exp-regular (exp lsymtab)
  (let ((exps nil))
    ;;
    (when sck*tmd-debug
      (insertf ";;; Subject expresion:\n\n")
      (insertf "%s\n\n" (sck-lir-pp (sck-lir-without-plist exp))))
    ;;
    ;; Tiling
    ;;
    (sck-tmd-tiling-exp exp)
    (when sck*tmd-debug
      (insertf ";;; After tiling:\n\n")
      (insertf "%s\n\n" (sck-tmd-format-exp-after-tiling exp t)))
    ;;
    ;; Linearize
    ;;
    (setq exps (sck-tmd-linearize-tiled-exp exp lsymtab))
    (when sck*tmd-debug
      (insertf ";;; After linearize:\n\n")
      (dolist (exp exps)
	(insertf "%s\n" (sck-lir-pp (sck-lir-without-plist exp))))
      (insert "\n"))
    ;;
    ;; Relaxing
    ;;
    (setq exps (sck-tmd-relaxing-tiled-exps exps lsymtab))
    (when sck*tmd-debug
      (insertf ";;; After relaxing:\n\n")
      (dolist (exp exps)
	(insertf "%s\n" (sck-lir-pp (sck-lir-without-plist exp))))
      (insert "\n"))
    ;;
    ;; clobber ̋L^B
    ;;
    (setq exps (mapcar 'sck-tmd-record-clobber exps))
    ;;
    ;; ^COOB
    ;;
    (dolist (exp exps)
      (sck-tmd-untiling-exp exp))
    ;;
    ;; asmout ̃eXg
    ;; sck-tmd-format-exp-after-tiling
    (when sck*tmd-debug
      (insertf ";;; Assembler instructions:\n\n")
      (dolist (exp (copy-tree exps))
	(sck-tmd-asmout-exp exp))
      (insert "\n"))
    ;;
    ;; ̃XgԂB
    ;;
    exps))


(defun sck-tmd-record-clobber (exp)
  ;; exp  clobber 
  ;; (PARALLEL exp (CLOBBER .)...) ɕϊB
  (cond
   ((sck-lir-getprop exp '&tiles)
    (let ((clobber (sck-tmd-rule-clobber (sck-tmd-exp-rule exp 'stmt)))
	  (pexp exp))
      (when clobber
	(setq pexp
	      (copy-list
	       `(parallel ,exp
			  ,@(mapcar #'(lambda (r) `(clobber ,r))
				    clobber)))))
      pexp))
   (t
    ;;  relaxing Ōꂽ SET ̂(̃nY)ŁAɂ
    ;; clobber ͂ȂƉ肷B
    exp)))


(defun sck-tmd-reduce-singleton-regsets (lfunc)
  ;; &regset VOg̉zWX^͂̎WX^ɒuB
  (let ((lsymtab (sck-lir-function-symtab lfunc))
	(substalist nil) ; (<Vreg> <Rreg>)
	(newents nil))
    ;; substalist A
    (dolist (ent (cdr lsymtab))
      ;; <LocalEnt>    ::= (<Name> < <RegEnt> | <FrameEnt>  >)
      ;; <RegEnt>      ::= reg    <Ltype> <Align> <Offset>
      (let ((regset (get (sck-lir-getprop ent '&regset) 'def))) ; 
	(when (= (length regset) 1)
	  (assert (not (= ?% (aref (car ent) 0)))) ; WX^͂肦ȂB
	  (let ((vreg `(reg ,(caddr ent) ,(car ent)))
		(rreg (car regset)))
	    (delq ent lsymtab) ; ̃Gg͍폜
	    (push (list vreg rreg) substalist)
	    (setf (car ent) (caddr rreg))
	    (sck-lir-remprop ent '&regset)))))
    ;; lfunc B
    (sck-lir-subst-exp-function lfunc
				#'(lambda (e)
				    (let ((a (assoc e substalist)))
				      (if a
					  (cadr a)
					e))))))
    

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; Tiling tF[YB
;;;
;;; L-{gAbv (DP) }b`OA^CƂďL^B
;;; ЂƂ̃^C̓[AݐσRXgAœKƂđI΂ꂽǂ
;;; ̏B
;;; ܂ Tiling I_ŁAI΂ꂽ^CKvWX^̌
;;; ]A &nregs ɋL^B

(defstruct sck-tmd-tile
  rule
  cost
  nxalist
  selected)

(defun sck-tmd-tile-nt (tile)
  (sck-tmd-rule-nt (sck-tmd-tile-rule tile)))

(defun sck-tmd-format-tile (tile)
  ;; <sck-tmd-tile> ₷ɕϊB
  (format "%c %d, %s: %S ; %S\n"
	  (if (sck-tmd-tile-selected tile) ?* ?\  )
	  (sck-tmd-tile-cost tile)
	  (sck-tmd-tile-nt tile)
	  (sck-tmd-rule-pat (sck-tmd-tile-rule tile))
	  (sck-tmd-rule-name (sck-tmd-tile-rule tile))))


;;; \ȃ^C̃Xg L- &tiles ƂċL^B

(defun sck-tmd-put-exp-tiles (exp tiles)
  (sck-lir-putprop exp '&tiles tiles))

(defun sck-tmd-get-exp-tiles (exp)
  (sck-lir-getprop exp '&tiles))

(defun sck-tmd-rem-exp-tiles (exp)
  (sck-lir-remprop exp '&tiles))

(defun sck-tmd-format-exp-after-tiling (exp &optional detail)
  ;; ^CO EXP 𕶎ɕϊB
  ;;  jump* call ̕\
  (format-tree exp
	       'sck-lir-args
	       #'(lambda (exp)
		   (with-temp-buffer
		     (case (car exp)
		       ((jump jumpc call)
			(insertf "%s" (car exp)))
		       (t
			(insertf "%s %s" (car exp) (cadr exp))))
		     (when (sck-lir-atomic-exp-p exp)
		       (insertf " %S" (caddr exp)))
		     (insert "\n")
		     ;;(when (has-prop? exp '&nregs)
		     ;; (fprintf sm "  &nregs = %d\n"(get-prop exp '&nregs)))
		     (dolist (tile (sck-tmd-get-exp-tiles exp))
		       (when (or detail
				 (sck-tmd-tile-selected tile))
			 (insert (sck-tmd-format-tile tile))))
		     (buffer-string)))
	       t ; numbering
	       ))


(defun sck-tmd-exp-tile (exp nt)
  ;; ^C̃Xg nt  nonterminal Ƃ tile TB
  ;;  nilB
  (find-if #'(lambda (tile) (eq nt (sck-tmd-tile-nt tile)))
	   (sck-tmd-get-exp-tiles exp)))
  
(defun sck-tmd-exp-rule (exp nt)
  (sck-tmd-tile-rule (sck-tmd-exp-tile exp nt)))

(defun sck-tmd-exp-nxalist (exp nt)
  (sck-tmd-tile-nxalist (sck-tmd-exp-tile exp nt)))

(defun sck-tmd-tiling-exp-mark-selected (exp)
  ;; œKƑIꂽ tile  selected  t ɂB
  (sck-tmd-tiling-exp-mark-selected/aux exp 'stmt))

(defun sck-tmd-tiling-exp-mark-selected/aux (exp nt)
  (setf (sck-tmd-tile-selected (sck-tmd-exp-tile exp nt)) t)
  (dolist (nx (sck-tmd-exp-nxalist exp nt))
    (sck-tmd-tiling-exp-mark-selected/aux (cadr nx) (car nx))))

(defun sck-tmd-untiling-exp (exp)
  ;; exp  &tiles &nregs NAB
  (sck-lir-remprop exp '&tiles)
  ;; (sck-lir-remprop exp '&nregs)
  )



(defun sck-tmd-tiling-exp (exp)
  ;; tiling ̃gbvxB
  ;; ЂƂ L-  tilingB
  ;; ʂ exp ɔjIɋL^B
  ;; R}hƂċNꂽꍇ̓|Cgȉ L-ɂ
  ;; tiling sAfobO_v\B
  (interactive (list (save-excursion (read (current-buffer)))))
  (sck-tmd-tiling-exp/rec exp)
  (unless (sck-tmd-exp-tile exp 'stmt)
    (message "*** TILING FAILED: %S\n" (sck-lir-without-plist exp))
    (message "%s\n" (sck-tmd-format-exp-after-tiling exp t))
    (error "tiling failed."))
  ;;
  ;; ^COAœKƑIꂽ tile  &selected #t  putB
  ;; ͂̃}[N̓fobO_v̂߂̂݁B
  (sck-tmd-tiling-exp-mark-selected exp)
  ;;
  ;; KvȃWX^L^B
  ;;  (tiling-exp-nregs exp 'stmt)
  ;;
  (when (interactive-p)
    (with-display-buffer "*sck-tmd-tiling-exp*"
      (insertf ";;; Tiling result:\n\n")
      (insertf "%s\n" (sck-tmd-format-exp-after-tiling exp t))))
  ;;
  exp)


(defun sck-tmd-tiling-exp/rec (exp)
  ;; typed expr iy jumpc Hj̃^COB
  ;; bottom up Ƀ^COB
  ;;
  ;; ܂qɂāA
  (dolist (exp (sck-lir-args exp))
    (sck-tmd-tiling-exp/rec exp))
  ;; Ď̏B
  ;; sc-tmd-matcher  .tmd 琶֐B
  ;; ϐɓ funcall 悤ɏCB
  (sck-tmd-put-exp-tiles exp nil) ;NAĂ
  (sck-tmd-matcher exp))


(defun sck-tmd-tiling-exp-action (exp rulename expvec)
  ;; sc-tmd-matcher Ă΂B
  ;; }b`̏̓B
  (let* ((rule (get rulename 'rule)) ; Xg̎gp
	 (nxalist (let ((patvars (sck-tmd-rule-patvars rule))
			(nxa (make-que)))
		    (dolist (v patvars)
		      (append-que nxa (cons (caddr v)
					      (aref expvec (cadr v)))))
		    (que-to-list nxa)))
	 (cost 0))
    ;;
    (when (and (sck-tmd-tiling-setreg-ok-p exp (sck-tmd-rule-pat rule))
	       (sck-tmd-tiling-exp-check-ok-p exp rule nxalist))
      ;; q̃RXgċL^B
      (dolist (nx nxalist)
	(let* ((nt1 (car nx))
	       (exp1 (cadr nx))
	       (tile (sck-tmd-exp-tile exp1 nt1)))
	  (incf cost (sck-tmd-tile-cost tile))))
      (incf cost (sck-tmd-tiling-exp-eval-cost exp rule nxalist))
      ;; L^B
      (when (sck-tmd-tiling-exp-record exp rule cost nxalist)
	(sck-tmd-tile-chain-rules exp (sck-tmd-rule-nt rule) nil cost))
      )))


(defun sck-tmd-tiling-exp-record (exp rule cost nxalist)
  ;; exp ɐV rule  cost L^B
  ;;  cost ɋL^ĂRXgȏȂL^ȂB
  ;; ۂɋL^/XVꂽǂԂB
  (when (sck-tmd-chain-rule-p rule)
    (unless (and (= 1 (length nxalist))
		 (eq (caar nxalist) (sck-tmd-chain-rule-nt rule)))
      (assert nil)))
  ;;
  (let ((updated nil)
	(tile (sck-tmd-exp-tile exp (sck-tmd-rule-nt rule))))
    (cond
     (tile
      (when (< cost (sck-tmd-tile-cost tile))
	;; XVB
	(setf (sck-tmd-tile-rule tile) rule
	      (sck-tmd-tile-cost tile) cost
	      (sck-tmd-tile-nxalist tile) nxalist)
	(setq updated t)))
      ;; VKB
      (t
	(sck-tmd-put-exp-tiles
	 exp
	 (nconc (sck-tmd-get-exp-tiles exp)
		(list (make-sck-tmd-tile :rule rule
					 :cost cost
					 :nxalist nxalist))))
	(setq updated t)))
    ;;
    updated))

(defun sck-tmd-tiling-setreg-ok-p (exp pat)
  ;;  (SET t ($ n reg) xxx) Ƃp^[ FOO  REG ȊOł
  ;;    (SET t (FOO ...) ...) ɁA reg: (FOO ...) }b`
  ;;    Ă܂A͌Ȃ̂ŒeB
  (if (and (eq (car pat) 'set)
	   (sck-tmd-patvar-p (caddr pat))
	   (eq (sck-tmd-patvar-nt (caddr pat)) 'reg))
      ;; reg ւ̑ȂA̕ reg łȂ΂ȂȂB
      (sck-lir-reg-exp-p (car (sck-lir-args exp)))
    t))

(defun sck-tmd-tiling-exp-eval-cost (exp rule nxalist)
  (sck-tmd-tiling-exp-eval (sck-tmd-rule-cost rule)
			   exp
			   (sck-tmd-rule-nt rule)
			   nxalist))


(defun sck-tmd-tiling-exp-check-ok-p (exp rule nxalist)
  ;; rule  (check <LispForm>) ̃eXgB
  (let ((checkform (or (sck-tmd-rule-check rule)
		       ;; (check ...) ȗĂ tB
		       t)))
    (sck-tmd-tiling-exp-eval checkform
			     exp
			     (sck-tmd-rule-nt rule)
			     nxalist)))

(defun sck-tmd-tiling-exp-eval (form exp nt nxalist)
  ;; cost y cond ̕]̉ʁB
  (if (atom form)
      (eval form)
    (let ((vals (mapcar 'cadr nxalist)))
      (sck-tmd-eval-with-$
       form
       (if (eq nt 'stmt)
	   vals
	 (cons exp vals))))))

(defun sck-tmd-eval-with-$ (form -vals-)
  ;; rule  <LispForm>  evaluatorB
  ;; vals = (v0 v1 ...) ̂ƂA
  ;; ($ i) => vi
  ;; Example:
  ;;  (sck-tmd-eval-with-$ '(+ ($ 0) ($ 1)) '(1 2)) => 3
  (flet (($ (n) (elt -vals- n)))
    (eval form)))


(defun sck-tmd-tile-chain-rules (exp nt nthistory cost)
  ;; chain [̏B
  (unless (memq nt nthistory) ; Ȃ
    (let ((chain (assq nt sck=tmd-chain-rule-alist)))
      ;; chain = ((Ni  R1name R2name) ...)
      (when chain
	(dolist (rname (cdr chain))
	  (let* ((rule (get rname 'rule)) ; Xg̎gp
		 (type (sck-tmd-rule-type rule)))
	    ;; type ꍇ͌^`FbNB
	    (when (or (null type)
		      (eq type (sck-lir-type exp)))
	      (let ((cost1 (+ cost (sck-tmd-rule-cost rule))))
		;; chain rule ̃RXg͒萔ƉB
		(sck-tmd-tiling-exp-record exp
					   rule
					   cost1
					   ;;  place ɂ͂ȂȂA
					   ;;  place ƂĎgȂ
					   (list
					    (list (sck-tmd-chain-rule-nt rule)
						  exp)))
		(sck-tmd-tile-chain-rules exp
					  (sck-tmd-rule-nt rule)
					  (cons nt nthistory)
					  cost1)
		))))))))

(defun sck-tmd-tiled-exp-regargs (exp nt)
  ;; Tiling ꂽ nt 炽ǂA^ reg 
  ;; (reg . expplace) XgԂB
  (let ((nxq (make-que)))
    (dolist (nx (sck-tmd-exp-nxalist exp nt))
      (sck-tmd-tiled-exp-regargs/aux nx nxq))
    (que-to-list nxq)))

(defun sck-tmd-tiled-exp-regargs/aux (nx nxq)
  (setq nx (sck-tmd-tiled-exp-regargs-skip-chain nx))
  (cond
   ((eq 'reg (car nx))
    (append-que nxq nx))
   (t
    (let* ((nt (car nx))
	   (expp (cdr nx))
	   (exp (car expp))
	   (rule (sck-tmd-exp-rule exp nt))
	   (nxalist (sck-tmd-exp-nxalist exp nt)))
      (dolist (nx1 nxalist)
	(sck-tmd-tiled-exp-regargs/aux nx1 nxq))))))


(defun sck-tmd-tiled-exp-regargs-skip-chain (nx)
  ;; nx = (nt . expplace)  nt  chain rule  nt u
  ;; nx ԂB
  (let* ((nt (car nx))
	 (expp (cdr nx))
	 (exp (car expp))
	 (rule (sck-tmd-exp-rule exp nt)))
    (while (and (not (eq 'reg (sck-tmd-rule-nt rule))) ; reg : xxx ͏()
		(sck-tmd-chain-rule-p rule))
      (setq nt (sck-tmd-chain-rule-nt rule))
      (setq rule (sck-tmd-exp-rule exp nt)))
    ;;
    (cons nt (cdr nx))))



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; Linearize tF[YB
;;; 
;;; ^COAߗɕꂽ؂𕪊AׂB
;;; ŁAVɍꂽ(WX^Rs[)͕IɃ^COĂȂB
;;; ōēx^COȂĂǂA &tiles 
;;; (Ȃ肤邳)NAAWX^AP[^ɓnA
;;; AZuo̓tF[Ył܂^COȂƂɂB
;;;
;;; ł͐̂Ƃ͖B
;;; o悤ɕό`̂ Relaxing tF[YňꊇčsȂB
;;; ō鉼zWX^͑S &regset = pending ƂȂĂāA
;;;  Relaxing tF[YœK؂ɃZbgB


(defun sck-tmd-linearize-tiled-exp (exp lsymtab)
  ;; Linearize  exp ̃XgԂB
  (let ((expq (make-que)))
    (sck-tmd-linearize-tiled-typed-exp exp expq lsymtab)
    (que-to-list expq)))

(defun sck-tmd-linearize-tiled-typed-exp (exp expq lsymtab)
  ;;  typed ƂȂAjump, jumpc, call ĂB
  (sck-tmd-linearize-tiled-typed-exp/aux exp 'stmt expq lsymtab)
  (append-que expq exp))

(defun sck-tmd-linearize-tiled-typed-exp/aux (exp nt expq lsymtab)
  (let ((regnxs (sck-tmd-tiled-exp-regargs exp nt)))
    (dolist (nx regnxs)
      (let ((exp1p (cdr nx)))
	(setf (car exp1p) (sck-tmd-linearize-tiled-typed-exp/aux
			   (car exp1p)
			   (car nx)
			   expq
			   lsymtab))))
    (cond
     ((eq nt 'stmt) 'junk)
     ((sck-lir-reg-exp-p exp) exp)
     (t
      (assert (eq nt 'reg))
      ;; WX^[ւ̑R[hóB
      (let* ((reg (sck-lir-new-vreg (sck-lir-type exp) lsymtab 'pending))
	     (exp1 (sck-lir-make-set-exp reg exp)))
	;; VȎ^COȂBIł͂B
	(sck-tmd-tiling-exp exp1) 
	(append-que expq exp1)
	reg)))))


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; Relaxing tF[YB
;;; 
;;; Tinling & Linearize A̖߂ɑΉɂāA
;;; WX^o悤ɃWX^[Rs[}
;;; Linearize ōꂽzWX^ &regset ݒ肷B


(defun sck-tmd-relaxing-tiled-exps (exps lsymtab)
  (let ((expq (make-que)))
    (dolist (exp exps)
      (append-que-list expq (sck-tmd-relaxing-tiled-exp exp lsymtab)))
    (que-to-list expq)))

(defun sck-tmd-relaxing-tiled-exp (exp lsymtab)
  (let* ((expq (make-que))
	 (rule (sck-tmd-exp-rule exp 'stmt))
	 (nxalist (sck-tmd-exp-nxalist exp 'stmt))
	 (r (sck-tmd-setget-reginfo exp 'stmt lsymtab))
	 (set-reginfo (car r))
	 (get-reginfo (cadr r)))
    ;;
    ;; ܂QƂĂ郌WX^̐̊ɘaB
    (sck-tmd-relaxing-copy-regs 'get get-reginfo expq lsymtab)
    ;;
    ;; exp goB
    (append-que expq exp)
    ;;
    ;; Ă郌WX^̐̊ɘaB
    (sck-tmd-relaxing-copy-regs 'set set-reginfo expq lsymtab)
    ;;
    (que-to-list expq)))

(defun sck-tmd-relaxing-copy-regs (direction reginfo expq lsymtab)
  (dolist (ri reginfo)
    (let* ((reg-place (car ri))
	   (expected-regset (cadr ri))
	   (eqreg (caddr ri))
	   (reg (car reg-place))
	   (ent (assoc (sck-lir-reg-name reg) lsymtab))
	   (current-regset (if (sck-lir-real-reg-p reg)
			       'realreg
			     (sck-lir-getprop ent '&regset))))
      ;;
      ;; (printf "dir = %S   eqreg = %S\n" direction eqreg) ; 
      ;;
      (cond
       ((and (not eqreg)
	     ;; WX^ȂR[s[͍ȂB
	     (eq current-regset 'realreg)))
       ((and (not eqreg)
	     ;; ҒʂȂRs[͍ȂB
	     (eq expected-regset current-regset)))
       (t
	;;
	(when (and (not eqreg) (eq current-regset 'pending))
	  ;; eqreg ȂƂɂRs[͍邪A
	  ;; łȂꍇɁAcurent-regset  pending Ȃ
	  ;; expected-regset ɕύXĂ܂B
	  (setq current-regset expected-regset)
	  (sck-lir-putprop ent '&regset expected-regset))
	;;
	(when (or eqreg (not (eq expected-regset current-regset)))
	  ;; eqreg ȂƂɂRs[B
	  ;; ܂ҒʂłȂ(oȂ)ꍇRs[B
	  (let* ((reg1 (or eqreg
			   (sck-lir-new-vreg (sck-lir-type reg)
					     lsymtab
					     expected-regset)))
		 (exp1 (ecase direction
			 (get (sck-lir-make-set-exp reg1 reg))
			 (set (sck-lir-make-set-exp reg reg1)))))
	    (append-que expq exp1)
	    (setf (car reg-place) reg1))))))))


(defun sck-tmd-setget-reginfo (exp nt lsymtab)
  ;; exp   Linearlize ς݂ŁAЂƂ݂̎閽߂\ĂB
  ;; ̈WX^𒲂ׁAAQƂĂ郌WX^ɂĂ
  ;;  setreginfoAgetreginfo ԂB xxxreginfo ́Ae Reg ɂ
  ;; ((RegExp-place regsetsym eqreg)... ) ƂXgB
  ;; eqreg  eq œƂꂽWX^ɑ΂āAVɊ蓖Ă
  ;; WX^Beq ɖ֌WȃWX^Ȃ nilB
  (let ((sq (make-que))
	(gq (make-que)))
    (sck-tmd-setget-reginfo/aux exp nt sq gq lsymtab)
    (list (que-to-list sq)
	  (que-to-list gq))))

(defun sck-tmd-setget-reginfo/aux (exp nt sq gq lsymtab)
  ;; setget-reginfo ̉ʊ֐B
  (let* ((rule (sck-tmd-exp-rule exp nt))
	 (eqs (sck-tmd-rule-regeqs rule))
	 (eqs-alist (let ((alist nil))
		      (dolist (eq eqs)
			(let ((rp (list nil)))
			  (dolist ($n eq)
			    (setq alist (cons (cons $n rp)
					      alist)))))
		      alist))
	 (rsalist (sck-tmd-rule-regset rule))
	 (nxalist (sck-tmd-exp-nxalist exp nt))
	 (n 0))
    ;;
    (dolist (nx nxalist)
      (cond
       ((sck-lir-reg-exp-p (cadr nx))
	(let* ((regplace (cdr nx))
	       (reg (car regplace))
	       (regset (sck-tmd-setget-reginfo/aux-find-regset
			n rsalist reg))
	       (eqreg (sck-tmd-setget-reginfo/aux-find-eqreg
		       n reg lsymtab regset eqs-alist)))
	  (if (and (eq (car exp) 'set)
		   (eq (cadr nx) (car (sck-lir-args exp))))
	      (append-que sq (copy-list `(,regplace ,regset ,eqreg)))
	    (append-que gq (copy-list `(,regplace ,regset ,eqreg))))))
       (t
	(sck-tmd-setget-reginfo/aux (cadr nx) (car nx) sq gq lsymtab)))
      ;;
      (incf n)
      )))


(defun sck-tmd-setget-reginfo/aux-find-regset (n rsalist reg)
  (let ((a (assq n rsalist)))
    (if a
	(cadr a)
      (let* ((type (sck-lir-type reg))
	     (a (assq type (get 'reg 'defregset)))) ; Xg̎gp
	(assert a)
	(cadr a)))))

(defun sck-tmd-setget-reginfo/aux-find-eqreg (n reg lsymtab regset eqs-alist)
  (let ((a (assq n eqs-alist)))
    (if a
	(or (cadr a)
	    (setf (cadr a)
		  (sck-lir-new-vreg (sck-lir-type reg) lsymtab regset)))
      nil)))

;;;
(provide 'sck-tmd-instsel)
