;;;; TMD ̃}N@\
;;;; LastChange: Fri Feb 09 14:35:46 2007


(defun sck-tmd-macro (forms)
  ;; .tmd ̃}NWJB
  ;; (sck-tmd-macro '(foo (foreach (n m) ((a 1) (b 2)) (xn ym "znm")) bar))
  ;; => (foo (xa y1 "za1") (xb y2 "zb2") bar)
  (sck-tmd-macro-foreach forms))

(defun sck-tmd-macro-foreach (forms)
  ;; foreach }N̓WJ
  ;; (foreach var (<Sexp>..) ...)
  ;; (foreach (var..) ((<Sexp>..)..) ...)
  (cond
   ((atom forms) forms)
   ((atom (car forms))
    (cons (car forms)
	  (sck-tmd-macro-foreach (cdr forms))))
   ((eq (caar forms) 'foreach)
    (let* ((fe (car forms))
	   (vars (cadr fe))
	   (valss (caddr fe))
	   (body (cdddr fe)))
      (append (sck-tmd-macro-foreach
	       (sck-tmd-macro-foreach/body vars valss body))
	      (sck-tmd-macro-foreach (cdr forms)))))
   (t
    (append (list (sck-tmd-macro-foreach (car forms)))
	    (sck-tmd-macro-foreach (cdr forms))))))

(defun sck-tmd-macro-foreach/body (vars valss body)
  (when (symbolp vars)
    ;; (foreach x (a b c) ...) -> (foreach (x) ((a) (b) (c)) ...)
    (setq vars (list vars)
	  valss (mapcar 'list valss)))
  (let ((ret nil))
    (dolist (vals valss)
      (let ((alist (zip-with #'(lambda (var val) `(,var ,val))
			     vars
			     vals)))
	(dolist (b body)
	  (push (sck-tmd-macro-foreach/body-subst b alist)
		ret))))
    (nreverse ret)))

(defun sck-tmd-macro-foreach/body-subst (sexp alist)
  (cond
   ((null sexp) sexp)
   ((symbolp sexp)
    (let ((a (assq sexp alist)))
      (if a
	  (cadr a)
	(intern (sck-tmd-macro-foreach/body-subst
		 (symbol-name sexp)
		 alist)))))
   ((stringp sexp)
    (dolist (a alist)
      (setq sexp
	    (let ((case-fold-search t))
	      (replace-regexp-in-string (regexp-quote (symbol-name (car a)))
					(format "%s" (cadr a))
					sexp
					t
					t))))
    sexp)
   ((consp sexp)
    (cons (sck-tmd-macro-foreach/body-subst (car sexp) alist)
	  (sck-tmd-macro-foreach/body-subst (cdr sexp) alist)))
   (t
    sexp)))


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; eXgpR}h

(defun sck-tmd-macro-region (beg end)
  ;; [W̃}NWJA*sck-tmd-macro* obt@֏o͂B
  (interactive "r")
  (let ((forms (save-restriction
		 (narrow-to-region beg end)
		 (read (concat "(" (buffer-string) ")")))))
    (with-display-buffer "*sck-tmd-macro*"
      (dolist (form (sck-tmd-macro forms))
	(insert (pp-to-string form) "\n")))))

(defun sck-tmd-macro-buffer ()
  ;; obt@̃}NWJA*sck-tmd-macro* obt@֏o͂B
  (interactive)
  (sck-tmd-macro-region (point-min) (point-max)))

	
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;

(put 'foreach 'lisp-indent-function 2)


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;
(provide 'sck-tmd-macro)
