;;;; Pattern Matcher 
;;;; LastChange: Thu Apr 12 23:33:50 2007


;;; S-̃p^[}b`sėpICu
;;;
;;; <PatVar> ::= ($ <MatchIndex> ...)
;;; <MatchIndex> ::= <Fixnum>
;;;
;;; S-p^[蒷ĂAp^[܂Ń}b`Ă΃}b`B
;;; <MatchIndex> Ȃ}b`͂邪oCh͂ȂB

(defun sck-tmd-pm-patvar-p (pat)
  ;; pat p^[ϐ ($ n ...) Ȃ琮 n AłȂ #f ԂB
  (and (eq (car-safe pat) '$)
       (cadr pat)))

(defun sck-tmd-pm-anon-patvar-p (pat)
  ;; ($ n) (n < 0) ̓oChΏۂƂȂB
  (and (eq (car-safe pat) '$)
       (< (cadr pat) 0)))


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; C^v^̒Pp^[̃}b`B

(defun sck-tmd-pm-match-1 (pat exp)
  ;; ЂƂ̃p^[ pat C^v^ S- exp փ}b`B
  ;;  [p0 p1 ...] ƂxN^ԂB
  ;;  pi ̓p^[ϐ ($ i) }b` car ŕێĂ
  ;; RXZB($ -1) ͖B
  ;; }b`s nil ԂB
  ;; Example:
  ;;  (sck-tmd-pm-match-1 '(foo (bar ($ 0)) a) '(foo (bar baz) a)) => [(baz)]
  ;;  (sck-tmd-pm-match-1 '(foo (bar ($ 0)) a) '(foo (bar baz))) => nil
  ;;  (sck-tmd-pm-match-1 '(foo (bar ($ 0)) a) '(foo (bar baz) a b)) => [(baz)]
  ;;  (sck-tmd-pm-match-1 '(foo (bar ($ -1)) a) '(foo (bar baz) a b)) => []
  (catch 'sck-tmd-pm-match-1-return
    (let* ((lis (sck-tmd-pm-match1-rec pat (list exp) nil))
	   (len (if (null lis)
		    0
		  (let ((l 0))
		    (dolist (x lis)
		      (setq l (max l (car x))))
		    (1+ l))))
	   (vec (make-vector len nil)))
      (dolist (x lis)
	(setf (aref vec (car x)) (cdr x)))
      ;;
      vec)))

(defun sck-tmd-pm-match1-rec (pat expplace alist)
  (let ((pvn (sck-tmd-pm-patvar-p pat)))
    (cond
     (pvn
      (if (<= 0 pvn)
	  (cons (cons pvn expplace) alist)
	alist))
     ((atom pat)
      (if (equal (car expplace) pat)
	  alist
	(throw 'sck-tmd-pm-match-1-return nil)))
     (t
      (let ((exp (car expplace)))
	(dolist (p pat)
	  (unless (consp exp)
	    (throw 'sck-tmd-pm-match-1-return nil))
	  (setq alist (sck-tmd-pm-match1-rec p exp alist))
	  (setq exp (cdr exp)))
	alist)))))



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; ̃p^[𓯎Ƀ}b` Emacs Lisp ̃}b`֐𐶐B
;;; p^[̃Xg pats  dtree Aꂩ Lisp R[h𐶐B

(defun sck-tmd-pm-make-matcher (pats matcher-name check-form action-form)
  ;; p^[̃Xg pats A}b`֐蕶ƂĕԂB
  ;; matcher-name ͐֐
  ;;
  ;; V^bNXIɃ}b`ŁAȉ́uR[hv֐Ă΂B
  ;; pat ̓}b`p^[A
  ;; pvalist = ((patvar exp expplace)....)
  ;;
  ;; check-form, action-form ͂ꂼ
  ;;
  ;; (funcall check-form pat pvalist) action-form s邩ǂ̏
  ;; (funcall action-form pat pvalist) }b`ɎsR[h
  ;; 𐶐֐B
  (let ((dtree (sck-tmd-pm-make-dtree pats)))
    (sck-tmd-pm-generate-matcher dtree matcher-name check-form action-form)))



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; pats -> dtree

(defun sck-tmd-pm-make-dtree (pats)
  (let ((pcalist (mapcar #'(lambda (p) `(,p ((pat ,p))))
			 (remove-duplicates pats :test 'equal))))
    (cons 'root (sck-tmd-pm-make-dtree-pats 'x pcalist))))

(defun sck-tmd-pm-format-dtree (dtree)
  ;; dtree  format-tree ɂ蕶ɕϊB
  (format-tree dtree
	       #'(lambda (dtree)
		   (cond
		    ((memq (car dtree) '(root true)) (cdr dtree))
		    ((consp (car dtree)) (cdr dtree))
		    ((eq (car dtree) 'pat) nil)
		    (t (error "illegal dtree: %S" dtree))))
	       #'(lambda (dtree)
		   (cond
		    ((eq (car dtree) 'pat)
		     (format "%S" (cadr dtree)))
		    (t
		     (format "%S" (car dtree)))))))


(defun sck-tmd-pm-classify-pcalist (pcalist)
  (let ((atoms (make-que))
	(lists (make-que))
	(vars (make-que))
	(anons (make-que)))
    (dolist (pc pcalist)
      (append-que (cond ((sck-tmd-pm-anon-patvar-p (car pc)) anons)
			  ((sck-tmd-pm-patvar-p (car pc)) vars)
			  ((consp (car pc)) lists)
			  (t atoms))
		    pc))
    (list (que-to-list atoms)
	  (que-to-list lists)
	  (que-to-list vars)
	  (que-to-list anons))))

(defun sck-tmd-pm-classify-dtree-args (dtargs)
  (let ((eqs (make-que))
	(matches (make-que))
	(pats (make-que))
	(trues (make-que)))
    (dolist (a dtargs)
      (append-que (cond
		     ((eq (car a) 'pat) pats)
		     ((eq (car a) 'true) trues)
		     ((eq (caar a) 'eq) eqs)
		     ((eq (caar a) 'match) matches)
		     (t
		      (error "illigal dtargs: %S" dtargs)))
	     a))
    (list (que-to-list eqs)
	  (que-to-list matches)
	  (que-to-list pats)
	  (que-to-list trues))))

(defun sck-tmd-pm-make-dtree-pats (x pcalist)
  ;; Cӎރp^[ pcalist  dtree B
  (multiple-value-bind (atoms lists vars anons)
      (sck-tmd-pm-classify-pcalist pcalist)
    (let ((dt-atoms (mapcar #'(lambda (pc) `((eq ,x ,(car pc)) ,@(cadr pc)))
			    atoms))
	  (dt-lists (sck-tmd-pm-make-dtree-lists x lists 0))
	  (dt-vars (mapcar #'(lambda (pc) `((match ,x ,(car pc)) ,@(cadr pc)))
			   vars))
	  (dt-anons (mapcar #'(lambda (pc) `(true ,@(cadr pc)))
			    anons)))
    ;;
    `(,@dt-atoms ,@dt-lists ,@dt-vars ,@dt-anons))))

(defun sck-tmd-pm-make-dtree-lists (x pcalist pos)
  ;; Xgp^[݂̂ pcalist  pos vfȍ~ŕނ dtree B
  (cond
   ((null pcalist) nil)
   ((<= (length (caar pcalist)) pos)
    (unless (= 1 (length pcalist))
      (error "duplicated pattern?"))
    (cadr (car pcalist)))
   (t
    (let* ((pats1 (remove-duplicates
		   (mapcar #'(lambda (pc) (elt (car pc) pos)) pcalist)
		   :test 'equal))
	   (pcalist1
	    (mapcar #'(lambda (pat1)
			(list
			 pat1 
			 (sck-tmd-pm-make-dtree-lists
			  x
			  (filter #'(lambda (pc)
				      (equal pat1 (elt (car pc) pos)))
				  pcalist)
			  (1+ pos))))
		    pats1)))
      ;;
      (sck-tmd-pm-make-dtree-pats (list pos x) pcalist1)))))



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; dtree -> matcher

(defun sck-tmd-pm-generate-matcher (dtree matcher-name check-form action-form)
  (with-temp-buffer
    (insertf "(defun %s (x)" matcher-name)
    (sck-tmd-pm-generate-matcher/conv dtree "\n  " nil  check-form action-form)
    (insert ")\n")
    (buffer-string)))


(defun sck-tmd-pm-generate-matcher/conv (dtree indent pvalist
					       check-form action-form)
  ;; pvalist ͂܂Ń}b`Ă patvar Ƃ̑Ώۂ vref  alist
  (multiple-value-bind (eqs matches pats trues)
      (sck-tmd-pm-classify-dtree-args (cdr dtree))
    (when (and pats (or eqs matches))
      (error "illegal dtree: %S\n" dtree))
    ;;
    (cond
     (pats
      (let* ((pvalist (sort (copy-list pvalist)
			    #'(lambda (x y) (< (cadar x) (cadar y)))))
	     (pat (cadar pats))
	     (cform (funcall check-form pat pvalist))
	     (aform (funcall action-form pat pvalist))
	     (aforms (if (eq (car aform) 'progn) (cdr aform) (list aform)))
	     (indent1 (concat indent "  ")))
	;;
	(cond
	 ((eq cform t)
	  (dolist (f aforms)
	    (insertf "%s%S" indent f)))
	 (t
	  (insertf "%s(when %S" indent cform)
	  (dolist (f aforms)
	    (insertf "%s%S" indent1 f))
	  (insert ")")))
	;;
	))
     ;;
     (t
      (cond
       ((null eqs))
       ((= 1 (length eqs))
	;; when
	(let ((v (sck-tmd-pm-generate-matcher/vref (cadr (caar eqs))))
	      (e (caddr (caar eqs))))
	  (insertf "%s(when (%s %s %s%S)"
		   indent
		   (if (symbolp e) "eq" "equal")
		   v
		   (if (symbolp e) "'" "")
		   e))
	(sck-tmd-pm-generate-matcher/conv (car eqs)
					  (concat indent "  ")
					  pvalist
					  check-form
					  action-form)
	(insert ")"))
       ;;
       (t
	  ;; case
	  (insertf "%s(case %S" indent 
		   (sck-tmd-pm-generate-matcher/vref (cadr (caar eqs))))
	  (let ((indent (concat indent "  ")))
	    (dolist (eq eqs)
	      (insertf "%s((%S)" indent (caddr (car eq)))
	      (sck-tmd-pm-generate-matcher/conv eq
						(concat indent " ")
						pvalist
						check-form
						action-form)
	      (insert ")")))
	  (insert ")")))
	;;
	(dolist (match matches)
	  (let* ((patvar (caddr (car match)))
		 (vref (cadr (car match)))
		 (exp (sck-tmd-pm-generate-matcher/vref vref))
		 (expp (sck-tmd-pm-generate-matcher/place vref)))
	    (sck-tmd-pm-generate-matcher/conv match
					      indent
					      (cons (list patvar exp expp)
						    pvalist)
					      check-form
					      action-form)
	    ))
	;;
	(dolist (true trues)
	  (sck-tmd-pm-generate-matcher/conv true
					    indent
					    pvalist
					    check-form
					    action-form))
	;;
	))))
  
  
(defun sck-tmd-pm-generate-matcher/vref (vref)
  ;; vref Ŏ鎮߂ form ɕϊB
  ;; (sck-tmd-pm-generate-matcher/vref '(0 x)) => (car x)
  ;; (sck-tmd-pm-generate-matcher/vref '(0 (4 (2 x))))
  ;; => (car (elt (caddr x) 4))
  (if (symbolp vref)
      vref
    (let ((n (car vref))
	  (v (sck-tmd-pm-generate-matcher/vref (cadr vref))))
      (if (<= n 3)
	  `(,(elt '(car cadr caddr cadddr) n) ,v)
	`(elt ,v ,n)))))

(defun sck-tmd-pm-generate-matcher/place (vref)
  ;; vref Ŏ鎮 place ߂ form ɕϊB
  ;;
  ;; (sck-tmd-pm-generate-matcher/place '(0 x)) => x
  ;; (sck-tmd-pm-generate-matcher/place '(1 x)) => (cdr x)
  ;; (sck-tmd-pm-generate-matcher/place '(2 x)) => (cddr x)
  ;;
  (assert (not (symbolp vref)))
  (let ((n (car vref))
	(a (sck-tmd-pm-generate-matcher/vref (cadr vref))))
    (cond
     ((zerop n) a)
     ((<= n 4) `(,(elt '(cdr cddr cdddr cddddr) (1- n)) ,a))
     (t `(nthcdr ,n  ,a)))))



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; demo

(defconst sck=tmd-pm-pats-sample
  '((SET I32 (MEM I32 ($ 0 disp)) ($ 1 reg))
    (SET I32 (MEM I32 ($ 0 reg)) ($ 1 reg))
    (MEM I32 (FRAME I32 ($ -1)))
    (ADD I32 ($ 0 reg) ($ 1 con))
    (ADD I32 ($ 0 reg) ($ 1 rc) &flag t)
    (CONVSX I32 (MEM I8 ($ 0 disp)))
    (CONVSX I32 ($ 0 reg))
    (MEM I8 ($ 0 reg))
    (FRAME I32 ($ -1))
    (INTCONST I32 ($ -1))
    (INTCONST I32 0)
    (INTCONST I32 1)))


(defconst sck=tmd-pm-sexps-sample
  '((SET I32 (MEM I32 X)  Y)
    (MEM I32 (FRAME I32 X))
    (MEM I8 X)
    (ADD I32 X Y)
    (ADD I32 X Y &flag t)
    (CONVSX I32 (MEM I8 X))
    (INTCONST I32 0)
    (INTCONST I32 1)
    (INTCONST I32 2)))


(defun sck-tmd-pm-demo ()
  (interactive)
  (let* ((pats sck=tmd-pm-pats-sample)
	 (sexps sck=tmd-pm-sexps-sample)
	 (dtree (sck-tmd-pm-make-dtree pats))
	 (matchername "sck-tmd-pm-test-matcher")
	 (matcher (sck-tmd-pm-generate-matcher dtree
					       matchername
					       'sck-tmd-pm-test-check-form
					       'sck-tmd-pm-test-action-form)))
    (with-display-buffer "*sck-tmd-pm-test*"
      (insertf ";;; Patterns:\n\n%s\n" (pp-to-string pats))
      (insertf ";;; Dtree:\n\n%s\n" (sck-tmd-pm-format-dtree dtree))
      (insertf ";;; Generated matcher function:\n\n%s\n" matcher)
      (eval (read matcher))
	(insertf ";;; Matching results:\n")
      (dolist (sexp sexps)
	(insertf "\nsexp=%S\n" sexp)
	(funcall (intern matchername) sexp)))))
	
(defun sck-tmd-pm-test-check-form (pat pvalist)
  (let ((ntcheck (make-que)))
    (dolist (a pvalist)
      (let ((patvar (car a))
	    (exp (cadr a)))
	(append-que ntcheck
		      `(sck-tmd-pm-test-has-nt-p ,exp ',(caddr patvar)))))
    (setq ntcheck (que-to-list ntcheck))
    ;;
    (cond
     ((null ntcheck) t)
     ((= 1 (length ntcheck)) (car ntcheck))
     (t
      `(and ,@ntcheck)))))

(defun sck-tmd-pm-test-has-nt-p (exp nt)
  t)

(defun sck-tmd-pm-test-action-form (pat pvalist)
  `(sck-tmd-pm-test-action-fun ',pat ,(if (null pvalist)
					  []
					`(vector ,@(mapcar 'caddr pvalist)))))

(defun sck-tmd-pm-test-action-fun (pat evec)
  (insertf "match=%S placevec=%S\n" pat evec)
  (dotimes (i (length evec))
    (insertf " ($ %d)=%S\n" i (car (aref evec i)))))



;;;
(provide 'sck-tmd-pm)
