;;;; Restructure
;;;; LastChange: Thu Apr 12 23:33:48 2007


(defun sck-tmd-restruct-module (module)
  "MODULE:<Module> ̃XgsAMODULE ԂB
͔jIɏCB
R}hƂċNꂽꍇ̓|Cgȉ S- MODULE ƂȂB"
  (interactive (list (save-excursion (read (current-buffer)))))
  (assert (eq (car-safe module) 'module))
  (let ((new-module (sck-tmd-restruct-add-reginfo module)))
    (dorest (ent new-module)
      (when (eq (car-safe (car ent)) 'function)
	(setf (car ent) (sck-tmd-restruct (car ent)))))
    ;;
    (when (interactive-p)
      (with-display-buffer "*sck-tmd-restruct-module*"
	(sck-lir-mode)
	(insert (sck-lir-pp new-module))))
    ;;
    new-module))


(defun sck-tmd-restruct (lfunc)
  "LFUNC:<Lfunc> ̃XgsALFUNC ԂB
͔jIɏCB
R}hƂċNꂽꍇ̓|Cgȉ S- LFUNC ƂȂB"
  (interactive (list (save-excursion (read (current-buffer)))))
  (assert (eq (car-safe lfunc) 'function))
  (let* ((name (cadr lfunc))
	 (lsymtab (caddr lfunc))
	 (exps (cdddr lfunc))
	 (new-exps nil)
	 (new-lfunc nil))
    ;;
    (let ((q (make-que)))
      (dolist (exp exps)
	(append-que-list q (sck-tmd-restruct-exp exp lsymtab)))
      (setq new-exps (que-to-list q)))
    ;;
    ;; SYMTAB  FRAME Gg̃ItZbg肵AFRAME XgB
    ;; ̃XgɂV FRAME ϐ̂ŁAōsB
    ;; sck-tmd-restruct-frame  .tmd Œ`B
    (sck-tmd-restruct-alloc-locals lsymtab)
    (dolist (exp new-exps)
      (sck-tmd-restruct-frame-exp exp lsymtab))
    ;; &regset ȂzWX^łL̂ɐݒB
    (sck-tmd-restruct-fillup-regset lsymtab)
    ;;
    (setq new-lfunc `(function ,name ,lsymtab ,@new-exps))
    ;;
    (when sck*tmd-debug
      (insertf ";;; After restructuring:\n\n")
      (insertf "%s\n\n" (sck-lir-pp new-lfunc)))
    ;;
    (when (interactive-p)
      (with-display-buffer "*sck-tmd-restruct*"
	(sck-lir-mode)
	(insert (sck-lir-pp new-lfunc))))
    ;;
    new-lfunc))

(defun sck-tmd-restruct-alloc-locals (lsymtab)
  ;; ܂ItZbg肵ĂȂ FRAME sent (  offset = nil Ŕf)
  ;; AP[gB
  (let ((maxoffset (- (sck-lir-lsymtab-frame-size lsymtab))))
    (dolist (lsent (cdr lsymtab))
      (when (eq (sck-lir-lsent-kind lsent) 'frame)
	(unless (sck-lir-lsent-offset lsent)
	  (decf maxoffset (sck-lir-type-bytes (sck-lir-lsent-type lsent)))
	  (setq maxoffset (- (roundup (- maxoffset)
				      (sck-lir-lsent-align lsent))))
	  (setf (sck-lir-lsent-offset lsent) maxoffset))))
    ;;
    lsymtab))

(defun sck-tmd-restruct-exp (exp lsymtab)
  (case (car exp)
    ((prologue) (sck-tmd-restruct-prologue exp lsymtab))
    ((call) (sck-tmd-restruct-call exp lsymtab))
    ((jumpn) (assert nil))
    ((epilogue) (sck-tmd-restruct-epilogue exp lsymtab))
    (t
     (list exp))))

(defun sck-tmd-restruct-frame-exp (sexp lsymtab)
  ;; S- sexp ċAIɂǂ (FRAME I32 "foo") Ƃ
  ;; (ADD I32 (REG I32 "FP") ItZbg) ŔjIɒuB
  (dorest (ep sexp)
    (cond
     ((atom (car ep)))
     ((eq (caar ep) 'frame)
      (let* ((frame-exp (car ep))
	     (lsent (assoc (caddr frame-exp) lsymtab))
	     (offset (if lsent
			 (sck-lir-lsent-offset lsent)
		       (assert nil))))
	;; sck-tmd-restruct-frame  .tmd Œ`B
	(setf (car ep) (sck-tmd-restruct-frame frame-exp offset))))
     (t
      (sck-tmd-restruct-frame-exp (car ep) lsymtab))))
  ;;
  sexp)

(defun sck-tmd-restruct-fillup-regset (lsymtab)
  ;; &regset ȂzWX^łL̂ɐݒB
  (dolist (sent (cdr lsymtab))
    (when (and (eq (cadr sent) 'reg)
	       (not (sck-lir-getprop sent '&regset)))
      (sck-lir-putprop sent
		       '&regset
		       (let* ((type (caddr sent))
			      (a (assq type (get 'reg 'defregset))))
			 (assert a)
			 (cadr a))))))

(defun sck-tmd-restruct-fillup-pending-regset (lsymtab)
  ;; &regset  pending ̂̂AłL̂ɐݒ肷B
  (dolist (lsent (cdr lsymtab))
    (when (and (eq (sck-lir-lsent-kind lsent) 'reg)
	       (eq (sck-lir-getprop lsent '&regset) 'pending))
      (sck-lir-putprop lsent '&regset
		       (let* ((type (caddr lsent))
			      (a (assq type (get 'reg 'defregset))))
			 (assert a)
			 (cadr a))))))


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; ݂ TMD ɏ] module  defs ǉAglobal symtab 
;;; WX^GgǉB

(defun sck-tmd-restruct-add-reginfo (module)
  "݂ TMD (sck=tmd-def-form-list) ɏ] module  defs ǉA
global symtab ɃWX^GgǉB͔j󂵂ȂB"
  (let* ((name (sck-lir-module-name module))
	 (gsymtab (sck-lir-module-symtab module))
	 (body (sck-lir-module-body module))
	 ;;
	 (defs (cons 'defs
		     (mapcar #'(lambda (dsv)
				 (list (cadr dsv) (caddr dsv)))
			     sck=tmd-def-form-list)))
	 (realregsymtab (cadr (assq '*real-reg-symtab* defs))))
    ;;
    (setq defs (remove-if #'(lambda (a)
			      (eq (car-safe a) '*real-reg-symtab*))
			  defs))
    ;;
    `(module ,name
	     ,defs
	     (symtab ,@(cdr gsymtab)
		     ,@(cdr realregsymtab))
	     ,@body)))
    
		       
;;;
(provide 'sck-tmd-restruct)
