;;;
;;;  Tarjan ̃ASY LOt狭Airtrongly bonnected bomponerntjT
;;;
;;;                        LastChange: Wed Jan 17 17:33:23 2007
;;;
;;;
;;;
;;;
;;; Export:
;;; findscc : <NodeList> <Relation> -> <SCC> |
;;;           <NodeList> <Relation> <BaseFunc> -> (<SCC> <SetValue>)
;;; 
;;; findscc2 : <NodeList> <RelationFunc> -> <SCC> |
;;;            <NodeList> <RelationFunc> <BaseFunc> -> (<SCC> <SetValue>)
;;;
;;; 
;;; Type:
;;; <NodeList>      ::= (<Node> ..)
;;; <Relation>   ::= <Node> <Node> -> <Boolean>
;;; <RelationFunc>   ::= <Node>  -> (<Node> ..)
;;; <BaseFunc> ::= <Node> -> <SetValue>
;;; <SetValue>  ::= (<Value> ..)  ; W
;;;
;;;  LOt狭A𓾂BBaseFunc ɒǉ
;;;  ł Fx = sF'x    {Fy | xRy} 𖞂 Fx ߂
;;;
;;;  m[hԂ relation 𔻒肷֐Ɏ̂ findscc
;;;  relation ֌Wɂm[h̃Xg炤֐Ɏ̂ findscc2

;;
;; 萔
;;
(defconst findscc-infinity 134217727) ; 


;;;
;;;  ֐
;;;
(defun findscc (nodelist relation-p &optional basefunc)
  (let ((findscc-stack nil)
	(findscc-depth-hash nil)
	(findscc-setvalue-hash nil)
	(findscc-scc nil)                ; SCC               ((<Node> ...) ...)
	(findscc-setvalue nil))          ; F(x) alist      ((<Node> <F(x)>) ...)

    (findscc-init nodelist)		; ϐ
    (dolist (node nodelist)		; C
      (if (equal (gethash node findscc-depth-hash) 0) ; xĂȂ
	  (findscc-traverse node nodelist relation-p basefunc)))
    (if basefunc	     ; F(x) nbVe[u烊Xgɂ
	(dolist (node nodelist)
	  (push (list node (gethash node findscc-setvalue-hash)) findscc-setvalue)))
    (if basefunc
	(list findscc-scc findscc-setvalue)
      findscc-scc)))



(defun findscc2 (nodelist relation-node &optional basefunc)
  (let ((findscc-stack nil)
	(findscc-depth-hash nil)
	(findscc-setvalue-hash nil)
	(findscc-scc nil)                ; SCC               ((<Node> ...) ...)
	(findscc-setvalue nil))          ; F(x) alist      ((<Node> <F(x)>) ...)

    (findscc-init nodelist)		; ϐ
    (dolist (node nodelist)		; C
      (if (equal (gethash node findscc-depth-hash) 0) ; xĂȂ
	  (findscc-traverse2 node relation-node basefunc)))
    (if basefunc	     ; F(x) nbVe[u烊Xgɂ
	(dolist (node nodelist)
	  (push (list node (gethash node findscc-setvalue-hash)) findscc-setvalue)))
    (if basefunc
	(list findscc-scc findscc-setvalue)
      findscc-scc)))



;;;
;;;  Traverse
;;;
(defun findscc-traverse (x nodelist relation-p basefunc)
  (push x findscc-stack)
  (let ((d (length findscc-stack)))
    (setf (gethash x findscc-depth-hash) d)
    (if basefunc
	(setf (gethash x findscc-setvalue-hash) (apply basefunc (list x)))) ; Fx <- F'x

    (dolist (y nodelist) ;loop
      (if (apply relation-p (list x y))
	  (progn
	    (if (equal (gethash y findscc-depth-hash) 0)
		(findscc-traverse y nodelist relation-p basefunc))
	    (setf (gethash x findscc-depth-hash)
		  (min (gethash x findscc-depth-hash) (gethash y findscc-depth-hash)))
	    (if basefunc
		(setf (gethash x findscc-setvalue-hash)
		      (findscc-union (gethash x findscc-setvalue-hash)
				     (gethash y findscc-setvalue-hash)))) ; Fx <- Fx  Fy
	    )));end loop

    (if (equal (gethash x findscc-depth-hash) d)
	(let ((scc nil))
	  (block repeat ; loop
	    (while t
	      (setf (gethash (car findscc-stack) findscc-depth-hash)
		    findscc-infinity)
	      (if basefunc
		  (setf (gethash (car findscc-stack) findscc-setvalue-hash)
			(gethash x findscc-setvalue-hash))) ; F(Top of S) <- Fx
	      (push (car findscc-stack) scc)
	      (when (equal (pop findscc-stack) x)
		(return-from repeat nil)))) ;end loop
	  (push scc findscc-scc))))) ; count scc



(defun findscc-traverse2 (x relation-node basefunc)
  (push x findscc-stack)
  (let ((d (length findscc-stack)))
    (setf (gethash x findscc-depth-hash) d)
    (if basefunc
	(setf (gethash x findscc-setvalue-hash) (apply basefunc (list x)))) ; Fx <- F'x

    (dolist (y (apply relation-node (list x))) ;loop
	       (progn
		 (if (equal (gethash y findscc-depth-hash) 0)
		     (findscc-traverse2 y relation-node basefunc))
		 (setf (gethash x findscc-depth-hash)
		       (min (gethash x findscc-depth-hash) (gethash y findscc-depth-hash)))
		 (if basefunc
		     (setf (gethash x findscc-setvalue-hash)
			   (findscc-union (gethash x findscc-setvalue-hash)
					  (gethash y findscc-setvalue-hash)))) ; Fx <- Fx  Fy
		 ))			;end loop

    (if (equal (gethash x findscc-depth-hash) d)
	(let ((scc nil))
	  (block repeat ; loop
	    (while t
	      (setf (gethash (car findscc-stack) findscc-depth-hash)
		    findscc-infinity)
	      (if basefunc
		  (setf (gethash (car findscc-stack) findscc-setvalue-hash)
			(gethash x findscc-setvalue-hash))) ; F(Top of S) <- Fx
	      (push (car findscc-stack) scc)
	      (when (equal (pop findscc-stack) x)
		(return-from repeat nil)))) ;end loop
	  (push scc findscc-scc))))) ; count scc


;;;
;;;  ϐ
;;;
(defun findscc-init (nodelist)
  (setq findscc-depth-hash (make-hash-table :test 'equal))
  (setq findscc-setvalue-hash (make-hash-table :test 'equal))
  (dolist (node nodelist)
    (setf (gethash node findscc-depth-hash) 0)
    (setf (gethash node findscc-setvalue-hash) nil)))




(defun findscc-union (x y)
  (union x y :test 'equal))

;;;
;;; Demo
;;;
(defvar findscc-sample-nodelist nil)
(defvar findscc-sample-relation-list nil)
(defvar findscc-sample-value-list nil)

(defun findscc-demo-init ()
  (setq findscc-sample-nodelist
	'(a b c d e f))

  (setq findscc-sample-relation-list
	'((a b)
	  (b c)
	  (c a)
	  (c d)
	  (c f)
	  (e d)
	  ))

  (setq findscc-sample-value-list
	'((a (A))
	  (b (B))
	  (c (C))
	  (d (D))
	  (e (E))
	  (f (F))
	  ))
  )

(defun findscc-sample-relation-p (x y)
  (member (list x y) findscc-sample-relation-list))


(defun findscc-sample-basefunc (x)
  (cadr (assoc x findscc-sample-value-list)))

(defun findscc-sample-relation-node (x)
  (let ((result nil))
    (dolist (y findscc-sample-relation-list)
      (if (equal x (car y))
	  (push (cadr y) result)))
    result))



(defun findscc-demo ()
  (interactive)
  (findscc-demo-init)
  (with-display-buffer "*findscc-demo*"
    (insertf "findscc-sample-nodelist = %S\n"
	     findscc-sample-nodelist)
    (insertf "findscc-sample-relation-list = %S\n"
	     findscc-sample-relation-list)
    (insertf "findscc-sample-value-list = %S\n"
	     findscc-sample-value-list)
    ;;
    (insert "
  (defun findscc-sample-relation-p (x y)
    (member (list x y) findscc-sample-relation-list))

  (defun findscc-sample-basefunc (x)
    (cadr (assoc x findscc-sample-value-list)))

  (findscc findscc-sample-nodelist
           #'findscc-sample-relation
	   #'findscc-sample-basefunc)  -> (SCC SetValue)")
    ;;
    (let ((result (findscc findscc-sample-nodelist
			   #'findscc-sample-relation-p
			   #'findscc-sample-basefunc)))

      (insertf "\n\n")
      (insertf "SCC  = %S\n\n" (car result))
      (insertf "SetValue = %s\n" (cadr result)))))


(defun findscc-demo2 ()
  (interactive)
  (findscc-demo-init)
  (with-display-buffer "*findscc-demo2*"
    (insertf "findscc-sample-nodelist = %S\n"
	     findscc-sample-nodelist)
    (insertf "findscc-sample-relation-list = %S\n"
	     findscc-sample-relation-list)
    (insertf "findscc-sample-value-list = %S\n"
	     findscc-sample-value-list)
    ;;
    (insert "
  (defun findscc-sample-relation-node (x)
    (let ((result nil))
      (dolist (y findscc-sample-relation-list)
        (if (equal x (car y))
	  (push (cadr y) result)))
      result))

  (defun findscc-sample-basefunc (x)
    (cadr (assoc x findscc-sample-value-list)))

  (findscc findscc-sample-nodelist
           #'findscc-sample-relation
	   #'findscc-sample-basefunc)  -> (SCC SetValue)")
    ;;
    (let ((result (findscc2 findscc-sample-nodelist
			   #'findscc-sample-relation-node
			   #'findscc-sample-basefunc)))

      (insertf "\n\n")
      (insertf "SCC  = %S\n\n" (car result))
      (insertf "SetValue = %s\n" (cadr result)))))


(provide 'findscc)
