;;;
;;;                          p[T Tv
;;;
;;;  tokens    : g[ÑXgiŌ $ j
;;;  lra       : yayacc ŐꂽI[g}g̃Xe[^X̃Xg
;;;
(defun sck-yayacc-parser (tokens lra &optional action)
  (save-excursion
    (let ((debug-buf (get-buffer-create "*sck-yayacc-parser-debug*")))
      (set-buffer debug-buf)
      (erase-buffer)
      (catch 'sck-yayacc-parser-catch-tag
	(let* ((state (car lra))	; JnXe[g
	       (start-symbol (caar (sck-yayacc-lra-state-lr0s state)))
	       (symbol-stack (list (car tokens))) ; X^bNɍŏ̃g[Nς
	       (parse-tree-stack (list (car tokens)))
	       (state-stack (list state)))
	  ;; state               s̏
	  ;; startsym            X^[gV{
	  ;; symbol-stack        V{̃X^bN
	  ;; parse-tree-stack    \ ̃X^bN
	  ;; state-stack         Ԃ̃X^bN
	  (setq tokens (cdr tokens))	; ǂݐi߂
	  (let ((loopflag t) (reduces nil) (shifts nil))
	    (while loopflag		; C[v

	      (insert (format "--- state %s --- \n" (sck-yayacc-lra-state-index state)))
	      (insert (format "symbol     : %S\n" (reverse symbol-stack)))
	      (insert (format "parse tree : %S\n" (reverse parse-tree-stack)))
	      (insert (format "---------------- \n\n"))

	      (setq state (sck-yayacc-parser-move-state state (car symbol-stack))) ; X^bNgbṽV{ɂJڂ

	      (insert (format "move to state %s\n\n" (sck-yayacc-lra-state-index state)))

	      (insert (format "--- state %s --- \n" (sck-yayacc-lra-state-index state)))
	      (insert (format "symbol     : %S\n" (reverse symbol-stack)))
	      (insert (format "parse tree : %S\n" (reverse parse-tree-stack)))
	      (insert (format "---------------- \n\n"))

	      (unless state		; Jڐ悪ȂH
		(insert (format "syntax error!!\n"))
		(insert (format "  %S\n" tokens))
		(sck-yayacc-parser-error "syntax error 1"))
	      (setq reduces (sck-yayacc-parser-get-reduce (car state) symbol-stack)) ; Ҍ[𓾂
	      (if (cdr reduces)		; Ҍ[Qȏ゠邩
		  (progn
		    (insert (format "reduce/reduce conflict!!\n"))
		    (dolist (x reduces)
		      (insert (format "  %S\n" x)))
		    (sck-yayacc-parser-error "reduce/reduce conflict")))
	      (setq shifts (sck-yayacc-parser-get-shift (car state) (car tokens))) ; Vtg[𓾂
	      (if (and reduces shifts) ; Ҍ[ƃVtg[邩
		  (progn
		    (insert (format "shift/reduce conflict!!\n"))
		    (dolist (x reduces)
		      (insert (format "  %S\n" x)))
		    (dolist (x shifts)
		      (insert (format "  %S\n" x)))
		    (sck-yayacc-parser-error "shift/reduce conflict")))

	      (cond
	       (reduces			; Ҍ
		(insert (format "reduce : %S\n\n" (car reduces)))
		(let* ((lval (caar reduces)) (rval (cadr (car reduces))) (production (cons lval rval)) (ptree nil))
		  (dolist (x (reverse rval))
		    (setq symbol-stack (cdr symbol-stack))
		    (setq ptree (cons (car parse-tree-stack) ptree))
		    (setq parse-tree-stack (cdr parse-tree-stack))
		    (setq state (car state-stack))
		    (setq state-stack (cdr state-stack)))
		  (setq symbol-stack (cons lval symbol-stack))
		  (setq state-stack (cons state state-stack))
		  (let ((actfunc (cadr (assoc production action))))
		    (if actfunc
			(setq ptree (apply actfunc ptree))
		      (setq ptree (cons lval ptree))))
		  (setq parse-tree-stack (cons ptree parse-tree-stack))))

	       (shifts			; VtgiԑJڂ͂Ȃj
		(insert (format "shift : %S\n\n" (car shifts)))
		(setq symbol-stack (cons (car tokens) symbol-stack))
		(setq parse-tree-stack (cons (car tokens) parse-tree-stack))
		(setq state-stack (cons state state-stack))
		(setq tokens (cdr tokens)))

	       (t
		(insert (format "syntax error!!\n"))
		(insert (format "  %S\n" tokens))
		(sck-yayacc-parser-error "syntax error 2")))

	      (if (equal start-symbol (car symbol-stack)) ; X^bNgbvX^[gV{ȂI
		  (setq loopflag nil))))

	  (insert (format "--- state %s --- \n" (sck-yayacc-lra-state-index state)))
	  (insert (format "symbol     : %S\n" (reverse symbol-stack)))
	  (insert (format "parse tree : %S\n" (reverse parse-tree-stack)))
	  (insert (format "---------------- \n\n"))

	  (car parse-tree-stack))))))






;;;
;;;                      SLR(1)   p[T
;;;
;;;  tokens    : g[ÑXgiŌ $ j
;;;  lra       : yayacc ŐꂽI[g}g̃Xe[^X̃Xg
;;;  follows   : yayacc Őꂽ follow W̃Xg
;;;
(defun sck-yayacc-slr1-parser (tokens lra follows &optional action)
  (save-excursion
    (let ((debug-buf (get-buffer-create "*sck-yayacc-parser-debug*")))
      (set-buffer debug-buf)
      (erase-buffer)
      (catch 'sck-yayacc-parser-catch-tag
	(let* ((state (car lra))	; JnXe[g
	       (start-symbol (caar (sck-yayacc-lra-state-lr0s state)))
	       (symbol-stack (list (car tokens))) ; X^bNɍŏ̃g[Nς
	       (parse-tree-stack (list (car tokens)))
	       (state-stack (list state)))
	  ;; state               s̏
	  ;; startsym            X^[gV{
	  ;; symbol-stack        V{̃X^bN
	  ;; parse-tree-stack    \ ̃X^bN
	  ;; state-stack         Ԃ̃X^bN
	  (setq tokens (cdr tokens))	; ǂݐi߂
	  (let ((loopflag t) (reduces nil) (shifts nil))
	    (while loopflag		; C[v

	      (insert (format "--- state %s --- \n" (sck-yayacc-lra-state-index state)))
	      (insert (format "symbol     : %S\n" (reverse symbol-stack)))
	      (insert (format "parse tree : %S\n" (reverse parse-tree-stack)))
	      (insert (format "---------------- \n\n"))

	      (setq state (sck-yayacc-parser-move-state state (car symbol-stack))) ; X^bNgbṽV{ɂJڂ

	      (insert (format "move to state %s\n\n" (sck-yayacc-lra-state-index state)))

	      (unless state		; Jڐ悪ȂH
		(insert (format "syntax error!!\n"))
		(insert (format "  %S\n" tokens))
		(sck-yayacc-parser-error "syntax error 1"))

	      (insert (format "--- state %s --- \n" (sck-yayacc-lra-state-index state)))
	      (insert (format "symbol     : %S\n" (reverse symbol-stack)))
	      (insert (format "parse tree : %S\n" (reverse parse-tree-stack)))
	      (insert (format "---------------- \n\n"))

	      (setq reduces (sck-yayacc-parser-get-reduce (sck-yayacc-lra-state-lr0s state) symbol-stack)) ; Ҍ[𓾂
	      (setq shifts (sck-yayacc-parser-get-shift (sck-yayacc-lra-state-lr0s state) (car tokens))) ; Vtg[𓾂

	      (let ((reduce nil) (shift nil))
		(dolist (r reduces) ; Ҍ[ݒ
		  (cond
		   ((null tokens) ; ɂރg[NȂꍇ ŊҌ
		    (setq reduce r))
		   ((member (car tokens) (sck-yayacc-parser-get-follow follows (car r))) ;ɓǂރg[NFollowWɂH
		    (if reduce
			(progn
			  (insert (format "reduce/reduce conflict!!\n"))
			  (insert (format "  %S\n" r))
			  (sck-yayacc-parser-error "reduce/reduce conflict"))
		      (setq reduce r)))
		   (t nil)))
		(setq shift (car shifts))

		(cond
		 (reduce		; Ҍ
		  (insert (format "reduce : %S\n\n" reduces))
		  (let* ((lval (caar reduces)) (rval (cadr (car reduces))) (production (cons lval rval)) (ptree nil))
		    (dolist (x (reverse rval))
		      (setq symbol-stack (cdr symbol-stack))
		      (setq ptree (cons (car parse-tree-stack) ptree))
		      (setq parse-tree-stack (cdr parse-tree-stack))
		      (setq state (car state-stack))
		      (setq state-stack (cdr state-stack)))
		    (setq symbol-stack (cons lval symbol-stack))
		    (setq state-stack (cons state state-stack))
		    (let ((actfunc (cadr (assoc production action))))
		      (if actfunc
			  (setq ptree (apply actfunc ptree))
			(setq ptree (cons lval ptree))))
		    (setq parse-tree-stack (cons ptree parse-tree-stack))))

		  (shift		; Vtg iԑJڂ͂Ȃj
		   (insert (format "shift : %S\n\n" shift))
		   (setq symbol-stack (cons (car tokens) symbol-stack))
		   (setq parse-tree-stack (cons (car tokens) parse-tree-stack))
		   (setq state-stack (cons state state-stack))
		   (setq tokens (cdr tokens)))

		  (t
		   (insert (format "syntax error!!\n"))
		   (insert (format "  %S\n" tokens))
		   (sck-yayacc-parser-error "syntax error 2"))))

	      (if (equal start-symbol (car symbol-stack)) ; X^bNgbvX^[gV{ȂI
		  (setq loopflag nil))))
	  
	  (insert (format "--- state %s --- \n" (sck-yayacc-lra-state-index state)))
	  (insert (format "symbol     : %S\n" (reverse symbol-stack)))
	  (insert (format "parse tree : %S\n" (reverse parse-tree-stack)))
	  (insert (format "---------------- \n\n"))

	  (car parse-tree-stack))))))




;;;
;;; 
;;;  Follow W𓾂
;;; 
;;;  follows  : FollowW̃e[u
;;;  sym      : L
;;;
(defun sck-yayacc-parser-get-follow (follows sym)
  (cadr (assoc sym follows)))




;;;
;;;@V{ɂJڂ̏Ԃ𓾂
;;;
;;;  state   : ݂̏
;;;  symbol  : ړV{
;;;
(defun sck-yayacc-parser-move-state (state symbol)
  (let ((succ (sck-yayacc-lra-state-succ state)))
    (cadr (assoc symbol succ))))


;;;
;;;@Ҍ\ǂׂĂ LR(0) ̃XgԂ
;;;
;;;  lr0s    : LR(0)̏W
;;;  sstk    : V{̃X^bN
;;;
(defun sck-yayacc-parser-get-reduce (lr0s sstk)
  (let ((reduce-lr0s nil))
    (dolist (lr0 lr0s)
      (if (sck-yayacc-lr0-complete-p lr0)
	  (let ((ok t) (rval (cadr lr0)) (vocabulary sstk))
	    (dolist (sym (reverse rval))
	      (unless (equal sym (car vocabulary))
		(setq ok nil))
	      (setq vocabulary (cdr vocabulary)))
	    (if ok
		(setq reduce-lr0s (cons lr0 reduce-lr0s))))))
    reduce-lr0s))


;;;
;;;@Vtg\ǂׂĂ LR(0) ̃XgԂ
;;;
;;;  lr0s    : LR(0)̏W
;;;  token   : ǂ݃g[N
;;;
(defun sck-yayacc-parser-get-shift (lr0s token)
  (let ((shift-lr0s nil))
    (dolist (lr0 lr0s)
      (if (sck-yayacc-lr0-shift-p lr0)
	  (if (equal (caaddr lr0) token)
	      (setq shift-lr0s (cons lr0 shift-lr0s)))))
    shift-lr0s))





;;;
;;;@G[
;;;
;;; memo : shift/reduce conflict, reduce/reduce conflict
;;;
(defun sck-yayacc-parser-error (msg)
  (throw 'sck-yayacc-parser-catch-tag msg))





;;;
;;;  vg
;;;
(defun sck-yayacc-parser-dump (token result)
  (save-excursion
    (let ((dspbuf (get-buffer-create "*sck-yayacc-parser-demo*")))
      (set-buffer dspbuf)
      (erase-buffer)
      (insert (format "token  : %S\n\n" token))
      (insert (format "result : %S\n\n" result))
      (goto-char (point-min))
      (display-buffer dspbuf)
      t)))



;;;
;;;  eXg
;;;
(defvar sck*yayacc-G5 nil)
(defvar sck*yayacc-G5-action nil)
(defvar sck*yayacc-parser-test-token nil)

(defun sck-yayacc-parser-test-init ()
  (setq sck*yayacc-G5
	'(
	  (START E $)
	  (E E "+" T)
	  (E T)
	  (T T "*" F)
	  (T F)
	  (F "(" E ")")
	  (F "0")
	  (F "1")
	  (F "2")
	  (F "3")
	  (F "4")
	  (F "5")
	  (F "6")
	  (F "7")
	  (F "8")
	  (F "9")
	  )
	)
  (setq sck*yayacc-G5-action
	'(
	  ((START E $)   (lambda (a b) a))
	  ((E E "+" T)   (lambda (a b c) (+ a c)))
	  ((E T)         (lambda (a) a))
	  ((T T "*" F)   (lambda (a b c) (* a c)))
	  ((T F)         (lambda (a) a))
	  ((F "(" E ")") (lambda (a b c) b))
	  ((F "0")       (lambda (a) 0))
	  ((F "1")       (lambda (a) 1))
	  ((F "2")       (lambda (a) 2))
	  ((F "3")       (lambda (a) 3))
	  ((F "4")       (lambda (a) 4))
	  ((F "5")       (lambda (a) 5))
	  ((F "6")       (lambda (a) 6))
	  ((F "7")       (lambda (a) 7))
	  ((F "8")       (lambda (a) 8))
	  ((F "9")       (lambda (a) 9))
	  )
	)

  (setq sck*yayacc-parser-test-token '("4" "+" "(" "3" "+" "2" "*" "(" "2" "+" "1" ")" ")" "*" "7" $))

  nil
  )

;;;
;;;  f
;;;
(defun sck-yayacc-parser-demo ()
  (interactive)
  (sck-yayacc-parser-test-init)   ; ϐ
  (sck-yayacc-make sck*yayacc-G5) ; LRA 쐬
  (let (result)
    (setq result (sck-yayacc-slr1-parser sck*yayacc-parser-test-token sck*yayacc-lra sck*yayacc-follow sck*yayacc-G5-action))
    (sck-yayacc-parser-dump sck*yayacc-parser-test-token result)))

