;;;
;;; $Id: sck-yayacc-yacc.el,v 1.6 2007/02/15 07:24:51 heavy Exp $
;;;
;;; <yayacc-input> ::= ((object-language <String>)
;;; 		    (precedences ((<Associativity> (<Terminal>..))..))
;;; 	            (attribute-grammar ((<BNF> <Action> [<Prec>])..))
;;; 		    (output-filename <String>)
;;; 		     ..
;;; 		     )
;;;
;;; <BNF> ::= (<NonTerminal> <Vocabulary>..)
;;; <NonTerminal> ::= <Symbol>
;;; <Vocabulary> ::= <NonTerminal> | <Terminal>
;;; <Terminal> ::= <String>
;;; <Action> ::= <String> | <S-Exp>
;;; <Prec> ::= <Terminal> 
;;; <Associativity> ::= left | right
;;;
;;; <yayacc-output> ::= Output parser file.
;;; 
;;; o͂ꂽp[Tgׂɂ lex ƂĈȉ̊֐pӂKvB
;;; 
;;; sck-yayacc-lex-get-token ()		token ǂ݂Pi token Ԃ
;;; sck-yayacc-lex-token-id (token)	token  ID Ԃ
;;; sck-yayacc-lex-toekn-attr (token)	token ̃Agr[gԂ
;;; sck-yayacc-lex-toekn-pos (token)	token ̈ʒuԂ
;;;
(require 'sck-yayacc)
;;(require 'findscc)
(load "findscc")

(defconst sck=yayacc-yacc-demo-input
  '((object-language "elisp")
    (associativity ((left ("+" "-"))
		    (left ("*" "/"))
		    (left (" NEG"))
		    ))
    (attribute-grammar 
     (
      ((START E " EOF")	$0)

      ((E E "+" E)	(list '+ $0 $2))
      ((E " ERROR" "+" E)	(list '+ $0 $2))
      ((E E "+" " ERROR")	(list '+ $0 $2))

      ((E E "-" E)	(list '- $0 $2))
      ((E " ERROR" "-" E)	(list '- $0 $2))
      ((E E "-" " ERROR")	(list '- $0 $2))

      ((E E "*" E)	(list '* $0 $2))
      ((E " ERROR" "*" E)	(list '* $0 $2))
      ((E E "*" " ERROR")	(list '* $0 $2))


      ((E E "/" E)	(list '/ $0 $2))
      ((E " ERROR" "/" E)	(list '/ $0 $2))
      ((E E "/" " ERROR")	(list '/ $0 $2))

      ((E "(" E ")")	$1)
      ((E "(" " ERROR" ")")	$1)

      ((E "-" E)	(list '- 0 $1) " NEG")
      ((E "-" " ERROR")	(list '- 0 $1) " NEG")

      ((E "+" E)	(list '+ 0 $1) " NEG")
      ((E "+" " ERROR")	(list '+ 0 $1) " NEG")

      ((E "number")	$0)
      ))
    (output-filename "yayacc-demo-output.el")))

;;;
;;; main
;;;

(defun sck-yayacc-yacc (input)
  "<yayacc-input> ::= ((object-language <String>)
 		    (precedences ((<Associativity> (<Terminal>..))..))
 	            (attribute-grammar ((<BNF> <Action> [<Prec>])..))
 		    (output-filename <String>)
 		     ..
		     )

<BNF> ::= (<NonTerminal> <Vocabulary>..)
<NonTerminal> ::= <Symbol>
<Vocabulary> ::= <NonTerminal> | <Terminal>
<Terminal> ::= <String>
<Action> ::= <String> | <S-Exp>
<Prec> ::= <Terminal> 
<Associativity> ::= left | right
"
  (let (sck*yayacc-yacc-productions
	sck*yayacc-yacc-actions
	sck*yayacc-yacc-precs
	sck*yayacc-yacc-lr-table
	sck*yayacc-yacc-associativity)
    (sck-letalist input
	((object-language language)
	 (associativity sck*yayacc-yacc-associativity)
	 (attribute-grammar grammar)
	 (output-filename outfile))
      (setq sck*yayacc-yacc-productions (mapcar 'car grammar))
      (setq sck*yayacc-yacc-actions (mapcar 'cadr grammar))
      (setq sck*yayacc-yacc-precs 
	    (sck-yayacc-yacc-make-precs grammar))
      (setq sck*yayacc-yacc-lr-table
	    (sck-yayacc-yacc-init-table sck*yayacc-yacc-productions))
      ;; check conflicts
      (sck-yayacc-yacc-check-table)
      ;;
      (sck-yayacc-yayacc-make-executor outfile))))

(defun sck-yayacc-yacc-associativity-member (terminal)
  ;; return : (Depth (<Associativity> (<Terminal>..)))
  (let ((depth 0) assoc)
    (block 'assoc
      (dolist (x sck*yayacc-yacc-associativity)
	(when (member terminal (cadr x))
	  (setq assoc x)
	  (return-from 'assoc))
	(incf depth)))
    (if assoc 
	(list depth assoc))))

(defun sck-yayacc-yacc-init-table (productions)
  (sck-letalist (sck-yayacc-lr (list (list 'productions productions)))
      (states)
    states))

(defun sck-yayacc-yacc-make-precs (grammar)
  (let (precs)
    (dolist (x grammar)
      (if (caddr x)
	  (push (caddr x) precs)
	(let (assoc)
	  (dolist (y (cdar x))
	    (when (sck-yayacc-yacc-associativity-member y)
	      (setq assoc y)))
	  (push assoc precs))))
    (nreverse precs)))

(defun sck-yayacc-yayacc-make-executor (outfile)
  (let ((buf (generate-new-buffer " *sck-yayacc-yayacc-make-executor*")))
    (save-excursion
      (set-buffer buf)
      (insert ";;;\n;;; sck-yayacc output\n;;;\n")
      (insert "(defun sck-yayacc-executor ()\n")
      ;; insert datas
      (insert "(let (\n")
      (insert (format "(sck*yayacc-cc-productions '%S)\n"
		      sck*yayacc-yacc-productions))
      (insert (format "(sck*yayacc-cc-lr-table '%S)\n"
		      sck*yayacc-yacc-lr-table))
      (insert (format "(sck*yayacc-cc-precs '%S)\n"
		      sck*yayacc-yacc-precs))
      (insert (format "(sck*yayacc-cc-actions '%S)\n"
		      sck*yayacc-yacc-actions))
      (insert (format "(sck*yayacc-cc-associativity '%S)\n"
		      sck*yayacc-yacc-associativity))
      (insert ")\n")
      ;; insert call executor
      (insert "(sck-yayacc-cc-executor)\n")
      (insert "))\n")
      ;;
      (insert-file-contents 
       (expand-file-name (concat sck=root-directory
				 "/yayacc/sck-yayacc-yacc-executor.el")))
      ;;
      (write-file outfile)
      (kill-buffer buf))))

(defun sck-yayacc-yacc-check-table ()
  ;; RtNg`FbNăbZ[Wo
  (let ((all-count 0))
    (dolist (st sck*yayacc-yacc-lr-table)
      (let ((shifts (caddr st))
	    (reduces (cadr st)))

	'(message "shifts:%S reduces:%S"
		  shifts reduces)

	;; check shift/reduce conflicts
	(let ((count 0))
	  (dolist (s shifts)
	    (dolist (r reduces)
	      (when (and (listp (cadr r))
			 (member (car s) (cadr r)))
		;; prec ̃`FbN

		'(message "s: %S assoc %S\nr: %S assoc %S" 
			  s
			  (sck-yayacc-yacc-associativity-member (car s))
			  r
			  (nth (car r) sck*yayacc-yacc-precs))

		(unless (and (sck-yayacc-yacc-associativity-member (car s))
			     (nth (car r) sck*yayacc-yacc-precs))
		  (incf count)))))
	  (unless (= count 0)
	    (setq all-count (+ all-count count))
	    (message "state %d conflicts: %d shift/reduce"
		     (car st) count)))
	;; check reduce/reduce conflicts
	(let ((count 0))
	  (while reduces
	    (let ((lookaheadset (cadar reduces)))
	      (setq reduces (cdr reduces))
	      (when (listp lookaheadset)
		(dolist (l lookaheadset)
		  (dolist (r reduces)
		    (when (and (listp (cadr r))
			       (member l (cadr r)))
			(incf count)))))))
	  (unless (= count 0)
	    (setq all-count (+ all-count count))
	    (message "state %d conflicts: %d reduce/reduce"
		     (car st) count)))))
    (if (= all-count 0)
	nil
      all-count)))

;;;
;;; demos
;;;
(defun sck-yayacc-yacc-demo ()
  (interactive)
  (sck-yayacc-yacc sck=yayacc-yacc-demo-input))

(defun sck-yayacc-yacc-demo-executor-file (infile)
  (interactive "F")
  (sck-yayacc-yacc-demo)
  (sck-letalist sck=yayacc-yacc-demo-input
      (object-language
       associativity
       attribute-grammar
       output-filename)
    ;; load & init
    (load output-filename)
    (sck-yayacc-lex-init infile)
    (let ((buf (get-buffer-create "*sck-yayacc-excuter-demo*")))
      (set-buffer buf)
      (erase-buffer)
      (insert (format "-- infile (%s) --\n" infile))
      (insert-file-contents infile)
      (goto-char (point-max))
      (insert "-- output --\n")
      (insert (format "%s" (sck-yayacc-executor)))
      (sck-yayacc-lex-clean)
      (display-buffer buf))))

;;;
;;; demo lex
;;;
(defvar sck*yayacc-lex-buffer nil)

(defun sck-yayacc-lex-init (infile)
  (setq sck*yayacc-lex-buffer 
	(generate-new-buffer " *sck-yayacc-lex-buffer*"))
  (save-excursion
    (set-buffer sck*yayacc-lex-buffer)
    (insert-file-contents infile)
    (goto-char (point-min))))

(defun sck-yayacc-lex-clean ()
  (kill-buffer sck*yayacc-lex-buffer))

(defun sck-yayacc-lex-get-token ()
  (save-excursion
    (set-buffer sck*yayacc-lex-buffer)
    (skip-chars-forward " \t\n")	; 󔒂XLbv
    (prog1
	(cond
	 ((looking-at "(")
	  (list "(" "("))
	 ((looking-at ")")
	  (list ")" ")"))
	 ((looking-at "+")
	  (list "+" (match-string 0)))
	 ((looking-at "-")
	  (list "-" (match-string 0)))
	 ((looking-at "*")
	  (list "*" (match-string 0)))
	 ((looking-at "/")
	  (list "/" (match-string 0)))
	 ((looking-at "[a-zA-Z][a-zA-Z0-9]*")
	  (list "symbol" (match-string 0)))
	 ((looking-at "[0-9]+")
	  (list "number" (string-to-int (match-string 0))))
	 ((looking-at "\\'")
	  (list " EOF" " EOF"))
	 (t
	  (error "Unexpected input")))
      ;; looking-at Ń}b`p^[̌ֈړ
      (goto-char (match-end 0)))))

(defun sck-yayacc-lex-token-id (token)
  (car token))

(defun sck-yayacc-lex-token-attr (token)
  (cadr token))

(defun sck-yayacc-lex-token-pos (token)
  nil)

(provide 'sck-yayacc-yacc)
