;;;
;;;              SCK   p[TWFl[^[  yayacc (yet another yacc)
;;;
;;;                                        LastChange: Tue Jan 30 18:00:35 2007
;;;
;;;
;;;


;;; Export:
;;; sck-yayacc-lr : <yayacc-lr-input> -> <yayacc-lr-output>
;;; @p[TɕKvȏ쐬ĕԂB
;;;
;;; Type:
;;; <yayacc-lr-input> ::= ((productions (<Production>..)))
;;;
;;;
;;; <yayacc-lr-output> ::= ((states (<State>..)))
;;;
;;; <Production> ::= <BNF>
;;; productions ŏBNF̓X^[gV{ɂȂ悤ɌĂԁB$ V{I[LɂȂB
;;;
;;; <State> ::= (<StateNo> 
;;;              ((<ProductionNo> <ProductionOpt>)..)
;;;              ((<Vocabulary> <StateNo>)..))
;;;
;;; <StateNo> ::= <FixNum>
;;;
;;; <ProductionNo> ::= <FixNum>
;;;
;;; <ProductionOpt> ::= <LookaheadSet> | <DotPosition>
;;;
;;; <LookaheadSet> ::= (<Terminal>..)
;;;
;;; <DotPosition> ::= <FixNum>
;;;
;;; <Grammar> ::= (<Production> ..)
;;;
;;; <LeftValue> ::= <NonTerminal>
;;;
;;; <BNF> ::= (<NonTerminal> <Vocabularys>)
;;;
;;; <Vocabularys> ::= <Vocabulary> ..
;;;
;;; <Vocabulary> ::= <NonTerminal> | <Terminal>
;;;
;;; <NonTerminal> ::= <Symbol>
;;;
;;; <Terminal> ::= <String>
;;;
;;; <LR0s>     ::= (<LR0> ..)
;;;
;;; <LR0>      ::= (<LeftValue> (<Vocabularys>) (<Vocabularys>))
;;;
;;; <LookAHead>       ::= (<Terminal> ..)
;;;
;;; <LRA>      ::= (<sck-yayacc-lra-state> ..)
;;;
;;;
;;;
;;; Demo:
;;; ESC x sck-yayacc-demo RET
;;; ZA|ZAʁǍvZT^Iȕ@ yayacc ŏf

(require 'sck-lib)
(require 'graphviz)
(require 'findscc)

;;; ---------------------------
;;;
;;;    \̒`
;;;
;;; ---------------------------

;;;
;;;  LRA ̏
;;;
;;; <index>    ::= <Fixnum>
;;; <lr0s>     ::= <LR0s>
;;; <succ>     ::= ((<Symbol> <index>) ..)
;;; <pred>     ::= ((<Symbol> <index>) ..)
;;; <reduces>  ::= ((<Production> <LookAHead>) ..)
;;;
(defstruct (sck-yayacc-lra-state)
  (index)      ; ʔԍ iOJnm[hj
  (lr0s)       ; LR0 W
  (succ)       ; Jڐ alist
  (pred)       ; Jڌ alist
  (reduces)    ; ҌK  lookahead  alist
  )


;;; ---------------------------
;;;
;;;     O[oϐ
;;;
;;; ---------------------------


;;;
;;;  LRA  Ԃ̃Xg
;;;
(defvar sck*yayacc-lra nil)


;;;
;;;  ɕϊ\̂鏑K̃Xg
;;;
(defvar sck*yayacc-nullable nil)


;;;
;;;  V{Ƃ First W alist
;;;
(defvar sck*yayacc-first nil)


;;;
;;;  V{Ƃ Follow W alist
;;;
(defvar sck*yayacc-follow nil)


;;;
;;;  Ԃ̐
;;;
(defvar sck*yayacc-lra-state-num 0)

;;;
;;;  @
;;;
(defvar sck*yayacc-lra-grammar nil)


(defvar sck*yayacc-lra-start nil)
(defvar sck*yayacc-lra-eof nil)


;;; for debug
(defvar sck*yayacc-counter1 0)
(defvar sck*yayacc-counter2 0)
(defvar sck*yayacc-make-lra-time 0)
(defvar sck*yayacc-make-lookahead-time 0)

;;; ---------------------------
;;;
;;;        ֐
;;;
;;; ---------------------------


;;;
;;;  @p[TiɕKvȃf[^j쐬
;;;
;;;  <yayacc-lr-input> -> <yayacc-lr-output>
;;;
(defun sck-yayacc-lr (input)
  (sck-letalist input
      ((productions grammer))
    (sck-yayacc-init grammer) ; 

    (let ((time nil))

      (setq time (current-time))
      (sck-yayacc-make-lra grammer)    ; lra 쐬
      (setq sck*yayacc-make-lra-time (sck-yayacc-time-difference (current-time) time))

      (setq time (current-time))
      (sck-yayacc-make-lookahead) ; lookahead 쐬
      (setq sck*yayacc-make-lookahead-time (sck-yayacc-time-difference (current-time) time))

      )

    (sck-yayacc-make-output)
))

;;;
;;;  
;;;
(defun sck-yayacc-init (grammer)
  (setq sck*yayacc-lra-grammar grammer)  ; @
  (setq sck*yayacc-lra-start (caar grammer)) ; START V{
  (unless (sck-yayacc-grammar-uniq-symbol-p sck*yayacc-lra-start)
    (error "start symbol %S is not uniq!\n" sck*yayacc-lra-start))
  (setq sck*yayacc-lra-eof (car (reverse (car grammer)))) ; EOF V{
  (unless (sck-yayacc-grammar-uniq-symbol-p sck*yayacc-lra-eof)
    (error "eof symbol %S is not uniq!\n" sck*yayacc-lra-eof))
  )


;;;
;;;  kqI[g}g쐬
;;;
;;;  <Grammar> ->  <LRA>
;;;
;;;O[oϐ sck*yayacc-lra ɍ쐬
;;;
(defun sck-yayacc-make-lra (grammar)
  (setq sck*yayacc-lra-state-num 0)
  (let ((startstate (sck-yayacc-make-startstate grammar)))
    (setq sck*yayacc-lra (list startstate)) ; JnXe[g͂߂ɐݒ肵Ă
    (sck-yayacc-build-lra startstate grammar)) ; LRA
  (setq sck*yayacc-lra (nreverse sck*yayacc-lra))) ; ɒi(car sck*yayacc-lra) ŏ̏ԁj


;;;
;;;  JnXe[g쐬
;;;
;;;  <Grammar> -> <LR0s>
;;;
(defun sck-yayacc-make-startstate (grammar)
  ;;ŏ̏K -> LR0ɕϊ -> N[W[쐬 -> Xe[g쐬
  (sck-yayacc-make-state (sck-yayacc-make-closure (list (sck-yayacc-make-lr0 0 (car grammar))) grammar)))


;;;
;;;  hm[h쐬Ă䂭(sck-yayacc-make-lra ̉)
;;;
(defun sck-yayacc-build-lra (state grammar)
  (let ((lr0s (sck-yayacc-lra-state-lr0s state)) (usesyms nil) (worklist nil))
    (dolist (lr0 lr0s)
      (let ((sym (sck-yayacc-lr0-nextsym lr0)))
	(if (and sym (null (member sym usesyms)))
	    (let* ((itms (sck-yayacc-make-nextlr0s lr0s sym grammar)) (x (sck-yayacc-get-state sck*yayacc-lra itms)))
	      (if x ; łɍ쐬ς݂
		  (sck-yayacc-link-state state x sym) ; N𒣂邾
		(let ((st (sck-yayacc-make-state itms))) ; VK쐬
		  (sck-yayacc-link-state state st sym)
		  (push st sck*yayacc-lra)
		  (push sym usesyms)
		  (push st worklist)))))))
    (setq worklist (nreverse worklist)); ɂ
    (dolist (st worklist)
      (sck-yayacc-build-lra st grammar))))



;;;
;;;  Xe[g쐬
;;;
;;;  <LR0s> -> <sck-yayacc-lra-state>
;;;
(defun sck-yayacc-make-state (lr0s)
  (let ((state (make-sck-yayacc-lra-state)))
    (setf (sck-yayacc-lra-state-index state) sck*yayacc-lra-state-num)
    (setf (sck-yayacc-lra-state-lr0s state) lr0s)
    (setf (sck-yayacc-lra-state-succ state) nil)
    (setf (sck-yayacc-lra-state-pred state) nil)
    (setf (sck-yayacc-lra-state-reduces  state) nil)
    (setq sck*yayacc-lra-state-num (1+ sck*yayacc-lra-state-num))
    (message "build lra : %s" sck*yayacc-lra-state-num)
    state))



;;;
;;;  Xe[gԂ̃N𒣂
;;;
;;;   state1  --[sym]-->  state2
;;;
(defun sck-yayacc-link-state (state1 state2 sym)
  (let ((succ (list sym (sck-yayacc-lra-state-index state2)))
	(pred (list sym (sck-yayacc-lra-state-index state1))))
    (unless (member succ (sck-yayacc-lra-state-succ state1))
      (push succ (sck-yayacc-lra-state-succ state1))
      (push pred (sck-yayacc-lra-state-pred state2)))))


;;;
;;;  LRA  w肵 LR0̏W Xe[g𓾂
;;;
(defun sck-yayacc-get-state (lra lr0s)
  (cond 
   ((null lra) nil)
   ((sck-yayacc-equal (sck-yayacc-lra-state-lr0s (car lra)) lr0s) (car lra))
   (t (sck-yayacc-get-state (cdr lra) lr0s))))



;;;
;;;  ԂV{ɂJڂԂ𓾂
;;;
(defun sck-yayacc-next-state (state symbol)
  (sck-yayacc-state
   (cadr (assoc symbol (sck-yayacc-lra-state-succ state)))))

(defun sck-yayacc-next-state-index (state symbol)
  (cadr (assoc symbol (sck-yayacc-lra-state-succ state))))


;;;
;;;  ԂV{ɂJڂԂ𓾂iӂɌ܂͂j
;;;
(defun sck-yayacc-move-state (state vocabularys)
  (cond
   ((null state) nil)
   ((null vocabularys) state)
   (t
    (let ((x (assoc (car vocabularys) (sck-yayacc-lra-state-succ state))))
      (sck-yayacc-move-state
       (sck-yayacc-state (cadr x))
       (cdr vocabularys))))))



;;;
;;;  index Ԃ𓾂
;;;
(defun sck-yayacc-state (index)
  (car (filter '(lambda (x) (equal index (sck-yayacc-lra-state-index x))) sck*yayacc-lra)))




;;;
;;;   GOTO    LR(0) ̏W wV{ǂ񂾎 LR(0) W𓾂
;;;
;;;   lr0s    :   LR(0) ̏W
;;;   symbol  :   ڍsV{
;;;   grammar :   @
;;;
(defun sck-yayacc-make-nextlr0s (lr0s symbol grammar)
  (let ((new nil))
    (dolist (lr0 lr0s)
      (if (equal (sck-yayacc-lr0-nextsym lr0) symbol)
	  (setq new (append new (sck-yayacc-make-closure (list (sck-yayacc-lr0-read lr0)) grammar)))))
    (sck-yayacc-set-uniq new)))





;;;
;;;   N[W[
;;; 
;;;   lr0s    :    LR(0) ̏W
;;;   grammar :    @
;;;
;;;
;;;
(defun sck-yayacc-make-closure (lr0s grammar)
  (cond
   ((null lr0s) nil)
   ((null grammar) lr0s)
   (t 
    (let ((rest grammar) (new nil))
      (dolist (lr0 lr0s)
	(dolist (x rest)
	  (if (equal (sck-yayacc-lr0-nextsym lr0) (sck-yayacc-lsym x))
	      (progn
		(push (sck-yayacc-make-lr0 0 x) new)
		(setq rest (remove x rest))))))
      (append lr0s (sck-yayacc-make-closure new rest))))))









;;;
;;;@K ̍ӂ𓾂
;;;
(defun sck-yayacc-lsym (production)
  (car production))

;;;
;;;@LR(0) ̍ӂ𓾂
;;;
(defun sck-yayacc-lr0-lsym (lr0)
  (car lr0))

;;;
;;;@LR(0) ̃hbg̑ÕV{𓾂
;;;
(defun sck-yayacc-lr0-rsym1 (lr0)
  (cadr lr0))

;;;
;;;@LR(0) ̃hbǧV{𓾂
;;;
(defun sck-yayacc-lr0-rsym2 (lr0)
  (caddr lr0))



;;;
;;;@LR(0) ̃hbg̎ɂV{𓾂
;;;
(defun sck-yayacc-lr0-nextsym (lr0)
  (car (sck-yayacc-lr0-rsym2 lr0)))


;;;
;;;  LR(0)  ̃hbgЂƂi߂
;;;
(defun sck-yayacc-lr0-read (lr0)
;;(sck-yayacc-lr0-read '(a (b c) (d e))) -> (a (b c d) (e))
;;(sck-yayacc-lr0-read '(a (b c d e) nil)) -> (a (b c d e) nil)
  (cond
   ((null (sck-yayacc-lr0-rsym2 lr0)) lr0)
   (t
    (list
     (sck-yayacc-lr0-lsym lr0)
     (nreverse (cons (sck-yayacc-lr0-nextsym lr0) (reverse (sck-yayacc-lr0-rsym1 lr0))))
     (cdr (sck-yayacc-lr0-rsym2 lr0))))))


;;;
;;;  K p  n ԖڂɃhbĝ
;;;@LR(0)  
;;;
(defun sck-yayacc-make-lr0 (n p)
  ;;(sck-yayacc-make-lr0 0 '(a b c)) -> (a nil (b c))
  ;;(sck-yayacc-make-lr0 1 '(a b c)) -> (a (b) (c))
  ;;(sck-yayacc-make-lr0 2 '(a b c)) -> (a (b c) nil)
  (cons  (car p) (sck-yayacc-split n (cdr p))))


;;;
;;;@LR(0)  K 𓾂
;;;
(defun sck-yayacc-lr0-production (lr0)
  (append (cons (car lr0) (sck-yayacc-lr0-rsym1 lr0)) (sck-yayacc-lr0-rsym2 lr0)))


;;;
;;;  I[Lǂ
;;;
(defun sck-yayacc-terminal-symbol-p (symbol)
  (or
   (stringp symbol)
   (equal symbol sck*yayacc-lra-eof))) ; eof ̓V{łI[L

;;;
;;;  LR(0) Sǂ ireduce \ǂj
;;;
(defun sck-yayacc-lr0-complete-p (lr0)
  (null (sck-yayacc-lr0-rsym2 lr0)))


;;;
;;;@LR(0)̃hbg̒オI[Lǂishift \ǂj
;;;
(defun sck-yayacc-lr0-shift-p (lr0)
  (sck-yayacc-terminal-symbol-p (car (sck-yayacc-lr0-rsym2 lr0))))


;;;
;;;@@KŃj[NȃV{ǂ
;;;
(defun sck-yayacc-grammar-uniq-symbol-p (symbol)
  (sck-yayacc-uniq-p symbol (apply 'append sck*yayacc-lra-grammar)))






;;;
;;;  ɂȂ\鏑K̃Xg
;;;
;;;  <Grammar> -> <Nullable>
;;;
;;; <Nullable> ::= (<Production> ..)
;;;
;;; O[oϐ sck*yayacc-nullable Ɍʂi[
;;;
(defun sck-yayacc-make-nullable (grammar)
  (setq sck*yayacc-nullable nil)
  (sck-yayacc-make-nullable-2 grammar)
  sck*yayacc-nullable)

(defun sck-yayacc-make-nullable-2 (grammar)
  (let ((worklist nil) (rest nil))
    (dolist (x grammar)
      (if (or (null (cdr x)) (sck-yayacc-nullable-vocabularys-p (cdr x)))
	  (setq worklist (cons x worklist))
	(push x rest)))
    (if worklist
	(progn
	  (setq sck*yayacc-nullable (append sck*yayacc-nullable worklist))
	  (sck-yayacc-make-nullable-2 rest)))))

;;;
;;;  L񂪋ɂȂ\邩ǂׂ
;;;
;;;  (<Vocabularys>) -> <Boolean>
;;;
(defun sck-yayacc-nullable-vocabularys-p (vocabularys)
  (let ((result t))
    (dolist (sym vocabularys)
      (unless (sck-yayacc-nullable-symbol-p sym)
	(setq result nil)
	(return)))
    result))

;;;
;;;  LɂȂ\邩ǂׂ
;;;
;;;  <Symbol> -> <Boolean>
;;;
(defun sck-yayacc-nullable-symbol-p (symbol)
  (assoc symbol sck*yayacc-nullable))




;;;
;;;  First W̃Xgi sck-yayacc-make-nullable Ŏs܂Ij
;;;
;;;  <Grammar> ->  <First>
;;;
;;; <First> ::= (<Terminal> ..)
;;;
;;; O[oϐ sck*yayacc-first Ɍʂi[
;;;
(defun sck-yayacc-make-first (grammar)
  (sck-yayacc-make-nullable grammar)
  (setq sck*yayacc-first nil)
  (let ((symlist nil) (check t))
    ;; symlist  : @ɎgĂV{̃Xg
    ;; check    : [v`FbNptO
    (dolist (g grammar) ; @ɏoĂV{Xgɂ
      (dolist (s g)
	(push s symlist)))
    (setq symlist (sck-yayacc-set-uniq symlist))
    (dolist (sym symlist) ; sck*yayacc-first  lݒ肷
      (cond
       ((stringp sym)
	  (push (list sym (list sym)) sck*yayacc-first))
       (t
	(push (list sym nil) sck*yayacc-first))))
    (while check ; first W̌vZ
      (setq check nil)
      (dolist (g grammar)
	(let ((e t) (s (car g)) (v (cdr g)))
	  (dolist (x v)
	    (if e
		(progn
		  (if (sck-yayacc-add-first s x)
		      (setq check t))
		  (setq e (sck-yayacc-nullable-symbol-p x)))))))))
  sck*yayacc-first)

;;;
;;; s1  First W  s2  First W 
;;;
;;; vfȂ nil Ԃ
;;;
(defun sck-yayacc-add-first (s1 s2)
  (let ((p1 (assoc s1 sck*yayacc-first))
	(p2 (assoc s2 sck*yayacc-first)))
    (cond
     ((not (sck-yayacc-subsetp (cadr p2) (cadr p1))) ; 镨Ή
      (setf (cadr p1) (sck-yayacc-union (cadr p1) (cadr p2)))
      t)
     (t nil))))

;;;
;;; 
;;;  First W𓾂
;;; 
;;;  (<Vocabularys>) -> <First>
;;;
;;;
(defun sck-yayacc-get-first (vocabularys)
  (let ((first nil) (e t))
    (dolist (sym vocabularys)
      (if e
	  (progn
	    (setq first (append first (cadr (assoc sym sck*yayacc-first))))
	    (setq e (sck-yayacc-nullable-symbol-p sym)))))
    first))






;;;
;;;  Follow W̃Xgi sck-yayacc-make-first Ŏs܂Ij
;;;
;;;  <Grammar> ->  <Follow>
;;;
;;; <Follow> ::= (<Terminal> ..)
;;;
;;; O[oϐ sck*yayacc-follow Ɍʂi[
;;;
;;;  ASY I[L Follow W쐬
;;;
(defun sck-yayacc-make-follow (grammar)
  (sck-yayacc-make-first grammar)
  (setq sck*yayacc-follow nil)
  (let ((symlist nil) (rgrammar nil) (check t))
    ;; symlist  : @ɎgĂV{̃Xg
    ;; rgrammar : tɂ
    ;; check    : [v`FbNptO
    (dolist (g grammar)		; @ɏoĂI[LXgɂ
      (dolist (s g)
	(setq symlist (cons s symlist)))
      (setq rgrammar (cons (cons (car g) (reverse (cdr g))) rgrammar)))
    (setq symlist (sck-yayacc-set-uniq symlist))
    (dolist (sym symlist)		; sck*yayacc-follow ɏlݒ肷
      (setq sck*yayacc-follow (cons (list sym nil) sck*yayacc-follow)))
    (if grammar
	(setf (cadr (car sck*yayacc-follow)) (list sck*yayacc-lra-eof))) ; START V{ Follow  $ ݒ
    (while check			; follow W̌vZ
      (setq check nil)
      (dolist (g rgrammar)
	(let ((A (car g)) (v (cdr g)) (alpha nil))
	  (dolist (B v)
	    (if (sck-yayacc-nullable-vocabularys-p  alpha)
		(if (sck-yayacc-add-follow B A)	; A -> ..B  Follow(B) += Follow(A)
		    (setq check t)))
	    (if (sck-yayacc-add-follow2 B alpha) ; A -> ..B  Follow(B) += First()
		(setq check t))
	    (setq alpha (cons B alpha)))))))
  sck*yayacc-follow)

;;;
;;; s1  Follow W  s2  Follow W 
;;;
;;; vfȂ nil Ԃ
;;;
(defun sck-yayacc-add-follow (s1 s2)
  (let ((p1 (assoc s1 sck*yayacc-follow))
	(p2 (assoc s2 sck*yayacc-follow)))
    (cond
     ((not (sck-yayacc-subsetp (cadr p2) (cadr p1))) ; 镨Ή
      (setf (cadr p1) (sck-yayacc-union (cadr p1) (cadr p2)))
      t)
     (t nil))))

;;;
;;; s1  Follow W  L v  First W 
;;;
;;; vfȂ nil Ԃ
;;;
(defun sck-yayacc-add-follow2 (s1 v)
  (let ((p1 (assoc s1 sck*yayacc-follow))
	(first (sck-yayacc-get-first v)))
    (cond
     ((not (sck-yayacc-subsetp first (cadr p1))) ; 镨Ή
      (setf (cadr p1) (sck-yayacc-set-uniq (append (cadr p1) first)))
      t)
     (t nil))))

;;;
;;; 
;;;  Follow W𓾂
;;; 
;;;  <Symbol> -> <Follow>
;;;
;;;
(defun sck-yayacc-get-follow (sym)
  (cadr (assoc sym sck*yayacc-follow)))






;;;
;;; 
;;;  Director W𓾂
;;; 
;;;  <Production> -> <Director>
;;; 
;;; <Director> ::= (<Symbol> ..)
;;;
(defun sck-yayacc-get-director (production)
  (let ((s (car production)) (v (cdr production)))
    (if (sck-yayacc-nullable-vocabularys-p v)
	(sck-yayacc-set-uniq (append (sck-yayacc-get-first v) (sck-yayacc-get-follow s)))
      (sck-yayacc-get-first v))))






;;;
;;;
;;;   lookahead 쐬
;;;
;;;


;;; 
;;;  DR𓾂
;;;
(defun sck-yayacc-DR (x)
  (let ((result nil)
	(st (sck-yayacc-next-state (car x) (cadr x))))
    (if st
	(dolist (succ (sck-yayacc-lra-state-succ st))
	  (if (sck-yayacc-terminal-symbol-p (car succ))
	      (push (car succ) result))))
    result))



;;;
;;;  
;;;  reads ̊֌Wǂ肷
;;;
;;;  x reads y
;;;
(defun sck-yayacc-reads-p (x y)
  (let ((state1 (car x))
	(symbol1 (cadr x))
	(state2 (car y))
	(symbol2 (cadr y)))
    (and (equal (sck-yayacc-next-state state1 symbol1) state2)
	 (sck-yayacc-nullable-symbol-p symbol2))))


;;;
;;;  
;;;  reads ̊֌Wɂ m[h̃Xg𓾂
;;;
;;;
(defun sck-yayacc-reads-node (x)
  (let ((state (sck-yayacc-next-state (car x) (cadr x)))
	(sck-reads-node-list nil))
    (dolist (succ (sck-yayacc-lra-state-succ state))
      (let ((sym (car succ)))
	(if (and (null (sck-yayacc-terminal-symbol-p sym))
		 (sck-yayacc-nullable-symbol-p sym))
	    (push (list state sym) sck-reads-node-list))))
    (setq sck*yayacc-counter1 (1+ sck*yayacc-counter1))
    (message "make Read table : %d / %d" sck*yayacc-counter1 sck*yayacc-graph-num)
    sck-reads-node-list))


;;;
;;;  
;;;  includes ̊֌Wǂ肷
;;;
;;;  x includes y
;;;
(defun sck-yayacc-includes-p (x y)
  (let ((result nil)
	(state1 (car x))
	(symbol1 (cadr x))
	(state2 (car y))
	(symbol2 (cadr y)))
    (block check-include
      (dolist (st sck*yayacc-lra)	; Ƃ肠SłĂ݂
	(dolist (lr0 (sck-yayacc-lra-state-lr0s st))
	  (if (and (equal symbol2 (sck-yayacc-lr0-lsym lr0)) ; symbol2 ɊҌ
		   (sck-yayacc-lr0-complete-p lr0) ; S
		   (member symbol1 (sck-yayacc-lr0-rsym1 lr0)) ; symbol1 ܂܂
		   )
	      (let ((beta nil)
		    (Agamma (sck-yayacc-lr0-rsym1 lr0)))
		(dolist (A (sck-yayacc-lr0-rsym1 lr0))
		  (let ((gamma (cdr Agamma))
			(node nil))
		    (if (and (equal symbol1 A)
			     (sck-yayacc-nullable-vocabularys-p gamma)
			     (setq node (sck-yayacc-move-state state1 Agamma)) ; nil ̏ꍇl邽
			     (equal (sck-yayacc-lra-state-index st) (sck-yayacc-lra-state-index node))
			     (setq node (sck-yayacc-move-state state2 (reverse beta)))
			     (equal (sck-yayacc-lra-state-index state1) (sck-yayacc-lra-state-index node)))
			(progn
			  (setq result t)
			  (return-from check-include nil))))
		  (setq Agamma (cdr Agamma))
		  (push A beta))))))
      );end block
    result))


;;;
;;;  
;;;  includes ̊֌Wɂ m[h̃Xg𓾂
;;;
;;;
(defun sck-yayacc-includes-node (x)
  (let ((sck-includes-node-list nil)
	(state1 (car x))
	(symbol (cadr x)))

    (dolist (g sck*yayacc-lra-grammar)
      (let ((reverse-beta nil)
	    (A (cadr g))
	    (gamma (cddr g))
	    (B (car g))
	    (state2 nil))
	(while A
	  (if (and
	       (equal symbol A)
	       (sck-yayacc-nullable-vocabularys-p gamma)
	       (setq state2 (sck-yayacc-move-state state1 (cons A gamma)))
	       (member (list B (cdr g) nil) (sck-yayacc-lra-state-lr0s state2)))
	      (sck-yayacc-includes-node-2 state1 state1 (reverse reverse-beta) B reverse-beta))
	  (push A reverse-beta)
	  (setq A (pop gamma)))))

    (setq sck*yayacc-counter2 (1+ sck*yayacc-counter2))
    (message "make Follow table : %d / %d" sck*yayacc-counter2 sck*yayacc-graph-num)
    sck-includes-node-list))


;;;
;;;          beta                      symbol
;;;  state2 ------> state1  &   state2   -> ... 
;;;  ƂȂ state2  symbol  T sck-yayacc-next-state ɒǉ
;;;
(defun sck-yayacc-includes-node-2 (state1 state2 beta symbol path)
  (if path
      (let ((next-symbol (car path)))
	(dolist (pred (sck-yayacc-lra-state-pred state2))
	  (if (equal next-symbol (car pred))
	      (sck-yayacc-includes-node-2 state1
					  (sck-yayacc-state (cadr pred))
					  beta
					  symbol
					  (cdr path)))))
    (if (and
	 (equal (sck-yayacc-lra-state-index (sck-yayacc-move-state state2 beta)) (sck-yayacc-lra-state-index state1))
	 (assoc symbol (sck-yayacc-lra-state-succ state2)))
	(push (list state2 symbol) sck-includes-node-list))))



;;;
;;;  
;;;  lookback ̊֌Wǂ肷
;;;
;;;  (state1, production) lookback (state2, symbol2)
;;;
(defun sck-yayacc-lookback-p (state1 production state2 symbol2)
  (let ((st (sck-yayacc-move-state state2 (cdr production))))
    (and 
     st
     (equal (car production) symbol2)
     (equal (sck-yayacc-lra-state-index state1) (sck-yayacc-lra-state-index st)))))






;;;
;;;  findscc g lookahead ߂
;;;
(defvar sck*yayacc-graph nil)
(defvar sck*yayacc-graph-num nil)
(defvar sck*yayacc-Read-alist nil)
(defvar sck*yayacc-Follow-alist nil)


;;;
;;;  e평
;;;
(defun sck-yayacc-make-lookahead-init ()
  ;;  ϐ
  (setq sck*yayacc-graph nil)
  (setq sck*yayacc-counter1 0)
  (setq sck*yayacc-counter2 0)
  ;;  findscc p graph 쐬
  (dolist (st sck*yayacc-lra)
    (dolist (x (sck-yayacc-lra-state-succ st))
      (unless (sck-yayacc-terminal-symbol-p (car x))
	(push (list st (car x)) sck*yayacc-graph))))
  (setq sck*yayacc-graph-num (length sck*yayacc-graph)))



;;;
;;;  findscc g Read ̃e[u쐬
;;;
(defun sck-yayacc-calc-Read-list ()
  (setq sck*yayacc-Read-alist
	(cadr
	 (findscc2 sck*yayacc-graph #'sck-yayacc-reads-node #'sck-yayacc-DR))))


;;;
;;;  Read ߂
;;;
(defun sck-yayacc-Read (x)
  (cadr (assoc x sck*yayacc-Read-alist)))


;;;
;;;  findscc g Follow ̃e[u쐬
;;;
(defun sck-yayacc-calc-Follow-list ()
  (setq sck*yayacc-Follow-alist
	(cadr
	 (findscc2 sck*yayacc-graph #'sck-yayacc-includes-node #'sck-yayacc-Read))))

;;;
;;;  Follow ߂
;;;
(defun sck-yayacc-Follow (x)
  (cadr (assoc x sck*yayacc-Follow-alist)))

;;;
;;;  LA ߂
;;;
(defun sck-yayacc-LA (state production)
  (let ((sck-lookahead-list nil))
    (sck-yayacc-calc-lookback state state (cdr production) (car production) (reverse (cdr production)))
    sck-lookahead-list))


;;;
;;;  lookback ֌Wǂ lookahead vZ
;;;
(defun sck-yayacc-calc-lookback (state1 state2 omega symbol path)
  (if path
      (let ((next-symbol (car path)))
	(dolist (pred (sck-yayacc-lra-state-pred state2))
	  (if (equal next-symbol (car pred))
	      (sck-yayacc-calc-lookback state1
					(sck-yayacc-state (cadr pred))
					omega
					symbol
					(cdr path)))))
    (if (and
	 (equal (sck-yayacc-lra-state-index (sck-yayacc-move-state state2 omega)) (sck-yayacc-lra-state-index state1))
	 (assoc symbol (sck-yayacc-lra-state-succ state2)))
	(setq sck-lookahead-list (sck-yayacc-union sck-lookahead-list (sck-yayacc-Follow (list state2 symbol)))))))


;;;
;;;  e state  ҌK lookahead vZ
;;;
(defun sck-yayacc-make-lookahead ()
  (sck-yayacc-make-lalr1-lookahead))

;;; LALR(1)
(defun sck-yayacc-make-lalr1-lookahead ()
  (sck-yayacc-make-nullable sck*yayacc-lra-grammar) ; nullable 쐬
  (sck-yayacc-make-lookahead-init)
  (sck-yayacc-calc-Read-list)
  (sck-yayacc-calc-Follow-list)
  (dolist (state sck*yayacc-lra)
    (message "make lalr1 lookahead set : %d / %d" (sck-yayacc-lra-state-index state) sck*yayacc-lra-state-num)
    (dolist (lr0 (sck-yayacc-lra-state-lr0s state))
      (if (sck-yayacc-lr0-complete-p lr0)
	  (let* ((production (cons (sck-yayacc-lr0-lsym lr0) (sck-yayacc-lr0-rsym1 lr0)))
		 (lookahead (sck-yayacc-LA state production)))
	    (push (list production lookahead) (sck-yayacc-lra-state-reduces state))
	    (if (and (null lookahead)
		     (not (equal (car production) sck*yayacc-lra-start)))
		(error "state%s's lookahead is none!" (sck-yayacc-lra-state-index state))))))))


;;; SLR(1)
(defun sck-yayacc-make-slr1-lookahead ()
  (sck-yayacc-make-follow sck*yayacc-lra-grammar) ; S follow 쐬
  (dolist (state sck*yayacc-lra)
    (message "make slr1 lookahead set : %d / %d" (sck-yayacc-lra-state-index state) sck*yayacc-lra-state-num)
    (dolist (lr0 (sck-yayacc-lra-state-lr0s state))
      (if (sck-yayacc-lr0-complete-p lr0)
	  (let* ((production (cons (sck-yayacc-lr0-lsym lr0) (sck-yayacc-lr0-rsym1 lr0)))
		 (lookahead (sck-yayacc-get-follow (car lr0))))
	    (push (list production lookahead) (sck-yayacc-lra-state-reduces state)))))))



;;;
;;;  LALR(1)  SLR(1)  lookahead r
;;;  قȂ镔XgAbv
;;;
(defun sck-yayacc-compare-lookahead ()
  (sck-yayacc-make-follow sck*yayacc-lra-grammar) ; S follow 쐬
  (let ((difflist nil))
    (dolist (state sck*yayacc-lra)
      (dolist (reduce (sck-yayacc-lra-state-reduces state))
	(let* ((production (car reduce))
	       (lookahead (cadr reduce))
	       (lookahead2 (sck-yayacc-get-follow (car production))))
	  (unless (sck-yayacc-equal lookahead lookahead2)
	    (push (list (sck-yayacc-lra-state-index state) production lookahead lookahead2) difflist)))))
    difflist))


;;;
;;;  o̓f[^
;;;

;;; Jڐ惊Xg
(defun sck-yayacc-make-output-succ (state)
  (let ((x nil))
    (dolist (s (sck-yayacc-lra-state-succ state))
      (push (list (car s) (cadr s)) x))
    (nreverse x)))

;;; Ҍ[ or  LR0   ̃Xg 
(defun sck-yayacc-make-output-productions (state)
  (let ((rlist nil))
    (dolist (lr0 (sck-yayacc-lra-state-lr0s state))
      (let* ((production (sck-yayacc-lr0-production lr0))
	     (index (position production sck*yayacc-lra-grammar :test 'equal)))
	(if (sck-yayacc-lr0-rsym2 lr0); Sł͂Ȃꍇ
	    (push (list index (length (sck-yayacc-lr0-rsym1 lr0)))
		  rlist)
	  (push (list index (cadr (assoc production (sck-yayacc-lra-state-reduces state))))
		rlist))))
    (nreverse rlist)))

;;; Xe[g
(defun sck-yayacc-make-output-state (state)
  (list (sck-yayacc-lra-state-index state) ;<StateNo> 
	(sck-yayacc-make-output-productions state)
	(sck-yayacc-make-output-succ state)))


(defun sck-yayacc-make-output-states ()
  (list 'states
	(let ((slist nil))
	  (dolist (st sck*yayacc-lra)
	    (push (sck-yayacc-make-output-state st) slist))
	  (nreverse slist))))

;;;
;;;  쐬 lra  o̓f[^ɂ
;;;
(defun sck-yayacc-make-output ()
  (list (sck-yayacc-make-output-states)))



;;;**********************
;;;        utilities
;;;**********************

;;;
;;;  XgnԖڂŕ
;;;
(defun sck-yayacc-split (n x)
  ;;(sck-yayacc-split 0 '(a b c)) -> (nil (a b c))
  ;;(sck-yayacc-split 1 '(a b c)) -> ((a) (b c))
  ;;(sck-yayacc-split 2 '(a b c)) -> ((a b) (c))
  (let ((lval nil) (rval x))
    (dotimes (i n)
      (if rval
	  (progn
	    (setq lval (cons (car rval) lval))
	    (setq rval (cdr rval)))))
    (list (nreverse lval) rval)))


(defun sck-yayacc-nthtail (n x)
  ;;(sck-yayacc-nthtail 0 '(a b c)) -> nil
  ;;(sck-yayacc-nthtail 1 '(a b c)) -> c
  ;;(sck-yayacc-nthtail 3 '(a b c)) -> a
  ;;(sck-yayacc-nthtail 4 '(a b c)) -> nil
  ;;(sck-yayacc-nthtail 5 '(a b c)) -> nil
  (car
   (nthcdr n
	   (cons nil (reverse x)))))




;;;
;;;  Wj[Nɂ
;;;
;;;  remove-duplicates ͎gȂ
;;;
(defun sck-yayacc-set-uniq (x)
  (delete-duplicates x :test 'equal))

;;;
;;;  W Union
;;;
(defun sck-yayacc-union (x y)
  (union x y :test 'equal))

;;;
;;;  W Intersection
;;;
(defun sck-yayacc-intersection (x y)
  (intersection x y :test 'equal))

;;;
;;;  Wǂ肷
;;;
(defun sck-yayacc-subsetp (x y)
  (subsetp x y :test 'equal))

;;;
;;; Wǂ肷
;;;
(defun sck-yayacc-equal (x y)
  (and (subsetp x y :test 'equal) (subsetp y x :test 'equal)))


;;;
;;; j[Nȃo[ǂ
;;;
(defun sck-yayacc-uniq-p (x y)
  (let ((num 0))
    (dolist (s y)
      (if (equal x s)
	  (setq num (1+ num))))
    (equal num 1)))


;;
;; current-time ֐Ԃ^̎̍bP (float) ŕԂB
;;
(defun sck-yayacc-time-difference (t1 t2)
  (let ((hi (- (car t1) (car t2)))
	(lo (- (cadr t1) (cadr t2)))
	(mi (- (or (caddr t1) 0) (or (caddr t2) 0))))
    (when (< mi 0)
      (setq mi (+ mi 1000000)
	    lo (- lo 1)))
    (when (< lo 0)
      (setq lo (+ lo 65536)
	    hi (- hi 1)))
    (if (<= 0 hi)
	(+ (* hi 65536.0) lo (/ mi 1000000.0))
      (- (sck-yayacc-time-difference t2 t1)))))


;;;
;;;  vg
;;;

(defun sck-yayacc-print-lr0 (lr0)
  (with-temp-buffer
    (insert (format "    %S ->" (car lr0)))
    (dolist (sym (cadr lr0))
      (insert (format " %S" sym)))
    (insert " .")
    (dolist (sym (caddr lr0))
      (insert (format " %S" sym)))
    (buffer-substring (point-min) (point-max))))


(defun sck-yayacc-print-lra-state (state)
  (with-temp-buffer
    (let ((lr0s (sck-yayacc-lra-state-lr0s state))
	  (succs (sck-yayacc-lra-state-succ state))
	  (preds (sck-yayacc-lra-state-pred state)))
      (insert (format "state%s = {\n" (sck-yayacc-lra-state-index state)))
      (insert "  [lr0s]\n")
      (dolist (lr0 lr0s)
	(insert (format "%s\n" (sck-yayacc-print-lr0 lr0))))
      (insert "\n")
      (insert "  [succ]\n")
      (dolist (succ succs)
	(insert (format "    %S : state%s\n" (car succ) (cadr succ))))
      (insert "\n")
      (insert "  [pred]\n")
      (dolist (pred preds)
	(insert (format "    %S : state%s\n" (car pred) (cadr pred))))
      (insert "\n")
      (insert "  [reduces]\n")
      (dolist (reduce (sck-yayacc-lra-state-reduces state))
	(insert (format "    %S ->" (caar reduce)))
	(dolist (sym (cdr (car reduce)))
	  (insert (format " %S" sym)))
	(insert "  :")
	(dolist (sym (cadr reduce))
	  (insert (format "  %S" sym)))
	(insert "\n"))
      (insert "}\n\n")
    (buffer-substring (point-min) (point-max)))))


(defun sck-yayacc-print-lra (lra)
  (with-temp-buffer
    (dolist (state lra)
      (insert (format "%s" (sck-yayacc-print-lra-state state))))
    (buffer-substring (point-min) (point-max))))


;;; lra ̃_v
(defun sck-yayacc-dump ()
  (interactive)
  (save-excursion
    (let ((dspbuf (get-buffer-create "*sck-yayacc-dump*")))
      (set-buffer dspbuf)
      (erase-buffer)
      (insert (format "%s" (sck-yayacc-print-lra sck*yayacc-lra)))

      (goto-char (point-min))
      (display-buffer dspbuf)
      t)))


;;; ẽ_v
(defun sck-yayacc-dump2 ()
  (interactive)
  (save-excursion
    (let ((dspbuf (get-buffer-create "*sck-yayacc-dump2*")))
      (set-buffer dspbuf)
      (erase-buffer)

      ;; lra ̏Ԑ
      (insert (format "number of lra state : %S\n\n" sck*yayacc-lra-state-num))

      ;; findscc ̃m[h
      (insert (format "number of node used by findscc : %S\n\n" sck*yayacc-graph-num))

      ;; 
      (insert (format "time of lra construction : %1.5g sec\n\n" sck*yayacc-make-lra-time))
      (insert (format "time of lookahead construction : %1.5g sec\n\n" sck*yayacc-make-lookahead-time))

      ;; start V{
      (insert (format "start symbol : %S\n\n" sck*yayacc-lra-start))

      ;; eof V{
      (insert (format "eof symbol : %S\n\n" sck*yayacc-lra-eof))

      ;; nullable
      (insert "nullable symbols : ")
      (dolist (x sck*yayacc-nullable)
	(insert (format "%S " (car x))))
      (insert "\n\n")

      ;; grammar
      (insert "grammar : \n")
      (let ((id 0))
	(dolist (x sck*yayacc-lra-grammar)
	  (insert (format "[%d]  %S  ->" id (car x)))
	  (dolist (y (cdr x))
	    (insert (format "  %S" y)))
	  (setq id (1+ id))
	  (insert "\n")))
      (insert "\n\n")

      (goto-char (point-min))
      (display-buffer dspbuf)
      t)))


;;; slr1  lalr1  lookahead ̈Ⴂ_v
(defun sck-yayacc-dump3 ()
  (interactive)
  (save-excursion
    (let ((dspbuf (get-buffer-create "*sck-yayacc-dump3*"))
	  (difflist (sck-yayacc-compare-lookahead)))
      (set-buffer dspbuf)
      (erase-buffer)

      (dolist (x difflist)
	(let ((id (car x))
	      (production (cadr x))
	      (lookahead (caddr x))
	      (lookahead2 (cadddr x)))

	  (insert (format "state%d  :  %S  ->" id (car production)))
	  (dolist (y (cdr production))
	    (insert (format "  %S" y)))
	  (insert "\n")

	  (insert "lookahead lalr1  :")
	  (dolist (y lookahead)
	    (insert (format "  %S" y)))
	  (insert "\n")

	  (insert "lookahead slr1  :")
	  (dolist (y lookahead2)
	    (insert (format "  %S" y)))
	  (insert "\n\n")
	  ))

      (goto-char (point-min))
      (display-buffer dspbuf)
      t)))


;;; elim pv^̒`
(when (featurep 'elim)
  (elim-add-printer
   'sck-yayacc-lra-state-p
   #'(lambda (x) (sck-yayacc-print-lra-state x)))
  (elim-add-printer
   #'(lambda (x) (and (listp x) (sck-yayacc-lra-state-p (car x))))
   #'(lambda (x) (sck-yayacc-print-lra x))))





;;
;; graphviz \
;;
(defun sck-yayacc-graphviz-display (&optional non-content)
  (interactive)
  (graphviz-graph-display
   (sgraph-to-graphviz-graph 
    (sck-yayacc-sgraph non-content))))

;;
;; sck*yayacc-lra  sgraph 쐬
;;
(defun sck-yayacc-sgraph (&optional non-content)
  (let (sgraph)
    ;; to (NodeID Content ((Successor..) ..))
    (dolist (x sck*yayacc-lra)
      (push (list 
	     (intern (format "State%s" (sck-yayacc-lra-state-index x)))
	     ;; Content
	     (unless non-content
	       (concat 
		(mapconcat #'(lambda (lr0)
			       (format "%s -> %s. %s"
				       (car lr0)
				       (if (cadr lr0)
					   (concat
					    (mapconcat #'(lambda (x)
							   (format "%S" x))
						       (cadr lr0)
						       " ")
					    " ")
					 "")
				       (mapconcat #'(lambda (x)
						      (format "%S" x))
						  (caddr lr0)
						  " ")))
			   (sck-yayacc-lra-state-lr0s x)
			   "\a")
		(when (sck-yayacc-lra-state-reduces x)
		  (concat 
		   "\a[Recuce]\a"
		   (mapconcat #'(lambda (reduce)
				  (format "%s ->%s:\a  %s"
					  (caar reduce)
					  (mapconcat #'(lambda (x)
							 (format "%S" x))
						     (cdar reduce)
						     " ")
					  (mapconcat #'(lambda (x)
							 (format "%S" x))
						     (cadr reduce)
						     " ")))
			      (sck-yayacc-lra-state-reduces x)
			      "\a")))
		"\a"))
	     ;; Edges
	     (let (edge)
	       (dolist (y (sck-yayacc-lra-state-succ x))
		 (push 
		  (list 
		   (intern (format "State%s" (cadr y)))
		   (format "%S" (car y)))
		  edge))
	       edge))
	    sgraph))
    (list (list 'node-list sgraph))))



;;;
;;;  DEMO
;;;

;;;
;;;  @̗
;;;
(defvar sck*yayacc-G1 nil)
(defvar sck*yayacc-G2 nil)
(defvar sck*yayacc-G3 nil)

(defun sck-yayacc-demo-init ()
  (setq sck*yayacc-G1
	'((productions
	    (
	     (START E " $")
	     (E E "+" T)
	     (E T)
	     (T T "*" F)
	     (T F)
	     (F "(" E ")")
	     (F "i")
	     ))))

  (setq sck*yayacc-G2
	'((productions
	    (
	     (START E " $")
	     (E T Ed)
	     (Ed "+" T Ed)
	     (Ed)
	     (T F Td)
	     (Td "*" F Td)
	     (Td)
	     (F "(" E ")")
	     (F "i")
	     ))))
  )


(defun sck-yayacc-demo ()
  (interactive)
  (sck-yayacc-demo-init)
  (sck-yayacc-lr sck*yayacc-G2)
  (sck-yayacc-dump)
;  (sck-yayacc-graphviz-display)
  )

(provide 'sck-yayacc)
